                         _BWM_ 
                 The Bat-Window Manager

 Did you have any doubt that the Caped Crusader used his 
 own implementation of a POSIX 1003.2-compliant crime-
 fighting system, complete with his own Bat-Window Manager?

 I didn't think so.

 by Matt Chisholm, http://www.theory.org/~matt/sawfish/

 Looks good with the GTK themes "BHGtk," "Blue Marble," and
 "SuedE_GTK."

SawLook - An OLVWM theme for Sawfish.
No config, simple and clean OLVWM look (and a bit of feel) plus a shaded mode.
This is released under GPL. 
Copyright 2002 by Ricardo Mones Lastra <mones@aic.uniovi.es>

Border and corner images by tigert (Enlightenment theme Brushed-Metal)
Titlebar and button images by Hallvar Helleseth (Enlightenment theme Absolute-E)
Lisp code derived from absolute-e theme for Sawfish by John Harper.

Integrated by Andrew S. Midthune <asm@texoma.net>, standing on the shoulders of giants. Well, really big guys anyway :)

CoolClean is modified from the CleanBig sawmill theme which originally came 
from enlightenment. This theme supports customizable gradients and colors for 
the title bar.

Scott Sams
sbsams@digitallabyrinth.com
http://www.digitallabyrinth.com/linux/sawmill/index.html

This is the Titanium theme for sawmill. It is based
on the MacOS9 interface and on jim-mac theme for icewm
by Jakub Steiner <jimmac@linux.com>.

Created by Jesús González <jgonzlz@terra.es>

Michele Campeotto <micampe@f2s.com>
	- Contributed code "Custom" button arrangement.
	
Released under the GPL license.

  Anonymous

This look is based on a theme that appeared in some early 
kde2 screenshots. I don't know who the original author is 
as I could never find the theme anywhere (was it ever 
released?), so I named it Anonymous.

The theme 'engine' is mostly the same one used in 
Operational. The main difference is in the button layouts 
which are now totally configurable. 
The window icons are also back. Compile sawfish with 
gdk-pixbuf support for best results.

A .gtkrc.mine is included - just copy it to your home dir 
to get a  matching shade of gray in Gnome/GTK. Enjoy!

Created by Pedro Lopes
paol@teleweb.pt

in the spirit of Twm and the project Athena, this is a clean theme
for sawfish.
It does not have unnecessary window decorations as buttons nor does it have
fancy graphics.

This without bringing back the uglyness of TWM... a pretty stylish theme
It were originally made for TWM, (and made heavy use of the feature to drag a
'delete' icon onto the window), then ported to FVWM2 (had to hack the source to
get rid of the ugly 3D widgets) and now finally upgraded to Sawfish

This theme were based on John Harpers 'mono' theme.

Improvements and comments go to arne@users.sourceforge.net
(no, I WON'T add buttons)

- --- ---- ----- ------ ------- ( HeliX ) ------- ------ ----- ---- --- -- -

This is the default theme from Helix Gnome Prerelease.

Created by Tuomas Kuosmanen <tigert@gimp.org>
Copyright 2000 Helix Code, Inc <www.helixcode.com>

Released under the GPL license

- --- ---- ----- ------ ------- ( o-X-o ) ------- ------ ----- ---- --- -- -

- --- ---- ----- ------ ---- ( DoubleHeliX ) ---- ------ ----- ---- --- -- -

This theme is a very simple combination of the two *excellent* themes 
designed by Tuomas, HeliX and HeliX-gray.

Artwork by Tuomas Kuosmanen <tigert@gimp.org>
Copyright 2000 Helix Code, Inc.
Gtk Theme : Marble3D

Released under the GPL license
ASMed by Jean-Matthieu <jms@supinfo.com>
- --- ---- ----- ------ ------- ( o-X-o ) ------- ------ ----- ---- --- -- -

FinalStep

FinalStep has been inspired by Sanity by Jason F. McBrayer
and is intended to be a Good Theme (tm).

It has a Step-ish look-and-feel and is meant to replace all
my previous Step* themes.

You can configure the colors, the buttons layout and the
titlebar font.

Copyright (C) 2001 Michele Campeotto <micampe@f2s.com>

|==                                           ==|
||   ######           ##  #######   ||
||   ######           ##  ##             ||
||      ##     ####  ##  #######    ||
||      ##     ####  ##  ##      ##    ||
||     ##               ##  ##      ##     ||
||     ##               ##  #######     ||
|==                                           ==|
        ==[ Yellow ]== 

Designed by Andrew Brehaut aka Gr1dl0ck
abrehaut@bigfoot.com

Created, in completely using 'The Gimp' and 'vi'

Also avalible in Red and Blue

Controls 

     |	LMB		RMB
-----------------------------
(T)  | Menu	      Close
(v)  | iconify	
 o   |  (nothing - isnt a button)

- drag using colored inset
- shade by dbl clicking inset

I never use Maximise, so its not on the buttons
get to it from the menu.

     ###  ###   |----------------------------------------|
     ###  ###   |  Sawfish theme by Gr1dl0ck                                 |
       ##  ##     |  gr1dl0ck.deviantart.com                                      |
       ##  ##     |                                                                                |
         #  #       |  Lovingly crafted by hand with the GIMP and vi  |
         ###       |  v0.4 prerelease                                                    |
           #         |----------------------------------------|

circle button [ LMB : Menu / RMB : Close ]
triangle button [ LMB : iconify ]

title [ drag : move / dbl : shade ]

this is the second public release of V, and it fixes a few of the problems
people have had with it - there are now two versions, 'V' is the normal one
and 'V-noInt' which has the interlacing removed on the titlebar for those of
you who have had trouble reading the text with the interlacing in.

Both now have an additional image for the mouseovers - the old pressed image 
is now the hover image, and there is now a new pressed image which has darker buttons.

           -----[2 Years to Never ]-----

[x.]"--------------------------------+
|         Another Eazel style	                          |
|            Sawfish theme.                                 |
|                                                                      |
-  By Andrew Brehaut aka Gr1dl0ck            |
|                                                                      |
+----------------------------------+

A minial theme based on STPShiny, and the other
Eazel style themes out there, with a small bit
of influence from absoluteE. 

Buttons are menu(left MB) close(right MB)
               minimize(left MB)

i find i never use maximise in X or when im using
a larger resolution. so i didnt put the button in.

The "Derivative" Sawfish Theme, v2.0

It was Klarth, but it's not anymore. It took me perhaps 4 evenings to make.
The name comes from the fact that I used Klarth's code (and threw out a lot
of unnecessary parts), and also from the fact that I'd been having way too
much fun with Calculus homework at the time.

It's not the most usable theme, nor the best looking theme, but it's -my-
theme. (Reason enough for it to exist, eh?) I think it looks cool, and it's
a change of pace. A bit of a combination between the Ice theme and the NeXT
stuff.

Features:
- No resize bar or maximize-button on non-resizable windows.
- Recolors based on GTK theme color (if it looks bad, switch to #0766ab ;)
- Titlebar and resize bar are both sized proportionally to your font size.
- Color changes and font size changes should occur without a restart.
- Maximize button's icon changes to an Un-maximize icon when you click it.
- Should be fairly speedy. (If not, blame the titlebar buttons.)

Planned Features:
- Resize the titlebar buttons to fit the titlebar. (Yes, it's only sane,
  logical, mandatory, and generally required for any usable theme - but...
  it's difficult.)

I want to know how to get rid of the resize handles when the window maximizes.
If you know how to do this, please email me! (I think it may require sawfish
changes.)

Feel free to email me with comments/questions/etc...or better,
jabber: kenny@jabber.whitecape.org.

Enjoy!

GPL'ed; (C) 2002 Kenny Graunke <kenny@whitecape.org>

              _Hacksaw_

 A minimal, industrial, yellow & grey theme. 
 Based loosely on my Kaleidoscope scheme "wxy" made long ago.

 Made using the Gimp and sawfish-themer.

 by Matt Chisholm http://theory.org/~matt/sawfish/

 Looks good the with GTK themes "Brass Alloy," "get-e," 
 "Rusty Metal," and "tildouf."
 

Yet Another Minimalist/Beos'ish Theme.

But you can change the highlight and unfocus colors!

This was hacked together from Eazel Inc's Crux theme  (which is very cool, 
I suggest you try it.)  Basicly I use images from my first theme with the 
geometry and color management of Crux.

Of course, since there are no buttons by default, you want to include shortcuts for
moveing and resizing the window.

Copyright 2001 Doug Johnson <doug@centibyte.org> under the GPL.

Designed to be easier to see if you find the other themes harder.

This theme is dedicated to my loving girlfriend Vicki

v0.61-1

(cl) Ian Norton-Badrul <bredroll@atari.org>

See CHANGELOG for changes to this version

The "Klarth" Sawfish Theme, v2.0

A mix between Window Maker's frames, the "Eazel" sawfish theme, and Crux.

Available under the Free Software Foundation's GNU General Public License,
either version 2 or (at your option) a later version published by the FSF.

Features:
- Recolors almost the entire frame to match your GTK theme's colors; recolors
  text to automatically contrast. Works with light and dark themes.
  (Crux only recolors the highlight and doesn't recolor the text, making it
   ugly with very dark themes and unusable with white hilights.)
- Resizes the titlebar's height so the text fits in it.
  (Most other themes which leave too much blank space with small fonts and cut
   off text with large fonts.)
- No resize handles or maximize button on non-resizable windows.
- Configurable button position themes. (like Crux)
- Changes button states based on window states.
  (The maximize icon changes to an unmaximized icon; shading could easily do
   so pending a sawfish bug fix.)
- Most of the frame is painted with dynamic gradients, not static pixmaps.

Known Issues:

- Large pink/magenta areas on titlebar:

  To render the dots/holes on the titlebar, Klarth requires GDK-Pixbuf Sawfish;
  I believe the tile-image function does not work for imlib sawfish. To the
  best of my knowledge, this is not a Klarth bug. Of course, if I'm wrong about
  that, don't hesitate to let me know how to fix it.

  You can compile sawfish with gdk-pixbuf by passing --with-gdk-pixbuf to
  ./configure. Most people compile with imlib, sadly, so you're on your own.

  An alternative is to simply turn off the dots (which are off by default as
  of Klarth 1.2) - you can do so by commenting out (inserting ;; in front of)
  ,@hole-parts at or near line 630.

- windows may have buttons for impossible operations
- the shade button's icon doesn't change when the icon is shaded

  These are all bugs, but I'm not sure how to fix them. Klarth doesn't know
  whether it is possible to shade/close/maximize/minimize a window. It works
  around the maximizable one by checking if it's resizable, the rest it cannot
  do much about (unless I've missed something). It also cannot tell if a window
  is shaded or not, hence the icon doesn't change.

  Some of these functions do exist in sawfish, but are not available to themes.
  So you can theoretically get around this by breaking gaol.jl and hacking
  Klarth some, but I won't do that for a release, obviously.

- most window colors do not update when GTK colors change; or
- titlebar does not resize when font is changed

  This is the immortal bug. It just never goes away. Eventually I gave up
  trying to fix it, for now you can just restart sawfish via

  sawfish-client -f quit ; sleep 1s ; sawfish &

  or

  sawfish-client -f restart

  or switch to another theme and back again.
  (using -f restart is known to crash the gdk-pixbuf version sometimes; the
   first is safer.)

  I may or may not fix it in a later release.

Enjoy!

(C) 2001-2002 Kenny Graunke <kenny@whitecape.org>

;; theme file, written Tue May 14 20:35:47 2002
;; created by sawfish-themer -- DO NOT EDIT!

;; Studio: a simply theme for sawfish window manager
;; by giangio@work
;; 
;; Created by Gianluca Sartori <gl.sartori@tiscali.it>
;; 2002-05-10


(require 'make-theme)

(let
    ((patterns-alist
      '(("top-border"
         (inactive
          "top-caption-border.png")
         (focused
          "top-caption-border.png"))
        ("left-border"
         (inactive
          "left-border.png")
         (focused
          "left-border.png"))
        ("right-border"
         (inactive
          "right-border.png")
         (focused
          "right-border.png"))
        ("bottom-border"
         (inactive
          "bottom-border.png")
         (focused
          "bottom-border.png"))
        ("bottom-left-corner"
         (inactive
          "bottom-left-corner.png")
         (focused
          "bottom-left-corner.png"))
        ("bottom-right-corner"
         (inactive
          "bottom-right-corner.png")
         (focused
          "bottom-right-corner.png"))
        ("button-close"
         (inactive
          "button-close.png")
         (focused
          "button-close.png")
         (highlighted
          "button-close-hi.png")
         (inactive-highlighted
          "button-close-hi.png"))
        ("button-minimize"
         (inactive
          "button-min.png")
         (focused
          "button-min.png")
         (highlighted
          "button-min-hi.png")
         (inactive-highlighted
          "button-min-hi.png"))
        ("button-maximize"
         (inactive
          "button-max.png")
         (focused
          "button-max.png")
         (highlighted
          "button-max-hi.png")
         (inactive-highlighted
          "button-max-hi.png"))
        ("top-bottom-border"
         (inactive
          "top-bottom-border.png")
         (focused
          "top-bottom-border.png"))
        ("top-left-corner"
         (inactive
          "top-left-corner.png")
         (focused
          "top-left-corner.png"))
        ("top-right-corner"
         (inactive
          "top-right-corner.png")
         (focused
          "top-right-corner.png"))
        ("caption"
         (inactive . "#999899989998")
         (focused
          "caption.png"
          (tiled . t)))
        ("bottons-bg"
         (inactive . "#cccccccccccc")
         (highlighted
          "caption.png"
          (tiled . t))
         (inactive-highlighted . "#999899989998"))
        ("dlg-bottom-right-corner"
         (inactive
          "dlg-bottom-right-corner.png")
         (focused
          "dlg-bottom-right-corner.png"))
        ("caption-left"
         (inactive . "#999899989998")
         (focused
          "caption-left.png"))
        ("caption-right"
         (inactive . "#999899989998")
         (focused
          "caption-right.png"))
        ("caption-bottom"
         (inactive . "#999899989998")
         (focused . "#8ccc9709a8f5"))
        ("caption-top"
         (inactive . "#999899989998")
         (focused . "#733275c287ad"))))

     (frames-alist
      '(("default"
         ((height . 3)
          (top-edge . -17)
          (right-edge . -1)
          (left-edge . -1)
          (background . "top-border")
          (class . top-border))
         ((top-edge . -14)
          (height . 11)
          (left-edge . -1)
          (right-edge . -1)
          (background . "#cccccccccccc"))
         ((height . 3)
          (top-edge . -3)
          (left-edge . -1)
          (background . "top-bottom-border")
          (right-edge . -1))
         ((top-edge . -1)
          (background . "left-border")
          (bottom-edge . 12)
          (left-edge . -4)
          (class . left-border))
         ((left-edge . -4)
          (height . 16)
          (background . "top-left-corner")
          (top-edge . -17)
          (class . top-left-corner))
         ((background . "top-right-corner")
          (height . 16)
          (top-edge . -17)
          (right-edge . -4)
          (class . top-right-corner))
         ((background . "left-border")
          (bottom-edge . 12)
          (top-edge . -1)
          (right-edge . -4)
          (class . right-border))
         ((background . "bottom-left-corner")
          (bottom-edge . -4)
          (left-edge . -4)
          (class . bottom-left-corner))
         ((background . "bottom-right-corner")
          (bottom-edge . -4)
          (right-edge . -4)
          (class . bottom-right-corner))
         ((left-edge . 12)
          (right-edge . 12)
          (background . "bottom-border")
          (bottom-edge . -4)
          (class . bottom-border))
         ((width . 12)
          (left-edge . -1)
          (top-edge . -14)
          (height . 11)
          (background . "bottons-bg")
          (foreground . "button-close")
          (class . close-button))
         ((right-edge . 13)
          (background . "bottons-bg")
          (foreground . "button-minimize")
          (height . 11)
          (width . 12)
          (top-edge . -14)
          (class . iconify-button))
         ((right-edge . 0)
          (foreground . "button-maximize")
          (height . 11)
          (width . 12)
          (background . "bottons-bg")
          (top-edge . -14)
          (class . maximize-button))
         ((font . "-schumacher-clean-medium-r-normal-*-*-120-*-*-c-*-iso646.1991-irv")
          (height . 11)
          (top-edge . -14)
          (left-edge . 12)
          (right-edge . 26)
          (background . "caption")
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (foreground . "#ffffffffffff")
          (class . title)))
        ("shaded"
         ((height . 3)
          (top-edge . -17)
          (left-edge . -1)
          (right-edge . -1)
          (background . "top-border")
          (class . top-border))
         ((top-edge . -14)
          (height . 11)
          (left-edge . -1)
          (right-edge . -1)
          (background . "#cccccccccccc"))
         ((top-edge . -3)
          (height . 3)
          (left-edge . -1)
          (background . "top-bottom-border")
          (right-edge . -1))
         ((top-edge . -17)
          (left-edge . -4)
          (height . 16)
          (background . "top-left-corner")
          (class . top-left-corner))
         ((top-edge . -17)
          (height . 16)
          (background . "top-right-corner")
          (right-edge . -4)
          (class . top-right-corner))
         ((left-edge . -1)
          (height . 11)
          (top-edge . -14)
          (width . 12)
          (background . "bottons-bg")
          (foreground . "button-close")
          (class . close-button))
         ((right-edge . 0)
          (background . "bottons-bg")
          (foreground . "button-minimize")
          (height . 11)
          (width . 12)
          (top-edge . -14)
          (class . iconify-button))
         ((right-edge . 13)
          (font . "-schumacher-clean-medium-r-normal-*-*-120-*-*-c-*-iso646.1991-irv")
          (left-edge . 12)
          (height . 11)
          (top-edge . -14)
          (background . "caption")
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (foreground . "#ffffffffffff")
          (class . title))
         ((height . 1)
          (background . "#000000000000")
          (top-edge . -1)
          (right-edge . -3)
          (left-edge . -4)))
        ("transient"
         ((height . 3)
          (top-edge . -17)
          (right-edge . -1)
          (left-edge . -1)
          (background . "top-border"))
         ((top-edge . -14)
          (height . 11)
          (left-edge . -1)
          (right-edge . -1)
          (background . "#cccccccccccc"))
         ((height . 3)
          (top-edge . -3)
          (left-edge . -1)
          (background . "top-bottom-border")
          (right-edge . -1))
         ((top-edge . -1)
          (bottom-edge . 12)
          (left-edge . -4)
          (background . "left-border"))
         ((height . 16)
          (top-edge . -17)
          (left-edge . -4)
          (background . "top-left-corner"))
         ((right-edge . -4)
          (background . "top-right-corner")
          (height . 16)
          (top-edge . -17))
         ((top-edge . -1)
          (background . "left-border")
          (bottom-edge . 12)
          (right-edge . -4))
         ((bottom-edge . -4)
          (background . "bottom-left-corner")
          (left-edge . -4))
         ((right-edge . -4)
          (bottom-edge . -4)
          (background . "dlg-bottom-right-corner"))
         ((right-edge . 12)
          (left-edge . 12)
          (background . "bottom-border")
          (bottom-edge . -4))
         ((font . "-schumacher-clean-medium-r-normal-*-*-120-*-*-c-*-iso646.1991-irv")
          (right-edge . 0)
          (left-edge . 12)
          (height . 11)
          (top-edge . -14)
          (background . "caption")
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (foreground . "#ffffffffffff")
          (class . title))
         ((left-edge . -1)
          (foreground . "button-close")
          (background . "bottons-bg")
          (height . 11)
          (width . 12)
          (top-edge . -14)
          (class . close-button)))))

     (mapping-alist
      '((default . "default")
        (shaded . "shaded")
        (transient . "transient")
        (shaded-transient . "shaded")
        (shaped . "shaded")))

     (theme-name 'Studio))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))

;; theme file, written Tue Apr 17 17:16:27 2001
;; created by sawfish-themer -- DO NOT EDIT!
;
; This file is part of the Strap Sawfish theme.
;
; Strap is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; Strap is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this theme; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(require 'make-theme)

(let
    ((patterns-alist
      '(("Knob"
         (inactive
          "unsel:knob-up.png")
         (focused
          "knob-up.png")
         (clicked
          "knob-dn.png"))
        ("VerticalBar"
         (inactive
          "unsel:vbar.png")
         (focused
          "vbar.png"))
        ("HorizontalBar"
         (inactive
          "unsel:hbar.png")
         (focused
          "hbar.png"))
        ("TopLeft"
         (inactive
          "unsel:tl.png"
          (border
           4
           4
           0
           0))
         (focused
          "tl.png"
          (border
           4
           4
           0
           0)))
        ("Title"
         (inactive
          "unsel:title.png"
          (border
           0
           4
           0
           0))
         (focused
          "title.png"
          (border
           0
           4
           0
           0)))
        ("Close"
         (inactive
          "unsel:close-up.png")
         (focused
          "close-up.png")
         (clicked
          "close-dn.png")
         (inactive-clicked
          "unsel:close-dn.png"))
        ("Minimize"
         (inactive
          "unsel:min-up.png")
         (focused
          "min-up.png")
         (clicked
          "min-dn.png")
         (inactive-clicked
          "unsel:min-dn.png"))
        ("Maximize"
         (inactive
          "unsel:max-up.png")
         (focused
          "max-up.png")
         (clicked
          "max-dn.png")
         (inactive-clicked
          "unsel:max-dn.png"))
        ("Shade"
         (inactive
          "unsel:shade-up.png")
         (focused
          "shade-up.png")
         (clicked
          "shade-dn.png")
         (inactive-clicked
          "unsel:shade-dn.png"))
        ("Shade2"
         (inactive
          "unsel:shade2-up.png")
         (focused
          "shade2-up.png")
         (highlighted
          "shade2-up.png")
         (clicked
          "shade2-dn.png")
         (inactive-clicked
          "unsel:shade2-dn.png"))
        ("br-shade"
         (inactive
          "unsel:br-shaded.png")
         (focused
          "br-shaded.png"))))

     (frames-alist
      '(("Default"
         ((top-edge . -10)
          (right-edge . -6)
          (class . top-right-corner))
         ((background . "VerticalBar")
          (top-edge . -2)
          (right-edge . -4)
          (bottom-edge . 2)
          (class . right-border))
         ((right-edge . -6)
          (bottom-edge . -4)
          (background . "Knob")
          (class . bottom-right-corner))
         ((bottom-edge . -4)
          (left-edge . -6)
          (background . "Knob")
          (class . bottom-left-corner))
         ((left-edge . -4)
          (bottom-edge . 2)
          (top-edge . 2)
          (background . "VerticalBar")
          (class . left-border))
         ((right-edge . 2)
          (left-edge . 2)
          (bottom-edge . -2)
          (background . "HorizontalBar")
          (class . bottom-border))
         ((width . 50)
          (left-edge . -8)
          (top-edge . -12)
          (background . "TopLeft"))
         ((right-edge . -6)
          (font . "-macromedia-bazaronite-medium-r-normal-*-*-90-*-*-p-*-ascii-0")
          (top-edge . -12)
          (left-edge . 42)
          (y-justify . 1)
          (x-justify . 5)
          (text . window-name)
          (background . "Title")
          (class . title))
         ((width . 13)
          (right-edge . 2)
          (top-edge . -8)
          (class . top-border))
         ((top-edge . -9)
          (left-edge . -4)
          (background . "Close")
          (class . close-button))
         ((top-edge . -9)
          (left-edge . 8)
          (background . "Minimize")
          (class . iconify-button))
         ((left-edge . 20)
          (top-edge . -9)
          (background . "Maximize")
          (class . maximize-button))
         ((class . shade-button)
          (top-edge . -9)
          (left-edge . 32)
          (background . "Shade")))
        ("Unframed")
        ("Shaped"
         ((top-edge . -10)
          (right-edge . -6)
          (class . top-right-corner))
         ((right-edge . -3)
          (left-edge . 40)
          (top-edge . -1)
          (background . "HorizontalBar")
          (class . bottom-border))
         ((width . 50)
          (left-edge . -8)
          (top-edge . -12)
          (background . "TopLeft"))
         ((right-edge . -6)
          (font . "-macromedia-bazaronite-medium-r-normal-*-*-90-*-*-p-*-ascii-0")
          (top-edge . -12)
          (left-edge . 42)
          (y-justify . 1)
          (x-justify . 5)
          (text . window-name)
          (background . "Title")
          (class . title))
         ((width . 13)
          (right-edge . 2)
          (top-edge . -8)
          (class . top-border))
         ((top-edge . -9)
          (left-edge . -4)
          (background . "Close")
          (class . close-button))
         ((top-edge . -9)
          (left-edge . 8)
          (background . "Minimize")
          (class . iconify-button))
         ((left-edge . 20)
          (top-edge . -9)
          (background . "Maximize")
          (class . maximize-button))
         ((left-edge . 32)
          (top-edge . -9)
          (class . shade-button)
          (background . "Shade2"))
         ((right-edge . -5)
          (top-edge . -1)
          (background . "br-shade")
          (class . bottom-right-corner)))))

     (mapping-alist
      '((default . "Default")
        (transient . "Default")
        (shaped . "Shaped")
        (shaped-transient . "Default")
        (unframed . "Unframed")))

     (theme-name 'Strap))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))

;; Blackwindow 
;; A blackletter theme.
;; by Matt Chisholm http://www.theory.org/~matt/sawfish/

(let*
  (
    ;; Update window title pixel length
    (title-width
      (lambda (w)
        (let
          ((w-width (car (window-dimensions w))))
          (max 0 (min (- w-width 100) (text-width (window-name w) 
          ))))))

     (thumb-half-width
      (lambda (w)
        (/ (- (car (window-dimensions w)) (title-width w)) 2)))

     (half-width 
      (lambda (w)
        (/ (car (window-dimensions w)) 2)))

     (half-height 
      (lambda (w)
        (/ (cdr (window-dimensions w)) 2)))

        (topleft (list 
         (make-image "top-left-i.png")
         (make-image "top-left-a.png")))
	(title-r (list
	 (make-image "title-r-i.png")
	 (make-image "title-r-a.png")))
	(title-l (list
	 (make-image "title-l-i.png")
	 (make-image "title-l-a.png")))
	(title (list
	 (make-image "title-i.png")
	 (make-image "title-a.png")))
        (top (list 
         (make-image "top-i.png")
         (make-image "top-a.png")))
        (topright (list 
         (make-image "top-right-i.png")
         (make-image "top-right-a.png")))
        (right (list 
         (make-image "side-i.png")
         (make-image "side-a.png")))
        (right-d (list 
         (make-image "right-i.png")
         (make-image "right-a.png")))
        (bottomright (list 
         (make-image "bottom-right-i.png")
         (make-image "bottom-right-a.png")))
        (bottom (list 
         (make-image "bottom-i.png")
         (make-image "bottom-a.png")))
        (bottomleft (list 
         (make-image "bottom-left-i.png")
         (make-image "bottom-left-a.png")))
        (left (list 
         (make-image "side-i.png")
         (make-image "side-a.png"))) 
        (left-d (list 
         (make-image "left-i.png")
         (make-image "left-a.png"))) 

	(button-1 (list
	  (make-image "button-1-i.png")
	  (make-image "button-1-a.png")
	  (make-image "button-1-h.png")
	  (make-image "button-1-a.png")))
	(button-4 (list
	  (make-image "button-4-i.png")
	  (make-image "button-4-a.png")
	  (make-image "button-4-h.png")
	  (make-image "button-4-a.png")))
	(button-3 (list
	  (make-image "button-3-i.png")
	  (make-image "button-3-a.png")
	  (make-image "button-3-h.png")
	  (make-image "button-3-a.png")))
	(button-2 (list
	  (make-image "button-2-i.png")
	  (make-image "button-2-a.png")
	  (make-image "button-2-h.png")
	  (make-image "button-2-a.png")))

	(bottom-d (list
	  (make-image "bottom-d-i.png")
	  (make-image "bottom-d-a.png")))

	(title-r-s (list
	 (make-image "title-r-i-s.png")
	 (make-image "title-r-a-s.png")))
	(title-l-s (list
	 (make-image "title-l-i-s.png")
	 (make-image "title-l-a-s.png")))
	(title-s (list
	 (make-image "title-i.png")
	 (make-image "title-a.png")))

	;; number of pixels with which to pad the title
	(title-pad 10)

	(font-colors ( list "#2f2f2f" "#1f1f1f" "#000000" "#2f2f2f" ))
	(font-colors2 ( list "#ff0000" ))
;;	(font2 (get-font "-sharefont-blackforest-normal-r-normal-*-*-180-*-*-p-*-iso8859-1"))

       (frame `(
	;; corners
         ((class . top-left-corner)
	  (top-edge . -17)
          (left-edge . -23)
          (background . ,topleft))
         ((bottom-edge . -32)
          (left-edge . -21)
          (background . ,bottomleft)
          (class . bottom-left-corner))
         ((top-edge . -17)
          (background . ,topright)
          (right-edge . -23)
          (class . top-right-corner))
         ((right-edge . -21)
          (background . ,bottomright)
          (bottom-edge . -32)
          (class . bottom-right-corner))

	;; edges
         ((left-edge . 4)
          (right-edge . 4)
          (top-edge . -3)
          (background . ,top)
          (class . top-border))
         ((top-edge . 39)
          (bottom-edge . 15)
          (left-edge . -6)
          (background . ,left)
          (class . left-border))
         ((left-edge . 1)
          (right-edge . 1)
          (bottom-edge . -3)
          (background . ,bottom)
          (class . bottom-border))
         ((top-edge . 39)
          (right-edge . -6)
          (bottom-edge . 15)
          (background . ,right)
          (class . right-border))

	;; side decorations
	 ((class . right-border)
	  (right-edge . -10)
	  (top-edge . ,(lambda (w) (half-height w)))
	  (background . ,right-d))
	 ((class . left-border)
	  (left-edge . -10)
	  (top-edge . ,(lambda (w) (half-height w)))
	  (background . ,left-d))
	;; bottom decoration
	 ((class . bottom-border)
	  (background . ,bottom-d)
	  (bottom-edge . -19)
	  (left-edge . ,(lambda (w) (- (half-width w) 6)))
	  (right-edge . ,(lambda (w) (- (half-width w) 6))))

	;; title bookends
	 ((class . title)
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 26)))
	  (top-edge . -40)
	  (background . ,title-r))
	 ((class . title)
	  (left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 26)))
	  (top-edge . -40)
	  (background . ,title-l))

	;; title
         ((left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad)))
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad)))
          (top-edge . -33)
          (width . ,(lambda (w) (+ (title-width w) title-pad title-pad )))
          (y-justify . center)
          (x-justify . center)
          (text . ,window-name)
	  (foreground . ,font-colors)
	  (font . ,font)
          (background . ,title)
          (class . title))

	;; side buttons
	 ((class . close-button)
	  (left-edge . -16)
	  (top-edge . 4)
	  (background . ,button-1))
	 ((class . maximize-button)
	  (right-edge . -16)
	  (top-edge . 4)
	  (background . ,button-4))

	;; top buttons
	 ((class . iconify-button)
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 21)))
	  (top-edge . -21)
	  (background . ,button-3))
	 ((class . shade-button)
	  (left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 21)))
	  (top-edge . -21)
	  (background . ,button-2))
    ))

	;; title bookends
       (shaped-frame `(
	 ((class . title)
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 26)))
	  (top-edge . -40)
	  (background . ,title-r-s))
	 ((class . title)
	  (left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 26)))
	  (top-edge . -40)
	  (background . ,title-l-s))

	;; title
         (
	  (left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad)))
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad)))
          (top-edge . -33)
          (width . ,(lambda (w) (+ (title-width w) 12 )))
          (y-justify . center)
          (x-justify . center)
          (text . ,window-name)
	  (foreground . ,font-colors)
	  (font . ,font)
          (background . ,title)
          (class . title))

	;; title buttons
	 ((class . iconify-button)
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 21)))
	  (top-edge . -21)
	  (background . ,button-3))
	 ((class . shade-button)
	  (left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 21)))
	  (top-edge . -21)
	  (background . ,button-2))
    ))
)

  (add-frame-style 'Blackwindow
                   (lambda (w type)
                     (case type
                       ((default) frame)
                       ((transient) frame)
                       ((shaped) shaped-frame)
                       ((shaped-transient) shaped-frame))))

  (call-after-property-changed
   'WM_NAME (lambda ()
              (rebuild-frames-with-style 'Blackwindow))))

;; theme file, written Mon May 20 19:12:29 2002
;; created by sawfish-themer -- DO NOT EDIT!


;; lower button definition

(def-frame-class lower-button '()
    (bind-keys lower-button-keymap "Button1-Off" 'lower-window))

;; sawfish-themer stuff

(require 'make-theme)

(let
    ((patterns-alist
      '(("title2"
         (inactive
          "title2_normal.png"
          (border
           35
           5
           0
           0))
         (focused
          "title2_active.png"
          (border
           35
           5
           0
           0)))
        ("kill"
         (inactive
          "kill_normal.png")
         (focused
          "kill_active.png")
         (clicked
          "kill_clicked.png"))
        ("side_left"
         (inactive
          "side_left_normal.png"
          (border
           0
           0
           2
           2))
         (focused
          "side_left_active.png"
          (border
           0
           0
           2
           2)))
        ("side_right"
         (inactive
          "side_right.png"
          (border
           0
           0
           2
           2))
         (focused
          "side_right.png"
          (border
           0
           0
           2
           2)))
        ("bottom"
         (inactive
          "bottom.png"
          (border
           2
           2
           0
           0))
         (focused
          "bottom.png"
          (border
           2
           2
           0
           0)))
        ("bottom_left_corner"
         (inactive
          "bottom_left_corner.png")
         (focused
          "bottom_left_corner.png"))
        ("bottom_right_corner"
         (inactive
          "bottom_right_corner_normal.png")
         (focused
          "bottom_right_corner_active.png"))
        ("iconify"
         (inactive
          "iconify_normal.png")
         (focused
          "iconify_active.png")
         (clicked
          "iconify_clicked.png"))
        ("maximise"
         (inactive
          "maximise_normal.png")
         (focused
          "maximise_active.png")
         (clicked
          "maximise_clicked.png"))
        ("lower"
         (inactive
          "lower_normal.png")
         (focused
          "lower_active.png")
         (clicked
          "lower_clicked.png"))
        ("base"
         (inactive
          "base.png"
          (border
           2
           3
           2
           2))
         (focused
          "base.png"))))

     (frames-alist
      '(("default"
         ((font . "-*-infernal-bold-r-normal-*-*-120-*-*-p-*-*-*")
          (y-justify . 1)
          (x-justify . center)
          (left-edge . -5)
          (top-edge . -21)
          (right-edge . 48)
          (background . "title2")
          (text . window-name)
          (class . title))
         ((top-edge . -13)
          (left-edge . 6)
          (background . "kill")
          (foreground . "kill")
          (class . close-button))
         ((below-client . t)
          (left-edge . -5)
          (right-edge . -5)
          (top-edge . -18)
          (background . "base")
          (class . top-border))
         ((bottom-edge . 9)
          (top-edge . -17)
          (background . "side_left")
          (left-edge . -5)
          (class . left-border))
         ((bottom-edge . 9)
          (top-edge . -2)
          (background . "side_right")
          (right-edge . -5)
          (class . right-border))
         ((left-edge . 0)
          (right-edge . 0)
          (background . "bottom")
          (bottom-edge . -5)
          (class . bottom-border))
         ((left-edge . -5)
          (bottom-edge . -5)
          (background . "bottom_left_corner")
          (class . bottom-left-corner))
         ((right-edge . -5)
          (background . "bottom_right_corner")
          (bottom-edge . -5)
          (class . bottom-right-corner))
         ((background . "lower")
          (top-edge . -16)
          (right-edge . 0)
          (class . lower-button))
         ((right-edge . 16)
          (background . "maximise")
          (top-edge . -16)
          (class . maximize-button))
         ((right-edge . 32)
          (background . "iconify")
          (top-edge . -16)
          (class . iconify-button)))
        ("shaded"
         ((right-edge . 48)
          (top-edge . -21)
          (font . "-*-infernal-bold-r-normal-*-*-120-*-*-p-*-*-*")
          (y-justify . 1)
          (x-justify . center)
          (left-edge . -5)
          (background . "title2")
          (text . window-name)
          (class . title))
         ((top-edge . -13)
          (left-edge . 6)
          (background . "kill")
          (foreground . "kill")
          (class . close-button))
         ((below-client . t)
          (left-edge . -5)
          (right-edge . -5)
          (top-edge . -18)
          (background . "base")
          (class . top-border))
         ((right-edge . 0)
          (top-edge . -16)
          (background . "lower")
          (class . lower-button))
         ((right-edge . 16)
          (background . "maximise")
          (top-edge . -16)
          (class . maximize-button))
         ((right-edge . 32)
          (background . "iconify")
          (top-edge . -16)
          (class . iconify-button)))))

     (mapping-alist
      '((default . "default")
        (shaped . "shaded")
        (transient . "default")
        (shaped-transient . "shaded")))

     (theme-name 'OrangeJuice))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))

;; Anonymous/theme.jl

;; Copyright (C) 2000 Pedro Lopes (paol@teleweb.pt)

;; This theme is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; It is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.


;; configuration options

;; main options
(defgroup Anonymous "Anonymous Theme"
  :group appearance)

(defcustom anon:title-font 
  (get-font "-b&h-lucida-bold-r-normal-*-*-120-*-*-p-*-iso8859-1")
  "Font for window titles."
  :group (appearance Anonymous)
  :type font)

(defcustom anon:frame-bevel nil
  "Beveled window frame inside."
  :group (appearance Anonymous)
  :type boolean)

(defcustom anon:use-icons t
  "Use application icon for titlebar menu button."
  :group (appearance Anonymous)
  :type boolean)

(defcustom anon:texture-clear 3
  "Clear space around groove texture in titlebar."
  :group (appearance Anonymous)
  :type number
  :range (0 . 1000))

(defcustom anon:btn-unfocused-color (get-color "#C0C0C0")
  "Inactive button color."
  :group (appearance Anonymous)
  :type color)

(defcustom anon:btn-focused-color (get-color "#ACCADC")
  "Active button color."
  :group (appearance Anonymous)
  :type color)

(defcustom anon:btn-highlight-color (get-color "#CEEDFF")
  "Highlighted button color."
  :group (appearance Anonymous)
  :type color)

(defcustom anon:btn-selected-color (get-color "#EEFAFF")
  "Selected button color."
  :group (appearance Anonymous)
  :type color)

;; button options - left side
(defgroup Left-Buttons "Left Titlebar Buttons"
  :group (appearance Anonymous))
  
(defcustom anon:left-buttons `((close ,t) (\(none\) ,nil) (\(none\) ,nil) (\(none\) ,nil) (\(none\) ,nil))
  "Left Titlebar Buttons (from left to right)"
  :group (appearance Anonymous Left-Buttons)
  :type (v-and (v-and (choice \(none\) close menu maximize minimize shade sticky)
		     (boolean "Show in transients"))
	       (v-and (choice \(none\) close menu maximize minimize shade sticky)
		     (boolean "Show in transients"))
	       (v-and (choice \(none\) close menu maximize minimize shade sticky)
		     (boolean "Show in transients"))
	       (v-and (choice \(none\) close menu maximize minimize shade sticky)
		     (boolean "Show in transients"))
	       (v-and (choice \(none\) close menu maximize minimize shade sticky)
		     (boolean "Show in transients"))))
  
;; button options - right side
(defgroup Right-Buttons "Right Titlebar Buttons"
  :group (appearance Anonymous))

(defcustom anon:right-buttons `((maximize ,nil) (minimize ,nil) (sticky ,nil) (\(none\) ,nil) (\(none\) ,nil))
  "Right Titlebar Buttons (from right to left)"
  :group (appearance Anonymous Right-Buttons)
  :type (v-and (v-and (choice \(none\) close menu maximize minimize shade sticky)
		     (boolean "Show in transients"))
	       (v-and (choice \(none\) close menu maximize minimize shade sticky)
		     (boolean "Show in transients"))
	       (v-and (choice \(none\) close menu maximize minimize shade sticky)
		     (boolean "Show in transients"))
	       (v-and (choice \(none\) close menu maximize minimize shade sticky)
		     (boolean "Show in transients"))
	       (v-and (choice \(none\) close menu maximize minimize shade sticky)
		     (boolean "Show in transients"))))


;; new frame part classes

(def-frame-class sticky-button ()
  (bind-keys sticky-button-keymap "Button1-Off" 'toggle-window-sticky))

(def-frame-class shade-button ()
  (bind-keys shade-button-keymap "Button1-Off" 'toggle-window-shaded))


;;

(let*
  ( ;; *** fonts & colors ********************************************

    (title-font	(lambda () anon:title-font))

    (bg-color	(get-color "#C0C0C0"))
    (dark-color	(get-color "#8E8E8E"))

    (last-line-color (lambda ()
		       (if anon:frame-bevel dark-color bg-color)))

    (btn-color	(lambda ()
		  (list
		    anon:btn-unfocused-color
		    anon:btn-focused-color
		    anon:btn-highlight-color
		    anon:btn-selected-color)))
    
    (text-color	(list
		  (get-color "#808080")
		  (get-color "#000000")))
    
    ;; *** textures **************************************************

    ;; button backgrounds (16x16)
    (bg-btn		btn-color)

    (default-icon	(make-image "default_icon.png"))
    (bg-btn-icon	(lambda (w)
			  (let ((icon (window-icon-image w)))
			    (if (eq icon nil) default-icon icon))))

    ;; button foregrounds (12x12)
    (fg-btn-menu	(list 	(make-image "btn_menu.png")
				nil
				nil
				nil))

    (fg-btn-close	(list 	(make-image "btn_close.png")
				nil
				nil
				nil))

    (fg-btn-min		(list 	(make-image "btn_min.png")
	    			nil
				nil
	    			nil))

    (fg-btn-max		(list 	(make-image "btn_max.png")
	    			nil
				nil
	    			nil))
    (fg-btn-unmax	(list 	(make-image "btn_unmax.png")
	    			nil
				nil
	    			nil))
    (fg-btn-max-unmax	(lambda (w)
			  (if (window-maximized-p w)
			      fg-btn-unmax
			    fg-btn-max)))

    (fg-btn-shade	(list 	(make-image "btn_shade.png")
	    			nil
				nil
	    			nil))
    (fg-btn-unshade	(list 	(make-image "btn_unshade.png")
	    			nil
				nil
	    			nil))
    (fg-btn-shd-unshd	(lambda (w)
			  (if (window-get w 'shaded)
			      fg-btn-unshade
			    fg-btn-shade)))

    (fg-btn-stick	(list 	(make-image "btn_stick.png")
	    			nil
				nil
	    			nil))
    (fg-btn-unstick	(list 	(make-image "btn_unstick.png")
	    			nil
				nil
	    			nil))
    (fg-btn-stk-unstk	(lambda (w)
			  (if (window-get w 'sticky)
			      fg-btn-unstick
			    fg-btn-stick)))

    ;; titlebar
    (title-tex
      (let ((tex-img (make-image "title_texture.png")))
        (image-put tex-img 'tiled t)
        (list bg-color tex-img)))

    (title-tex-end-l	(list bg-color
			      (make-image "title_texture_end_l.png")))
			      
    (title-tex-end-r	(list bg-color
			      (make-image "title_texture_end_r.png")))

    ;; edges (4 pixel wide)
    (textures-top-edge		(make-image "top.png"))

    (textures-bottom-bev	(make-image "bottom_bevel.png"))
    (textures-bottom-nobev	(make-image "bottom.png"))
    (textures-bottom-edge	(lambda ()
				  (if anon:frame-bevel
				      textures-bottom-bev
				    textures-bottom-nobev)))
    
    (textures-left-bev		(make-image "left_bevel.png"))
    (textures-left-nobev	(make-image "left.png"))
    (textures-left-edge		(lambda ()
				  (if anon:frame-bevel
				      textures-left-bev
				    textures-left-nobev)))

    (textures-right-bev		(make-image "right_bevel.png"))
    (textures-right-nobev	(make-image "right.png"))
    (textures-right-edge	(lambda ()
				  (if anon:frame-bevel
				      textures-right-bev
				    textures-right-nobev)))

    ;; top corners (16x22, 4 pixel wide)
    (textures-tl-corner		(make-image "top_left.png"))

    (textures-tr-corner		(make-image "top_right.png"))

    ;; bottom corners (16x16, 4 pixel wide)
    (textures-bl-bev		(make-image "bottom_left_bevel.png"))
    (textures-bl-nobev		(make-image "bottom_left.png"))
    (textures-bl-corner		(lambda ()
				  (if anon:frame-bevel
				      textures-bl-bev
				    textures-bl-nobev)))

    (textures-br-bev		(make-image "bottom_right_bevel.png"))
    (textures-br-nobev		(make-image "bottom_right.png"))
    (textures-br-corner		(lambda ()
				  (if anon:frame-bevel
				      textures-br-bev
				    textures-br-nobev)))

    ;; edges for windowshade titlebar
    (title-tex-left	(make-image "title_left.png"))

    (title-tex-right	(make-image "title_right.png"))

    (title-tex-bottom	(make-image "bottom.png"))


    ;; *** dimensions ************************************************

    (tex-norm-left	nil)
    (tex-norm-right	nil)
    (tex-trans-left	nil)
    (tex-trans-right	nil)

    (texture-pos-left
      (lambda (w)
	(if (or (eq (window-type w) 'transient)
		(eq (window-type w) 'shaped-transient))
	    (+ anon:texture-clear tex-trans-left)
	  (+ anon:texture-clear tex-norm-left))))
    
    (texture-pos-right
      (lambda (w)
	(if (or (eq (window-type w) 'transient)
		(eq (window-type w) 'shaped-transient))
	    (+ anon:texture-clear tex-trans-right)
	  (+ anon:texture-clear tex-norm-right))))

    (texture-width
      (lambda (w)
	(let* ((title-width   (+ (text-width (window-name w) anon:title-font)
				 (* 2 anon:texture-clear)))
	       ;; free space after drawing buttons and window title
	       (freespace     (- (car (window-dimensions w))
				 (texture-pos-left w)
				 (texture-pos-right w)
				 title-width)))
	  (max (quotient freespace 2) 0))))

    (hide-texture-p
      (lambda (w) (<= (texture-width w) 0)))

    ;; *** normal frame **********************************************

    (normal-frame `(
	;; top border
	((class		. top-border)
	 (background	. ,textures-top-edge)
         (left-edge	. 12)
         (right-edge	. 12)
         (top-edge	. -22)
         (height	. 4))
	;; bottom border
	((class		. bottom-border)
	 (background	. ,textures-bottom-edge)
         (left-edge	. 12)
         (right-edge	. 12)
         (bottom-edge	. -4)
         (height	. 4))
	;; right border
	((class		. right-border)
	 (background	. ,textures-right-edge)
         (right-edge	. -4)
         (width		. 4)
         (top-edge	. -1)
         (bottom-edge	. 12))
	;; left border
	((class		. left-border)
	 (background	. ,textures-left-edge)
         (left-edge	. -4)
         (width		. 4)
         (top-edge	. -1)
         (bottom-edge	. 12))
	;; top-left corner
	((class		. top-left-corner)
	 (background	. ,textures-tl-corner)
         (left-edge	. -4)
         (width		. 16)
         (top-edge	. -22)
         (height	. 22))
	;; top-right corner
	((class		. top-right-corner)
	 (background	. ,textures-tr-corner)
         (right-edge	. -4)
         (width		. 16)
         (top-edge	. -22)
         (height	. 22))
	;; bottom-left corner
	((class		. bottom-left-corner)
	 (background	. ,textures-bl-corner)
         (left-edge	. -4)
         (width		. 16)
         (bottom-edge	. -4)
         (height	. 16))
	;; bottom-right corner
	((class		. bottom-right-corner)
	 (background	. ,textures-br-corner)
         (right-edge	. -4)
         (width		. 16)
         (bottom-edge	. -4)
         (height	. 16))
	;; title bar
	((class		. title)		; background
	 (background	. ,bg-color)
	 (left-edge	. 0)
	 (right-edge	. 0)
	 (top-edge	. -18)
	 (height	. 17))
	((class		. title)		; left bg texture
	 (background	. ,title-tex)
	 (left-edge	. ,texture-pos-left)
	 (width		. ,texture-width)
	 (top-edge	. -16)
	 (height	. 11))
	((class		. title)
	 (background	. ,title-tex-end-l)
	 (left-edge	. ,texture-pos-left)
	 (width		. 1)
	 (top-edge	. -16)
	 (height	. 11)
	 (hidden	. ,hide-texture-p))
	((class		. title)
	 (background	. ,title-tex-end-r)
	 (left-edge	. ,(lambda (w) (+ (texture-pos-left w) (texture-width w))))
	 (width		. 1)
	 (top-edge	. -16)
	 (height	. 11)
	 (hidden	. ,hide-texture-p))
	((class		. title)		; right bg texture
	 (background	. ,title-tex)
	 (right-edge	. ,texture-pos-right)
	 (width		. ,texture-width)
	 (top-edge	. -16)
	 (height	. 11))
	((class		. title)
	 (background	. ,title-tex-end-r)
	 (right-edge	. ,texture-pos-right)
	 (width		. 1)
	 (top-edge	. -16)
	 (height	. 11)
	 (hidden	. ,hide-texture-p))
	((class		. title)
	 (background	. ,title-tex-end-l)
	 (right-edge	. ,(lambda (w) (+ (texture-pos-right w) (texture-width w))))
	 (width		. 1)
	 (top-edge	. -16)
	 (height	. 11)
	 (hidden	. ,hide-texture-p))
	((class		. title)		; title
	 (foreground	. ,text-color)
	 (background	. ,bg-color)
	 (font		. ,title-font)
	 (text		. ,window-name)
	 (x-justify	. center)
	 (y-justify	. center)
	 (left-edge	. ,(lambda (w) (+ (texture-pos-left w) (texture-width w) 1)))
	 (right-edge	. ,(lambda (w) (+ (texture-pos-right w) (texture-width w) 1)))
	 (top-edge	. -19)
	 (height	. 18))
	((class		. title)		; lower bevel
	 (background	. ,last-line-color)
	 (left-edge	. 0)
	 (right-edge	. 0)
	 (top-edge	. -1)
	 (height	. 1))))


    ;; *** shaped & windowshade frame ********************************

    (shaped-frame `(
	;; title bar
	((class		. title)		; background
	 (background	. ,bg-color)
	 (left-edge	. 0)
	 (right-edge	. 0)
	 (top-edge	. -18)
	 (height	. 17))
	((class		. title)		; left bg texture
	 (background	. ,title-tex)
	 (left-edge	. ,texture-pos-left)
	 (width		. ,texture-width)
	 (top-edge	. -16)
	 (height	. 11))
	((class		. title)
	 (background	. ,title-tex-end-l)
	 (left-edge	. ,texture-pos-left)
	 (width		. 1)
	 (top-edge	. -16)
	 (height	. 11)
	 (hidden	. ,hide-texture-p))
	((class		. title)
	 (background	. ,title-tex-end-r)
	 (left-edge	. ,(lambda (w) (+ (texture-pos-left w) (texture-width w))))
	 (width		. 1)
	 (top-edge	. -16)
	 (height	. 11)
	 (hidden	. ,hide-texture-p))
	((class		. title)		; right bg texture
	 (background	. ,title-tex)
	 (right-edge	. ,texture-pos-right)
	 (width		. ,texture-width)
	 (top-edge	. -16)
	 (height	. 11))
	((class		. title)
	 (background	. ,title-tex-end-r)
	 (right-edge	. ,texture-pos-right)
	 (width		. 1)
	 (top-edge	. -16)
	 (height	. 11)
	 (hidden	. ,hide-texture-p))
	((class		. title)
	 (background	. ,title-tex-end-l)
	 (right-edge	. ,(lambda (w) (+ (texture-pos-right w) (texture-width w))))
	 (width		. 1)
	 (top-edge	. -16)
	 (height	. 11)
	 (hidden	. ,hide-texture-p))
	((class		. title)		; title
	 (foreground	. ,text-color)
	 (background	. ,bg-color)
	 (font		. ,title-font)
	 (text		. ,window-name)
	 (x-justify	. center)
	 (y-justify	. center)
	 (left-edge	. ,(lambda (w) (+ (texture-pos-left w) (texture-width w) 1)))
	 (right-edge	. ,(lambda (w) (+ (texture-pos-right w) (texture-width w) 1)))
	 (top-edge	. -19)
	 (height	. 18))
	((class		. title)		; top border
	 (background	. ,textures-top-edge)
	 (left-edge	. 0)
	 (right-edge	. 0)
	 (top-edge	. -22)
	 (height	. 4))
	((class		. title)		; bottom border
	 (background	. ,title-tex-bottom)
	 (left-edge	. 0)
	 (right-edge	. 0)
	 (top-edge	. -3)
	 (height	. 4))
	((class		. title)		; right border
	 (background	. ,title-tex-right)
	 (right-edge	. -4)
	 (width		. 4)
	 (top-edge	. -22)
	 (height	. 23))
	((class		. title)		; left border
	 (background	. ,title-tex-left)
	 (left-edge	. -4)
	 (width		. 4)
	 (top-edge	. -22)
	 (height	. 23))))


    ;; *** buttons ***************************************************

    (close-button
      `((class		. close-button)
	(background	. ,bg-btn)
	(top-edge	. -19)
	(foreground	. ,fg-btn-close)
	(width		. 16)
	(height		. 16)
	(removable	. t)))
    (menu-button-icon
      `((class		. menu-button)
	(background	. ,bg-btn-icon)
	(top-edge	. -19)
	(width		. 16)
	(height		. 16)
	(removable	. t)))
    (menu-button-noicon
      `((class		. menu-button)
	(background	. ,bg-btn)
	(top-edge	. -19)
	(foreground	. ,fg-btn-menu)
	(width		. 16)
	(height		. 16)
	(removable	. t)))
    (min-button
      `((class		. iconify-button)
	(background	. ,bg-btn)
	(top-edge	. -19)
	(foreground	. ,fg-btn-min)
	(width		. 16)
	(height		. 16)
	(removable	. t)))
    (max-button
      `((class		. maximize-button)
	(background	. ,bg-btn)
	(top-edge	. -19)
	(foreground	. ,fg-btn-max-unmax)
	(width		. 16)
	(height		. 16)
	(removable	. t)))
    (shade-button
      `((class		. shade-button)
	(background	. ,bg-btn)
	(top-edge	. -19)
	(foreground	. ,fg-btn-shd-unshd)
	(width		. 16)
	(height		. 16)
	(removable	. t)))
    (sticky-button
      `((class		. sticky-button)
	(background	. ,bg-btn)
	(top-edge	. -19)
	(foreground	. ,fg-btn-stk-unstk)
	(width		. 16)
	(height		. 16)
	(removable	. t)))


    ;; *** function to build the complete frames *********************

    (normal-frame-full		nil)
    (shaped-frame-full		nil)
    (trans-frame-full		nil)
    (shaped-trans-frame-full	nil)

    (create-frames
      (lambda ()
	(let* ( ; mapping from button names to definitions
		(button-alist
		  `((close	. ,close-button)
		    (menu	. ,(if anon:use-icons menu-button-icon menu-button-noicon))
		    (minimize	. ,min-button)
		    (maximize	. ,max-button)
		    (shade	. ,shade-button)
		    (sticky	. ,sticky-button)
		    (\(none\)	. ,nil)))
	
		; turns one cons cell (btn-name . show-in-transients) into a button 
		; definition, adding the button position
		(make-button
		  (lambda (is-trans btn edge pos)
		    (let ((btn-def	(cdr (assq (car btn) button-alist)))
			  (btn-in-trans (last btn)))
		      (if (or (null btn-def) (and is-trans (not btn-in-trans)))
			  nil
			(cons (cons edge pos) btn-def)))))

		; turns the list of cons cells (btn-name . show-in-transients) into 
		; a list of button definitions, adding the button positions
		(make-button-list
		  (lambda (is-trans btn-list edge pos-start pos-inc)
		    (let loop ((rest btn-list) (pos pos-start) (result ()))
			 (if (null rest)
			     result
			   (let ((new-btn (make-button is-trans (car rest) edge pos)))
			     (if (null new-btn)
				 (loop (cdr rest) pos result)
			       (loop (cdr rest) (+ pos pos-inc) (append (list new-btn) result))))))))

		(normal-buttons-l
		  (make-button-list nil anon:left-buttons  'left-edge  0 18))
		(normal-buttons-r
		  (make-button-list nil anon:right-buttons 'right-edge 0 18))

		(trans-buttons-l
		  (make-button-list t anon:left-buttons  'left-edge  0 18))
		(trans-buttons-r
		  (make-button-list t anon:right-buttons 'right-edge 0 18))
	      )

	(setq tex-norm-left  (- (* 18 (length normal-buttons-l)) 2))
	(setq tex-norm-right (- (* 18 (length normal-buttons-r)) 2))

	(setq tex-trans-left  (- (* 18 (length trans-buttons-l)) 2))
	(setq tex-trans-right (- (* 18 (length trans-buttons-r)) 2))

	(setq normal-frame-full
	  (append normal-frame normal-buttons-l normal-buttons-r))
	(setq shaped-frame-full
	  (append shaped-frame normal-buttons-l normal-buttons-r))
	(setq trans-frame-full
	  (append normal-frame trans-buttons-l trans-buttons-r))
	(setq shaped-trans-frame-full
	  (append shaped-frame trans-buttons-l trans-buttons-r)))))

    ;; *** redrawing functions ***************************************

    (redraw-one-frame
      (lambda (w)
	(if (eq (window-get w 'current-frame-style) 'Anonymous)
	    (rebuild-frame w))))

    (redraw-all-frames
      (lambda ()
	(rebuild-frames-with-style 'Anonymous)))

    (recreate-all-frames
      (lambda ()
        (create-frames)
      	(reframe-windows-with-style 'Anonymous)))

  )


  ;; create the full frames

  (create-frames)
  
  ;; frame style function now returns nil for unknow styles

  (add-frame-style 'Anonymous
    (lambda (w type)
      (case type
	((default)		normal-frame-full)
	((transient)		trans-frame-full)
	((shaped)		shaped-frame-full)
	((shaped-transient)	shaped-trans-frame-full))))

  ;; make sure frames are redrawn/recreated when necessary

  (call-after-property-changed 'WM_NAME		redraw-one-frame)
  ;; redraw on WM_HINTS to catch icon changes (at least it works for gnomecc...)
  (call-after-property-changed 'WM_HINTS	redraw-one-frame)
  (call-after-state-changed '(sticky)		redraw-one-frame)

  (custom-set-property 'anon:title-font		 ':after-set redraw-all-frames)
  (custom-set-property 'anon:frame-bevel	 ':after-set redraw-all-frames)
  (custom-set-property 'anon:texture-clear	 ':after-set redraw-all-frames)
  (custom-set-property 'anon:btn-unfocused-color ':after-set redraw-all-frames)
  (custom-set-property 'anon:btn-focused-color	 ':after-set redraw-all-frames)
  (custom-set-property 'anon:btn-highlight-color ':after-set redraw-all-frames)
  (custom-set-property 'anon:btn-selected-color	 ':after-set redraw-all-frames)

  (custom-set-property 'anon:use-icons		':after-set recreate-all-frames)
  (custom-set-property 'anon:left-buttons	':after-set recreate-all-frames)
  (custom-set-property 'anon:right-buttons	':after-set recreate-all-frames)
)

;; absolute-metal/theme.jl

;; By Andrew S. Midthune

;; This theme is heavily derived from Dr. Harper's absolute-e theme and
;; retains his copyright and the Gnu GPL license it was originally released
;; under as part of the sawfish window manager.

;; Props to John Harper for his clean and elegant code, and tigert and
;; Hallvar Helleseth for their killer graphics.

;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; sawmill is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; sawmill is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; Some of the images in this theme are by tigert, it matches the GTK theme of
;; the same name; they were originally taken from Enlightenment 0.15

;; Some of the images in this theme are from Hallvar Helleseth's
;; Absolute E theme for Enlightenment

(let*
    ((bottom-images (list (make-image "border_bottom_normal.png")
			  (make-image "border_bottom_active.png")))

     (top-images (list (make-image "border_top_normal.png")
		       (make-image "border_top_active.png")))

     (right-images (list (flip-image-diagonally
			  (copy-image (nth 0 bottom-images)))
			 (flip-image-diagonally
			  (copy-image (nth 1 bottom-images)))))

     (left-images (list (flip-image-diagonally
			 (copy-image (nth 0 top-images)))
			(flip-image-diagonally
			 (copy-image (nth 1 top-images)))))

     (top-left-images (list (make-image "corner_top_left_normal.png")
			    (make-image "corner_top_left_active.png")))

     (bottom-left-images (list (make-image "corner_bottom_left_normal.png")
			       (make-image "corner_bottom_left_active.png")))

     (top-right-images (list (make-image "corner_top_right_normal.png")
			     (make-image "corner_top_right_active.png")))

     (bottom-right-images (list (make-image "corner_bottom_right_normal.png")
				(make-image "corner_bottom_right_active.png")))

     (title-images (list (set-image-border (make-image "bar_normal.png")
					   4 4 4 4)
			 (set-image-border (make-image "bar_active.png")
					   4 4 4 4)))

     (close-images (list (set-image-border (make-image "bar_normal.png")
					   4 4 4 4)
			 (set-image-border (make-image "bar_active.png")
					   4 4 4 4)
			 (set-image-border (make-image "bar_hilited.png")
					   4 4 4 4)
			 (set-image-border (make-image "bar_clicked.png")
					   4 4 4 4)))

     (close-icons (list (make-image "close_normal.png")
			(make-image "close_active.png")))

     (frame `(((background . ,left-images)
	       (left-edge . -4)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))
	      ((background . ,right-images)
	       (right-edge . -4)
	       (top-edge . -15)
	       (bottom-edge . 0)
	       (class . right-border))
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -4)
	       (class . bottom-border))
	      ((background . ,top-right-images)
	       (right-edge . -4)
	       (top-edge . -19)
	       (class . top-right-corner))
	      ((background . ,bottom-left-images)
	       (left-edge . -4)
	       (bottom-edge . -4)
	       (class . bottom-left-corner))
	      ((background . ,bottom-right-images)
	       (right-edge . -4)
	       (bottom-edge . -4)
	       (class . bottom-right-corner))
	      ((background . ,title-images)
	       (foreground . ("grey" "white" "white" "white"))
	       (text . ,window-name)
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . 15)
	       (right-edge . 0)
	       (top-edge . -19)
	       (height . 19)
	       (class . title))
	      ((background . ,close-images)
	       (foreground . ,close-icons)
	       (x-justify . center)
	       (y-justify . center)
	       (left-edge . -4)
	       (top-edge . -19)
	       (width . 19)
	       (height . 19)
	       (class . close-button))))

     (shaped-frame `(((background . ,bottom-images)
		      (left-edge . 0)
		      (right-edge . 0)
		      (top-edge . 0)
		      (class . bottom-border))
		     ((background . ,right-images)
		      (right-edge . -4)
		      (top-edge . -19)
		      (height . 23)
		      (class . right-border))
		     ((background . ,top-right-images)
		      (right-edge . -4)
		      (top-edge . -19)
		      (class . top-right-corner))
		     ((background . ,bottom-left-images)
		      (left-edge . -4)
		      (top-edge . 0)
		      (class . bottom-left-corner))
		     ((background . ,bottom-right-images)
		      (right-edge . -4)
		      (top-edge . 0)
		      (class . bottom-right-corner))
		     ((background . ,title-images)
		      (foreground . ("grey" "white" "white" "white"))
		      (text . ,window-name)
		      (x-justify . center)
		      (y-justify . center)
		      (left-edge . 15)
		      (right-edge . 0)
		      (top-edge . -19)
		      (height . 19)
		      (class . title))
		     ((background . ,close-images)
		      (foreground . ,close-icons)
	       	      (x-justify . center)
	       	      (y-justify . center)
		      (left-edge . -4)
		      (top-edge . -19)
		      (width . 19)
		      (height . 19)
		      (class . close-button))))

     (transient-frame `(((background . ,top-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (top-edge . -4)
			 (class . title))
			((background . ,bottom-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (bottom-edge . -4)
			 (class . bottom-border))
			((background . ,left-images)
			 (left-edge . -4)
			 (top-edge . -4)
			 (bottom-edge . 0)
			 (class . left-border))
			((background . ,right-images)
			 (right-edge . -4)
			 (top-edge . -4)
			 (bottom-edge . 0)
			 (class . right-border))
			((background . ,top-left-images)
			 (left-edge . -4)
			 (top-edge . -4)
			 (class . top-left-corner))
			((background . ,top-right-images)
			 (right-edge . -4)
			 (top-edge . -4)
			 (class . top-right-corner))
			((background . ,bottom-left-images)
			 (left-edge . -4)
			 (bottom-edge . -4)
			 (class . bottom-left-corner))
			((background . ,bottom-right-images)
			 (right-edge . -4)
			 (bottom-edge . -4)
			 (class . bottom-right-corner))))

     (shaped-transient-frame `(((background . ,top-images)
				(left-edge . 0)
				(right-edge . 0)
				(top-edge . -4)
				(class . title))
			       ((background . ,top-left-images)
				(left-edge . -4)
				(top-edge . -4)
				(class . top-left-corner))
			       ((background . ,top-right-images)
				(right-edge . -4)
				(top-edge . -4)
				(class . top-right-corner)))))

  (add-frame-style 'absolute-metal
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame)))))

; 2YearsToNever: by Andrew Brehaut aka Gr1dl0ck
;
; This file is part of the 2YearsToNever Sawfish theme.
;
; 2YearsToNever is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; 2YearsToNever is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this theme; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(let*
    ;; 14x17
    ((menu-images (list (make-image "in-menu.png")
			(make-image "an-menu.png") nil
                        (make-image "ap-menu.png")))
     (shaded-menu-images (list (make-image "in-sh-menu.png")
                               (make-image "an-sh-menu.png") nil
                               (make-image "ap-sh-menu.png")))


     ;; 12x17
     (minimize-images (list (make-image "in-minimize.png")
			    (make-image "an-minimize.png") nil
                            (make-image "ap-minimize.png")))

     ;; 11x17
     (jagged-top-images (list (make-image "i-jagged-top.png")
		              (make-image "a-jagged-top.png")))

     ;; 224x17
     (title-images (make-image "title.png"))

     ;; 4x17
     (top-right-corner-image (make-image "top-right-corner.png"))
     (shaded-top-right-corner-image (make-image "sh-top-right-corner.png"))

     ;; 4x4
     (bottom-left-corner-images (make-image "bottom-left-corner.png"))
     (bottom-right-corner-images (make-image "bottom-right-corner.png"))

     ;; 4x11
     (left-join-images (list (make-image "i-left-join.png")
			     (make-image "a-left-join.png")))

     ;; 4x38
     (left-border-images (list (make-image "i-left-border.png")
			      (make-image "a-left-border.png")))

     ;; 257x4
     (bottom-border-images (make-image "bottom-border.png"))

     ;; 4x49
     (right-border-images (make-image "right-border.png"))     

     ;; frame layout 

     (frame `(((background . ,menu-images)
              (top-edge . -17)
	       (left-edge . -4)
               (class . menu-button))

	      ((background . ,minimize-images)
               (top-edge . -17)
	       (left-edge . 10)
               (class . iconify-button))

              ((background . ,jagged-top-images)
               (top-edge . -17)
	       (left-edge . 22) 
	       (class . title))

	      ((background . ,title-images)
               (foreground . "black")
               (font . "-b&h-lucidux sans-medium-r-normal-*-*-80-*-*-p-*-iso8859-11")
               (text . ,window-name)
               (x-justify . 10)
               (y-justify . center)
	       (left-edge . 33)
	       (right-edge . 0)
	       (top-edge . -17)
	       (class . title))

              ((background . ,top-right-corner-image)
	       (right-edge . -4)
	       (top-edge . -17)
	       (class . top-right-corner))

	      ((background . ,left-border-images)
	       (left-edge . -4)
	       (top-edge . 0)
	       (bottom-edge . 11)
	       (class . left-border))

	      ((background . ,left-join-images)
	       (left-edge . -4)
	       (bottom-edge . 0)
	       (class . left-border))	
	
	      ((background . ,bottom-left-corner-images)
               (bottom-edge . -4)
               (left-edge . -4)
               (class . bottom-left-corner))
                              
	      ((background . ,bottom-border-images)
	       (left-edge . 0)
               (right-edge . 0)
               (bottom-edge . -4)
               (class . bottom-border))

	      ((background . ,bottom-right-corner-images)
               (right-edge . -4)
               (bottom-edge . -4)
               (class . bottom-right-corner))

	      ((background . ,right-border-images)
               (bottom-edge . 0)
	       (top-edge . 0)
	       (right-edge . -4)
               (class . right-border))))

     (shaped-frame `(((background . ,shaded-menu-images)
              (top-edge . -17)
	       (left-edge . -4)
               (class . menu-button))

	      ((background . ,minimize-images)
               (top-edge . -17)
	       (left-edge . 10)
               (class . iconify-button))

              ((background . ,jagged-top-images)
               (top-edge . -17)
	       (left-edge . 22) 
	       (class . title))

	      ((background . ,title-images)
               (foreground . "black")
               (font . "-b&h-lucidux sans-medium-r-normal-*-*-80-*-*-p-*-iso8859-11")
               (text . ,window-name)
               (x-justify . 10)
               (y-justify . center)
	       (left-edge . 33)
	       (right-edge . 0)
	       (top-edge . -17)
	       (class . title))

              ((background . ,shaded-top-right-corner-image)
	       (right-edge . -4)
	       (top-edge . -17)
	       (class . top-right-corner)))))

 (add-frame-style '2YearsToNever
                   (lambda (w type)
                     (case type
                       ((default) frame)
                       ((transient) frame)
                       ((shaped) shaped-frame)
                       ((shaped-transient) frame)))))

;; T-16-d for the 'Sawfish' Window Manager for X
;; by Gr1dl0ck (gr1dl0ck.deviantart.com)
;; email : abrehaut@bigfoot.com
;
; This file is part of the T-16-blue Sawfish theme.
;
; T-16-blue is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; T-16-blue is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this theme; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


(let*
    ((title-width (lambda (w)
		    (let
			((w-width (car (window-dimensions w))))
		      (- (min (max (/ w-width 2) 100) w-width) 16))))
     
	;; Image Defintions (colorisations and scaling borders too) ====---     

     (top-images (mapcar (lambda (i)
			   (set-image-border i 32 8 1 1))
			 (list (make-image "top.png")
			       (make-image "top.png")
			       (make-image "top.png")
			       (make-image "top.png"))))

     (left-images (make-image "left.png"))
     (right-images (make-image "right.png"))

     (bottom-left-images (list (make-image "bottom-left.png")
			       (make-image "active-bottom-left.png")
                               (make-image "over-bottom-left.png")
                               (make-image "down-bottom-left.png")))
     (bottom-right-images (list (make-image "bottom-right.png")
				(make-image "active-bottom-right.png")
				(make-image "over-bottom-right.png")
				(make-image "down-bottom-right.png")))

     (bottom-images (set-image-border (make-image "bottom.png") 3 3 1 1))

     (title-images (mapcar (lambda (i)
                           (set-image-border i 3 3 1 1))
                         (list (make-image "title.png")
                               (make-image "active-title.png")
                               (make-image "active-title.png")
                               (make-image "active-title.png"))))

     (button-large-images (list (make-image "button-large.png")
                                (make-image "active-button-large.png")
                                (make-image "over-button-large.png")
				(make-image "down-button-large.png")))
     (button-medium-images (list (make-image "button-medium.png")
                                 (make-image "active-button-medium.png")
                                 (make-image "over-button-medium.png")
                                 (make-image "down-button-medium.png")))
     (button-small-images (make-image "button-small.png"))

     (black-image (make-image "black.png"))

	;; Frame Definitions =============---------

     (frame `(((background . ,top-images)
	       (left-edge . -8)
	       (right-edge . -5)
	       (top-edge . -30))
	      ((background . ,left-images)
	       (left-edge . -5)
	       (top-edge . 0)
	       (bottom-edge . 5)
	       (class . left-border))	
              ((background . ,right-images)
               (right-edge . -5)
               (top-edge . 0)
               (bottom-edge . 5)
	       (class . right-border)) 
              ((background . ,bottom-left-images)
               (left-edge . -5)
	       (bottom-edge . -6)
	       (class . bottom-left-corner)) 
              ((background . ,bottom-right-images)
               (right-edge . -5)
               (bottom-edge . -6)
               (class . bottom-right-corner))
	      ((background . ,bottom-images)
	       (left-edge . 17)
	       (right-edge . 17)
	       (bottom-edge . -6)
	       (class . bottom-border))

		;; Title =====------

              ((background . ,title-images)
	       (foreground . black)
               (text . ,window-name)
               (x-justify . 4)
               (y-justify . center)
               (left-edge . 25)
               (right-edge . 2)
               (top-edge . -19)
	       (class . title))

		;; buttons ====----
	      ((background . ,button-large-images)
	       (top-edge . -28)
	       (left-edge . 4)
	       (class . menu-button))
              ((background . ,button-medium-images)
               (top-edge . -13)
               (left-edge . -1)
               (class . iconify-button))
              ((background . ,button-small-images)
               (top-edge . -19)
               (left-edge . -6))
     ))

     (frame-shaped `(((background . ,top-images)
	       (left-edge . -8)
	       (right-edge . -5)
	       (top-edge . -30))

	      ((background . ,black-image)
	       (left-edge . -5)
	       (right-edge . -5)
	       (top-edge . -1)
	       (height . 2))

		;; Title =====------

              ((background . ,title-images)
	       (foreground . black)
               (text . ,window-name)
               (x-justify . 4)
               (y-justify . center)
               (left-edge . 25)
               (right-edge . 2)
               (top-edge . -19)
	       (class . title))

		;; buttons ====----
	      ((background . ,button-large-images)
	       (top-edge . -28)
	       (left-edge . 4)
	       (class . menu-button))
              ((background . ,button-medium-images)
               (top-edge . -13)
               (left-edge . -1)
               (class . iconify-button))
              ((background . ,button-small-images)
               (top-edge . -19)
               (left-edge . -6))
     ))

)

  (add-frame-style 'T-16-blue
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) frame)
		       ((shaped) frame-shaped)
		       ((shaped-transient) frame-shaped)))))

;; SawthenaForever/theme.jl
;; $Id: theme.jl,v 1.10 2001/02/11 01:33:56 jsh Exp $

;; Copyright (C) 2002 Thomas Eriksson <arne@users.sourceforge.net>
;; Copyright (C) 1999 John Harper <john@dcs.warwick.ac.uk>

;; This file were part of sawmill, I (Thomas) just did a bunch of regexp changes to 
;; make it fit my way...

;; Athena Forever is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; Athena Forever is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with Athena Forever; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(defgroup SawthenaForever "Sawthena Forever"
  :group appearance)

(defcustom SawthenaForever:normal-color nil
  "Color of inactive frames (if unset use GTK+ background color)."
  :type (optional color)
  :group (appearance SawthenaForever)
  :user-level novice
  :after-set after-setting-frame-option)

(defcustom SawthenaForever:active-color nil
  "Color of active frames (if unset use GTK+ selection color)."
  :type (optional color)
  :group (appearance SawthenaForever)
  :user-level novice
  :after-set after-setting-frame-option)

;; more color options for text colors and such

(defcustom SawthenaForever:normal-text-color nil
  "Color of inactive title text (if unset use GTK+ background color)."
  :type (optional color)
  :group (appearance SawthenaForever)
  :user-level novice
  :after-set after-setting-frame-option)

(defcustom SawthenaForever:active-text-color nil
  "Color of active title text (if unset use GTK+ selection color)."
  :type (optional color)
  :group (appearance SawthenaForever)
  :user-level novice
  :after-set after-setting-frame-option)

;; text justification


(defcustom SawthenaForever:text-justify 'left
  "Text is \\w justified in window titles."
  :type (choice left right center)
  :group (appearance SawthenaForever)
  :after-set after-setting-frame-option)

;; 16x16

(define initialised-gtk nil)

(define (rebuild)
  (when (and (or (not SawthenaForever:normal-color)
		 (not SawthenaForever:active-color)
		 (not SawthenaForever:normal-text-color)
		 (not SawthenaForever:active-text-color))
	     (not initialised-gtk))
    (setq initialised-gtk t)
    (require 'gtkrc)
    (gtkrc-call-after-changed
     (lambda () (rebuild-frames-with-style 'SawthenaForever))))
  (rebuild-frames-with-style 'SawthenaForever))

;; frame
(define (frame-colors w)
  (list (or (window-get w 'frame-inactive-color)
	    (and (not SawthenaForever:normal-text-color)
		 (car gtkrc-background))
	    SawthenaForever:normal-color)
	(or (window-get w 'frame-active-color)
	    (and (not SawthenaForever:active-text-color)
		 (nth 3 gtkrc-background))
	    SawthenaForever:active-color)))

;; text

(define (text-colors w)
  (list (or (window-get w 'frame-inactive-color)
            (and (not SawthenaForever:normal-text-color)
                 (car gtkrc-foreground))
            SawthenaForever:normal-text-color)
        (or (window-get w 'frame-active-color)
            (and (not SawthenaForever:active-text-color)
                 (nth 3 gtkrc-foreground))
            SawthenaForever:active-text-color)))




(define (text-justifier w)
  (case SawthenaForever:text-justify
    ((left) 10)
    ((right) -10)
    ((center) 'center)))

(define frame
  `(((background . ,frame-colors)
     (foreground . ,text-colors)
     (text . ,window-name)
     (x-justify . ,text-justifier)
     (y-justify . center)
     (left-edge . 0)
     (right-edge . 0)
     (top-edge . -15)
     (height . 15)
     (class . title))

    ((background . ,frame-colors)
     (left-edge . 0)
     (right-edge . 0)
     (top-edge . -17)
     (height . 2))

    ((background . ,frame-colors)
     (left-edge . -2)
     (width . 2)
     (top-edge . -17)
     (bottom-edge . -2))

    ((background . ,frame-colors)
     (right-edge . -2)
     (width . 2)
     (top-edge . -17)
     (bottom-edge . -2))


    ((background . ,frame-colors)
     (left-edge . 0)
     (right-edge . 0)
     (bottom-edge . -2)
     (height . 2))

))
(define shaped-frame
  `(((background . ,frame-colors)
     (foreground . ,text-colors)
     (text . ,window-name)
     (x-justify . ,text-justifier)
     (y-justify . center)
     (left-edge . -2)
     (right-edge . -2)
     (top-edge . -19)
     (height . 19)
     (class . title))

))


(add-frame-style 'SawthenaForever
		 (lambda (w type)
		   (case type
		     ((default) frame)
		     ((transient) frame)
		     ((shaped) shaped-frame)
		     ((shaped-transient) shaped-frame))))

(rebuild)
(custom-set-property 'SawthenaForever:normal-color ':after-set rebuild)

;; theme file, written Wed Jul  4 18:39:29 2001
;; created by sawfish-themer -- DO NOT EDIT!
;; edited despite urgent warnings by matt, to no ill effect
;;c5c655
(let*
    ;; Update window title pixel length
  (
    (title-width
      (lambda (w)
        (let
          ((w-width (car (window-dimensions w))))
          (max 0 (min (- w-width 100) (text-width (window-name w)))))))

        (bottom-left (list 
	  (make-image "bottom-left.png")
	  (make-image "bottom-left.png")))
        (bottom-right (list 
         (make-image "bottom-right.png")
         (make-image "bottom-right.png")))
        (bottom 
	 (let ((bottom-t (make-image "bottom.png")))
           (image-put bottom-t `tiled t)   	
	 (list bottom-t bottom-t)))
        (close (list
         (make-image "close-inactive.png")
         (make-image "close-active.png")
         (make-image "close-highlighted.png")
	 (make-image "close-pressed.png")))
        (left 
	 (let ((left-t (make-image "right.png")))
           (image-put left-t `tiled t)   	
	 (list left-t left-t)))
        (max (list
         (make-image "max-inactive.png")
         (make-image "max-active.png")
         (make-image "max-highlighted.png")
	 (make-image "max-pressed.png")))
        (min (list
         (make-image "min-inactive.png")
         (make-image "min-active.png")
	 (make-image "min-highlighted.png")
	 (make-image "min-pressed.png")))
        (right 
	 (let ((right-t (make-image "right.png")))
           (image-put right-t `tiled t)   	
	 (list right-t right-t)))
        (title-l (list
         (make-image "title-l.png")
         (make-image "title-l.png")))
        (title-r (list
         (make-image "title-r.png")
         (make-image "title-r.png")))
        (title 
	 (let ((title-t (make-image "title.png")))
           (image-put title-t `tiled t)   	
	 (list title-t title-t)))
        (top-right (list 
         (make-image "top-rightn.png")
         (make-image "top-rightn.png")))
        (top 
	 (let ((top-t (make-image "top.png")))
           (image-put top-t `tiled t)   	
	 (list top-t top-t)))
        (max-shaded (list 
         (make-image "max-inactive-shaded.png")
         (make-image "max-active-shaded.png")
         (make-image "max-highlighted-shaded.png")
	 (make-image "max-pressed-shaded.png")))
        (bottom-left-shaded ( list 
         (make-image "bottom-left-shaded.png")
         (make-image "bottom-left-shaded.png")))
        (bottom-shaded ( list
         (make-image "bottom-shaded.png")
         (make-image "bottom-shaded.png")))
        (title-r-shaded ( list
         (make-image "title-r-shaded.png")
         (make-image "title-r-shaded.png")))

	(font-colors ( list  "#a8a341" "#d9d552" "#d9d552" "#fff760"))

       (frame `(
         ((left-edge . 4)
          (top-edge . -31)
	  (width . ,(lambda (w) (+ (title-width w) 36)))
          (text . ,window-name)
          (class . title)
	  (foreground . ,font-colors)
          (x-justify . center)
          (y-justify . center)
	  (background . ,title))
         ((left-edge . -31)
          (top-edge . -31)
          (background . ,close)
          (class . close-button))
         ((top-edge . 22)
          (left-edge . -31)
          (background . ,min)
          (class . iconify-button))
         ((left-edge . -31)
          (top-edge . 0)
          (class . maximize-button)
          (background . ,max))
         ((top-edge . -6)
          (width . 16)
          (left-edge . ,(lambda (w) (+ (title-width w) 36)))
          (right-edge . 0)
          (class . top-border)
          (background . ,top))
         ((top-edge . 55)
          (left-edge . -6)
          (bottom-edge . 0)
          (background . ,left)
          (class . left-border))
         ((right-edge . -6)
          (top-edge . 0)
          (bottom-edge . 0)
          (class . right-border)
          (background . ,right))
         ((left-edge . 0)
          (bottom-edge . -6)
          (right-edge . 30)
          (class . bottom-border)
          (background . ,bottom))
         ((right-edge . -9)
          (top-edge . -6)
          (x-justify . left)
          (background . ,top-right)
          (class . top-right-corner))
         ((bottom-edge . -6)
          (left-edge . -6)
          (background . ,bottom-left)
          (class . bottom-left-corner))
         ((foreground . "#cccccf5b5709")
          (bottom-edge . -27)
          (right-edge . -6)
;;          (width . ,(lambda (w) (+ (title-width w) 36)))	
          (class . bottom-right-corner)
          (background . ,bottom-right))
         ((left-edge . 0)
          (top-edge . -31)
          (background . ,title-l)
          (class . title))
         ((top-edge . -31)
          (left-edge . ,(lambda (w) (+ (title-width w) 36)))
          (background . ,title-r)
          (class . title))))
       (shaped-frame `(
         ((left-edge . 4)
          (top-edge . -31)
          (width . ,(lambda (w) (+ (title-width w) 36)))
          (text . ,window-name)
          (class . title)
          (foreground . ,font-colors)
          (x-justify . center)
          (y-justify . center)
          (background . ,title))
         ((left-edge . -31)
          (top-edge . -31)
          (background . ,close)
          (class . close-button))
         ((top-edge . 0)
          (left-edge . -31)
          (class . maximize-button)
          (background . ,max-shaded))
         ((top-edge . -31)
          (left-edge . 0)
          (background . ,title-l)
          (class . title))
         ((background . ,title-r-shaded)
          (left-edge . ,(lambda (w) (+ (title-width w) 36)))
          (top-edge . -31)
          (class . title))
         ((left-edge . -29)
          (top-edge . 22)
          (class . title)
          (background . ,bottom-left-shaded))
         ((left-edge . 0)
          (top-edge . 0)
          (background . ,bottom-shaded)
          (class . title)))))

  (add-frame-style 'Hacksaw
                   (lambda (w type)
                     (case type
                       ((default) frame)
                       ((transient) frame)
                       ((shaped) shaped-frame)
                       ((shaped-transient) shaped-frame))))

  (call-after-property-changed
   'WM_NAME (lambda ()
              (rebuild-frames-with-style 'Hacksaw))))

;; Empire 
;; Copyright (C) 2001 Matt Chisholm
;; large parts of this code based on the "Crux" theme.jl file, by John Harper <jsh@eazel.com>
;; http://www.theory.org/~matt/sawfish/
#|
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(require 'sawfish.wm.util.recolor-image)

(defgroup Empire "Empire Theme"
  :group appearance)

(defcustom Empire:active-decor-color nil
  "Color of focused window decorations (if unset uses the GTK+ selection color)."
  :type (optional color)
  :group (appearance Empire)
  :user-level novice
  :after-set (lambda () (color-changed)))

(defcustom Empire:active-bgrd-color nil
  "Color of focused window backgrounds (if unset uses the GTK+ selection color)."
  :type (optional color)
  :group (appearance Empire)
  :user-level novice
  :after-set (lambda () (color-changed)))

(defcustom Empire:inactive-decor-color nil
  "Color of unfocused window decorations (if unset uses the GTK+ selection color)."
  :type (optional color)
  :group (appearance Empire)
  :user-level novice
  :after-set (lambda () (color-changed)))

(defcustom Empire:inactive-bgrd-color nil
  "Color of unfocused window backgrounds (if unset uses the GTK+ selection color)."
  :type (optional color)
  :group (appearance Empire)
  :user-level novice
  :after-set (lambda () (color-changed)))


        (define topleft1 (list
         (make-image "top-left-1-a.png")
         (make-image "top-left-1-a.png")))
        (define topleft2 (list 
         (make-image "top-left-2-a.png")
         (make-image "top-left-2-a.png")))
        (define topleft3 (list 
         (make-image "top-left-3-a.png")
         (make-image "top-left-3-a.png")))
        (define topleftresize (list 
         (make-image "top-left-resize-i.png")
         (make-image "top-left-resize-a.png")
         (make-image "top-left-resize-h.png")
         (make-image "top-left-resize-p.png")))

	(define title-r (list
	 (make-image "title-r-a.png")
	 (make-image "title-r-a.png")))
	(define title-l (list
	 (make-image "title-l-a.png")
	 (make-image "title-l-a.png")))
	(define title (list
	 (make-image "title-a.png")
	 (make-image "title-a.png")))
        (define top (list 
         (make-image "top-a.png")
         (make-image "top-a.png")))

        (define topright1 (list 
         (make-image "top-right-1-a.png")
         (make-image "top-right-1-a.png")))
        (define topright2 (list 
         (make-image "top-right-2-a.png")
         (make-image "top-right-2-a.png")))
        (define topright3 (list 
         (make-image "top-right-3-a.png")
         (make-image "top-right-3-a.png")))
        (define toprightresize (list 
         (make-image "top-right-resize-i.png")
         (make-image "top-right-resize-a.png")
         (make-image "top-right-resize-h.png")
         (make-image "top-right-resize-p.png")))

        (define right1 (list 
         (make-image "right-1-a.png")
         (make-image "right-1-a.png")))
        (define right2 (list 
         (make-image "right-2-a.png")
         (make-image "right-2-a.png")))

        (define bottomright (list 
         (make-image "bottom-right-a.png")
         (make-image "bottom-right-a.png")
         (make-image "bottom-right-h.png")
         (make-image "bottom-right-p.png")))
        (define bottom (list 
         (make-image "bottom-a.png")
         (make-image "bottom-a.png")))
        (define bottomleft (list 
         (make-image "bottom-left-a.png")
         (make-image "bottom-left-a.png")
         (make-image "bottom-left-h.png")
         (make-image "bottom-left-p.png")))

        (define left1 (list 
         (make-image "left-1-a.png")
         (make-image "left-1-a.png"))) 
        (define left2 (list 
         (make-image "left-2-a.png")
         (make-image "left-2-a.png"))) 

	(define button-1 (list
	  (make-image "big-i.png")
	  (make-image "big-a.png")
	  (make-image "big-h.png")
	  (make-image "big-p.png")))
	(define button-4 (list
	  (make-image "small-i.png")
	  (make-image "small-a.png")
	  (make-image "small-h.png")
	  (make-image "small-p.png")))
	(define button-3 (list
 	  (make-image "big-i.png")
	  (make-image "big-a.png")
	  (make-image "big-h.png")
	  (make-image "big-p.png")))
	(define button-2 (list
	  (make-image "small-i.png")
	  (make-image "small-a.png")
	  (make-image "small-h.png")
	  (make-image "small-p.png")))

	(define bottom-d (list
	  (make-image "bottom-d-a.png")
	  (make-image "bottom-d-a.png")
	  (make-image "bottom-d-h.png")
	  (make-image "bottom-d-p.png")))
	(define bottom-s (list
	  (make-image "bottom-s.png")
	  (make-image "bottom-s.png")))
	(define title-r-s (list
	 (make-image "title-r-a-s.png")
	 (make-image "title-r-a-s.png")))
	(define title-l-s (list
	 (make-image "title-l-a-s.png")
	 (make-image "title-l-a-s.png")))
	(define title-b-s (list
	 (make-image "title-b-s.png")
	 (make-image "title-b-s.png")))

        (define topright2s (list 
         (make-image "top-right-2-a-s.png")
         (make-image "top-right-2-a-s.png")))
        (define topleft2s (list 
         (make-image "top-left-2-a-s.png")
         (make-image "top-left-2-a-s.png")))


   (define title-width
      (lambda (w)
        (let
          ((w-width (car (window-dimensions w))))
          (max 0 (min (- w-width 100) (text-width (window-name w) 
          ))))))

     (define thumb-half-width
      (lambda (w)
        (/ (- (car (window-dimensions w)) (title-width w)) 2)))

     (define half-width 
      (lambda (w)
        (/ (car (window-dimensions w)) 2)))

    (define title-pad 10)

;; initialization
(define initialize-gtkrc
  (let ((done nil))
    (lambda ()
      (unless done
        (require 'gtkrc)
        ;; recolour everything when the GTK theme changes
        (gtkrc-call-after-changed color-changed)
        (setq done t)))))

;; get colors from config, fall back to gtk colors otherwise
(define (a-d-col)
  (if (colorp Empire:active-decor-color)
      Empire:active-decor-color
    (initialize-gtkrc)
    (if (colorp (nth 3 gtkrc-background))
        (nth 3 gtkrc-background)
      (get-color "steelblue"))))

(define (a-b-col)
  (if (colorp Empire:active-bgrd-color)
      Empire:active-bgrd-color
    (initialize-gtkrc)
    (if (colorp (nth 3 gtkrc-background))
        (nth 3 gtkrc-background)
      (get-color "steelblue"))))

(define (i-d-col)
  (if (colorp Empire:inactive-decor-color)
      Empire:inactive-decor-color
    (initialize-gtkrc)
    (if (colorp (nth 3 gtkrc-background))
        (nth 3 gtkrc-background)
      (get-color "steelblue"))))

(define (i-b-col)
  (if (colorp Empire:inactive-bgrd-color)
      Empire:inactive-bgrd-color
    (initialize-gtkrc)
    (if (colorp (nth 3 gtkrc-background))
        (nth 3 gtkrc-background)
      (get-color "steelblue"))))

;; font colors
;;(define font-colors ( list "#bfbfbf" "#efefef" ))
;;(define font-colors ( list i-d-col a-d-col ))
;;(define font-colors ( list Empire:inactive-decor-color Empire:active-decor-color))
;; why doesn't this change the font colors when the images are recolored?
(define (font-colors)
	(list 
  (if (colorp Empire:inactive-decor-color)
      Empire:inactive-decor-color
    (initialize-gtkrc)
    (if (colorp (nth 3 gtkrc-background))
        (nth 3 gtkrc-background)
      (get-color "steelblue")))
  (if (colorp Empire:active-decor-color)
      Empire:active-decor-color
    (initialize-gtkrc)
    (if (colorp (nth 3 gtkrc-background))
        (nth 3 gtkrc-background)
      (get-color "steelblue")))
	)
)

;; frames
       (define frame `(
	;;top edge
         ((left-edge . 8)
          (right-edge . 8)
          (top-edge . -24)
          (background . ,top)
          (class . top-border))
	;;bottom edge
         ((left-edge . -1)
          (right-edge . -1)
          (bottom-edge . -6)
          (background . ,bottom)
          (class . bottom-border))

	;; top left corner
         ((class . top-left-corner)
	  (top-edge . -13)
          (left-edge . -43)
          (background . ,topleft1))
         ((class . top-left-corner)
	  (top-edge . 52)
          (left-edge . -21)
          (background . ,topleft3))
         ((class . top-left-corner)
	  (top-edge . -24)
          (left-edge . -8)
          (background . ,topleft2))
         ((class . top-left-corner)
	  (top-edge . -22)
          (left-edge . -20)
          (background . ,topleftresize))

	;; bottom left corner
         ((bottom-edge . -12)
          (left-edge . -27)
          (background . ,bottomleft)
          (class . bottom-left-corner))

	;; top right corner
         ((top-edge . -13)
          (background . ,topright1)
          (right-edge . -43)
          (class . top-right-corner))
         ((top-edge . 52)
          (background . ,topright3)
          (right-edge . -21)
          (class . top-right-corner))
         ((top-edge . -24)
          (background . ,topright2)
          (right-edge . -8)
          (class . top-right-corner))
         ((class . top-right-corner)
	  (top-edge . -22)
          (right-edge . -20)
          (background . ,toprightresize))

	;; bottom right corner
         ((right-edge . -27)
          (background . ,bottomright)
          (bottom-edge . -12)
          (class . bottom-right-corner))

	;; left edge
         ((top-edge . 76)
          (bottom-edge . 54)
          (left-edge . -8)
          (background . ,left1)
          (class . left-border))
         ((top-edge . 76)
          (bottom-edge . 54)
          (left-edge . -12)
          (background . ,left2)
          (class . left-border))

	;; right edge
         ((top-edge . 76)
          (right-edge . -8)
          (bottom-edge . 54)
          (background . ,right1)
          (class . right-border))
         ((top-edge . 76)
          (right-edge . -12)
          (bottom-edge . 54)
          (background . ,right2)
          (class . right-border))

	;; bottom decoration
	 ((class . bottom-border)
	  (background . ,bottom-d)
	  (bottom-edge . -15)
	  (left-edge . ,(lambda (w) (- (half-width w) 23)))
	  (right-edge . ,(lambda (w) (- (half-width w) 23))))

	;; title bookends
	 ((class . title)
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 13)))
	  (top-edge . -33)
	  (background . ,title-r))
	 ((class . title)
	  (left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 13)))
	  (top-edge . -33)
	  (background . ,title-l))

	;; title
         ((left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad)))
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad)))
          (top-edge . -33)
          (width . ,(lambda (w) (+ (title-width w) title-pad title-pad )))
          (y-justify . center)
          (x-justify . center)
          (text . ,window-name)
	  (foreground . ,font-colors)
;;	  (font . ,font)
          (background . ,title)
          (class . title))

	;; big buttons
	 ((class . close-button)
	  (left-edge . -32)
	  (top-edge . -6)
	  (background . ,button-1))
	 ((class . maximize-button)
	  (right-edge . -31)
	  (top-edge . -6)
	  (background . ,button-3))

	;; small buttons
	 ((class . iconify-button)
	  (right-edge . -29)
	  (top-edge . 25)
	  (background . ,button-2))
	 ((class . menu-button)
	  (left-edge . -30)
	  (top-edge . 25)
	  (background . ,button-4))
    ))

(define shaped-frame `( 
	;; top edge
         ((left-edge . 8)
          (right-edge . 8)
          (top-edge . -24)
          (background . ,top)
          (class . title))
	;;shaded bottom
	 ((top-edge . -1)
	  (left-edge . 8)
	  (right-edge . 8)
	  (background . ,bottom-s)
	  (class . title))

	;; top right corner
         ((top-edge . -24)
          (background . ,topright2s)
          (right-edge . -8)
          (class . title))
	;; top left corner
         ((class . title)
	  (top-edge . -24)
          (left-edge . -8)
          (background . ,topleft2s))

	;; title bookends
	 ((class . title)
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 13)))
	  (top-edge . -33)
	  (background . ,title-r-s))
	 ((class . title)
	  (left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad 13)))
	  (top-edge . -33)
	  (background . ,title-l-s))
	;; title
         ((left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad)))
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad)))
          (top-edge . -33)
          (width . ,(lambda (w) (+ (title-width w) title-pad title-pad )))
          (y-justify . center)
          (x-justify . center)
          (text . ,window-name)
	  (foreground . ,font-colors)
;;	  (font . ,font)
          (background . ,title)
          (class . title))

	;; bottom shaded title
	((left-edge . ,(lambda (w) (- (thumb-half-width w) title-pad)))
	  (right-edge . ,(lambda (w) (- (thumb-half-width w) title-pad)))
	  (width . ,(lambda (w) (+ (title-width w) title-pad title-pad )))
	  (top-edge . -1)
          (background . ,title-b-s)
          (class . title))
))

;; Recolor all images that need recolouring. Precalculates the lookup
;; tables first.
(define (recolor-all)
  ;; Use the SELECTED state of the background colors as the
  ;; midpoint of the gradient for recolouring images. (This is
  ;; usually a bright, contrasting colour, and thus is the
  ;; best choice. It works particularly well with the Eazel-Foo
  ;; themes)
  (let ((recolor-a-d (make-image-recolorer (a-d-col)
                                         #:zero-channel red-channel
                                         #:index-channel green-channel))

        (recolor-a-b (make-image-recolorer (a-b-col)
                                         #:zero-channel red-channel
                                         #:index-channel green-channel))

	(recolor-i-d (make-image-recolorer (i-d-col)
                                         #:zero-channel red-channel
                                         #:index-channel green-channel))

        (recolor-i-b (make-image-recolorer (i-b-col)
                                         #:zero-channel red-channel
                                         #:index-channel green-channel)))

    (mapc (lambda (x) (mapc recolor-a-d (cdr x)))
          (list topleft1 topright1 title title-l title-r title-l-s title-r-s
		title-b-s bottomleft bottomright left1 right1 bottom-d ))

    (mapc (lambda (x) (recolor-i-d ( car x )))
          (list topleft1 topright1 title title-l title-r title-l-s title-r-s
		title-b-s bottomleft bottomright left1 right1 bottom-d ))

    (mapc (lambda (x) (mapc recolor-a-b (cdr x)))
          (list top topright2 topright3 topleft2 topleft3 
		topright2s topleft2s left2 right2 bottom bottom-s))

    (mapc (lambda (x) (recolor-i-b ( car x )))
          (list top topright2 topright3 topleft2 topleft3 
		topright2s topleft2s left2 right2 bottom bottom-s))
))


(define (reframe-all)
  (reframe-windows-with-style 'Empire))

(define (color-changed)
  (recolor-all)
  (reframe-all))

  (recolor-all)

  (add-frame-style 'Empire
                   (lambda (w type)
                     (case type
                       ((default) frame)
                       ((transient) frame)
                       ((shaped) shaped-frame)
                       ((shaped-transient) shaped-frame))))

  (call-after-property-changed
   'WM_NAME (lambda ()
              (rebuild-frames-with-style 'Empire)))

;; FinalStep/theme.jl

;; Copyright (C) 2001 Michele Campeotto <micampe@f2s.com>

;; FinalStep has been inspired by Sanity by Jason F. McBrayer and is intended
;; to be a Good Theme (tm).
;;
;; It has a Step-ish look-and-feel and is meant to replace all my previous
;; Step* themes.


;; This code comes from many themes around www.themes.org, but mainly from
;; Sanity and Klarth.
;; Thanks to Jason for the help with 


;; This theme is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public Licence as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; It is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public Licence for more details.
;;
;; You should have received a copy of the GNU General Public Licence
;; along with sawfish; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge (Our
;; Fair City), MA 02139, USA.

(require 'gradient)
(require 'sawfish.wm.util.recolor-image)

;; --- Frame preferences ------------------

(defgroup FinalStep-frame "FinalStep"
    :group appearance)

(defcustom FinalStep:the-font (get-font "-*-helvetica-bold-r-normal-*-12-*-*-*-*-*-*")
  "Titlebar font: \\w"
  :type font
  :group (appearance FinalStep-frame)
  :user-level intermediate
  :after-set (lambda () (option-changed)))

(defcustom FinalStep:button-layout 'antiplatinum
    "Titlebar buttons layout: \\w"
    :type (choice
            (default "Platinum+")
            (antiplatinum "AntiPlatinum+")
            (platinum "Mac OS 9")
            (next "NeXTStep")
            (crux "Crux")
            (twm "TWM")
            (win "MS Windows"))
    :group (appearance FinalStep-frame)
    :user-level intermediate
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:titlebar-padding 9
    "Title text padding: \\w"
    :group (appearance FinalStep-frame)
    :type number
    :user-level expert
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:resizebar-height 8
    "Resizebar size: \\w"
    :group (appearance FinalStep-frame)
    :type number
    :user-level expert
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:flat-buttons t
    "Use flat titlebar buttons"
    :group (appearance FinalStep-frame)
    :type boolean
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:title-active-color (get-color "#ffffffffffff")
    "Color of the active window title"
    :group (appearance FinalStep-frame)
    :type color
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:title-inactive-color (get-color "#404040404040")
    "Color of inactive windows titles"
    :group (appearance FinalStep-frame)
    :type color
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defgroup FinalStep-titlebar "Titlebar colors"
    :group (appearance FinalStep-frame))

(defcustom FinalStep:titlebar-gradient 'vertical
    "Gradient direction"
    :type symbol
    :options (none horizontal vertical diagonal)
    :group (appearance FinalStep-frame FinalStep-titlebar)
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:titlebar-active-color (get-color "#3d70785191ea")
    "Start color of the active window titlebar"
    :type color
    :group (appearance FinalStep-frame FinalStep-titlebar)
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:titlebar-active-color-end (get-color "#2e895ac46e14")
    "End color of the active window titlebar"
    :type color
    :group (appearance FinalStep-frame FinalStep-titlebar)
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:titlebar-inactive-color (get-color "#bfbfbfbfbfbf")
    "Start color of inactive windows titlebars"
    :type color
    :group (appearance FinalStep-frame FinalStep-titlebar)
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:titlebar-inactive-color-end (get-color "#7fff7fff7fff")
    "End color of inactive windows titlebars"
    :type color
    :group (appearance FinalStep-frame FinalStep-titlebar)
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defgroup FinalStep-resizebar "Resizebar colors"
    :group (appearance FinalStep-frame))

(defcustom FinalStep:resizebar-gradient 'vertical
    "Gradient direction"
    :type symbol
    :options (none horizontal vertical diagonal)
    :group (appearance FinalStep-frame FinalStep-resizebar)
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:resizebar-active-color (get-color "#bfbfbfbfbfbf")
    "Start color of the active window resizebar"
    :type color
    :group (appearance FinalStep-frame FinalStep-resizebar)
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:resizebar-active-color-end (get-color "#7fff7fff7fff")
    "End color of the active window resizebar"
    :type color
    :group (appearance FinalStep-frame FinalStep-resizebar)
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:resizebar-inactive-color (get-color "#bfbfbfbfbfbf")
    "Start color of inactive windows resizebars"
    :type color
    :group (appearance FinalStep-frame FinalStep-resizebar)
    :user-level beginner
    :after-set (lambda () (option-changed)))

(defcustom FinalStep:resizebar-inactive-color-end (get-color "#7fff7fff7fff")
    "End color of inactive windows resizebars"
    :type color
    :group (appearance FinalStep-frame FinalStep-resizebar)
    :user-level beginner
    :after-set (lambda () (option-changed)))

;; --- Buttons ----------------------------

(define close-images
  (list
    (make-image "close-normal.png")
    (make-image "close-normal.png")
    (make-image "close-normal.png")
    (make-image "close-clicked.png")))

(define close-flat-images
  (list
    (make-image "close-flat.png")
    (make-image "close-flat.png")
    (make-image "close-flat.png")
    (make-image "close-flat.png")))

(define minimize-images
  (list
    (make-image "minimize-normal.png")
    (make-image "minimize-normal.png")
    (make-image "minimize-normal.png")
    (make-image "minimize-clicked.png")))

(define minimize-flat-images
  (list
    (make-image "minimize-flat.png")
    (make-image "minimize-flat.png")
    (make-image "minimize-flat.png")
    (make-image "minimize-flat.png")))

(define maximize-images
  (list
    (make-image "maximize-normal.png")
    (make-image "maximize-normal.png")
    (make-image "maximize-normal.png")
    (make-image "maximize-clicked.png")))

(define maximize-flat-images
  (list
    (make-image "maximize-flat.png")
    (make-image "maximize-flat.png")
    (make-image "maximize-flat.png")
    (make-image "maximize-flat.png")))

(define unmaximize-images
  (list
    (make-image "unmaximize-normal.png")
    (make-image "unmaximize-normal.png")
    (make-image "unmaximize-normal.png")
    (make-image "unmaximize-clicked.png")))

(define unmaximize-flat-images
  (list
    (make-image "unmaximize-flat.png")
    (make-image "unmaximize-flat.png")
    (make-image "unmaximize-flat.png")
    (make-image "unmaximize-flat.png")))

(define shade-images
  (list
    (make-image "shade-normal.png")
    (make-image "shade-normal.png")
    (make-image "shade-normal.png")
    (make-image "shade-clicked.png")))

(define shade-flat-images
  (list
    (make-image "shade-flat.png")
    (make-image "shade-flat.png")
    (make-image "shade-flat.png")
    (make-image "shade-flat.png")))

(define unshade-images
  (list
    (make-image "unshade-normal.png")
    (make-image "unshade-normal.png")
    (make-image "unshade-normal.png")
    (make-image "unshade-clicked.png")))

(define unshade-flat-images
  (list
    (make-image "unshade-flat.png")
    (make-image "unshade-flat.png")
    (make-image "unshade-flat.png")
    (make-image "unshade-flat.png")))

(define resize-images
  (list
    (make-image "resize-normal.png")
    (make-image "resize-normal.png")
    (make-image "resize-normal.png")
    (make-image "resize-clicked.png")))

(define resize-flat-images
  (list
    (make-image "resize-flat.png")
    (make-image "resize-flat.png")
    (make-image "resize-flat.png")
    (make-image "resize-flat.png")))

(define menu-images
  (list
    (make-image "menu-normal.png")
    (make-image "menu-normal.png")
    (make-image "menu-normal.png")
    (make-image "menu-clicked.png")))

(define menu-flat-images
  (list
    (make-image "menu-flat.png")
    (make-image "menu-flat.png")
    (make-image "menu-flat.png")
    (make-image "menu-flat.png")))

;; --- Utilities --------------------------

(define (title-font)
  (if (fontp FinalStep:the-font)
      FinalStep:the-font
    default-font))

;    (get-font "-*-helvetica-bold-r-normal-*-12-*-*-*-*-*-*"))
;    default-font)

(define (title-colors)
  (list FinalStep:title-inactive-color
        FinalStep:title-active-color))

(define border-color
  (get-color "black"))

(define (color-active)
  FinalStep:title-active-color)

(define (color-inactive)
  FinalStep:title-inactive-color)

(define (titlebar-padding)
  FinalStep:titlebar-padding)

(define (titlebar-height) 
  (max 16 (+ (font-height (title-font)) (titlebar-padding))))

(define (resizebar-height)
  FinalStep:resizebar-height)

(define (titlebar-right-edge)
    (cond
      ((eq FinalStep:button-layout 'default)
        (* (- (titlebar-height) 2) 2))
      ((eq FinalStep:button-layout 'antiplatinum)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'platinum)
        (* (- (titlebar-height) 2) 2))
      ((eq FinalStep:button-layout 'next)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'crux)
        (* (- (titlebar-height) 2) 3))
      ((eq FinalStep:button-layout 'twm)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'win)
        (* (- (titlebar-height) 2) 3))
    ))

(define (titlebar-left-edge)
    (cond
      ((eq FinalStep:button-layout 'default)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'antiplatinum)
        (* (- (titlebar-height) 2) 2))
      ((eq FinalStep:button-layout 'platinum)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'next)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'crux)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'twm)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'win)
        (- (titlebar-height) 2))
    ))

(define (transient-titlebar-right-edge)
    (cond
      ((eq FinalStep:button-layout 'default)
        0)
      ((eq FinalStep:button-layout 'antiplatinum)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'platinum)
        0)
      ((eq FinalStep:button-layout 'next)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'crux)
        0)
      ((eq FinalStep:button-layout 'twm)
        0)
      ((eq FinalStep:button-layout 'win)
        (- (titlebar-height) 2))
    ))

(define (transient-titlebar-left-edge)
    (cond
      ((eq FinalStep:button-layout 'default)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'antiplatinum)
        0)
      ((eq FinalStep:button-layout 'platinum)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'next)
        0)
      ((eq FinalStep:button-layout 'crux)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'twm)
        (- (titlebar-height) 2))
      ((eq FinalStep:button-layout 'win)
        (- (titlebar-height) 2))
    ))

(define (titlebar-gradient)
  (case FinalStep:titlebar-gradient
    ('horizontal draw-horizontal-gradient)
    ('vertical draw-vertical-gradient)
    ('diagonal draw-diagonal-gradient)))

(define (render-titlebar img state)
  (bevel-image
    (if (eq FinalStep:titlebar-gradient 'none)
      (clear-image img
        (if (or (eq state 'focused) (eq state 'highlighted) (eq state 'clicked))
          FinalStep:titlebar-active-color
          FinalStep:titlebar-inactive-color))
      (apply (titlebar-gradient) img
        (if (or (eq state 'focused) (eq state 'highlighted) (eq state 'clicked))
            (list
              FinalStep:titlebar-active-color
              FinalStep:titlebar-active-color-end)
            (list
              FinalStep:titlebar-inactive-color
              FinalStep:titlebar-inactive-color-end))))
    1 t 50))

(define (resizebar-gradient)
  (case FinalStep:resizebar-gradient
    ('horizontal draw-horizontal-gradient)
    ('vertical draw-vertical-gradient)
    ('diagonal draw-diagonal-gradient)))

(define (render-resizebar img state)
  (bevel-image
    (if (eq FinalStep:resizebar-gradient 'none)
      (clear-image img
        (if (or (eq state 'focused) (eq state 'highlighted) (eq state 'clicked))
          FinalStep:resizebar-active-color
          FinalStep:resizebar-inactive-color))
      (apply (resizebar-gradient) img
        (if (or (eq state 'focused) (eq state 'highlighted) (eq state 'clicked))
            (list
              FinalStep:resizebar-active-color
              FinalStep:resizebar-active-color-end)
            (list
              FinalStep:resizebar-inactive-color
              FinalStep:resizebar-inactive-color-end))))
    1 t 50))

(define (render-button img state)
  (bevel-image
    (if (eq FinalStep:titlebar-gradient 'none)
      (clear-image img
        (if (or (eq state 'focused) (eq state 'highlighted) (eq state 'clicked))
          FinalStep:titlebar-active-color
          FinalStep:titlebar-inactive-color))
      (apply (titlebar-gradient) img
        (if (or (eq state 'focused) (eq state 'highlighted) (eq state 'clicked))
            (list
              FinalStep:titlebar-active-color
              FinalStep:titlebar-active-color-end)
            (list
              FinalStep:titlebar-inactive-color
              FinalStep:titlebar-inactive-color-end))))
    1 t (if (eq state 'clicked) 20 50)))
;    1 (not (eq state 'clicked)) 50))

(define (recolor-active)
  (let (
    (recolorer
      (make-image-recolorer (color-active)
                            #:zero-channel blue-channel
                            #:index-channel green-channel)))
    (mapc (lambda (x) (mapc recolorer (cdr x)))
      (list minimize-flat-images
            maximize-flat-images
            unmaximize-flat-images
            shade-flat-images
            unshade-flat-images
            resize-flat-images
            close-flat-images
            menu-flat-images))))

(define (recolor-inactive)
  (let (
    (recolorer
      (make-image-recolorer (color-inactive)
                            #:zero-channel blue-channel
                            #:index-channel green-channel)))
    (mapc (lambda (x) (recolorer (car x)))
      (list minimize-flat-images
            maximize-flat-images
            unmaximize-flat-images
            shade-flat-images
            unshade-flat-images
            resize-flat-images
            close-flat-images
            menu-flat-images))))

(define (recolor-all)
  (recolor-active)
  (recolor-inactive))

(define (reframe-all)
  (reframe-windows-with-style 'FinalStep))

(define (rebuild-all)
  (rebuild-frames-with-style 'FinalStep))

(define (option-changed)
  (recolor-all)
  (rebuild-all)
  (reframe-all))

;; --- Frame parts ------------------------

(define (titlebar-border) `(
  ((background . ,border-color)
   (left-edge . -1)
   (width . 1)
   (top-edge . ,(- (titlebar-height)))
   (height . ,(titlebar-height)))
  ((background . ,border-color)
   (right-edge . -1)
   (width . 1)
   (top-edge . ,(- (titlebar-height)))
   (height . ,(titlebar-height)))
  ((background . ,border-color)
   (right-edge . -1)
   (left-edge . -1)
   (top-edge . ,(- (titlebar-height)))
   (height . 1))
  ((background . ,border-color)
   (right-edge . -1)
   (left-edge . -1)
   (top-edge . -1)
   (height . 1))
))

(define (titlebar) `(
  ((renderer . ,render-titlebar)
   (foreground . ,title-colors)
   (font . ,title-font)
   (text . ,window-name)
   (x-justify . center)
   (y-justify . center)
   (left-edge . ,(lambda () (if FinalStep:flat-buttons (titlebar-left-edge) 0)))
   (right-edge . ,(lambda () (if FinalStep:flat-buttons (titlebar-right-edge) 0)))
   (top-edge . ,(- (- (titlebar-height) 1)))
   (height . ,(- (titlebar-height) 2))
   (class . title))
))

(define (transient-titlebar) `(
  ((renderer . ,render-titlebar)
   (foreground . ,title-colors)
   (font . ,title-font)
   (text . ,window-name)
   (x-justify . center)
   (y-justify . center)
   (left-edge . ,(lambda ()
                   (if FinalStep:flat-buttons
                       (transient-titlebar-left-edge) 0)))
   (right-edge . ,(lambda ()
                   (if FinalStep:flat-buttons
                        (transient-titlebar-right-edge) 0)))
   (top-edge . ,(- (- (titlebar-height) 1)))
   (height . ,(- (titlebar-height) 2))
   (class . title))
))

(define resizebar `(
  ((renderer . ,render-resizebar)
   (left-edge . 0)
   (width . 30)
   (bottom-edge . ,(lambda () (- (+ (resizebar-height) 1))))
;   (bottom-edge . ,(lambda (w) (if (window-maximized-p w) 0 (- (+ (resizebar-height) 1)))))
   (height . ,(lambda () (resizebar-height)))
;   (height . ,(lambda (w) (if (window-maximized-p w) 0 (resizebar-height))))
   (class . bottom-left-corner))
  ((renderer . ,render-resizebar)
   (left-edge . 30)
   (right-edge . 30)
   (bottom-edge . ,(lambda () (- (+ (resizebar-height) 1))))
   (height . ,(lambda () (resizebar-height)))
   (class . bottom-border))
  ((renderer . ,render-resizebar)
   (right-edge . -1)
   (width . 31)
   (bottom-edge . ,(lambda () (- (+ (resizebar-height) 1))))
   (height . ,(lambda () (resizebar-height)))
   (class . bottom-right-corner))
))

(define resizebar-border `(
  ((background . ,border-color)
   (right-edge . -1)
   (width . 1)
   (bottom-edge . ,(lambda () (- (+ (resizebar-height) 1))))
   (height . ,(lambda () (resizebar-height))))
  ((background . ,border-color)
   (left-edge . -1)
   (right-edge . -1)
   (bottom-edge . ,(lambda () (- (+ (resizebar-height) 1))))
   (height . 1))
  ((background . ,border-color)
   (left-edge . -1)
   (width . 1)
   (bottom-edge . ,(lambda () (- (+ (resizebar-height) 1))))
   (height . ,(lambda () (resizebar-height))))
))

(define window-border `(
  ((background . ,border-color)
   (right-edge . -1)
   (width . 1)
   (top-edge . 0)
   (bottom-edge . -1))
  ((background . ,border-color)
   (left-edge . -1)
   (width . 1)
   (top-edge . 0)
   (bottom-edge . -1))
  ((background . ,border-color)
   (left-edge . -1)
   (right-edge . -1)
   (top-edge . -1)
   (height . 1))
  ((background . ,border-color)
   (left-edge . -1)
   (right-edge . -1)
   (bottom-edge . -1)
   (height . 1))
))

;; --- Buttons -----------------------------

(define (close) `(
  (background . ,close-images)
  (removable . t)
  (width . 14)
  (height . 14)
  (top-edge . ,(- (/ (- (titlebar-height) 13) 2) (titlebar-height)))
  (class . close-button)
))

(define (close-flat) `(
  (renderer . ,render-button)
  (foreground . ,close-flat-images)
  (x-justify . center)
  (y-justify . center)
;  (removable . t)
  (width . ,(- (titlebar-height) 2))
  (height . ,(- (titlebar-height) 2))
  (top-edge . ,(+ (- (titlebar-height)) 1))
  (class . close-button)
))

(define (minimize) `(
  (background . ,minimize-images)
  (removable . t)
  (width . 14)
  (height . 14)
  (top-edge . ,(- (/ (- (titlebar-height) 13) 2) (titlebar-height)))
  (class . iconify-button)
))

(define (minimize-flat) `(
  (renderer . ,render-button)
  (foreground . ,minimize-flat-images)
  (x-justify . center)
  (y-justify . center)
;  (removable . t)
  (width . ,(- (titlebar-height) 2))
  (height . ,(- (titlebar-height) 2))
  (top-edge . ,(+ (- (titlebar-height)) 1))
  (class . iconify-button)
))

(define (maximize) `(
  (background . ,(lambda (w)
    (if (window-maximized-p w)
      unmaximize-images
      maximize-images)))
  (removable . t)
  (width . 14)
  (height . 14)
  (top-edge . ,(- (/ (- (titlebar-height) 13) 2) (titlebar-height)))
  (class . maximize-button)
))

(define (maximize-flat) `(
  (renderer . ,render-button)
  (foreground . ,(lambda (w)
    (if (window-maximized-p w)
      unmaximize-flat-images
      maximize-flat-images)))
  (x-justify . center)
  (y-justify . center)
;  (removable . t)
  (width . ,(- (titlebar-height) 2))
  (height . ,(- (titlebar-height) 2))
  (top-edge . ,(+ (- (titlebar-height)) 1))
  (class . maximize-button)
))

(define (shade) `(
  (background . ,(lambda (w)
    (if (window-get w 'shaded)
      unshade-images
      shade-images)))
  (removable . t)
  (width . 14)
  (height . 14)
  (top-edge . ,(- (/ (- (titlebar-height) 13) 2) (titlebar-height)))
  (class . shade-button)
))

(define (shade-flat) `(
  (renderer . ,render-button)
  (foreground . ,(lambda (w)
    (if (window-get w 'shaded)
      unshade-flat-images
      shade-flat-images)))
  (x-justify . center)
  (y-justify . center)
;  (removable . t)
  (width . ,(- (titlebar-height) 2))
  (height . ,(- (titlebar-height) 2))
  (top-edge . ,(+ (- (titlebar-height)) 1))
  (class . shade-button)
))

(define (resize) `(
  (background . ,resize-images)
  (removable . t)
  (width . 14)
  (height . 14)
  (top-edge . ,(- (/ (- (titlebar-height) 13) 2) (titlebar-height)))
  (class . resize-button)
))

(define (resize-flat) `(
  (renderer . ,render-button)
  (foreground . ,resize-flat-images)
  (x-justify . center)
  (y-justify . center)
;  (removable . t)
  (width . ,(- (titlebar-height) 2))
  (height . ,(- (titlebar-height) 2))
  (top-edge . ,(+ (- (titlebar-height)) 1))
  (class . resize-button)
))

(define (menu) `(
  (background . ,menu-images)
  (removable . t)
  (width . 14)
  (height . 14)
  (top-edge . ,(- (/ (- (titlebar-height) 13) 2) (titlebar-height)))
  (class . menu-button)
))

(define (menu-flat) `(
  (renderer . ,render-button)
  (foreground . ,menu-flat-images)
  (x-justify . center)
  (y-justify . center)
;  (removable . t)
  (width . ,(- (titlebar-height) 2))
  (height . ,(- (titlebar-height) 2))
  (top-edge . ,(+ (- (titlebar-height)) 1))
  (class . menu-button)
))

(define (left-buttons)
  (cond
    ((eq FinalStep:button-layout 'antiplatinum)
      (if FinalStep:flat-buttons
        (list (cons '(left-edge . 0) (minimize-flat))
              (cons `(left-edge . ,(- (titlebar-height) 2)) (maximize-flat)))
        (list (cons '(left-edge . 4) (minimize))
              (cons '(left-edge . 20) (maximize)))))
    ((eq FinalStep:button-layout 'next)
      (if FinalStep:flat-buttons
        (list (cons '(left-edge . 0) (minimize-flat)))
        (list (cons '(left-edge . 4) (minimize)))))
    ((eq FinalStep:button-layout 'twm)
      (if FinalStep:flat-buttons
        (list (cons '(left-edge . 0) (minimize-flat)))
        (list (cons '(left-edge . 4) (minimize)))))
    ((eq FinalStep:button-layout 'win)
      (if FinalStep:flat-buttons
        (list (cons '(left-edge . 0) (menu-flat)))
        (list (cons '(left-edge . 4) (menu)))))
    (t
      (if FinalStep:flat-buttons
        (list (cons '(left-edge . 0) (close-flat)))
        (list (cons '(left-edge . 4) (close)))))
  ))

(define (right-buttons)
  (cond
    ((eq FinalStep:button-layout 'antiplatinum)
      (if FinalStep:flat-buttons
        (list (cons '(right-edge . 0) (close-flat)))
        (list (cons '(right-edge . 4) (close)))))
    ((eq FinalStep:button-layout 'platinum)
      (if FinalStep:flat-buttons
        (list (cons '(right-edge . 0) (shade-flat))
              (cons `(right-edge . ,(- (titlebar-height) 2)) (maximize-flat)))
        (list (cons '(right-edge . 4) (shade))
              (cons '(right-edge . 20) (maximize)))))
    ((eq FinalStep:button-layout 'crux)
      (if FinalStep:flat-buttons
        (list (cons '(right-edge . 0) (shade-flat))
              (cons `(right-edge . ,(- (titlebar-height) 2)) (maximize-flat))
              (cons `(right-edge . ,(* (- (titlebar-height) 2) 2)) (minimize-flat)))
        (list (cons '(right-edge . 4) (shade))
              (cons '(right-edge . 20) (maximize))
              (cons '(right-edge . 36) (minimize)))))
    ((eq FinalStep:button-layout 'next)
      (if FinalStep:flat-buttons
        (list (cons '(right-edge . 0) (close-flat)))
        (list (cons '(right-edge . 4) (close)))))
    ((eq FinalStep:button-layout 'twm)
      (if FinalStep:flat-buttons
        (list (cons '(right-edge . 0) (resize-flat)))
        (list (cons '(right-edge . 4) (resize)))))
    ((eq FinalStep:button-layout 'win)
      (if FinalStep:flat-buttons
        (list (cons '(right-edge . 0) (close-flat))
              (cons `(right-edge . ,(- (titlebar-height) 2)) (maximize-flat))
              (cons `(right-edge . ,(* (- (titlebar-height) 2) 2)) (minimize-flat)))
        (list (cons '(right-edge . 4) (close))
              (cons '(right-edge . 20) (maximize))
              (cons '(right-edge . 36) (minimize)))))
    (t
      (if FinalStep:flat-buttons
        (list (cons '(right-edge . 0) (minimize-flat))
              (cons `(right-edge . ,(- (titlebar-height) 2)) (maximize-flat)))
        (list (cons '(right-edge . 4) (minimize))
              (cons '(right-edge . 20) (maximize)))))
  ))

(define (transient-left-buttons)
  (cond
    ((eq FinalStep:button-layout 'antiplatinum)
      (if FinalStep:flat-buttons ()))
    ((eq FinalStep:button-layout 'next)
      (if FinalStep:flat-buttons ()))
    ((eq FinalStep:button-layout 'twm)
      (if FinalStep:flat-buttons
        (list (cons '(left-edge . 0) (minimize-flat)))
        (list (cons '(left-edge . 4) (minimize)))))
    ((eq FinalStep:button-layout 'win)
      (if FinalStep:flat-buttons
        (list (cons '(left-edge . 0) (menu-flat)))
        (list (cons '(left-edge . 4) (menu)))))
    (t
      (if FinalStep:flat-buttons
        (list (cons '(left-edge . 0) (close-flat)))
        (list (cons '(left-edge . 4) (close)))))
  ))

(define (transient-right-buttons)
  (cond
    ((eq FinalStep:button-layout 'antiplatinum)
      (if FinalStep:flat-buttons
        (list (cons '(right-edge . 0) (close-flat)))
        (list (cons '(right-edge . 4) (close)))))
    ((eq FinalStep:button-layout 'platinum)
      (if FinalStep:flat-buttons ()))
    ((eq FinalStep:button-layout 'crux)
      (if FinalStep:flat-buttons ()))
    ((eq FinalStep:button-layout 'next)
      (if FinalStep:flat-buttons
        (list (cons '(right-edge . 0) (close-flat)))
        (list (cons '(right-edge . 4) (close)))))
    ((eq FinalStep:button-layout 'win)
      (if FinalStep:flat-buttons
        (list (cons '(right-edge . 0) (close-flat)))
        (list (cons '(right-edge . 4) (close)))))
    ((eq FinalStep:button-layout 'twm)
      (if FinalStep:flat-buttons ()))
    (t
      (if FinalStep:flat-buttons ()))
  ))

;; --- Frame definitions -------------------

(define (normal-frame) `(
  ,@(titlebar-border)
  ,@(titlebar)
  ,@(left-buttons)
  ,@(right-buttons)
  ,@window-border
  ,@resizebar
  ,@resizebar-border
))

(define (shaped-normal-frame) `(
  ,@(titlebar-border)
  ,@(titlebar)
  ,@(left-buttons)
  ,@(right-buttons)
))

(define (transient-frame) `(
  ,@(titlebar-border)
  ,@(transient-titlebar)
  ,@(transient-left-buttons)
  ,@(transient-right-buttons)
  ,@window-border
))

(define (shaped-transient-frame) `(
  ,@(titlebar-border)
  ,@(transient-titlebar)
  ,@(transient-left-buttons)
  ,@(transient-right-buttons)
))

;; --- Resize button class -----------------

(def-frame-class resize-button '((cursor . left_ptr))
  (bind-keys resize-button-keymap
    "Button1-Move" 'resize-window-interactively)
  (bind-keys resize-button-keymap
    "Button3-Off" 'popup-window-menu))

(recolor-all)
(reframe-all)
(rebuild-all)

;; --- Register frame ----------------------

(add-frame-style 'FinalStep
  (lambda (w type)
    (case type
      ((default) (normal-frame))
      ((shaped) (shaped-normal-frame))
      ((transient) (transient-frame))
      ((shaped-transient) (shaped-transient-frame)))))

;; theme file, written Mon Apr 15 21:32:21 2002
;; created by sawfish-themer -- DO NOT EDIT!

(require 'make-theme)

(let
    ((patterns-alist
      '(("border-bottom"
         (inactive
          "border-bottom.png"))
        ("border-left"
         (inactive
          "border-left.png"))
        ("border-right"
         (inactive
          "border-right.png"))
        ("icon-menu"
         (inactive
          "icon-menu.png")
         (clicked
          "icon-menu-clicked.png"))
        ("icon-close"
         (inactive
          "icon-close.png")
         (clicked
          "icon-close-clicked.png"))
        ("icon-maximize"
         (inactive
          "icon-maximize.png")
         (clicked
          "icon-maximize-clicked.png"))
        ("border-right-bottom-corner"
         (inactive
          "border-right-bottom-corner.png"))
        ("border-left-bottom-corner"
         (inactive
          "border-left-bottom-corner.png"))
        ("border-left-top-corner"
         (inactive
          "border-left-top-corner.png"))
        ("border-top"
         (inactive
          "border-top-unfocused.png")
         (focused
          "border-top.png"))
        ("border-right-top-corner"
         (inactive
          "border-right-top-corner.png"))
        ("bottom-right-corner-mod-1"
         (inactive
          "border-right-bottom-corner-mod-1.png"))
        ("border-left-bottom-shaped"
         (inactive
          "border-left-bottom-shaped.png"))
        ("border-bottom-shaped"
         (inactive
          "border-bottom-shaped.png"))
        ("border-right-bottom-shaped"
         (inactive
          "border-right-bottom-shaped.png"))))

     (frames-alist
      '(("normal"
         ((left-edge . -3)
          (right-edge . -4)
          (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-iso10646-1")
          (top-edge . -18)
          (height . 18)
          (foreground . "#ffffffffffff")
          (background . "border-top")
          (text . window-name)
          (x-justify . 16)
          (y-justify . 6)
          (class . title))
         ((left-edge . 16)
          (right-edge . 16)
          (bottom-edge . -5)
          (x-justify . center)
          (background . "border-bottom")
          (class . bottom-border))
         ((bottom-edge . 15)
          (top-edge . -1)
          (left-edge . -5)
          (background . "border-left")
          (class . left-border))
         ((bottom-edge . 15)
          (top-edge . -1)
          (right-edge . -5)
          (background . "border-right")
          (class . right-border))
         ((right-edge . -2)
          (top-edge . -18)
          (background . "icon-close")
          (class . close-button))
         ((top-edge . -18)
          (right-edge . 10)
          (background . "icon-maximize")
          (class . maximize-button))
         ((left-edge . -1)
          (top-edge . -18)
          (background . "icon-menu")
          (class . iconify-button))
         ((background . "border-right-bottom-corner")
          (right-edge . -5)
          (bottom-edge . -5)
          (class . bottom-right-corner))
         ((bottom-edge . -5)
          (left-edge . -5)
          (background . "border-left-bottom-corner")
          (class . bottom-left-corner))
         ((top-edge . -18)
          (left-edge . -5)
          (background . "border-left-top-corner")
          (class . top-left-corner))
         ((right-edge . -5)
          (top-edge . -18)
          (foreground . "border-right-top-corner")
          (background . "border-right-top-corner")
          (class . top-right-corner)))
        ("shape"
         ((text . window-name)
          (x-justify . 16)
          (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-iso10646-1")
          (right-edge . -4)
          (left-edge . -3)
          (top-edge . -18)
          (height . 18)
          (foreground . "#ffffffffffff")
          (background . "border-top")
          (y-justify . 6)
          (class . title))
         ((right-edge . -2)
          (top-edge . -18)
          (background . "icon-close")
          (class . close-button))
         ((top-edge . -18)
          (right-edge . 10)
          (background . "icon-maximize")
          (class . maximize-button))
         ((left-edge . -1)
          (top-edge . -18)
          (background . "icon-menu")
          (class . iconify-button))
         ((top-edge . -18)
          (left-edge . -5)
          (background . "border-left-top-corner")
          (class . top-left-corner))
         ((right-edge . -5)
          (top-edge . -18)
          (foreground . "border-right-top-corner")
          (background . "border-right-top-corner")
          (class . top-right-corner))
         ((top-edge . 0)
          (left-edge . -5)
          (background . "border-left-bottom-shaped")
          (class . bottom-left-corner))
         ((top-edge . 0)
          (right-edge . 0)
          (left-edge . 0)
          (background . "border-bottom-shaped")
          (class . bottom-border))
         ((background . "border-right-bottom-shaped")
          (top-edge . 0)
          (right-edge . -5)
          (class . bottom-right-corner)))))

     (mapping-alist
      '((default . "normal")
        (shaped-transient . "shape")
        (shaped . "shape")))

     (theme-name 'bluefoo))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))

;; theme file, written Mon Jul 29 16:27:49 2002
;; created by sawfish-themer -- DO NOT EDIT!

(require 'make-theme)

(let
    ((patterns-alist
      '(("titlebar"
         (inactive
          "abutton1.png"
          (border
           6
           6
           6
           6))
         (focused
          "abutton3.png"
          (border
           6
           6
           6
           6))
         (highlighted
          "abutton2.png"
          (border
           6
           6
           6
           6))
         (inactive-highlighted
          "red.png"
          (border
           7
           7
           7
           7))
         (clicked
          "blue.png"
          (border
           6
           6
           6
           6))
         (inactive-clicked
          "abutton3.png"
          (border
           6
           6
           6
           6)))
        ("border"
         (inactive . "#be0ebe0ebe0e")
         (focused . "#917391739173")
         (highlighted . "#db25c99fa391")
         (inactive-highlighted . "#b2a8b83dad12")
         (clicked . "#9022e4d88b74"))
        ("closebutton"
         (inactive
          "close_overlay.png")
         (focused
          "close_overlay.png")
         (highlighted
          "close_overlay.png")
         (inactive-highlighted
          "close_overlay.png")
         (clicked
          "close_overlay.png")
         (inactive-clicked
          "close_overlay.png"))
        ("button"
         (inactive
          "abutton1.png"
          (border
           6
           6
           6
           6))
         (focused
          "abutton1.png"
          (border
           6
           6
           6
           6))
         (highlighted
          "abutton2.png"
          (border
           6
           6
           6
           6))
         (inactive-highlighted
          "abutton2.png"
          (border
           6
           6
           6
           6))
         (clicked
          "abutton3.png"
          (border
           6
           6
           6
           6))
         (inactive-clicked
          "abutton3.png"
          (border
           6
           6
           6
           6)))
        ("iconifybutton"
         (inactive
          "iconify_overlay.png")
         (focused
          "iconify_overlay.png")
         (highlighted
          "iconify_overlay.png")
         (inactive-highlighted
          "iconify_overlay.png")
         (clicked
          "iconify_overlay.png")
         (inactive-clicked
          "iconify_overlay.png"))
        ("maximizebutton"
         (inactive
          "maximize_overlay.png")
         (focused
          "maximize_overlay.png")
         (highlighted
          "maximize_overlay.png")
         (inactive-highlighted
          "maximize_overlay.png")
         (clicked
          "maximize_overlay.png")
         (inactive-clicked
          "maximize_overlay.png"))
        ("menubutton"
         (inactive
          "menu_overlay.png")
         (focused
          "menu_overlay.png")
         (highlighted
          "menu_overlay.png")
         (inactive-highlighted
          "menu_overlay.png")
         (clicked
          "menu_overlay.png")
         (inactive-clicked
          "menu_overlay.png"))
        ("shadebutton"
         (inactive
          "shade_overlay.png")
         (focused
          "shade_overlay.png")
         (highlighted
          "shade_overlay.png")
         (inactive-highlighted
          "shade_overlay.png")
         (clicked
          "shade_overlay.png")
         (inactive-clicked
          "shade_overlay.png"))
        ("stickybutton"
         (inactive
          "sticky_overlay.png")
         (focused
          "sticky_overlay.png")
         (highlighted
          "sticky_overlay.png")
         (inactive-highlighted
          "sticky_overlay.png")
         (clicked
          "sticky_overlay.png")
         (inactive-clicked
          "sticky_overlay.png"))
        ("bg"
         (inactive
          "bg.xpm")
         (focused
          "bg.xpm")
         (highlighted
          "bg.xpm")
         (inactive-highlighted
          "bg.xpm")
         (clicked
          "bg.xpm")
         (inactive-clicked
          "bg.xpm"))
        ("unstickybutton"
         (inactive
          "unsticky_overlay.png")
         (focused
          "unsticky_overlay.png")
         (highlighted
          "unsticky_overlay.png")
         (inactive-highlighted
          "unsticky_overlay.png")
         (clicked
          "unsticky_overlay.png")
         (inactive-clicked
          "unsticky_overlay.png"))))

     (frames-alist
      '(("default"
         ((font . "-adobe-helvetica-medium-r-normal-*-*-140-*-*-p-*-iso8859-15")
          (top-edge . -23)
          (height . 20)
          (right-edge . 60)
          (left-edge . 30)
          (y-justify . center)
          (x-justify . center)
          (background . "titlebar")
          (text . window-name)
          (class . title))
         ((right-edge . 0)
          (height . 20)
          (top-edge . -23)
          (background . "button")
          (foreground . "closebutton")
          (y-justify . center)
          (x-justify . center)
          (class . close-button))
         ((foreground . "iconifybutton")
          (background . "button")
          (height . 20)
          (top-edge . -23)
          (right-edge . 30)
          (y-justify . center)
          (x-justify . center)
          (text . "-")
          (class . iconify-button))
         ((height . 2)
          (right-edge . 0)
          (top-edge . -26)
          (left-edge . 0)
          (foreground . "border")
          (background . "border")
          (class . top-border))
         ((class . left-border)
          (top-edge . -24)
          (bottom-edge . 0)
          (left-edge . -2)
          (width . 2)
          (foreground . "border")
          (background . "border"))
         ((top-edge . -24)
          (right-edge . -2)
          (bottom-edge . 0)
          (width . 2)
          (foreground . "border")
          (background . "border")
          (class . right-border))
         ((left-edge . 0)
          (right-edge . 0)
          (bottom-edge . -2)
          (height . 2)
          (foreground . "border")
          (background . "border")
          (class . bottom-border))
         ((top-edge . -26)
          (height . 2)
          (width . 2)
          (left-edge . -2)
          (background . "border")
          (class . top-left-corner))
         ((top-edge . -26)
          (background . "border")
          (height . 2)
          (width . 2)
          (right-edge . -2)
          (class . top-right-corner))
         ((background . "border")
          (height . 2)
          (width . 2)
          (bottom-edge . -2)
          (left-edge . -2)
          (class . bottom-left-corner))
         ((background . "border")
          (height . 2)
          (width . 2)
          (bottom-edge . -2)
          (right-edge . -2)
          (class . bottom-right-corner))
         ((y-justify . center)
          (x-justify . center)
          (right-edge . 15)
          (top-edge . -23)
          (height . 20)
          (foreground . "maximizebutton")
          (background . "button")
          (class . maximize-button))
         ((y-justify . center)
          (x-justify . center)
          (right-edge . 45)
          (height . 20)
          (top-edge . -23)
          (class . shade-button)
          (foreground . "shadebutton")
          (background . "button"))
         ((height . 20)
          (y-justify . center)
          (x-justify . center)
          (top-edge . -23)
          (left-edge . 0)
          (foreground . "menubutton")
          (background . "button")
          (class . menu-button))
         ((height . 25)
          (top-edge . -25)
          (right-edge . -2)
          (left-edge . -2)
          (below-client . t)
          (background . "bg")
          (class . title))
         ((y-justify . center)
          (x-justify . center)
          (foreground . "stickybutton")
          (background . "button")
          (height . 20)
          (top-edge . -23)
          (left-edge . 15)
          (class . sticky-button)))
        ("shaped"
         ((right-edge . 30)
          (left-edge . 15)
          (font . "-adobe-helvetica-medium-r-normal-*-*-140-*-*-p-*-iso8859-15")
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (background . "titlebar")
          (height . 20)
          (top-edge . -23)
          (class . title))
         ((left-edge . 0)
          (y-justify . center)
          (x-justify . center)
          (foreground . "menubutton")
          (background . "button")
          (height . 20)
          (top-edge . -23)
          (class . menu-button))
         ((right-edge . 15)
          (top-edge . -23)
          (height . 20)
          (y-justify . center)
          (x-justify . center)
          (foreground . "shadebutton")
          (background . "button")
          (class . shade-button))
         ((top-edge . -23)
          (height . 20)
          (y-justify . center)
          (x-justify . center)
          (foreground . "closebutton")
          (background . "button")
          (right-edge . 0)
          (class . close-button))
         ((height . 24)
          (top-edge . -25)
          (right-edge . -2)
          (left-edge . -2)
          (below-client . t)
          (background . "bg")
          (class . title)))))

     (mapping-alist
      '((default . "default")
        (transient . "default")
        (shaped-transient . "shaped")
        (shaped . "shaped")))

     (theme-name 'Bubbles_Exact))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))

;; theme file, written Thu Dec  6 01:47:21 2001
;; created by sawfish-themer -- DO NOT EDIT!

(require 'make-theme)

(let
    ((patterns-alist
      '(("title-colors"
         (inactive . "#8c5f8e8c9554")
         (focused . "#ffffffffffff"))
        ("left-border"
         (inactive
          "left-u.png")
         (focused
          "left.png"))
        ("right-border"
         (inactive
          "right-u.png")
         (focused
          "right.png"))
        ("bottom-border"
         (inactive
          "bottom-u.png")
         (focused
          "bottom.png"))
        ("top-border"
         (inactive
          "top-u.png")
         (focused
          "top.png"))
        ("tl"
         (inactive
          "tl-u.png")
         (focused
          "tl.png"))
        ("tr"
         (inactive
          "tr-u.png")
         (focused
          "tr.png"))
        ("bl"
         (inactive
          "bl-u.png")
         (focused
          "bl.png"))
        ("br"
         (inactive
          "br-u.png")
         (focused
          "br.png"))
        ("title"
         (inactive . "#59995c286666")
         (focused
          "title.png"))
        ("min"
         (inactive
          "min-unfocused.png")
         (focused
          "min.png"))
        ("max"
         (inactive
          "max-unfocused.png")
         (focused
          "max.png"))
        ("menu"
         (inactive
          "menu-unfocused.png")
         (focused
          "menu.png"))))

     (frames-alist
      '(("default-frame"
         ((top-edge . -17)
          (right-edge . 0)
          (y-justify . 2)
          (x-justify . 8)
          (text . window-name)
          (foreground . "title-colors")
          (left-edge . 0)
          (background . "title")
          (class . title))
         ((left-edge . -6)
          (top-edge . -15)
          (bottom-edge . 0)
          (background . "left-border")
          (class . left-border))
         ((right-edge . -6)
          (top-edge . -15)
          (bottom-edge . 0)
          (background . "right-border")
          (class . right-border))
         ((top-edge . -23)
          (right-edge . 0)
          (left-edge . 0)
          (background . "top-border")
          (class . top-border))
         ((bottom-edge . -6)
          (right-edge . 0)
          (left-edge . 0)
          (background . "bottom-border")
          (class . bottom-border))
         ((left-edge . -6)
          (top-edge . -23)
          (background . "tl")
          (class . top-left-corner))
         ((right-edge . -6)
          (background . "tr")
          (top-edge . -23)
          (class . top-right-corner))
         ((left-edge . -6)
          (bottom-edge . -6)
          (background . "bl")
          (class . bottom-left-corner))
         ((background . "br")
          (bottom-edge . -6)
          (right-edge . -6)
          (class . bottom-right-corner))
         ((top-edge . -14)
          (right-edge . 4)
          (background . "menu")
          (class . close-button))
         ((right-edge . 22)
          (top-edge . -14)
          (background . "max")
          (class . maximize-button))
         ((right-edge . 40)
          (top-edge . -14)
          (background . "min")
          (class . iconify-button)))
        ("shaded"
         ((top-edge . -17)
          (right-edge . 0)
          (y-justify . 2)
          (x-justify . 8)
          (text . window-name)
          (foreground . "title-colors")
          (left-edge . 0)
          (background . "title")
          (class . title))
         ((left-edge . 0)
          (top-edge . -23)
          (right-edge . 0)
          (background . "top-border")
          (class . top-border))
         ((top-edge . -23)
          (left-edge . -6)
          (background . "tl")
          (class . top-left-corner))
         ((top-edge . -23)
          (right-edge . -6)
          (background . "tr")
          (class . top-right-corner))
         ((top-edge . -14)
          (right-edge . 4)
          (background . "menu")
          (class . close-button)))
        ("transient"
         ((top-edge . -17)
          (right-edge . 0)
          (y-justify . 2)
          (x-justify . 8)
          (text . window-name)
          (foreground . "title-colors")
          (left-edge . 0)
          (background . "title")
          (class . title))
         ((left-edge . -6)
          (top-edge . -15)
          (bottom-edge . 0)
          (background . "left-border")
          (class . left-border))
         ((right-edge . -6)
          (top-edge . -15)
          (bottom-edge . 0)
          (background . "right-border")
          (class . right-border))
         ((top-edge . -23)
          (right-edge . 0)
          (left-edge . 0)
          (background . "top-border")
          (class . top-border))
         ((bottom-edge . -6)
          (right-edge . 0)
          (left-edge . 0)
          (background . "bottom-border")
          (class . bottom-border))
         ((left-edge . -6)
          (top-edge . -23)
          (background . "tl")
          (class . top-left-corner))
         ((right-edge . -6)
          (background . "tr")
          (top-edge . -23)
          (class . top-right-corner))
         ((left-edge . -6)
          (bottom-edge . -6)
          (background . "bl")
          (class . bottom-left-corner))
         ((background . "br")
          (bottom-edge . -6)
          (right-edge . -6)
          (class . bottom-right-corner)))
        ("shaded-transient"
         ((top-edge . -17)
          (right-edge . 0)
          (y-justify . 2)
          (x-justify . 8)
          (text . window-name)
          (foreground . "title-colors")
          (left-edge . 0)
          (background . "title")
          (class . title))
         ((top-edge . -23)
          (right-edge . 0)
          (left-edge . 0)
          (background . "top-border")
          (class . top-border))
         ((top-edge . -23)
          (left-edge . -6)
          (background . "tl")
          (class . top-left-corner))
         ((top-edge . -23)
          (right-edge . -6)
          (background . "tr")
          (class . top-right-corner)))))

     (mapping-alist
      '((default . "default-frame")
        (shaded . "shaded")
        (shaded-transient . "shaded-transient")
        (transient . "transient")))

     (theme-name 'gorilla))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))

#| Klarth sawfish theme

Copyright (C) 2001-2002 Kenny Graunke

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

$Id: theme.jl,v 2.0 2002/11/30 20:15:46 kenny Exp $

Authors: Kenny Graunke <kenny@whitecape.org>

|#

(require 'gradient)
(require 'rep.data.tables)		;need hash tables for icon cache
(require 'sawfish.wm.util.recolor-image)
(require 'sawfish.wm.util.gtkrc)

(defgroup Klarth "Klarth Theme"
          :group appearance)

(defvar Klarth:button-themes
  '((default
      ((close-button) . (maximize-button iconify-button)))
    (platinum
     ((close-button) . (maximize-button shade-button)))
    (macos-x
     ((close-button iconify-button maximize-button)))
    (windows
     ((menu-button) . (iconify-button maximize-button close-button)))
    (next
     ((iconify-button) . (close-button)))))

(defcustom Klarth:button-theme 'default
           "Display title buttons to mimic: \\w"
  ;; XXX it would be better if the choices were extracted from
  ;; XXX the above alist somehow
           :type (choice (default "Default")
                         (platinum "Mac OS 8/9")
                         (macos-x "Mac OS X")
                         (windows "MS Windows")
                         (next "NeXTSTEP"))
           :group (appearance Klarth)
           :after-set (lambda () (reframe-all)))
;; FIXME: Why is this a lambda? Can't it just be reframe-all?
;; ...because reframe-all is defined below. no other reason. :-)
;; I suppose I could fix this, if I really wanted to

;; maps WINDOW -> BUTTON-LIST
(define button-table (make-weak-table eq-hash eq))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;; Klarth Image & Color Functions

;;;; Colors

;; klarth-modify-color : color Int -> color
(define (klarth-modify-color color change)
  (define (modify-single rgorb ch)
    (max 0 (min 65535 (round (* rgorb ch)))))
  (let* ((rgb (color-rgb color))
         (r (nth 0 rgb))
         (g (nth 1 rgb))
         (b (nth 2 rgb)))
    (get-color-rgb (modify-single r change)
                   (modify-single g change)
                   (modify-single b change))))

;; klarth-bw-contrast-color-name : color -> string
(define (klarth-bw-contrast-color-name base focused)
  (define rgb (color-rgb base))
  (define (comparison n) (> (nth n rgb) 42767))
  (if (and (comparison 0) (comparison 1) (comparison 2))
      (if focused "black" "grey35") (if focused "white" "grey75")))

;; klarth-bw-contrast-color-list : color color -> (list "unfoc-col" "foc-col")
(define (klarth-bw-contrast-color-list foc-base unfoc-base)
  (list (klarth-bw-contrast-color-name unfoc-base ())
        (klarth-bw-contrast-color-name foc-base t)))

;; klarth-gtk-bg-color : symbol -> color
(define (klarth-gtk-bg-color state)
  (define (if-color num default)
    (if (colorp (nth num gtkrc-background))
        (nth num gtkrc-background)
        (get-color default)))
  (cond
   ((eq state 'selected) (if-color 3 "steelblue"))
   ((eq state 'normal) (if-color 0 "#dddddd"))))

(define klarth-hilight-color (klarth-gtk-bg-color 'selected))
(define klarth-hilight-light-color
  (klarth-modify-color klarth-hilight-color 125/100))
(define klarth-hilight-dark-color
  (klarth-modify-color klarth-hilight-color 55/100))
(define klarth-unfocused-color (klarth-gtk-bg-color 'normal))
(define klarth-unfocused-dark-color
  (klarth-modify-color klarth-unfocused-color 13/100))

;; klarth-black : boolean -> color
(define (klarth-black focused)
  (get-color (if focused "black" "grey35")))

;; klarth-black-list : boolean -> (list "unfoc" "foc")
(define (klarth-black-list focused)
  (list "grey35" "black"))

;;;; Images

;; klarth-image-height : image -> Int:0-Inf
(define (klarth-image-height img)
  (cdr (image-dimensions img)))

;; klarth-image-width : image -> Int:0-Inf
(define (klarth-image-width img)
  (car (image-dimensions img)))

;; klarth-make-transparent-sized-image : Int Int -> image
(define transparent-image (make-image "transparent-image.png"))
(define (klarth-make-transparent-sized-image width height)
  (scale-image transparent-image width height))

;; klarth-bevel-image : image Int:1-inf boolean Int:0-100 boolean -> image
;(define (klarth-bevel-image img size out opacity crisp)
;  (define tmp (copy-image img))
;  (case crisp
;    (() (define (beveller img opacity step)
;	  (bevel-image img step out opacity)
;	  (unless (< step 1) (beveller img opacity (- step 1))))
;        (beveller tmp (/ opacity size) size))
;    (t  (bevel-image tmp size out opacity)))
;  (set-image-border tmp size size size size)
;  tmp)
(define (klarth-bevel-image img size out opacity)
  (klarth-increase-image-border (bevel-image (copy-image img) size out opacity)
				size size size size))

;; klarth-composite-images : image image x y -> image
;; Composites the second image on top of the first one starting at (x,y)
;; (the origin being at the upper left corner of the first image), returns it
(define (klarth-composite-images bottom top x y)
  (define tmp (copy-image bottom))
  (composite-images tmp top x y)
  tmp)

;; klarth-greyscale-image : image -> image
;; Returns a greyscale version of an image.
(define (klarth-greyscale-image img)
  (define tmp (copy-image img))
  (image-map (lambda (pixval)
               (let* ((r (nth 0 pixval))
                      (g (nth 1 pixval))
                      (b (nth 2 pixval))
                      (a (nth 3 pixval))
                      (avg (/ (+ r g b) 3)))
                 (list avg avg avg a)))
             tmp)
  tmp)

;; klarth-draw-gradient : image symbol color color -> image
(define (klarth-draw-gradient img direction primary secondary)
  (define tmp (copy-image img))
  (case direction
    ('horizontal (draw-horizontal-gradient tmp primary secondary))
    ('vertical (draw-vertical-gradient tmp primary secondary))
    ('diagonal (draw-diagonal-gradient tmp primary secondary)))
  tmp)

;; A klarth-gradient-descriptor is:
;; 1. a color, or
;; 2. (list direction primary secondary)
;; where direction is a symbol, and primary and secondary are colors.

;; klarth-new-filled-image : Int:0-Inf Int:0-Inf klarth-gradient-descriptor
;; -> image
(define (klarth-new-filled-image width height colors)
    (if (consp colors)
	(klarth-draw-gradient (make-sized-image width height)
			      (nth 0 colors)
			      (nth 1 colors)
			      (nth 2 colors))
        (make-sized-image width height colors)))

;; klarth-scale-image-to-height : image Int:0-Inf -> image
;; Returns the image scaled to the height but preserving the same aspect ratio.
(define (klarth-scale-image-to-height img height)
  (define original-height (klarth-image-height img))
  (define original-width (klarth-image-width img))
  (define ratio (divide original-width original-height))
  (scale-image img (round (* ratio height)) height))

(define klarth-generic-window-icon (make-image "gnome-tasklist.png"))

;; klarth-window-icon: window -> image
;; Returns a scaled version of the window icon or a generic image if the window
;; doesn't have an icon.
(define (klarth-window-icon w)
  (define wicon (if (window-icon-image w)
                    (window-icon-image w)
                    klarth-generic-window-icon))
  (klarth-scale-image-to-height wicon klarth-icon-size))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;; Klarth Geometry Computations

;; klarth-window-width : window -> Int:0-Inf
(define (klarth-window-width w)
  (car (window-dimensions w)))

;; klarth-window-height : window -> Int:0-Inf
(define (klarth-window-height w)
  (cdr (window-dimensions w)))

;; klarth-window-with-decorations-width : window -> Int:0-Inf
(define (klarth-window-with-decorations-width w)
  (+ (klarth-window-width w) (if (klarth-window-resizable-p w)
				 11
			         0)))

;; klarth-absolute-left-edge : window -> Int
(define (klarth-absolute-left-edge w)
  (if (klarth-window-resizable-p w) -5 -1))

;; klarth-absolute-right-edge : window -> Int
(define (klarth-absolute-right-edge w)
  (if (klarth-window-resizable-p w) -6 -2))

;; klarth-titlebar-center : window -> Int
(define (klarth-titlebar-center w)
  (/ (klarth-window-width w) 2))

;; klarth-left-colored-hangdown-endpoint : window -> Int
(define (klarth-left-colored-hangdown-endpoint w)
  (/ (klarth-window-height w) 2))

(define klarth-font-height (font-height default-font))

(define klarth-icon-size klarth-font-height)

;; Do not set this below 1, or else the icon will get whacked off on top
(define klarth-titlearea-padding 1)

(define klarth-titlearea-bevel-size 1)

(define klarth-titlearea-height
  (+ klarth-font-height (* 2 klarth-titlearea-padding)
     (* 2 klarth-titlearea-bevel-size)))

(define klarth-titlearea-top-edge (- -1 klarth-titlearea-height))

(define klarth-titlebar-height (+ 2 klarth-titlearea-height))

;; klarth-titlebar-width : window -> Int
(define (klarth-titlebar-width w) (+ 5 6 (klarth-window-width w)))

(define klarth-titlebar-top-edge (* -1 klarth-titlebar-height))

;; klarth-left-buttonbox-width : window -> Int
(define (klarth-left-buttonbox-width w)
  (let ((nbuttons (length (car (table-ref button-table w)))))
    (+ 1 (* nbuttons klarth-titlearea-height) nbuttons)))

;; klarth-right-buttonbox-width : window -> Int
(define (klarth-right-buttonbox-width w)
  (let ((nbuttons (length (cdr (table-ref button-table w)))))
    (+ 1 (* nbuttons klarth-titlearea-height) nbuttons)))

;; klarth-titlearea-width : window -> Int
(define (klarth-titlearea-width w)
  ;(- (+ 5 (klarth-window-width w) 6)
  (- (klarth-window-with-decorations-width w)
     (klarth-left-buttonbox-width w)
     (klarth-right-buttonbox-width w)))

;; klarth-titlearea-left-edge : window -> Int
(define (klarth-titlearea-left-edge w)
  (+ (klarth-absolute-left-edge w)
     (klarth-left-buttonbox-width w)))

;; klarth-titlearea-right-edge : window -> Int
(define (klarth-titlearea-right-edge w)
  (+ (klarth-absolute-right-edge w) 1
     (klarth-right-buttonbox-width w)))

;; klarth-titlearea-center : window -> Int
(define (klarth-titlearea-center w)
  (+ (klarth-titlearea-left-edge w) (/ (klarth-titlearea-width w) 2)))

;; klarth-icon-left-edge : window -> Int
(define (klarth-icon-left-edge w)
  (max (+ klarth-titlearea-padding klarth-titlearea-bevel-size
	  (klarth-titlearea-left-edge w))
       (- (klarth-titlearea-center w)
	  (/ (+ (text-width (window-name w))
		(klarth-image-width (klarth-window-icon w))
		(klarth-em 1/2)) 2))))
;  (define C (klarth-titlebar-center w))
;  (define s (text-width " "))
;  (define i (klarth-image-width (klarth-window-icon w)))
;  (define tx (text-width (window-name w)))
;  (define pure-centered (- C (/ tx 2) s (/ i 2)))

;; klarth-titletext-left-edge : window -> Int
(define (klarth-titletext-left-edge w)
  (+ (klarth-icon-left-edge w)
     (klarth-image-width (klarth-window-icon w))
     (klarth-em 1/2)))
;(define (klarth-titletext-left-edge w)
;  (- (klarth-titlearea-center w)
;     (/ (text-width (window-name w)) 2)))
;(define (klarth-titletext-left-edge w)
;  (let* ((icon-width (klarth-image-width (klarth-window-icon w))))
;    (max (+ (klarth-titlearea-left-edge w)
;	    klarth-titlearea-bevel-size klarth-titlearea-padding
;	    icon-width klarth-titlearea-padding)
;	 (+ (klarth-titlearea-center w)
;	    (/ (+ (* -1 (text-width (window-name w)))
;		  icon-width (klarth-em 1/2)) 2)))))

;; klarth-titletext-left-edge : window -> Int
;(define (klarth-titletext-left-edge w)
;  (let ((space-width (text-width " "))
;	(icon-width (klarth-image-width (klarth-window-icon w))))
;    (max (+ klarth-titlearea-padding klarth-titlearea-bevel-size
;	    (klarth-titlearea-left-edge w) icon-width space-width)
;	 (+ (- (klarth-titlebar-center w)
;	       (/ (text-width (window-name w)) 2))
;	    space-width (/ icon-width 2)))))

;; klarth-titletext-x-justify : window -> Int
(define (klarth-titletext-x-justify w)
  (- (klarth-titletext-left-edge w) (klarth-titlearea-left-edge w)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;; Klarth Utility Functions

;; klarth-window-maximized-both-p : window -> boolean
(define (klarth-window-maximized-both-p w)
  (and (window-maximized-horizontally-p w) (window-maximized-vertically-p w)))

;; klarth-window-resizable-p : window -> boolean
(define (klarth-window-resizable-p w)
  (let* ((size-hints (window-size-hints w))
	 (max-width-item (assoc 'max-width size-hints))
	 (min-width-item (assoc 'min-width size-hints)))
    (not (and max-width-item min-width-item
	      (= (cdr max-width-item) (cdr min-width-item))))))

;; klarth-increase-image-border : image num num num num -> image
(define (klarth-increase-image-border img a b c d)
  (let ((ib (image-border img))
        (addto (lambda (n lst val) (+ (nth n lst) val))))
    (set-image-border img (addto 0 ib a) (addto 1 ib b)
                      (addto 2 ib c) (addto 3 ib d))))

;; klarth-em : number -> number
(define (klarth-em n)
  (round (* n klarth-font-height)))

;; klarth-round-to-lower-multiple-of : number number -> number
(define (klarth-round-to-lower-multiple-of n by)
  (* (truncate (divide n by)) by))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;; Klarth Renderers, Choppers, Etc.

;; klarth-render-titlearea-bgpart : boolean
;; -> (list image image image image) or (list image image)
;; remember: background . (NORMAL FOCUSED HIGHLIGHTED CLICKED)
(define (klarth-render-titlearea-bgpart extra)
  (define (renderer out primod secmod)
    (klarth-bevel-image
     (klarth-new-filled-image klarth-titlearea-height klarth-titlearea-height
			    (list 'vertical
				  (klarth-modify-color
				   klarth-hilight-color primod)
				  (klarth-modify-color
				   klarth-hilight-color secmod)))
     klarth-titlearea-bevel-size out 45))
  (list
   (klarth-new-filled-image klarth-titlearea-height klarth-titlearea-height
			     klarth-unfocused-color)
   (klarth-increase-image-border (renderer t 129/100 51/100) 1 1 1 1) ; FIXME 
   (if extra (renderer t  159/100 81/100))
   (if extra (renderer () 51/100 129/100))))

;; klarth-render-resizer-bgpart : symbol symbol
(define (klarth-render-resizer-bgpart position gtk-col)
  (case position
    ((left)   (define b-width 5)   (define b-height 100)
              (define f-width 3)   (define f-height 100)
	      (define x 1)         (define y 0)
	      (define direction 'horizontal))
    ((right)  (define b-width 6)   (define b-height 100)
              (define f-width 3)   (define f-height 100)
	      (define x 1)         (define y 0)
	      (define direction 'horizontal))
    ((bottom) (define b-width 100) (define b-height 6)
              (define f-width 100) (define f-height 3)
	      (define x 0)         (define y 1)
	      (define direction 'vertical)))
  (define (renderer focused)
    (define titlearea-img
      (klarth-new-filled-image f-width f-height
			       (if focused
				   (list direction
					 (klarth-modify-color
					  (klarth-gtk-bg-color gtk-col)
					  109/100)
					 (klarth-modify-color
					  (klarth-gtk-bg-color gtk-col)
					  51/100))
				 (klarth-gtk-bg-color 'normal))))
    
    (klarth-composite-images (make-sized-image b-width b-height
					       (klarth-black focused))
			     (if focused
				 (klarth-bevel-image titlearea-img 1 t 35)
			         titlearea-img)
			     x y))
  (list (renderer ()) (klarth-increase-image-border (renderer t) 2 2 2 2)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;; The Messy Stuff

;; bgparts & such

;; Titlebar/area stuff...

;; klarth-titlearea-height x klarth-titlearea-height
(define full-titlearea-bgpart
  (klarth-render-titlearea-bgpart ()))
;; note: this does NOT include the black line...that is another part
;; klarth-titlearea-height x 2
(define (top-resizer-bgpart)
  (define (chopper fnc)
    (klarth-increase-image-border (crop-image (fnc full-titlearea-bgpart)
					      0 0 klarth-titlearea-height 2)
				  2 2 0 0))
  (list (chopper car) (chopper cadr)))
;; klarth-titlearea-height x klarth-titlearea-height
(define button-background-bgpart
  (klarth-render-titlearea-bgpart t))

;; <resized-to-match-height> x klarth-titlearea-height - 4
;; klarth-render-window-icon-bgpart : window -> image
(define (klarth-render-window-icon-bgpart w)
  (define wicon (klarth-window-icon w))
  ;; car, cdr.
  (define (renderer fnc wicon)
    ;; The window icon may be wider than klarth-titlearea-height, so we have
    ;; to crop conservatively and then scale/tile that to the proper size.
    ;; We scale because theoretically this should all be the same gradient
    ;; piece and the scaling function in sawfish is nowhere near as stupid as
    ;; the tiling one.
    
    (define bap-size (+ klarth-titlearea-bevel-size klarth-titlearea-padding))
    (klarth-composite-images
     (scale-image (crop-image (fnc full-titlearea-bgpart) bap-size bap-size
			      1 klarth-icon-size) ;; 1 is fairly arbitrary
		  (klarth-image-width wicon) klarth-icon-size)
     wicon 0 0))
  (list (renderer car (klarth-greyscale-image wicon)) (renderer cadr wicon)))

(define hole-image (make-image "hole.png"))
;; [somewhat] available-width (see below) x klarth-icon-size
;; klarth-render-titlearea-holes-bgpart : window fnc -> bgpart
(define (klarth-render-titlearea-holes-bgpart w)
  (define available-width
    (klarth-round-to-lower-multiple-of (- (klarth-icon-left-edge w)
					  (klarth-em 1/2)
					  (klarth-titlearea-left-edge w)) 4))
  (define (renderer fnc)
    (define bap-size (+ klarth-titlearea-bevel-size klarth-titlearea-padding))
    ;; FIXME: Y'know, I think we mangle an image here. Need to wrap tile-image.
    (define titlearea-cropped-img
      (scale-image (crop-image (fnc full-titlearea-bgpart) bap-size bap-size
                               1 klarth-icon-size) ;; 1 is fairly arbitrary
                   available-width klarth-icon-size))
    (klarth-composite-images
     titlearea-cropped-img
     (tile-image (make-sized-image available-width klarth-icon-size)
                 hole-image)
     0 0))
  (if (> available-width 0) (list (renderer car) (renderer cadr)) ()))

;; 5x100
(define left-plain-resizer-bgpart
  (klarth-render-resizer-bgpart 'left 'normal))
(define left-colored-resizer-bgpart
  (klarth-render-resizer-bgpart 'left 'selected))

;; 6x100
(define right-resizer-bgpart
  (klarth-render-resizer-bgpart 'right 'normal))

;; 100x6
(define bottom-resizer-bgpart
  (klarth-render-resizer-bgpart 'bottom 'normal))

;; 27x27
(define bottom-left-corner-bgpart 
  (list (make-image "inactive:bottom-left-corner.png")
	(make-image "active:bottom-left-corner.png")))

;; 28x27
(define bottom-right-corner-bgpart 
  (list (make-image "inactive:bottom-right-corner.png")
	(make-image "active:bottom-right-corner.png")))

;; 3x4
(define left-colored-hangdown-tip-bgpart 
  (list (make-image "inactive:left-colored-hangdown-tip.png")
	(make-image "active:left-colored-hangdown-tip.png")))

;; 10x10
(define (make-button-bgpart filename)
  (list (make-image filename) (make-image filename)))

(define close-bgpart      (make-button-bgpart "close-button.png"))
(define minimize-bgpart   (make-button-bgpart "minimize-button.png"))
(define maximize-bgpart   (make-button-bgpart "maximize-button.png"))
(define unmaximize-bgpart (make-button-bgpart "unmaximize-button.png"))
(define unmaximize-horiz-bgpart
  (make-button-bgpart "unmaximize-horiz-button.png"))
(define unmaximize-vert-bgpart
  (make-button-bgpart "unmaximize-vert-button.png"))
(define shade-bgpart      (make-button-bgpart "shade-button.png"))
(define unshade-bgpart    (make-button-bgpart "unshade-button.png"))
(define menu-bgpart       (make-button-bgpart "menu-button.png"))

;; Recolor all images that need recolouring. Precalculates the lookup
;; tables first. (Whatever that means.)

(define (recolor-bgparts)
  (define (make-recolorer color)
    (make-image-recolorer color
			  #:zero-channel blue-channel
			  #:index-channel green-channel))
  (define (helper color fnc loi)
    (mapc (lambda (x) ((make-recolorer color) (fnc x))) loi))
  (let ((loi (list bottom-left-corner-bgpart
			bottom-right-corner-bgpart
			left-colored-hangdown-tip-bgpart)))
    (helper (klarth-gtk-bg-color 'normal) car loi)
    (helper (klarth-gtk-bg-color 'selected) cadr loi))
  (let ((loi (list close-bgpart
		   minimize-bgpart 
		   maximize-bgpart
		   unmaximize-bgpart
		   unmaximize-horiz-bgpart
		   unmaximize-vert-bgpart
		   shade-bgpart
		   unshade-bgpart
		   menu-bgpart)))
    (helper
     (get-color (klarth-bw-contrast-color-name klarth-unfocused-color
					       ()))
     car loi)
    (helper
     (get-color (klarth-bw-contrast-color-name klarth-hilight-color
					       t))
     cadr loi)))

;; window icons

(define icon-table (make-weak-table eq-hash eq))

;; holes
(define hole-parts
  `(
    ((background . ,(lambda (w) (klarth-render-titlearea-holes-bgpart w)))
     (left-edge . ,(lambda (w)
		     (+ (klarth-titlearea-left-edge w)
			klarth-titlearea-bevel-size klarth-titlearea-padding)))
     (top-edge . ,(+ klarth-titlearea-top-edge
		     klarth-titlearea-bevel-size klarth-titlearea-padding))
     ;(width . ,(lambda (w) (- (klarth-icon-left-edge w) (klarth-titlearea-left-edge w) (klarth-em 1/2))))
     (class . title))

    ((background . ,(lambda (w) (klarth-render-titlearea-holes-bgpart w)))
     (right-edge . ,(lambda (w)
		     (+ (klarth-titlearea-right-edge w)
			klarth-titlearea-bevel-size klarth-titlearea-padding)))
     (top-edge . ,(+ klarth-titlearea-top-edge
		     klarth-titlearea-bevel-size klarth-titlearea-padding))
     ;(width . ,(lambda (w) (- (klarth-icon-left-edge w) (klarth-titlearea-left-edge w) (klarth-em 1/2))))
     (class . title))
    ))

;; frames
(define common-frame-parts
  `(
    ((background . ,klarth-black-list)
     (left-edge . ,klarth-absolute-left-edge)
     (top-edge . ,klarth-titlebar-top-edge)
     (right-edge . ,(lambda (w) (+ (klarth-absolute-right-edge w) 1)))
     (height . ,klarth-titlebar-height)
     (class . title))
    
    ((background . ,klarth-black-list)
     (top-edge . ,(+ klarth-titlebar-top-edge 1))
     (right-edge . ,klarth-absolute-right-edge)
     (height . ,klarth-titlebar-height)
     (width . 1)
     (class . title))

    ((background . ,full-titlearea-bgpart)
     (foreground . ,(klarth-bw-contrast-color-list klarth-hilight-color
						   klarth-unfocused-color))
     (left-edge . ,klarth-titlearea-left-edge)
     (right-edge . ,klarth-titlearea-right-edge)
     (top-edge . ,klarth-titlearea-top-edge) 
     (text . ,window-name)
     (x-justify . ,klarth-titletext-x-justify)
     (y-justify . ,(+ klarth-titlearea-bevel-size klarth-titlearea-padding))
     (class . title))

    ,@hole-parts

    ((background . ,klarth-render-window-icon-bgpart)
     (left-edge . ,klarth-icon-left-edge)
     (top-edge . ,(+ klarth-titlearea-top-edge
		     klarth-titlearea-bevel-size klarth-titlearea-padding))
     (class . title))
    ))

(define normal-frame
    `(,@common-frame-parts
      
      ((background . ,klarth-black-list)
       (left-edge . ,klarth-titlearea-left-edge)
       (right-edge . ,klarth-titlearea-right-edge)
       (top-edge . ,klarth-titlebar-top-edge) 
       (class . top-border))

      ((background . ,top-resizer-bgpart)
       (left-edge . ,klarth-titlearea-left-edge)
       (right-edge . ,klarth-titlearea-right-edge)
       (top-edge . ,klarth-titlearea-top-edge) 
       (class . top-border))

      ((background . ,left-plain-resizer-bgpart)
       (left-edge . -5)
       (top-edge . ,klarth-left-colored-hangdown-endpoint)
       (bottom-edge . 17)
       (class . left-border))      

      ((background . ,left-colored-resizer-bgpart)
       (left-edge . -5)
       (top-edge . 0)
       (height . ,klarth-left-colored-hangdown-endpoint)
       (class . left-border))

      ((background . ,left-colored-hangdown-tip-bgpart)
       (left-edge . -4)
       (top-edge . ,(lambda (w)
		      (- (klarth-left-colored-hangdown-endpoint w) 1)))
       (class . left-border))      
      
      ((background . ,bottom-resizer-bgpart)
       (left-edge . 18)
       (right-edge . 18)
       (bottom-edge . -6)
       (class . bottom-border))
      
      ((background . ,right-resizer-bgpart)
       (right-edge . -6)
       (top-edge . 0)
       (bottom-edge . 17)
       (class . right-border))
      
      ((background . ,bottom-left-corner-bgpart)
       (bottom-edge . -6)
       (left-edge . -5)
       (class . bottom-left-corner))
      
      ((background . ,bottom-right-corner-bgpart)
       (bottom-edge . -6)
       (right-edge . -6)
       (class . bottom-right-corner))
      ))

(define shaped-frame
    `(,@common-frame-parts

      ((background . ,klarth-black-list)
       (left-edge . ,(lambda (w) (+ 2 (klarth-absolute-left-edge w))))
       (right-edge . ,(lambda (w) (klarth-absolute-right-edge w)))
       (top-edge . 0)
       (height . 1)
       (class . title))
      ))

(define non-resizable-frame
  `(,@common-frame-parts

    ((background . ,klarth-black-list)
     (top-edge . 0)
     (bottom-edge . 0)
     (left-edge . -1)
     (width . 1)
     (class . title))
    
    ((background . ,klarth-black-list)
     (top-edge . 0)
     (bottom-edge . 0)
     (right-edge . -1)
     (width . 1)
     (class . title))

    ((background . ,klarth-black-list)
     (top-edge . ,(+ klarth-titlebar-top-edge 1))
     (bottom-edge . 0)
     (right-edge . -2)
     (width . 1)
     (class . title))

    ((background . ,klarth-black-list)
     (bottom-edge . -1)
     (left-edge . -1)
     (right-edge . -2)
     (height . 1)
     (class . title))

    ((background . ,klarth-black-list)
     (bottom-edge . -2)
     (left-edge . 2)
     (right-edge . -2)
     (height . 1)
     (class . title))
    ))

;; packing buttons

(define button-map
  `((iconify-button . ,minimize-bgpart)
;    (maximize-button . ,(lambda (w) (if (window-maximized-p w)
;					unmaximize-bgpart maximize-bgpart)))
    (maximize-button . ,(lambda (w)
			  (cond
			   ((klarth-window-maximized-both-p w)
			    unmaximize-bgpart)
			   ((window-maximized-horizontally-p w)
			    unmaximize-horiz-bgpart)
			   ((window-maximized-vertically-p w)
			    unmaximize-vert-bgpart)
			   (t maximize-bgpart))))
    (close-button . ,close-bgpart)
    (menu-button . ,menu-bgpart)
;; This works, but requires window-get to not be gaol'ed - arggh
;    (shade-button . ,(lambda (w)
;		       (if (window-get w 'shaded) shade-bgpart unshade-bgpart)))
    (shade-button . ,shade-bgpart)
    ))

;; klarth-remove-unnecessary-buttons : (something like vvv) -> 
;; '((close-button) maximize-button iconify-button)
(define (klarth-remove-unnecessary-buttons dual-buttons w)
  ;; FIXME: can't let* lambda here, since it won't be able to call itself
  (define (helper buttons)
    ;; this is just a '(foo bar), so it's empty or a symbol (button name).
    (cond
     ((null buttons) ())
     ((not (eq (car buttons) 'maximize-button))
      (cons (car buttons) (helper (cdr buttons))))
     ((klarth-window-resizable-p w)
      (cons 'maximize-button (helper (cdr buttons))))
     (t (helper (cdr buttons)))))
  (cons (helper (car dual-buttons)) (helper (cdr dual-buttons))))
  
(define (button-theme w)
  (klarth-remove-unnecessary-buttons
   (car (cdr (or (assq Klarth:button-theme Klarth:button-themes)
		 (assq 'default Klarth:button-themes)))) w))

(define (make-buttons spec colored edge resizable)
  
  (define (make-button class fg point)
    `((background . ,button-background-bgpart)
	(foreground . ,fg)
	(x-justify . center)
	(y-justify . center)
	(,edge . ,point)
	(top-edge . ,klarth-titlearea-top-edge) 
	(class . ,class)))
  
  (do ((rest spec (cdr rest))
       (point (+ 1 (if resizable -5 -1))
	      (+ point (+ klarth-titlearea-height 1)))
       (out '() (if (or (not (eq (car rest) 'maximize-button)) resizable)
		    (cons (make-button (car rest)
				       (cdr (assq (car rest) button-map))
				       point)
			  out)
		    out)))
    ((null rest) out)))


;; misc stuff

(define (rebuild-all)
  (rebuild-frames-with-style 'Klarth))

(define (reframe-all)
  (reframe-windows-with-style 'Klarth))

(define (color-changed)
  (recolor-bgparts (klarth-gtk-bg-color 'selected)
		  (klarth-gtk-bg-color 'normal))
  (rebuild-all))

(define (make-frame w frame buttons)
  (let ((resizable (klarth-window-resizable-p w)))
    (table-set button-table w buttons)
    (append frame
	    (make-buttons (car buttons) t 'left-edge resizable)
	    (make-buttons (reverse (cdr buttons)) () 'right-edge resizable))))

(define (get-frame w type)  
  (make-frame w (if (or (eq type 'default) (eq type 'transient))
		    (if (klarth-window-resizable-p w)
			normal-frame
		        non-resizable-frame)
		  shaped-frame)
	      (button-theme w)))

;; initialization

(gtkrc-call-after-changed color-changed)

;; setup the initial colours
(recolor-bgparts (klarth-gtk-bg-color 'selected) (klarth-gtk-bg-color 'normal))

;; register the theme
(add-frame-style 'Klarth get-frame)

;; recalibrate frames when the window-name changes
(call-after-property-changed 'WM_NAME rebuild-frame)

;; theme file, written Wed Mar  8 09:30:29 2000
;; created by sawmill-themer -- DO NOT EDIT!

(require 'make-theme)

(let
    ((patterns-alist
      '(("part#12"
         (inactive
          "part#12-inactive.png")
         (focused
          "part#12.png"))
        ("part#11"
         (inactive
          "part#11-inactive.png")
         (focused
          "part#11.png"))
        ("part#10"
         (inactive
          "part#10-inactive.png")
         (focused
          "part#10.png"))
        ("part#9"
         (inactive
          "part#9-inactive.png")
         (focused
          "part#9.png")
         (highlighted
          "part#9.png"))
        ("part#8"
         (inactive
          "part#8-inactive.png")
         (focused
          "part#8.png")
         (highlighted
          "part#8.png")
         (clicked
          "part#8.png"))
        ("part#7"
         (inactive
          "part#7-inactive.png")
         (focused
          "part#7.png")
         (clicked
          "part#7-clicked.png"))
        ("part#6"
         (inactive
          "part#6-inactive.png")
         (focused
          "part#6.png")
         (clicked
          "part#6-clicked.png"))
        ("part#5"
         (inactive
          "part#5-inactive.png")
         (focused
          "part#5.png")
         (clicked
          "part#5-clicked.png"))
        ("part#4"
         (inactive
          "part#4-inactive.png")
         (focused
          "part#4.png"))
        ("part#3"
         (inactive
          "part#3-inactive.png")
         (focused
          "part#3-hi.png"
          (border
           38
           38
           0
           0)))
        ("part#2"
         (inactive
          "part#2-inactive.png")
         (focused
          "part#2.png"))
        ("part"
         (inactive
          "part-inactive.png")
         (focused
          "part.png")
         (clicked
          "part-clicked.png"))
        ("title-colors"
         (inactive . "#6e146e146e14")
         (focused . "#000000000000"))
        ("bottomleft-shaped"
         (inactive
          "bl-shaped-u.png")
         (focused
          "bl-shaped.png"))
        ("bottomright-shaped"
         (inactive
          "br-shaped-u.png")
         (focused
          "br-shaped.png"))
        ("top-border-only"
         (inactive
          "top-border-only-inactive.png"
          (border
           6
           6
           2
           1))
         (focused
          "top-border-only.png"
          (border
           6
           6
           2
           1)))))

     (frames-alist
      '(("normal"
         ((right-edge . -6)
          (top-edge . 0)
          (background . "part#12")
          (bottom-edge . 0)
          (class . right-border)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#11")
          (right-edge . -6)
          (bottom-edge . -6)
          (class . bottom-right-corner)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#10")
          (left-edge . 0)
          (right-edge . 0)
          (bottom-edge . -6)
          (class . bottom-border)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#9")
          (left-edge . -6)
          (bottom-edge . -6)
          (class . bottom-left-corner)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#8")
          (left-edge . -6)
          (top-edge . 0)
          (bottom-edge . 0)
          (class . left-border)
          (x-justify . center)
          (y-justify . center))
         ((right-edge . -6)
          (background . "part#7")
          (top-edge . -22)
          (class . close-button)
          (x-justify . center)
          (y-justify . center))
         ((right-edge . 14)
          (background . "part#6")
          (top-edge . -22)
          (class . maximize-button)
          (x-justify . center)
          (y-justify . center))
         ((top-edge . -22)
          (right-edge . 30)
          (background . "part#5")
          (class . iconify-button)
          (x-justify . center)
          (y-justify . center))
         ((top-edge . -22)
          (right-edge . 48)
          (background . "part#4")
          (class . title)
          (x-justify . center)
          (y-justify . center))
         ((left-edge . 18)
          (top-edge . -22)
          (font . "-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1")
          (right-edge . 50)
          (foreground . "title-colors")
          (background . "part#3")
          (class . title)
          (text . window-name)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#2")
          (left-edge . 16)
          (top-edge . -22)
          (class . title))
         ((left-edge . -6)
          (background . "part")
          (top-edge . -22)
          (class . menu-button)))
        ("shaped"
         ((right-edge . -6)
          (top-edge . -22)
          (background . "part#7")
          (class . close-button)
          (x-justify . center)
          (y-justify . center))
         ((top-edge . -22)
          (right-edge . 14)
          (background . "part#6")
          (class . maximize-button)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#5")
          (right-edge . 30)
          (top-edge . -22)
          (class . iconify-button)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#4")
          (right-edge . 48)
          (top-edge . -22)
          (class . title)
          (x-justify . center)
          (y-justify . center))
         ((right-edge . 50)
          (font . "-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1")
          (top-edge . -22)
          (left-edge . 18)
          (foreground . "title-colors")
          (background . "part#3")
          (class . title)
          (text . window-name)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#2")
          (left-edge . 16)
          (top-edge . -22)
          (class . title))
         ((background . "part")
          (left-edge . -6)
          (top-edge . -22)
          (class . menu-button))
         ((left-edge . -6)
          (top-edge . -3)
          (class . title)
          (background . "bottomleft-shaped"))
         ((top-edge . -3)
          (right-edge . -6)
          (class . title)
          (background . "bottomright-shaped")))
        ("transient"
         ((top-edge . 0)
          (right-edge . -6)
          (background . "part#12")
          (bottom-edge . 0)
          (class . right-border)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#11")
          (right-edge . -6)
          (bottom-edge . -6)
          (class . bottom-right-corner)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#10")
          (left-edge . 0)
          (right-edge . 0)
          (bottom-edge . -6)
          (class . bottom-border)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#9")
          (left-edge . -6)
          (bottom-edge . -6)
          (class . bottom-left-corner)
          (x-justify . center)
          (y-justify . center))
         ((top-edge . 0)
          (left-edge . -6)
          (background . "part#8")
          (bottom-edge . 0)
          (class . left-border)
          (x-justify . center)
          (y-justify . center))
         ((background . "top-border-only")
          (top-edge . -6)
          (right-edge . -6)
          (left-edge . -6)
          (class . title)))
        ("shaped-transient"
         ((right-edge . -6)
          (top-edge . -22)
          (background . "part#7")
          (class . close-button)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#6")
          (right-edge . 14)
          (top-edge . -22)
          (class . maximize-button)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#5")
          (right-edge . 30)
          (top-edge . -22)
          (class . iconify-button)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#4")
          (right-edge . 48)
          (top-edge . -22)
          (class . title)
          (x-justify . center)
          (y-justify . center))
         ((font . "-adobe-helvetica-medium-r-normal-*-*-120-*-*-p-*-iso8859-1")
          (right-edge . 50)
          (foreground . "title-colors")
          (background . "part#3")
          (left-edge . 18)
          (top-edge . -22)
          (class . title)
          (text . window-name)
          (x-justify . center)
          (y-justify . center))
         ((background . "part#2")
          (left-edge . 16)
          (top-edge . -22)
          (class . title))
         ((background . "part")
          (left-edge . -6)
          (top-edge . -22)
          (class . menu-button)))
        ("unframed")))

     (mapping-alist
      '((default . "normal")
        (transient . "transient")
        (shaped . "shaped")
        (shaped-transient . "shaped-transient")
        (unframed . "nil")))

     (theme-name 'HeliX))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))

; This USED to be the theme.jl from the microGUI theme by
; Ryan Lovett, Ben FrantzDale, and John Harper.  Big props to them, and
; here's to hoping someone will write a decent HOWTO for sawfish-themer
; because I really, _really_ suck at scheme coding.

; This theme is GPL, unless Ryan, Ben, or John have a problem with that.
; I just got tired of there not being many non-hideous themes for Sawfish.

(let*
    ;; Update window title pixel length
    ((title-width
      (lambda (w)
	(let
	    ((w-width (car (window-dimensions w))))
	  (max 0 (min (- w-width 100) (text-width (window-name w)))))))
     
     ;; 6x19 - upper left corner
     (upper-left-images (list (make-image "i-ul.png")
                              (make-image "a-ul.png")))
     (upper-left-shaped-images (list (make-image "i-uls.png")
				     (make-image "a-uls.png")))

     ;; 16x19 - upper left menu button
     (menu-images (list (make-image "i-th.png")
			(make-image "a-th.png")
                        (make-image "p-th.png")
			(make-image "c-th.png")))

     ;; 11x19 - upper left grey to green border
     (top-lefthollow-images (list (make-image "i-t1.png")
		  	          (make-image "a-t1.png")))

     ;; 3x19 - upper green background
     (top-hollow-images (list (make-image "i-t2.png")
		  	      (make-image "a-t2.png")))

     ;; 11x19 - upper right green to grey border
     (top-righthollow-images (list (make-image "i-t3.png")
		       	           (make-image "a-t3.png")))

     ;; 3x19 - upper grey background
     (top-grey-images (list (make-image "i-t0.png")
                                 (make-image "a-t0.png")))

     ;; 17x16 - iconify icon
     (iconify-images (list (make-image "i-ti.png")
			   (make-image "a-ti.png")
			   (make-image "p-ti.png")
			   (make-image "c-ti.png")))

     ;; 17x16 - maximize icon
     (maximize-images (list (make-image "i-tm.png")
			    (make-image "a-tm.png")
			    (make-image "p-tm.png")
			    (make-image "c-tm.png")))

     ;; 17x16 - close icon
     (close-images (list (make-image "i-tx.png")
			 (make-image "a-tx.png")
			 (make-image "p-tx.png")
			 (make-image "c-tx.png")))

     ;; 18x6 - upper right corner
     (upper-right-images (list (make-image "i-ur.png")
                               (make-image "a-ur.png")))
     (upper-right-shaped-images (list (make-image "i-urs.png")
				      (make-image "a-urs.png")))


     ;; 6x18 - left side
     (left-side-images (list (make-image "i-ls.png")
                             (make-image "a-ls.png")))
     ;; 6x18 - right side
     (right-side-images (list (make-image "i-rs.png")
                              (make-image "a-rs.png")))

     ;; 6x6 - lower left corner
     (bottom-left-images (list (make-image "i-ll.png")
                               (make-image "a-ll.png")))
     ;; 18x6 - lower ledge
     (bottom-images (list (make-image "i-bot.png")
                          (make-image "a-bot.png")))
     ;; 6x6 - lower right corner
     (bottom-right-images (list (make-image "i-lr.png")
                                (make-image "a-lr.png")))

     ;; 4x4
     (t-upper-left-images (list (make-image "i-tul.png")
                                (make-image "a-tul.png")))
     ;; 11x4
     (t-upper-side-images (list (make-image "i-ttop.png")
                                (make-image "a-ttop.png")))
     ;; 17x4
     (t-upper-right-images (list (make-image "i-tur.png")
                                 (make-image "a-tur.png")))
     (t-upper-right-shaped-images (list (make-image "i-turs.png")
                                        (make-image "a-turs.png")))

     ;; 4x17
     (t-left-images (list (make-image "i-tls.png")
                          (make-image "a-tls.png")))

     ;; 17x16
     (t-close-images (list (make-image "i-ttx.png")
			   (make-image "a-ttx.png")
			   (make-image "p-ttx.png")
			   (make-image "c-ttx.png")))

     ;; 17x3
     (t-right-images (list (make-image "i-tt0.png")
                           (make-image "a-tt0.png")))

     ;; 4x4
     (t-bottom-left-images (list (make-image "i-tll.png")
                                 (make-image "a-tll.png")))
     ;; 11x4
     (t-bottom-side-images (list (make-image "i-tbot.png")
                                 (make-image "a-tbot.png")))
     ;; 17x4
     (t-bottom-right-images (list (make-image "i-tlr.png")
                                  (make-image "a-tlr.png")))
     (t-bottom-right-shaped-images (list (make-image "i-tlrs.png")
                                         (make-image "a-tlrs.png")))


     (text-colors '("grey85" "white"))

     ;; frame layout

     (frame `(((background . ,upper-left-images)
	       (left-edge . -6)
	       (top-edge . -19)
	       (class . top-left-corner))

	      ;; menu button
	      ((background . ,menu-images)
	       (top-edge . -19)
	       (left-edge . 0)
	       (class . menu-button))

	      ;; top curves
	      ((background . ,top-lefthollow-images)
	       (top-edge . -19)
               (left-edge . 16)
	       (class . title))

	      ;; top green
	      ((background . ,top-hollow-images)
	       (foreground . ,text-colors)
	       (text . ,window-name)
	       (x-justify . 4)
	       (y-justify . center)
	       (top-edge . -19)
	       (left-edge . 27)
	       (width . ,(lambda (w) (+ (title-width w) 13)))
	       (class . title))

	      ;; top curves
	      ((background . ,top-righthollow-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 37)))
	       (top-edge . -19)
	       (class . title))

	      ;; top grey
	      ((background . ,top-grey-images)
	       (left-edge . ,(lambda (w) (+ (title-width w) 48)))
	       (top-edge . -19)
	       (right-edge . 48)
	       (class . title))

	      ;; left border
	      ((background . ,left-side-images)
	       (left-edge . -6)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; top-right corner
	      ((background . ,upper-right-images)
	       (right-edge . -6)
	       (top-edge . -19)
	       (class . top-right-corner))

	      ;; right border
	      ((background . ,right-side-images)
	       (right-edge . -6)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom border
	      ((background . ,bottom-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -6)
	       (class . bottom-border))

	      ;; bottom-left corner
	      ((background . ,bottom-left-images)
	       (left-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,bottom-right-images)
	       (right-edge . -6)
	       (bottom-edge . -6)
	       (class . bottom-right-corner))

	      ;; iconify button
	      ((background . ,iconify-images)
	       (right-edge . 32)
	       (top-edge . -19)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . 16)
	       (top-edge . -19)
	       (class . maximize-button))

	      ;; delete button
	      ((background . ,close-images)
	       (right-edge . 0)
	       (top-edge . -19)
	       (class . close-button))))

       (shaped-frame `(((background . ,upper-left-shaped-images)
			(left-edge . -6)
			(top-edge . -19)
			(height . 19)
			(class . top-left-corner))

		       ;; menu button
		       ((background . ,menu-images)
			(top-edge . -19)
			(left-edge . 0)
			(class . menu-button))

                       ;; top curves
                       ((background . ,top-lefthollow-images)
                        (top-edge . -19)
                        (left-edge . 16) 
                        (class . title))

		       ;; Title text area
		       ((background . ,top-hollow-images)
			(foreground . ,text-colors)
			(text . ,window-name)
			(x-justify . 4)
			(y-justify . center)
			(top-edge . -19)
			(left-edge . 27)
			(width . ,(lambda (w) (+ (title-width w) 13)))
			(class . title))

		       ;; top curves
		       ((background . ,top-righthollow-images)
			(left-edge . ,(lambda (w) (+ (title-width w) 37)))
			(top-edge . -19)
			(class . title))

		       ;; top grey
		       ((background . ,top-grey-images)
			(left-edge . ,(lambda (w) (+ (title-width w) 48)))
			(top-edge . -19)
			(right-edge . 48)
			(class . title))

		       ;; top-right corner
		       ((background . ,upper-right-shaped-images)
			(right-edge . -6)
			(top-edge . -19)
			(height . 19)
			(class . top-right-corner))

		       ;; iconify button
		       ((background . ,iconify-images)
			(right-edge . 32)
			(top-edge . -19)
			(class . iconify-button))

		       ;; maximize button
		       ((background . ,maximize-images)
			(right-edge . 16)
			(top-edge . -19)
			(class . maximize-button))

		       ;; delete button
		       ((background . ,close-images)
			(right-edge . 0)
			(top-edge . -19)
			(class . close-button))))

       (transient-frame `(((background . ,t-upper-left-images)
			   (left-edge . -4)
			   (top-edge . -4)
			   (class . top-left-corner))

			  ;;top-right corner
			  ((background . ,t-upper-right-images)
			   (right-edge . -17)
			   (top-edge . -4)
			   (class . top-right-corner))

			  ;;title border
			  ((background . ,t-upper-side-images)
			   (left-edge . -1)
			   (right-edge . -1)
			   (top-edge . -4)
			   (class . top-border))

			  ;; left border
			  ((background . ,t-left-images)
			   (left-edge . -4)
			   (top-edge . -1)
			   (bottom-edge . -1)
			   (class . left-border))

			  ;; right border
			  ((background . ,t-right-images)
			   (right-edge . -17)
			   (top-edge . -1)
			   (bottom-edge . -1)
			   (class . title))

			  ;; bottom border
			  ((background . ,t-bottom-side-images)
			   (left-edge . -1)
			   (right-edge . -1)
			   (bottom-edge . -4)
			   (class . bottom-border))

			  ;; bottom-left corner
			  ((background . ,t-bottom-left-images)
			   (left-edge . -4)
			   (bottom-edge . -4)
			   (class . bottom-left-corner))

			  ;; bottom-right corner
			  ((background . ,t-bottom-right-images)
			   (right-edge . -17)
			   (bottom-edge . -4)
			   (class . bottom-right-corner))

			  ;; delete button
			  ((background . ,t-close-images)
			   (right-edge . -17)
			   (top-edge . 1)
			   (class . close-button))))

       (shaped-transient-frame `(((background . ,t-upper-right-shaped-images)
				  (right-edge . -17)
				  (top-edge . -4)
				  (class . top-right-corner))

				 ;; right border
				 ((background . ,t-right-images)
				  (right-edge . -17)
				  (top-edge . -1)
				  (bottom-edge . -1)
				  (class . title))

				 ;; bottom-right corner
				 ((background . ,t-bottom-right-shaped-images)
				  (right-edge . -17)
				  (bottom-edge . -4)
				  (class . bottom-right-corner))

				 ;; delete button
				 ((background . ,t-close-images)
				  (right-edge . -17)
				  (top-edge . 1)
				  (class . close-button)))))
  
  (add-frame-style 'Elberg
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((transient) transient-frame)
		       ((shaped) shaped-frame)
		       ((shaped-transient) shaped-transient-frame))))

  (call-after-property-changed
   'WM_NAME (lambda ()
	      (rebuild-frames-with-style 'Elberg))))

; Aquiline/theme.jl
;; Original Aquaesque theme:
;; Copyright (C) 2000 Henrik Magnusson <henma887@student.liu.se>
;; Aquiline theme:
;; Modifications (C) 2001 Matt Chisholm <matt@theory.org>

(let*
    ;; Update window title pixel length
    ((title-width
      (lambda (w)
	(let
	    ((w-width (car (window-dimensions w))))
	  (max 0 (min (- w-width 100) (text-width (window-name w)))))))
     
     (font (get-font "-*-lucida-medium-r-normal-*-*-100-*-*-p-*-iso8859-1"))

     (font-colors (list "white" "black"))

     (top-left-images (list (make-image "top_left_inactive.png")
	   		    (make-image "top_left.png")))

     (top-left-shaded-images (list (make-image "top_left_inactive_shaded.png")
	                           (make-image "top_left_shaded.png")))
     
     (top-title-images (list (make-image "top_title_inactive.png")
	                     (make-image "top_title.png")))

     (top-gradient-images (list (make-image "top_gradient_inactive.png")
	       			(make-image "top_gradient.png")))

     (top-right-images (list (make-image "top_right_inactive.png")
	       	             (make-image "top_right.png")))

     (top-right-shaded-images (list (make-image "top_right_inactive_shaded.png")
	       		            (make-image "top_right_shaded.png")))

     (close-images (list (make-image "close_normal.png")
	                 (make-image "close_active.png")
               		 (make-image "close_high.png")
               		 (make-image "close_pressed.png")))

     (maximize-images (list (make-image "max_normal.png")
	            	    (make-image "max_active.png")
                     	    (make-image "max_high.png")
	                    (make-image "max_pressed.png")))

     (iconify-images (list (make-image "min_normal.png")
		           (make-image "min_active.png")
        	           (make-image "min_high.png")
	                   (make-image "min_pressed.png")))

     (border-images (make-image "bl.png"))

     ;; Frame definitions:
     (frame `(
	      ;; top left corner
	      ((background . ,top-left-images)
	       (left-edge . -2)
	       (top-edge . -23)
	       (class . top-left-corner))

	      ;; behind title
	      ((background . ,top-gradient-images)
	       ;;             top-title-images
	       (foreground . ,font-colors)
	       (text . ,window-name)
	       (x-justify . 4)
	       (y-justify . 6)
	       (top-edge . -23)
	       (left-edge . 5) 
	       (right-edge . 35) ;; comment out
	       (class . title))

	      ;; iconify button
	      ((background . ,iconify-images)
	       (right-edge . 37)
	       (top-edge . -23)
	       (class . iconify-button))

	      ;; maximize button
	      ((background . ,maximize-images)
	       (right-edge . 20)
	       (top-edge . -23)
	       (class . maximize-button))

	      ;; delete button
	      ((background . ,close-images)
	       (right-edge . 2)
	       (top-edge . -23)
	       (class . close-button))

	      ;; top-right corner
	      ((background . ,top-right-images)
	       (right-edge . -2)
	       (top-edge . -23)
	       (class . top-right-corner))

	      ;; left border
	      ((background . ,border-images)
	       (left-edge . -2)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . left-border))

	      ;; right border
	      ((background . ,border-images)
	       (right-edge . -2)
	       (top-edge . 0)
	       (bottom-edge . 0)
	       (class . right-border))

	      ;; bottom border
	      ((background . ,border-images)
	       (left-edge . 0)
	       (right-edge . 0)
	       (bottom-edge . -2)
	       (class . bottom-border))

	      ;; bottom-left corner
	      ((background . ,border-images)
	       (left-edge . -1)
	       (bottom-edge . -1)
	       (class . bottom-left-corner))

	      ;; bottom-right corner
	      ((background . ,border-images)
	       (right-edge . -1)
	       (bottom-edge . -1)
	       (class . bottom-right-corner))))

     (shaded-frame `(
		     ;; top left corner
		     ((background . ,top-left-shaded-images)
		      (left-edge . -2)
		      (top-edge . -23)
		      (class . top-left-corner))

		     ;; behind title
		     ((background . ,top-title-images)
		      (foreground . ,font-colors)
		      (text . ,window-name)
		      (x-justify . 4)
		      (y-justify . 6)
		      (top-edge . -23)
		      (left-edge . 5)
		      (width . ,(lambda (w) (+ (title-width w) 13)))
		      (class . title))

		     ;; gradient
		     ((background . ,top-gradient-images)
		      (top-edge . -23)
		      (left-edge . ,(lambda (w) (+ (title-width w) 13)))
		      (right-edge . 35)
		      (class . title))

		     ;; iconify button
		     ((background . ,iconify-images)
	      	      (right-edge . 37)
		      (top-edge . -23)
		      (class . iconify-button))

		     ;; maximize button
		     ((background . ,maximize-images)
		      (right-edge . 20)
		      (top-edge . -23)
		      (class . maximize-button))

		     ;; delete button
		     ((background . ,close-images)
		      (right-edge . 2)
		      (top-edge . -23)
		      (class . close-button))

		     ;; top-right corner
		     ((background . ,top-right-shaded-images)
		      (right-edge . -2)
		      (top-edge . -23)
		      (class . top-right-corner))))
     
     (transient-frame `(
			;; top left corner
			((background . ,top-left-images)
			 (left-edge . -2)
			 (top-edge . -23)
			 (class . top-left-corner))

			;; behind title
			((background . ,top-gradient-images)
			 ;;             top-title-images
			 (foreground . ,font-colors)
			 (text . ,window-name)
			 (x-justify . 4)
			 (y-justify . 6)
			 (top-edge . -23)
			 (left-edge . 5)
			 (right-edge . 35) ;; comment out
			 (class . title))

			;; iconify button
	 	        ((background . ,iconify-images)
		         (right-edge . 37)
	                 (top-edge . -23)
	                 (class . iconify-button))

			;; maximize button
			((background . ,maximize-images)
			 (right-edge . 20)
			 (top-edge . -23)
			 (class . maximize-button))

			;; delete button
			((background . ,close-images)
			 (right-edge . 2)
			 (top-edge . -23)
			 (class . close-button))

			;; top-right corner
			((background . ,top-right-images)
			 (right-edge . -2)
			 (top-edge . -23)
			 (class . top-right-corner))

			;; left border
			((background . ,border-images)
			 (left-edge . -2)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . left-border))

			;; right border
			((background . ,border-images)
			 (right-edge . -2)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (class . right-border))

			;; bottom border
			((background . ,border-images)
			 (left-edge . 0)
			 (right-edge . 0)
			 (bottom-edge . -2)
			 (class . bottom-border))

			;; bottom-left corner
			((background . ,border-images)
			 (left-edge . -1)
			 (bottom-edge . -1)
			 (class . bottom-left-corner))

			;; bottom-right corner
			((background . ,border-images)
			 (right-edge . -1)
			 (bottom-edge . -1)
			 (class . bottom-right-corner))))

     (shaded-transient-frame `(
			       ;; top left corner
			       ((background . ,top-left-shaded-images)
				(left-edge . -2)
				(top-edge . -23)
				(class . top-left-corner))

			       ;; behind title
			       ((background . ,top-title-images)
				(foreground . ,font-colors)
				(text . ,window-name)
				(x-justify . 4)
				(y-justify . 6)
				(top-edge . -23)
				(left-edge . 5)
				(width . ,(lambda (w) (+ (title-width w) 13)))
				(class . title))

			       ;; gradient
			       ((background . ,top-gradient-images)
				(top-edge . -23)
				(left-edge . ,(lambda (w) (+ (title-width w) 13)))
				(right-edge . 35)
				(class . title))

			       ;; maximize button
	 	               ((background . ,maximize-images)
		                (right-edge . 37)
	                        (top-edge . -23)
	                        (class . maximize-button))

			       ;; maximize button
			       ((background . ,maximize-images)
				(right-edge . 20)
				(top-edge . -23)
				(class . maximize-button))

			       ;; delete button
			       ((background . ,close-images)
				(right-edge . 2)
				(top-edge . -23)
				(class . close-button))

			       ;; top-right corner
			       ((background . ,top-right-shaded-images)
				(right-edge . -2)
				(top-edge . -23)
				(class . top-right-corner)))))
  
  (add-frame-style 'Aquiline
		   (lambda (w type)
		     (cond ((eq type 'shaded)
			    shaded-frame)
			   ((eq type 'transient)
			    transient-frame)
			   ((eq type 'shaded-transient)
			    shaded-transient-frame)
			   ((eq type 'unframed)
			    nil-frame)
			   (t
			    frame))))
  
  (call-after-property-changed
   'WM_NAME (lambda ()
	      (rebuild-frames-with-style 'Aquiline))))

;;  -V- theme for Sawfish by Gr1dl0ck (gr1dl0ck.deviantart.com)
;;   v0.3
;
; This file is part of the -V- Sawfish theme.
;
; -V- is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; -V- is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this theme; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


(let*
    ;; 13x11
    ((menu-images (list (make-image "menu-unpressed.png")
			(make-image "menu-unpressed.png")
			(make-image "menu-pressed.png")
                        (make-image "menu-dark.png")))

     (iconify-images (list (make-image "iconify-unpressed.png")
			   (make-image "iconify-unpressed.png")
 			   (make-image "iconify-pressed.png")
			   (make-image "iconify-dark.png")))

     ;;41x19
     (top-left-corner-image (make-image "top-left-corner.png"))
     (top-left-corner-shaded-image (make-image "top-left-corner-shaded.png"))
     
     (title-left-images (list (make-image "inact-title-left.png")
                              (make-image "act-title-left.png")))

     (title-images (list (make-image "inact-title.png")
                         (make-image "act-title.png")))

     (top-right-corner-images (list (make-image "inact-top-right-corner.png")
                                    (make-image "act-top-right-corner.png")))
     (top-right-corner-shaded-images (list (make-image "inact-top-right-corner-shaded.png")     
                                      (make-image "act-top-right-corner-shaded.png")))	

     ;;4x26
     (left-border-nostretch-image (make-image "left-border-nostretch.png"))
     ;;4x18
     (left-border-stretch-image (make-image "left-border-stretch.png"))
     ;;7x6
     (bottom-left-corner-image (make-image "bottom-left-corner.png"))
	
     (right-border-image (make-image "right-border.png"))
     (bottom-right-corner-image (make-image "bottom-right-corner.png"))

     (bottom-border-nostretch-image (make-image "bottom-border-nostretch.png"))
     (bottom-border-stretch-image (make-image "bottom-border-stretch.png"))


	;; Transient Window Graphics ::
     (t-top-left-corner-images (list (make-image "t-inact-top-left-corner.png")
				    (make-image "t-act-top-left-corner.png")))

     (t-menu-images (list (make-image "t-unpressed-menu.png")
                          (make-image "t-unpressed-menu.png") nil
  		          (make-image "t-pressed-menu.png")))

     (t-left-bar-images (list (make-image "t-inact-left-bar.png")
			     (make-image "t-act-left-bar.png")))

     (t-bottom-left-corner-images (list (make-image "t-inact-bottom-left-corner.png")
                                        (make-image "t-act-bottom-left-corner.png")))

     (t-top-border-image (make-image "t-top-border.png"))

     (t-top-right-corner-image (make-image "t-top-right-corner.png"))

     (t-bottom-border-image (make-image "t-bottom-border.png"))

     (t-bottom-right-corner-image (make-image "t-bottom-right-corner.png"))

     (t-right-border-image (make-image "t-right-border.png"))

     ;; frame layout 

     (frame `(((background . ,top-left-corner-image)
	       (top-edge . -19)
	       (left-edge . -4)
	       (class . top-left-corner))

	      ((background . ,menu-images)
               (top-edge . -19)
	       (left-edge . 5)
               (class . menu-button))

	      ((background . ,iconify-images)
               (top-edge . -19)
	       (left-edge . 21)
               (class . iconify-button))
		;;titlebar
              ((background . ,title-left-images)
               (top-edge . -19)
	       (left-edge . 33)
	       (class . title))

              ((background . ,title-images)
               (foreground . "black")
               (font . "-adobe-helvetica-bold-r-normal-*-*-100-*-*-p-*-iso8859-1")
               (text . ,window-name)
               (x-justify . 4)
               (y-justify . center)
	       (top-edge . -19)
               (left-edge . 48)
	       (right-edge . 24)
               (class . title))

              ((background . ,top-right-corner-images)
               (top-edge . -19)
               (right-edge . -4)
               (class . title))	      

		;;left border
 	      ((background . ,left-border-nostretch-image)
               (top-edge . 0)
	       (left-edge . -4)
	       (class . left-border))

	      ((background . ,left-border-stretch-image)
               (top-edge . 26)
               (left-edge . -4)
               (bottom-edge . -3)
               (class . left-border))

	      ((background . ,bottom-left-corner-image)
	       (bottom-edge . -4)
	       (left-edge . -4)
	       (class . bottom-left-corner))

		;;;right border
	      ((background . ,right-border-image)
	       (right-edge . -4)
	       (top-edge . 0)
	       (bottom-edge . 3)
               (class . right-border))

	      ((background . ,bottom-right-corner-image)
               (right-edge . -4)
	       (bottom-edge . -4)
               (class . bottom-right-corner))

		;;;bottom-border
	      ((background . ,bottom-border-nostretch-image)
               (right-edge . 0)
               (bottom-edge . -4)
               (class . bottom-border))

	      ((background . ,bottom-border-stretch-image)
               (right-edge . 39)
               (left-edge . 3)
               (bottom-edge . -4)
	       (class . bottom-border))))

     (shaped-frame `(((background . ,top-left-corner-shaded-image)
                      (top-edge . -19)
                      (left-edge . -4)
                      (class . top-left-corner))

                     ((background . ,menu-images)
                      (top-edge . -19)
                      (left-edge . 5)
                      (class . menu-button))

                     ((background . ,iconify-images)
                      (top-edge . -19)
                      (left-edge . 21)
                      (class . iconify-button))
                      ;;titlebar
                     ((background . ,title-left-images)
                      (top-edge . -19)
                      (left-edge . 33)
                      (class . title))

                     ((background . ,title-images)
                      (foreground . "black")
                      (font . "-adobe-helvetica-bold-r-normal-*-*-100-*-*-p-*-iso8859-1")
                      (text . ,window-name)
                      (x-justify . 4)
                      (y-justify . center)
                      (top-edge . -19)
                      (left-edge . 48)
                      (right-edge . 24)
                      (class . title))

                     ((background . ,top-right-corner-shaded-images)
                      (top-edge . -19)
                      (right-edge . -4)
                      (class . title))))

     (transient-frame `(((background . ,t-top-left-corner-images)
                         (top-edge . -4)
                         (left-edge . -11)
		  	 (class . title))

			((background . ,t-menu-images)
			 (top-edge . 6)
			 (left-edge . -11)
		  	 (class . menu-button))  
 
			((background . ,t-left-bar-images)
			 (top-edge . 42)
		         (left-edge . -11)
			 (bottom-edge . 26)
			 (class . title))
	
			((background . ,t-bottom-left-corner-images)
			 (bottom-edge . -4)
			 (left-edge . -11)
			 (class . title))

			((background . ,t-top-border-image)
	    		 (top-edge . -4)
			 (left-edge . 5)
			 (right-edge . 17))
	       
			((background . ,t-top-right-corner-image)
			 (top-edge . -4)
			 (right-edge . -4))

			((background . ,t-right-border-image)
			 (top-edge . 1)
			 (right-edge . -4)
			 (bottom-edge . 7))
	
			((background . ,t-bottom-right-corner-image)
			 (bottom-edge . -4)
			 (right-edge . -4))

			((background . ,t-bottom-border-image)
			 (left-edge . 3)
			 (right-edge . 2)
			 (bottom-edge . -4))))

     (shaped-transient-frame `(((background . ,t-top-left-corner-images)
                         (top-edge . -4)
                         (left-edge . -11)
                         (class . title))

                        ((background . ,t-menu-images)
                         (top-edge . 6)
                         (left-edge . -11)
                         (class . menu-button))

                        ((background . ,t-left-bar-images)
                         (top-edge . 42)
                         (left-edge . -11)
                         (bottom-edge . 26)
                         (class . title))

                        ((background . ,t-bottom-left-corner-images)
                         (bottom-edge . -4)
                         (left-edge . -11)
                         (class . title))))

)

 (add-frame-style 'V
                   (lambda (w type)
                     (case type
                       ((default) frame) 
                       ((transient) frame)
                       ((shaped) shaped-frame)
                       ((shaped-transient) shaped-frame)))))

;; Microtene/theme.jl

;; Copyright (C) 2000 Martin Kavalec <martin@penguin.cz>

;; you can use, modify and distribute this file under the terms
;; od GNU General Public License

;; icon images are taken form the Helix theme (then modified)
;; Helix theme is by Tuomas Kuosmanen <tigert@gimp.org>

;; this file is written analogically to
;; brushed-metal/theme.jl from the sawfish distribution

(let*
  (
    (font (get-font "-*-lucida-medium-r-normal-*-*-100-*-*-p-*-iso8859-2"))
    (font-colors (list "black" "white"))
    
	(title-images (list (make-image "title-inactive.png")
                            (make-image "title.png")))

	(title-left (list (make-image "title-left-i.png")
			    (make-image "title-left.png")))
	
	(title-right (list (make-image "title-right-i.png")
			    (make-image "title-right.png")))


    	(iconify-images (list (make-image "button-left.png")
			      nil nil
                              (make-image "button-left-c.png")))

     	(close-images (list (make-image "button-right.png")
			    nil nil
                            (make-image "button-right-c.png")))

     	(border-bottom (make-image "bottom.png"))
     	(border-right (make-image "right.png"))
     	(border-left (make-image "left.png"))

     	(top-left (make-image "top-left.png"))
    	(top-right (make-image "top-right.png"))
     	(top-lefts (make-image "top-left-shaded.png"))
    	(top-right-shaded (make-image "top-right-shaded.png"))
     	(corner-bl (make-image "bottom-left.png"))
     	(corner-br (make-image "bottom-right.png"))

     	(frame `(
		((background . ,top-left)
		 (top-edge . -14)
		 (left-edge . -4)
		 (class . top-left-corner))
		
		((background . ,iconify-images)
		 (top-edge . -14)
		 (left-edge . 0)
		 (class . iconify-button))

		((background . ,title-left)
		 (top-edge . -14)
		 (left-edge . 16)
		 (class . title))

		((background . ,title-images)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
		 (x-justify . 4)
		 (y-justify . center)
		 (top-edge . -14)
		 (left-edge . 17)
		 (right-edge . 17)
		 (class . title))
		
		((background . ,title-right)
		 (top-edge . -14)
		 (right-edge . 16)
		 (class . title))

    		((background . ,close-images)
      		 (top-edge . -14)
      		 (right-edge . 0)
      		 (class . close-button))
		
		((background . ,top-right)
		 (top-edge . -14)
		 (right-edge . -4)
		 (class . top-right-corner))

     		((background . ,border-left)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (left-edge . -4) 
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (right-edge . -4)
      		 (class . right-border))

     		((background . ,border-bottom)
      		 (bottom-edge . -4)
      		 (right-edge . 16)  
      		 (left-edge . 16)   
      		 (class . bottom-border))

     		((background . ,corner-bl)
      		 (bottom-edge . -4)
      		 (left-edge . -4)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br)
      		 (bottom-edge . -4)
      		 (right-edge . -4) 
      		 (class . bottom-right-corner))
	))

	(shaped-frame `(
		((background . ,top-lefts)
		 (top-edge . -14)
		 (left-edge . -4)
		 (class . top-left-corner))

		((background . ,iconify-images)
		 (top-edge . -14)
		 (left-edge . 0)
		 (class . iconify-button))

		((background . ,title-left)
		 (top-edge . -14)
		 (left-edge . 16)
		 (class . title))

		((background . ,title-images)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
		 (x-justify . 4)
		 (y-justify . center)
		 (top-edge . -14)
		 (left-edge . 17)
		 (right-edge . 17)
		 (class . title))
		
		((background . ,title-right)
		 (top-edge . -14)
		 (right-edge . 16)
		 (class . title))

    		((background . ,close-images)
      		 (top-edge . -14)
      		 (right-edge . 0)
      		 (class . close-button))

		((background . ,top-right-shaded)
		 (top-edge . -14)
		 (right-edge . -4)
		 (class . top-right-corner))
	))

	(transient-frame `(
		((background . ,title-right)
		 (top-edge . -14)
		 (left-edge . -4)
		 (class . title))
		((background . ,title-left)
		 (top-edge . -14)
		 (left-edge . -3)
		 (class . title))

		((background . ,title-images)
		 (foreground . ,font-colors)
		 (font . ,font)
		 (text . ,window-name)
		 (x-justify . 4)
		 (y-justify . center)
		 (top-edge . -14)
		 (left-edge . -2)
		 (right-edge . 17)
		 (class . title))
		
		((background . ,title-right)
		 (top-edge . -14)
		 (right-edge . 16)
		 (class . title))

    		((background . ,close-images)
      		 (top-edge . -14)
      		 (right-edge . 0)
      		 (class . close-button))
		
		((background . ,top-right)
		 (top-edge . -14)
		 (right-edge . -4)
		 (class . top-right-corner))

     		((background . ,border-left)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (left-edge . -4) 
      		 (class . left-border))

     		((background . ,border-right)
      		 (top-edge . 0)
      		 (bottom-edge . 0)
      		 (right-edge . -4)
      		 (class . right-border))

     		((background . ,border-bottom)
      		 (bottom-edge . -4)
      		 (right-edge . 16)  
      		 (left-edge . 16)   
      		 (class . bottom-border))

     		((background . ,corner-bl)
      		 (bottom-edge . -4)
      		 (left-edge . -4)  
      		 (class . bottom-left-corner))

     		((background . ,corner-br)
      		 (bottom-edge . -4)
      		 (right-edge . -4) 
      		 (class . bottom-right-corner))
	))
	
	(shaped-transient-frame `(
		((background . ,title-right)
		 (top-edge . -14)
		 (left-edge . -4)
		 (class . title))

		((background . ,title-left)
		 (top-edge . -14)
		 (left-edge . -3)
		 (class . title))

     		((background . ,title-images)
      		 (foreground . ,font-colors)
      		 (font . ,font)
      		 (text . ,window-name)
      		 (x-justify . 4)
      		 (y-justify . center)
      		 (top-edge . -14)
      		 (left-edge . -2)
      		 (right-edge . 17)
      		 (class . title))
		
		((background . ,title-right)
		 (top-edge . -14)
		 (right-edge . 16)
		 (class . title))

     		((background . ,close-images)
      		 (top-edge . -14)
      		 (right-edge . 0)
      		 (class . close-button))
		
		((background . ,top-right-shaded)
		 (top-edge . -14)
		 (right-edge . -4)
		 (class . top-right-corner))

	))
	
  )
  (add-frame-style 'Microtene
    	(lambda (w type)   
          (case type
	      ((default) frame)
	      ((shaped) shaped-frame)
              ((transient) transient-frame)
              ((shaped-transient) shaped-transient-frame)
              ((unframed) nil-frame)))))

;; theme file, written Mon Apr 23 17:46:22 2001
;; created by sawfish-themer -- DO NOT EDIT!

(require 'make-theme)

(let
    ((patterns-alist
      '(("title"
         (inactive . "#b45cb45cb45c")
         (focused . "#7fff8ccc9997"))
        ("buttons"
         (inactive . "#b45cb45cb45c")
         (focused . "#7f2d8c629997"))
        ("title fore"
         (inactive . "#7e0f7e0f7e0f")
         (focused . "#01f001f001f0"))
        ("buttons fore"
         (inactive . "#89b189b189b1")
         (focused . "#01f001f001f0"))))

     (frames-alist
      '(("typo"
         ((right-edge . 72)
          (left-edge . 18)
          (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (top-edge . -18)
          (height . 18)
          (foreground . "title fore")
          (background . "title")
          (x-justify . center)
          (y-justify . center)
          (text . window-name)
          (class . title))
         ((font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (right-edge . 48)
          (width . 24)
          (foreground . "buttons fore")
          (height . 18)
          (background . "buttons")
          (y-justify . center)
          (top-edge . -18)
          (class . iconify-button)
          (x-justify . center)
          (text . "[ _ ]"))
         ((font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (right-edge . 0)
          (foreground . "buttons fore")
          (background . "buttons")
          (y-justify . center)
          (top-edge . -18)
          (height . 18)
          (x-justify . center)
          (text . "[ X ]")
          (width . 24)
          (class . close-button))
         ((right-edge . 24)
          (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (foreground . "buttons fore")
          (background . "buttons")
          (y-justify . center)
          (height . 18)
          (top-edge . -18)
          (text . "[ ^ ]")
          (x-justify . center)
          (width . 24)
          (class . maximize-button))
         ((height . 18)
          (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (left-edge . 0)
          (foreground . "buttons fore")
          (background . "buttons")
          (y-justify . center)
          (x-justify . center)
          (text . "[ = ]")
          (width . 24)
          (top-edge . -18)
          (class . menu-button))
         ((height . 10)
          (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (right-edge . 0)
          (bottom-edge . 0)
          (foreground . "buttons fore")
          (background . "buttons")
          (y-justify . center)
          (x-justify . center)
          (text . "<=>")
          (width . 24)
          (class . bottom-right-corner)))
        ("typoshaded"
         ((font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (top-edge . -18)
          (left-edge . 18)
          (height . 18)
          (right-edge . 72)
          (foreground . "title fore")
          (background . "title")
          (x-justify . center)
          (y-justify . center)
          (text . window-name)
          (class . title))
         ((font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (right-edge . 48)
          (width . 24)
          (foreground . "buttons fore")
          (height . 18)
          (background . "buttons")
          (y-justify . center)
          (top-edge . -18)
          (class . iconify-button)
          (x-justify . center)
          (text . "[ _ ]"))
         ((right-edge . 0)
          (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (foreground . "buttons fore")
          (background . "buttons")
          (y-justify . center)
          (top-edge . -18)
          (height . 18)
          (x-justify . center)
          (text . "[ X ]")
          (width . 24)
          (class . close-button))
         ((right-edge . 24)
          (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (foreground . "buttons fore")
          (background . "buttons")
          (y-justify . center)
          (height . 18)
          (top-edge . -18)
          (text . "[ ^ ]")
          (x-justify . center)
          (width . 24)
          (class . maximize-button))
         ((height . 18)
          (font . "-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-*-*")
          (left-edge . 0)
          (foreground . "buttons fore")
          (background . "buttons")
          (y-justify . center)
          (x-justify . center)
          (text . "[ = ]")
          (width . 24)
          (top-edge . -18)
          (class . menu-button)))))

     (mapping-alist
      '((default . "typo")
        (transient . "typo")
        (shaped-transient . "typoshaded")
        (shaped . "typoshaded")))

     (theme-name 'typo))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))

#| Klarth sawfish theme, written in -*-lisp-*-

Copyright (C) 2001-2002 Kenny Graunke

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

$Id: theme.jl,v 1.7 2001/08/21 19:44:46 kenny Exp $

Authors: Kenny Graunke <kenny@whitecape.org>

|#

(require 'gradient)
(require 'rep.data.tables)		;need hash tables for icon cache
(require 'sawfish.wm.util.recolor-image)
(require 'sawfish.wm.util.gtkrc)

(defgroup Derivative "Derivative Theme"
          :group appearance)

(defvar Derivative:button-themes
  '((default
      ((iconify-button maximize-button) . (close-button)))
    (limit
      ((close-button) . (shade-button iconify-button maximize-button)))
    (platinum
     ((close-button) . (maximize-button shade-button)))
    (macos-x
     ((close-button iconify-button maximize-button)))
    (windows
     ((menu-button) . (iconify-button maximize-button close-button)))
    (next
     ((iconify-button) . (close-button)))))

(defcustom Derivative:button-theme 'default
           "Display title buttons to mimic: \\w"
  ;; XXX it would be better if the choices were extracted from
  ;; XXX the above alist somehow
           :type (choice (default "Default")
			 (limit "Limit")
                         (platinum "Mac OS 8/9")
                         (macos-x "Mac OS X")
                         (windows "MS Windows")
                         (next "NeXTSTEP"))
           :group (appearance Derivative)
           :after-set (lambda () (reframe-all)))
;; FIXME: Why is this a lambda? Can't it just be reframe-all?
;; ...because reframe-all is defined below. no other reason. :-)
;; I suppose I could fix this, if I really wanted to

;; maps WINDOW -> BUTTON-LIST
(define button-table (make-weak-table eq-hash eq))

;; new frame part classes (thanks to Greg Merchan)
(def-frame-class mover-grip ()
  (bind-keys mover-grip-keymap "Button1-Move" 'move-window-interactively))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;; Derivative Image & Color Functions

;; klarth-image-height : image -> Int:0-Inf
(define (klarth-image-height img)
  (cdr (image-dimensions img)))

;; klarth-image-width : image -> Int:0-Inf
(define (klarth-image-width img)
  (car (image-dimensions img)))

(define transparent-image (make-image "transparent-image.png"))
;; klarth-make-transparent-sized-image : Int Int -> image
(define (klarth-make-transparent-sized-image width height)
  (scale-image transparent-image width height))

;; klarth-rgb-to-hsv : (list num num num [num]) -> (list num num num)
(define (klarth-rgb-to-hsv rgb)
  (let* ((r (divide (nth 0 rgb) 255.))
         (g (divide (nth 1 rgb) 255.))
         (b (divide (nth 2 rgb) 255.))
         (maxim (max r g b))
	 (delta (- maxim (min r g b))))
    
    (cond
     ((= max 0) (list 0 0 maxim))
     ((= delta 0) (list -1 0 maxim))
     (t (list (let ((h (* 60 (cond
			      ((= r maxim) (divide (- g b) delta))
			      ((= g maxim) (+ 2 (divide (- b r) delta)))
			      (t (+ 4 (divide (- r g) delta)))))))
		(if (< h 0) (+ h 360) h))
	      (divide delta maxim) maxim)))))

;; klarth-hsv-to-rgb : (list num num num) -> (list num num num)
(define (klarth-hsv-to-rgb hsv)
  (let ((h (divide (nth 0 hsv) 60.)) (s (nth 1 hsv)) (v (nth 2 hsv)))
    (if (= s 0) (mapcar (lambda (n) (klarth-round (* 255 n))) (list v v v))
      (let* ((i (floor h))
	     (f (- h i))
	     (p (* v (- 1 s)))
	     (q (* v (- 1 (* s f))))
	     (t (* v (- 1 (* s (- 1 f))))))
	(mapcar (lambda (n) (klarth-round (* 255 n)))
		(cond
		 ((= i 0) (list v t p))
		 ((= i 1) (list q v p))
		 ((= i 2) (list p v t))
		 ((= i 3) (list p q v))
		 ((= i 4) (list t p v))
		 (t (list v p q))))))))

;; klarth-value-composite-image-on-color : img color -> img
(define (klarth-value-composite-image-on-color img color)
  (let* ((w (klarth-image-width img))
	 (h (klarth-image-height img))
	 (crgb (klarth-color-rgb color))
	 (chsv (klarth-rgb-to-hsv crgb))
	 (ch (nth 0 chsv))
	 (cs (nth 1 chsv))
	 (cv (nth 2 chsv))
	 (out (make-sized-image w h color)))
    (do ((y 0 (1+ y)))
        ((> y (1- h)) y)
      (do ((x 0 (1+ x)))
          ((> x (1- w)) x)
        (unless (= (nth 3 (image-ref img x y)) 0)
	  (let* ((orgb (image-ref img x y))
		 (ohsv (klarth-rgb-to-hsv orgb))
		 (aval (divide (nth 3 orgb) 255))
		 (avg (lambda (n)
			(+ (* (- 1 aval) (nth n chsv))
			   (* aval (nth n ohsv))))))
	    (image-set out x y (append (klarth-hsv-to-rgb
					(list (nth 0 chsv) (nth 1 chsv)
					      (avg 2)))
				       (list 255)))))))
    out))

;; klarth-vn-composite-to-bg image image color -> image
(define (klarth-vn-composite-to-bg vimg nimg col)
  (klarth-composite-images
   (klarth-value-composite-image-on-color vimg col) nimg 0 0))

;; klarth-composite-images : image image x y -> image
;; Composites the second image on top of the first one starting at (x,y)
;; (the origin being at the upper left corner of the first image), returns it
(define (klarth-composite-images bottom top x y)
  (define tmp (copy-image bottom))
  (composite-images tmp top x y)
  tmp)

;; klarth-color-rgb : color -> '(Int:0-255 Int:0-255 Int:0-255 Int:0-255)
(define (klarth-color-rgb color)
  (mapcar (lambda (x) (klarth-round (divide x 257.))) (color-rgb color)))

;;;; Colors

;; klarth-modify-color : string Int -> string
(define (klarth-modify-color cstr change)
  (define (modify-single rgorb ch)
    (max 0 (min 65535 (round (* rgorb ch)))))
  (let* ((rgb (color-rgb (get-color cstr)))
         (r (nth 0 rgb))
         (g (nth 1 rgb))
         (b (nth 2 rgb)))
    (color-name (get-color-rgb (modify-single r change)
			       (modify-single g change)
			       (modify-single b change)))))

;; klarth-get-gtk-color : num {gtkrc-foreground/background} string -> string
(define (klarth-get-gtk-color num gtkcols default)
  (if (colorp (nth num gtkcols)) (color-name (nth num gtkcols)) default))

;; klarth-gtk-bg-color : symbol -> string
(define (klarth-gtk-bg-color state)
  (cond
   ((eq state 'selected) (klarth-get-gtk-color 3 gtkrc-background "black"))
   ((eq state 'normal) (klarth-get-gtk-color 0 gtkrc-background "grey50"))))

;; klarth-gtk-fg-color : symbol -> string
(define (klarth-gtk-fg-color state)
  (cond
   ((eq state 'selected) (klarth-get-gtk-color 3 gtkrc-foreground "white"))
   ((eq state 'normal) (klarth-get-gtk-color 0 gtkrc-foreground "black"))))

(define klarth-focused-bg-color nil)
(define klarth-focused-bg-light-color nil)
(define klarth-focused-bg-dark-color nil)
(define klarth-unfocused-bg-color nil)
(define klarth-focused-fg-color nil)
(define klarth-unfocused-fg-color nil)
(define klarth-focused-border-color nil)
(define klarth-unfocused-border-color nil)

(define (klarth-update-colors)
  (setq klarth-focused-bg-color (klarth-gtk-bg-color 'selected))
  (setq klarth-focused-bg-light-color
	(klarth-modify-color klarth-focused-bg-color 135/100))
  (setq klarth-focused-bg-dark-color
	(klarth-modify-color klarth-focused-bg-color 45/100))
  (setq klarth-unfocused-bg-color (klarth-gtk-bg-color 'normal))
  
  (setq klarth-focused-fg-color (klarth-gtk-fg-color 'selected))
  (setq klarth-unfocused-fg-color (klarth-gtk-fg-color 'normal))
  
  ;; FIXME: do darken/lighten based on color (and if black), ok?
  (setq klarth-focused-border-color (get-color "black"))
  (setq klarth-unfocused-border-color (get-color "grey15")))
;; Initialize them.
(klarth-update-colors)

(define (klarth-bg-colors)
  (list klarth-unfocused-bg-color klarth-focused-bg-color))
(define (klarth-fg-colors)
  (list klarth-unfocused-fg-color klarth-focused-fg-color))
(define (klarth-border-colors)
  (list klarth-unfocused-border-color klarth-focused-border-color))
(define (klarth-light-bevel-colors)
  (list klarth-unfocused-bg-color klarth-focused-bg-light-color))
(define (klarth-dark-bevel-colors)
  (list klarth-unfocused-bg-color klarth-focused-bg-dark-color))

;; klarth-scale-image-to-height : image Int:0-Inf -> image
;; Returns the image scaled to the height but preserving the same aspect ratio.
(define (klarth-scale-image-to-height img height)
  (let* ((original-height (klarth-image-height img))
         (original-width (klarth-image-width img))
         (ratio (divide original-width original-height)))
    (scale-image img (round (* ratio height)) height)))

(define klarth-generic-window-icon (make-image "apple-red.png"))

;; klarth-window-icon: window -> image
;; Returns a scaled version of the window icon or a generic image if the window
;; doesn't have an icon.
(define (klarth-window-icon w)
  (let* ((wicon (window-icon-image w)))
    (klarth-scale-image-to-height (if wicon wicon klarth-generic-window-icon)
                                  (- (klarth-em klarth-titlearea-height) 4))))

;; klarth-greyscale-image : image -> image
;; Returns a greyscale version of an image.
(define (klarth-greyscale-image img)
  (let* ((tmp (copy-image img)))
    (image-map (lambda (pixval)
                 (let* ((r (nth 0 pixval))
                        (g (nth 1 pixval))
                        (b (nth 2 pixval))
                        (a (nth 3 pixval))
                        (avg (/ (+ r g b) 3)))
                   (list avg avg avg a)))
               tmp)
    tmp))

;; FIXME: Yes, I've stupidly added alpha-mod here, which doesn't belong
;; klarth-recolor-to : image string num -> image
(define (klarth-recolor-to img col alpha-mod)
  (let* ((tmp (copy-image img))
         (crgb (color-rgb (get-color col)))
         (cr (nth 0 crgb))
         (cg (nth 1 crgb))
         (cb (nth 2 crgb))
         (recolorer (lambda (pixval)
                      (let* ((r (nth 0 pixval))
                             (g (nth 1 pixval))
                             (b (nth 2 pixval))
                             (a (nth 3 pixval)))
                        (if (> a 0)
                            (list cr cg cb (klarth-round (* a alpha-mod)))
			    (list r g b (klarth-round (* a alpha-mod))))))))
    (image-map recolorer tmp)
    tmp))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;; Derivative Geometry Computations

;; klarth-window-width : window -> Int:0-Inf
(define (klarth-window-width w)
  (car (window-dimensions w)))

;; klarth-window-height : window -> Int:0-Inf
(define (klarth-window-height w)
  (cdr (window-dimensions w)))

;; klarth-titlebar-center : window -> Int
(define (klarth-titlebar-center w)
  (/ (klarth-window-width w) 2))

;; these are specified in EM!
(define klarth-titlearea-height 1.2)
(define klarth-resizer-height 0.5)
(define klarth-corner-width 1.8)

(define (klarth-corner-pwidth w)
  (min (klarth-em 1.8) (/ (klarth-window-width w) 3)))

;; klarth-left-buttonbox-width : window -> Int
(define (klarth-left-buttonbox-width w)
  (let ((nbuttons (length (car (table-ref button-table w)))))
    (+ 1 (* nbuttons klarth-titlearea-height) nbuttons)))

;; We SETQ values later, as we add buttons. :-/
(define klarth-left-buttons-width 0)
(define klarth-right-buttons-width 0)

;; klarth-titletext-x-justify : window -> Int
(define (klarth-titletext-x-justify w)
  (+ (klarth-image-width (klarth-window-icon w))
     klarth-left-buttons-width (klarth-em 0.3)))

;; klarth-titletext : window -> string
(define (klarth-titletext w)
  (let* ((tt (window-name w))
	 (ttw (text-width tt))
	 (av (- (klarth-window-width w)
;	       (* 2 (max 2 (klarth-em 0.3))) ;; FIXME_42: defined const this.
	       ; ^^^ unnecessary? I think it may be included in point already,
	       ; and hence already in k-l/r-b-w
;	       klarth-left-buttons-width
;	       why bother? just use the x-justify. :-D
		(klarth-titletext-x-justify w)
		klarth-right-buttons-width)))
    ;; FIXME
    (if () ;(> ttw av) 
	(concat (substring tt 0 (- (length tt)
				   (max 0 (/ (- ttw av (text-width "..."))
					     (klarth-em 0.2)))))
		"...")
        tt)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;; Derivative Utility Functions

;; klarth-window-maximized-both-p : window -> boolean
(define (klarth-window-maximized-both-p w)
  (and (window-maximized-horizontally-p w) (window-maximized-vertically-p w)))

;; klarth-window-resizable-p : window -> boolean
(define (klarth-window-resizable-p w)
  (let* ((size-hints (window-size-hints w))
	 (max-width-item (assoc 'max-width size-hints))
	 (min-width-item (assoc 'min-width size-hints)))
    (not (and max-width-item min-width-item
	      (= (cdr max-width-item) (cdr min-width-item))))))

;; klarth-round : number -> integer
(define (klarth-round x)
  (inexact->exact (round x)))

;; klarth-em : number -> integer
(define (klarth-em n)
  (klarth-round (* n (font-height default-font))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;; The Messy Stuff

;; bgparts & such

;; I wish I didn't have to keep all this around, but I have no choice.
;; sawfish removes the theme directory from the image path later, so when
;; I need to refresh the images due to a gtk+ theme change, they have to be
;; around.
(define close-v (make-image "close-v.png"))
(define close-n (make-image "close-n.png"))
(define min-v (make-image "min-v.png"))
(define min-n (make-image "min-n.png"))
(define max-v (make-image "max-v.png"))
(define max-n (make-image "max-n.png"))
(define umax-v (make-image "umax-v.png"))
(define umax-n (make-image "umax-n.png"))
(define shade-v (make-image "shade-v.png"))
(define shade-n (make-image "shade-n.png"))
(define menu-v (make-image "menu-v.png"))
(define menu-n (make-image "menu-n.png"))

;; make-button-bgpart : string string -> bgpart
(define (make-button-bgpart nimg vimg)
;  (let ((khei (- (klarth-em klarth-titlearea-height) 4)))
    (list (klarth-vn-composite-to-bg
	   (klarth-recolor-to vimg klarth-unfocused-fg-color 0.5)
	   (klarth-recolor-to nimg klarth-unfocused-fg-color 0.3)
	   ;; FIXME: and just chop the blasted alpha channel in half, don't
	   ;; do all this weighting stuff!
	   ;; FIXME: only recolor-to once, save resources...
	   ;; can't recolor-to the VN, because it has no alpha
	   ;(klarth-scale-image-to-height vimg khei)
	   ;(klarth-scale-image-to-height nimg khei)
	   (get-color klarth-unfocused-bg-color))
	  (klarth-vn-composite-to-bg
	   vimg nimg
	   ;(klarth-scale-image-to-height vimg khei)
	   ;(klarth-scale-image-to-height nimg khei)
	   (get-color klarth-focused-bg-color))
	  (klarth-composite-images
	   (klarth-composite-images
	    (make-sized-image (klarth-image-width nimg)
			      (klarth-image-height nimg)
			      (get-color klarth-focused-bg-color))
	    vimg 0 0) nimg 0 0)
));)

;	  (klarth-vn-composite-to-bg
;	   (klarth-composite-images vimg vimg 0 0) nimg
;	   ;(klarth-scale-image-to-height vimg khei)
;	   ;(klarth-scale-image-to-height nimg khei)
;	   (get-color klarth-focused-bg-color))

;(klarth-vn-composite-to-bg
;      (klarth-scale-image-to-height vimg khei)
;      (klarth-scale-image-to-height nimg khei)
;      (get-color klarth-focused-bg-color))

(define close-bgpart nil)
(define minimize-bgpart nil)
(define maximize-bgpart nil)
(define unmaximize-bgpart nil)
(define shade-bgpart nil)
(define menu-bgpart nil)

(define (klarth-update-bgparts)
  (setq close-bgpart      (make-button-bgpart close-n close-v))
  (setq minimize-bgpart   (make-button-bgpart min-n min-v))
  (setq maximize-bgpart   (make-button-bgpart max-n max-v))
  (setq unmaximize-bgpart (make-button-bgpart umax-n umax-v))
  (setq shade-bgpart      (make-button-bgpart shade-n shade-v))
  (setq menu-bgpart       (make-button-bgpart min-n min-v)))
(klarth-update-bgparts)

;; window icons

(define icon-table (make-weak-table eq-hash eq))

;; frames
(define common-frame-parts
  `(((background . ,klarth-border-colors)
     (left-edge . -1)
     (top-edge . ,(lambda () (- -2 (klarth-em klarth-titlearea-height))))

     (right-edge . -1)
     (height . ,(lambda () (+ 2 (klarth-em klarth-titlearea-height))))
     (class . title))

    ((background . ,klarth-bg-colors)
     (foreground . ,klarth-fg-colors)
     (left-edge . 0)
     (right-edge . 0)
     (top-edge . ,(lambda () (- -1 (klarth-em klarth-titlearea-height))))
     (height . ,(lambda () (klarth-em klarth-titlearea-height)))
;     (text . ,(lambda (w) (klarth-titletext w)))
     (text . ,window-name)
     (x-justify . ,klarth-titletext-x-justify)
     (y-justify . center)
     (class . title))

    ((background . ,(lambda (w)
		      (let* ((wicon (klarth-window-icon w)))
			(list (klarth-composite-images
			       (make-sized-image
				(klarth-image-width wicon)
				(klarth-image-height wicon)
				(get-color klarth-unfocused-bg-color))
			       (klarth-greyscale-image wicon) 0 0)
			      (klarth-composite-images
			       (make-sized-image
				(klarth-image-width wicon)
				(klarth-image-height wicon)
				(get-color klarth-focused-bg-color))
			       wicon 0 0)))))
     (left-edge . ,(lambda () klarth-left-buttons-width))
     (top-edge . ,(lambda () (- 1 (klarth-em klarth-titlearea-height))))
     (class . title))

    ;; bevels

    ((background . ,klarth-light-bevel-colors)
     (left-edge . 0)
     (right-edge . 0)
     (top-edge . ,(lambda () (- -1 (klarth-em klarth-titlearea-height))))
     (height . 1)
     (class . title))
    ((background . ,klarth-light-bevel-colors)
     (left-edge . 0)
     (top-edge . ,(lambda () (- -1 (klarth-em klarth-titlearea-height))))
     (height . ,(lambda () (klarth-em klarth-titlearea-height)))
     (width . 1)
     (class . title))
    ((background . ,klarth-dark-bevel-colors)
     (left-edge . 1)
     (right-edge . 0)
     (top-edge . -2)
     (height . 1)
     (class . title))
    ((background . ,klarth-dark-bevel-colors)
     (right-edge . 0)
     (top-edge . ,(lambda () (- 0 (klarth-em klarth-titlearea-height))))
     (height . ,(lambda () (- (klarth-em klarth-titlearea-height) 1)))
     (width . 1)
     (class . title))
    ))

(define shaped-frame
  `(,@common-frame-parts
    ((background . ,klarth-border-colors)
     (top-edge . ,(lambda () (- 0 (klarth-em klarth-titlearea-height))))
     (right-edge . -2)
     (height . ,(lambda () (klarth-em klarth-titlearea-height)))
     (width . 2)
     (class . mover-grip))
    
    ((background . ,klarth-border-colors)
     (top-edge . 0)
     (left-edge . 2)
     (right-edge . -2)
     (height . 1)
     (class . mover-grip))
    ))

(define non-resizable-frame
  `(,@common-frame-parts

    ((background . ,klarth-border-colors)
     (top-edge . 0)
     (bottom-edge . 0)
     (left-edge . -1)
     (width . 1)
     (class . mover-grip))

    ((background . ,klarth-border-colors)
     (top-edge . ,(lambda () (- 0 (klarth-em klarth-titlearea-height))))
     (bottom-edge . 0)
     (right-edge . -2)
     (width . 2)
     (class . mover-grip))

    ((background . ,klarth-border-colors)
     (bottom-edge . -1)
     (left-edge . -1)
     (right-edge . -2)
     (height . 1)
     (class . mover-grip))

    ((background . ,klarth-border-colors)
     (bottom-edge . -2)
     (left-edge . 2)
     (right-edge . -2)
     (height . 1)
     (class . mover-grip))
    ))

(define resizable-frame
  `(,@non-resizable-frame
    ((background . ,klarth-border-colors)
     (left-edge . ,klarth-corner-pwidth)
     (right-edge . ,klarth-corner-pwidth)
     (bottom-edge . ,(lambda () (- -1 (klarth-em klarth-resizer-height))))
     (height . ,(lambda () (+ (klarth-em klarth-resizer-height) 1)))
     (class . bottom-border))

    ((background . ,klarth-bg-colors)
     (left-edge . ,klarth-corner-pwidth)
     (right-edge . ,klarth-corner-pwidth)
     (bottom-edge . ,(lambda () (- 1 (klarth-em klarth-resizer-height))))
     (height . ,(lambda () (- (klarth-em klarth-resizer-height) 2)))
     (class . bottom-border))

    ((background . ,klarth-light-bevel-colors)
     (left-edge . ,(lambda (w) (+ 1 (klarth-corner-pwidth w))))
     (right-edge . ,(lambda (w) (+ 1 (klarth-corner-pwidth w))))
     (bottom-edge . -2)
     (height . 1)
     (class . bottom-border))

    ((background . ,(lambda () (list klarth-unfocused-border-color
		      klarth-focused-bg-light-color)))
     (left-edge . ,klarth-corner-pwidth)
;     (left-edge . ,(lambda () (klarth-em klarth-corner-width)))
     (bottom-edge . ,(lambda () (- 1 (klarth-em klarth-resizer-height))))
     (height . ,(lambda () (- (klarth-em klarth-resizer-height) 2)))
     (width . 1)
     (class . bottom-border))

    ((background . ,(lambda () (list klarth-unfocused-border-color
		      klarth-focused-bg-dark-color)))
;     (right-edge . ,(lambda () (klarth-em klarth-corner-width)))
     (right-edge . ,klarth-corner-pwidth)
     (bottom-edge . ,(lambda () (- 1 (klarth-em klarth-resizer-height))))
     (height . ,(lambda () (- (klarth-em klarth-resizer-height) 2)))
     (width . 1)
     (class . bottom-border))

    ;; FIXME
    ((background . ,(lambda () (list klarth-unfocused-border-color
		      klarth-focused-bg-light-color)))
     (right-edge . ,klarth-corner-pwidth)
;     (right-edge . ,(lambda () (klarth-em klarth-corner-width)))
     (bottom-edge . -2)
     (height . 1)
     (width . 1)
     (class . bottom-border))

    ((background . ,klarth-border-colors)
     (right-edge . -2)
     (bottom-edge . ,(lambda () (- -1 (klarth-em klarth-resizer-height))))
     (height . ,(lambda () (+ (klarth-em klarth-resizer-height) 1)))
;     (width . ,(lambda () (+ (klarth-em klarth-corner-width) 2)))
     (width . ,(lambda (w) (+ 2 (klarth-corner-pwidth w))))
     (class . bottom-right-corner))

    ((background . ,klarth-bg-colors)
     (right-edge . 0)
     (bottom-edge . ,(lambda () (- 1 (klarth-em klarth-resizer-height))))
     (height . ,(lambda () (- (klarth-em klarth-resizer-height) 2)))
     (width . ,klarth-corner-pwidth)
;     (width . ,(lambda () (klarth-em klarth-corner-width)))
     (class . bottom-right-corner))

    ((background . ,klarth-light-bevel-colors)
     (right-edge . 0)
     (bottom-edge . -2)
     (height . 1)
     (width . ,klarth-corner-pwidth)
;     (width . ,(lambda () (klarth-em klarth-corner-width)))
     (class . bottom-right-corner))

    ((background . ,klarth-light-bevel-colors)
     (right-edge . ,(lambda (w) (- (klarth-corner-pwidth w) 1)))
     (bottom-edge . ,(lambda () (- 1 (klarth-em klarth-resizer-height))))
     (height . ,(lambda () (- (klarth-em klarth-resizer-height) 2)))
     (width . 1)
     (class . bottom-right-corner))

    ((background . ,klarth-border-colors)
     (left-edge . -1)
     (bottom-edge . ,(lambda () (- 0 (klarth-em klarth-resizer-height))))
     (height . ,(lambda () (klarth-em klarth-resizer-height)))
     (width . ,(lambda (w) (+ 1 (klarth-corner-pwidth w))))
     (class . bottom-left-corner))

    ((background . ,klarth-border-colors)
     (left-edge . 2)
     (bottom-edge . ,(lambda () (- -1 (klarth-em klarth-resizer-height))))
     (height . 1)
     (width . ,(lambda (w) (- (klarth-corner-pwidth w) 2)))
     (class . bottom-left-corner))

    ((background . ,klarth-bg-colors)
     (left-edge . 0)
     (bottom-edge . ,(lambda () (- 1 (klarth-em klarth-resizer-height))))
     (height . ,(lambda () (- (klarth-em klarth-resizer-height) 2)))
     (width . ,klarth-corner-pwidth)
     (class . bottom-left-corner))

    ((background . ,klarth-light-bevel-colors)
     (left-edge . 0)
     (bottom-edge . -2)
     (height . 1)
     (width . ,klarth-corner-pwidth)
     (class . bottom-left-corner))

    ((background . ,klarth-dark-bevel-colors)
     (left-edge . ,(lambda (w) (- (klarth-corner-pwidth w) 1)))
     (bottom-edge . ,(lambda () (- 1 (klarth-em klarth-resizer-height))))
     (height . ,(lambda () (- (klarth-em klarth-resizer-height) 3)))
     (width . 1)
     (class . bottom-left-corner))
    ))

;; packing buttons

(define button-map
  `((iconify-button . (,(image-dimensions min-v) ,(lambda () minimize-bgpart)))
    (maximize-button . (,(image-dimensions max-v)
			,(lambda (w) (if (window-maximized-p w)
					 unmaximize-bgpart maximize-bgpart))))
    (close-button . (,(image-dimensions close-v) ,(lambda () close-bgpart)))
    (menu-button . (,(image-dimensions menu-v) ,(lambda () menu-bgpart)))
;; This works, but requires window-get to not be gaol'ed - arggh
;    (shade-button . ,(lambda (w)
;		       (if (window-get w 'shaded) shade-bgpart unshade-bgpart)))
    (shade-button . (,(image-dimensions shade-v) ,(lambda () shade-bgpart)))
    ))

;; klarth-remove-unnecessary-buttons : (something like vvv) -> 
;; '((close-button) maximize-button iconify-button)
(define (klarth-remove-unnecessary-buttons dual-buttons w)
  ;; FIXME: can't let* lambda here, since it won't be able to call itself
  (define (helper buttons)
    ;; this is just a '(foo bar), so it's empty or a symbol (button name).
    (cond
     ((null buttons) ())
     ((not (eq (car buttons) 'maximize-button))
      (cons (car buttons) (helper (cdr buttons))))
     ((klarth-window-resizable-p w)
      (cons 'maximize-button (helper (cdr buttons))))
     (t (helper (cdr buttons)))))
  (cons (helper (car dual-buttons)) (helper (cdr dual-buttons))))
  
(define (button-theme w)
  (klarth-remove-unnecessary-buttons
   (car (cdr (or (assq Derivative:button-theme Derivative:button-themes)
		 (assq 'default Derivative:button-themes)))) w))

(define (make-buttons spec colored edge resizable)
  (define (make-button class height bg point)
    `((background . ,bg)
      (,edge . ,point)
      (top-edge . ,(lambda () (+ (/ (- (klarth-em klarth-titlearea-height)
				       height) 2)
				 (- 0 (klarth-em klarth-titlearea-height)))))
      (class . ,class)))

  (do ((rest spec (cdr rest))
       (point (max 2 (klarth-em 0.3)) ;; FIXME_42: make this a defined const
	      (+ point (max 1 (klarth-em 0.3))
		 (car (cadr (assq (car rest) button-map)))))
       (out '() (cons (make-button (car rest)
;    (shade-button . (,(image-dimensions shade-v) ,(lambda () shade-bgpart))) 				   
				   (cdr (cadr (assq (car rest) button-map)))
				   (car (cddr (assq (car rest) button-map)))
				   point)
		      out)))
      ((null rest) (if (eq edge 'left-edge)
		       (setq klarth-left-buttons-width point)
		       (setq klarth-right-buttons-width point))
     out)))


;; misc stuff

(define (reframe-all)
  (klarth-update-colors)
  (klarth-update-bgparts)
  (reframe-windows-with-style 'Derivative))
(gtkrc-call-after-changed reframe-all)

(define (make-frame w frame buttons)
  (let ((resizable (klarth-window-resizable-p w)))
    (table-set button-table w buttons)
    (append frame
	    (make-buttons (car buttons) t 'left-edge resizable)
	    (make-buttons (reverse (cdr buttons)) () 'right-edge resizable))))

(define (get-frame w type)  
  (make-frame w (if (or (eq type 'default) (eq type 'transient))
		    (if (klarth-window-resizable-p w)
			resizable-frame
		        non-resizable-frame)
		  shaped-frame)
	      (button-theme w)))

;; register the theme
(add-frame-style 'Derivative get-frame)

;; recalibrate frames when the window-name changes
(call-after-property-changed 'WM_NAME rebuild-frame)

;; Titanium/theme.jl

;; Copyright (C) 2001 Jesús González <jgonzlz@terra.es>

;; Contributions for "Custom" button arrangement
;; by Michele Campeotto <micampe@f2s.com>

;; This theme is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;;
;; It is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with sawmill; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

(defgroup
	Titanium
	"Titanium"
	:group appearance
)
  
(defcustom
	Titanium:ShowIcon t
	"Show window icon on titlebar"
	:user-level novice
	:type boolean
	:group (appearance Titanium)
)

(defcustom
	Titanium:ShowHandle t
	"Show resize handle"
	:user-level novice
	:type boolean
	:group (appearance Titanium)
)

(defcustom 
	Titanium:ButtonLayout 'Titanium
	"Arrangement of buttons on titlebar"
	:user-level novice
	:type symbol
	:options (Titanium Platinum Platinum+ Aqua Amiga FVWM2 KDE TWM WindowMaker Custom)
	:group (appearance Titanium)
)

(defcustom 
	Titanium:ButtonStyle 'Titanium
	"Style of buttons on titlebar"
	:user-level novice
	:type symbol
	:options (Titanium Platinum)
	:group (appearance Titanium)
)

(defcustom
	Titanium:DefaultIcon ""
	"Default Icon image"
	:user-level expert
	:type file-name
	:group (appearance Titanium)
)

(defcustom
	Titanium:TitleFont (get-font "-b&h-lucida-bold-r-normal-*-*-120-*-*-p-*-iso8859-1")
	"Titlebar font"
	:user-level expert
	:type font
	:group (appearance Titanium)
)
	
(defcustom
	Titanium:TransientTitleFont (get-font "-b&h-lucida-bold-r-normal-*-*-100-*-*-p-*-iso8859-1")
	"Transient titlebar font"
	:user-level expert
	:type font
	:group (appearance Titanium)
)
	
(defcustom
	Titanium:ActiveBaseColor (get-color "white")
	"Active decoration base color"
	:user-level expert
	:type color
	:group (appearance Titanium)
)

(defcustom
	Titanium:InactiveBaseColor (get-color "white")
	"Inactive decoration base color"
	:user-level expert
	:type color
	:group (appearance Titanium)
)

(defcustom
	Titanium:ActiveTitleColor (get-color "black")
	"Active title text color"
	:user-level expert
	:type color
	:group (appearance Titanium)
)

(defcustom
	Titanium:InactiveTitleColor (get-color "#6c6c6c")
	"Inactive title text color"
	:user-level expert
	:type color
	:group (appearance Titanium)
)
	
(defgroup
    LeftButtons
    "Custom left buttons"
    :group (appearance Titanium)
)
  
(defcustom 
    Titanium:LeftButton1 'Shade
    "First button on the left"
    :user-level novice
    :type symbol
    :options (Close Maximize Minimize Shade None)
    :group (appearance Titanium LeftButtons)
)

(defcustom 
    Titanium:LeftButton2 'Minimize
    "Second button on the left"
    :user-level novice
    :type symbol
    :options (Close Maximize Minimize Shade None)
    :group (appearance Titanium LeftButtons)
)

(defcustom 
    Titanium:LeftButton3 'Maximize
    "Third button on the left"
    :user-level novice
    :type symbol
    :options (Close Maximize Minimize Shade None)
    :group (appearance Titanium LeftButtons)
)

(defcustom 
    Titanium:LeftButton4 'None
    "Fourth button on the left"
    :user-level novice
    :type symbol
    :options (Close Maximize Minimize Shade None)
    :group (appearance Titanium LeftButtons)
)

(defgroup
    RightButtons
    "Custom right buttons"
    :group (appearance Titanium)
)
  
(defcustom 
    Titanium:RightButton1 'Close
    "First button on the right"
    :user-level novice
    :type symbol
    :options (Close Maximize Minimize Shade None)
    :group (appearance Titanium RightButtons)
)

(defcustom 
    Titanium:RightButton2 'None
    "Second button on the right"
    :user-level novice
    :type symbol
    :options (Close Maximize Minimize Shade None)
    :group (appearance Titanium RightButtons)
)

(defcustom 
    Titanium:RightButton3 'None
    "Third button on the right"
    :user-level novice
    :type symbol
    :options (Close Maximize Minimize Shade None)
    :group (appearance Titanium RightButtons)
)

(defcustom 
    Titanium:RightButton4 'None
    "Fourth button on the right"
    :user-level novice
    :type symbol
    :options (Close Maximize Minimize Shade None)
    :group (appearance Titanium RightButtons)
)

(letrec
	(
		dht dft dsw sdw gsw
		
		bt2 bt4 bt5 bt6 bt7 bt8 bt9 btA btB btC btD btE btF
		
		close-button-mask
		maximize-button-mask
		iconify-button-mask
		shade-button-mask
		transient-close-button-mask
		transient-maximize-button-mask
		transient-iconify-button-mask
		transient-shade-button-mask
	
		(default-icon (make-image "icon.png"))
		
		(user-icon ())
		
		(icon-image (lambda (win)
			(let
				((icon (window-icon-image win)))
				(if icon
					icon
					(if user-icon
						user-icon
						default-icon
					)
				)
			)
		))
		
		(make-image-set (lambda (width height)
			`(
				,(make-sized-image width height)
				,(make-sized-image width height)
			)
		))
		
		(make-button-set (lambda (width height)
			`(
				,(make-sized-image width height)
				,(make-sized-image width height)
				nil
				,(make-sized-image width height)
			)
		))
		
		;;
		;; Normal frames
		;;
		
		(button-default-mask [
			[bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 btC]
			[bt8 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 btF]
			[bt8 bt2 btF btC btC btC btC btC btC btC btC bt2 btF]
			[bt8 bt2 btC bt9 bt9 btA btA btB btB btC bt8 bt2 btF]
			[bt8 bt2 btC bt9 btA btA btB btB btC btC bt8 bt2 btF]
			[bt8 bt2 btC btA btA btB btB btC btC btD bt8 bt2 btF]
			[bt8 bt2 btC btA btB btB btC btC btD btD bt8 bt2 btF]
			[bt8 bt2 btC btB btB btC btC btD btD btE bt8 bt2 btF]
			[bt8 bt2 btC btB btC btC btD btD btE btE bt8 bt2 btF]
			[bt8 bt2 btC btC btC btD btD btE btE btF bt8 bt2 btF]
			[bt8 bt2 btC bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt2 btF]
			[bt8 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 btF]
			[btC btF btF btF btF btF btF btF btF btF btF btF btF]		
		])
		(button-clicked-mask [
			[bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 btC]
			[bt8 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 btF]
			[bt8 bt2 bt4 bt4 bt5 bt5 bt6 bt6 bt7 bt7 bt8 bt2 btF]
			[bt8 bt2 bt4 bt5 bt5 bt6 bt6 bt7 bt7 bt8 bt8 bt2 btF]
			[bt8 bt2 bt5 bt5 bt6 bt6 bt7 bt7 bt8 bt8 bt9 bt2 btF]
			[bt8 bt2 bt5 bt6 bt6 bt7 bt7 bt8 bt8 bt9 bt9 bt2 btF]
			[bt8 bt2 bt6 bt6 bt7 bt7 bt8 bt8 bt9 bt9 bt9 bt2 btF]
			[bt8 bt2 bt6 bt7 bt7 bt8 bt8 bt9 bt9 btA bt9 bt2 btF]
			[bt8 bt2 bt7 bt7 bt8 bt8 bt9 bt9 btA btA bt9 bt2 btF]
			[bt8 bt2 bt7 bt8 bt8 bt9 bt9 btA btA btB bt9 bt2 btF]
			[bt8 bt2 bt7 bt8 bt8 bt9 bt9 bt9 bt9 bt9 bt9 bt2 btF]
			[bt8 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 btF]
			[btC btF btF btF btF btF btF btF btF btF btF btF btF]
		])
		
		(close-image (make-button-set 13 13))
		(titanium-close-button-mask [
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil bt2 bt2 bt2 nil nil nil nil nil]
			[nil nil nil nil bt2 nil bt2 nil bt2 nil nil nil nil]
			[nil nil nil nil nil bt2 bt2 bt2 nil nil nil nil nil]
			[nil nil nil nil nil bt2 bt2 bt2 nil nil nil nil nil]
			[nil nil nil nil bt2 nil bt2 nil bt2 nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
		])
		(platinum-close-button-mask [
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
		])
		
		(maximize-image (make-button-set 13 13))
		(titanium-maximize-button-mask [
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil bt2 nil nil nil nil nil nil]
			[nil nil nil nil nil bt2 bt2 bt2 nil nil nil nil nil]
			[nil nil nil nil bt2 bt2 bt2 bt2 bt2 nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
		])
		(platinum-maximize-button-mask [
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil bt2 nil nil nil nil nil]
			[nil nil nil nil nil nil nil bt2 nil nil nil nil nil]
			[nil nil nil nil nil nil nil bt2 nil nil nil nil nil]
			[nil nil nil nil nil nil nil bt2 nil nil nil nil nil]
			[nil nil nil nil nil nil nil bt2 nil nil nil nil nil]
			[nil nil bt2 bt2 bt2 bt2 bt2 bt2 nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
		])
		
		(iconify-image (make-button-set 13 13))
		(titanium-iconify-button-mask [
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil bt2 bt2 bt2 bt2 bt2 nil nil nil nil]
			[nil nil nil nil nil bt2 bt2 bt2 nil nil nil nil nil]
			[nil nil nil nil nil nil bt2 nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
		])
		(platinum-iconify-button-mask [
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
		])
		
		(shade-image (make-button-set 13 13))
		(titanium-shade-button-mask [
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil bt2 bt2 bt2 nil nil nil nil nil]
			[nil nil nil nil nil bt2 bt2 bt2 nil nil nil nil nil]
			[nil nil nil nil nil bt2 bt2 bt2 nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
		])
		(platinum-shade-button-mask [
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil nil nil nil]
		])
		
		(title-image (make-image-set 1 1))
		(title-image-mask [
			[dft]
		])
		
		(side-top (make-image-set 1 4))
		(side-top-mask [
			[sdw]
			[dht]
			[dft]
			[dft]
		])

		(side-bottom (make-image-set 1 6))
		(side-bottom-mask [
			[sdw]
			[dht]
			[dft]
			[dft]
			[dsw]
			[sdw]
		])
		
		(side-subtitle (make-image-set 1 4))
		(side-subtitle-mask [
			[dft]
			[dft]
			[dsw]
			[sdw]
		])
		
		(sides (make-image-set 6 1))
		(sides-mask [
			[sdw dht dft dft dsw sdw]
		])

		(corner-top-side-left (make-image-set 6 1))
		(corner-top-side-left-mask [
			[sdw dht dft dft dft dft]
		])

		(corner-top-side-right (make-image-set 6 1))
		(corner-top-side-right-mask [
			[dft dft dft dft dsw sdw]
		])

		(junction-left (make-image-set 6 2))
		(junction-left-mask [
			[sdw dht dft dft dsw dsw]
			[sdw dht dft dft dsw sdw]
		])

		(junction-right (make-image-set 6 2))
		(junction-right-mask [
			[dsw dft dft dft dsw sdw]
			[sdw dht dft dft dsw sdw]
		])

		(corner-top-left (make-image-set 10 10))
		(corner-top-left-mask [
			[sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
			[sdw dht dht dht dht dht dht dht dht dht]
			[sdw dht dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft]
		])
		
		(corner-top-right (make-image-set 10 10))
		(corner-top-right-mask [
			[sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
			[dht dht dht dht dht dht dht dht dft sdw]			
			[dft dft dft dft dft dft dft dft dsw sdw]
			[dft dft dft dft dft dft dft dft dsw sdw]
			[dft dft dft dft dft dft dft dft dsw sdw]
			[dft dft dft dft dft dft dft dft dsw sdw]
			[dft dft dft dft dft dft dft dft dsw sdw]
			[dft dft dft dft dft dft dft dft dsw sdw]
			[dft dft dft dft dft dft dft dft dsw sdw]
			[dft dft dft dft dft dft dft dft dsw sdw]
		])

		(corner-bottom-left (make-image-set 10 10))
		(corner-bottom-left-mask [
			[sdw dht dft dft dsw sdw sdw sdw sdw sdw]
			[sdw dht dft dft dsw sdw sdw sdw sdw sdw]
			[sdw dht dft dft dsw sdw sdw sdw sdw sdw]
			[sdw dht dft dft dsw sdw sdw sdw sdw sdw]
			[sdw dht dft dft dsw sdw sdw sdw sdw sdw]
			[sdw dht dft dft dft dht dht dht dht dht]
			[sdw dht dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft]
			[sdw dft dsw dsw dsw dsw dsw dsw dsw dsw]
			[sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(corner-bottom-right (make-image-set 10 10))
		(corner-bottom-right-mask [
			[sdw sdw sdw sdw sdw dht dft dft dsw sdw]
			[sdw sdw sdw sdw sdw dht dft dft dsw sdw]
			[sdw sdw sdw sdw sdw dht dft dft dsw sdw]
			[sdw sdw sdw sdw sdw dht dft dft dsw sdw]
			[sdw sdw sdw sdw sdw dht dft dft dsw sdw]
			[dht dht dht dht dht dht dft dft dsw sdw]
			[dft dft dft dft dft dft dft dft dsw sdw]
			[dft dft dft dft dft dft dft dft dsw sdw]
			[dsw dsw dsw dsw dsw dsw dsw dsw dsw sdw]
			[sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw]
		])
		
		(shadow (make-image-set 1 1))
		(shadow-mask [
			[sdw]
		])
		
		(grip (let
			((grp (make-image-set 4 4)))
			(image-put (last grp) 'tiled t)
			grp
		))
		(grip-mask [
			[gsw dft dft dft]
			[dft dht dft dft]
			[dft dft dft dft]
			[dft dft dft dft]
		])
				
		(handle (make-image-set 16 16))
		(handle-mask [
			[sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw sdw dht]
			[sdw dht dht dht dht dht dht dht dht dht dht dht dht dht dht dht]
			[sdw dht dft dft dft dft dft dft dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft gsw dft dft dft gsw dft dft dft gsw dft dft]
			[sdw dht dft dft dft dft dht dft dft dft dht dft dft dft dht dft]
			[sdw dht dft dft dft dft dft dft dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft gsw dft dft dft gsw dft dft dft gsw dft dft]
			[sdw dht dft dft dft dft dht dft dft dft dht dft dft dft dht dft]
			[sdw dht dft dft dft dft dft dft dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft dft dft dft dft dft dft dft dft dft dft dft]
			[sdw dht dft dft dft gsw dft dft dft gsw dft dft dft gsw dft dft]
			[sdw dht dft dft dft dft dht dft dft dft dht dft dft dft dht dft]
			[dht dht dft dft dft dft dft dft dft dft dft dft dft dft dft dft]
		])
		
		;;
		;; Transient frames
		;;

		(transient-button-default-mask [
			[bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 btC]
			[bt8 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 btF]
			[bt8 bt2 btF btC btC btC btC btC bt2 btF]
			[bt8 bt2 btC bt9 bt9 btA btC bt8 bt2 btF]
			[bt8 bt2 btC bt9 btA btC btD bt8 bt2 btF]
			[bt8 bt2 btC btA btC btD btE bt8 bt2 btF]
			[bt8 bt2 btC btC btD btE btF bt8 bt2 btF]
			[bt8 bt2 btC bt8 bt8 bt8 bt8 bt8 bt2 btF]
			[bt8 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 btF]
			[btC btF btF btF btF btF btF btF btF btF]		
		])
		(transient-button-clicked-mask [
			[bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 bt8 btC]
			[bt8 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 btF]
			[bt8 bt2 bt4 bt4 bt5 bt7 bt8 bt8 bt2 btF]
			[bt8 bt2 bt4 bt5 bt7 bt8 bt8 bt9 bt2 btF]
			[bt8 bt2 bt5 bt7 bt8 bt8 bt9 bt9 bt2 btF]
			[bt8 bt2 bt7 bt8 bt8 bt9 btA bt9 bt2 btF]
			[bt8 bt2 bt8 bt8 bt9 btA btB bt9 bt2 btF]
			[bt8 bt2 bt8 bt9 bt9 bt9 bt9 bt9 bt2 btF]
			[bt8 bt2 bt2 bt2 bt2 bt2 bt2 bt2 bt2 btF]
			[btC btF btF btF btF btF btF btF btF btF]
		])

		
		(transient-close-image (make-button-set 10 10))
		(titanium-transient-close-button-mask [
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil bt2 bt2 nil nil nil nil]
			[nil nil nil bt2 bt2 bt2 bt2 nil nil nil]
			[nil nil nil nil bt2 bt2 nil nil nil nil]
			[nil nil nil bt2 nil nil bt2 nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
		])
		(platinum-transient-close-button-mask [
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
		])
		
		(transient-maximize-image (make-button-set 10 10))
		(titanium-transient-maximize-button-mask [
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil bt2 bt2 nil nil nil nil]
			[nil nil nil bt2 bt2 bt2 bt2 nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
		])
		(platinum-transient-maximize-button-mask [
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil bt2 nil nil nil nil]
			[nil nil nil nil nil bt2 nil nil nil nil]
			[nil nil nil nil nil bt2 nil nil nil nil]
			[nil nil bt2 bt2 bt2 bt2 nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
		])
		
		(transient-iconify-image (make-button-set 10 10))
		(titanium-transient-iconify-button-mask [
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil bt2 bt2 bt2 bt2 nil nil nil]
			[nil nil nil nil bt2 bt2 nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
		])
		(platinum-transient-iconify-button-mask [
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil bt2 bt2 bt2 bt2 bt2 bt2 nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
		])
		
		(transient-shade-image (make-button-set 10 10))
		(titanium-transient-shade-button-mask [
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil bt2 bt2 nil nil nil nil]
			[nil nil nil nil bt2 bt2 nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
		])
		(platinum-transient-shade-button-mask [
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil bt2 bt2 bt2 bt2 bt2 bt2 nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil bt2 bt2 bt2 bt2 bt2 bt2 nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
			[nil nil nil nil nil nil nil nil nil nil]
		])

		(transient-side-top (make-image-set 1 2))
		(transient-side-top-mask [
			[sdw]
			[dht]
		])

		(transient-side-bottom (make-image-set 1 4))
		(transient-side-bottom-mask [
			[sdw]
			[dht]
			[dsw]
			[sdw]
		])
		
		(transient-side-subtitle (make-image-set 1 2))
		(transient-side-subtitle-mask [
			[dsw]
			[sdw]
		])
		
		(transient-sides (make-image-set 4 1))
		(transient-sides-mask [
			[sdw dht dsw sdw]
		])

		(transient-corner-top-side-left (make-image-set 2 1))
		(transient-corner-top-side-left-mask [
			[sdw dht]
		])

		(transient-corner-top-side-right (make-image-set 2 1))
		(transient-corner-top-side-right-mask [
			[dsw sdw]
		])

		(transient-junction-left (make-image-set 4 2))
		(transient-junction-left-mask [
			[sdw dht dsw dsw]
			[sdw dht dsw sdw]
		])

		(transient-junction-right (make-image-set 4 2))
		(transient-junction-right-mask [
			[dsw dft dsw sdw]
			[sdw dht dsw sdw]
		])

		(transient-corner-top-left (make-image-set 5 5))
		(transient-corner-top-left-mask [
			[sdw sdw sdw sdw sdw]
			[sdw dht dht dht dht]
			[sdw dht dft dft dft]
			[sdw dht dft dft dft]
			[sdw dht dft dft dft]
		])
		
		(transient-corner-top-right (make-image-set 5 5))
		(transient-corner-top-right-mask [
			[sdw sdw sdw sdw sdw]
			[dht dht dht dft sdw]			
			[dft dft dft dsw sdw]
			[dft dft dft dsw sdw]
			[dft dft dft dsw sdw]
		])

		(transient-corner-bottom-left (make-image-set 5 5))
		(transient-corner-bottom-left-mask [
			[sdw dht dsw sdw sdw]
			[sdw dht dsw sdw sdw]
			[sdw dht dft dht dht]
			[sdw dft dsw dsw dsw]
			[sdw sdw sdw sdw sdw]
		])
		
		(transient-corner-bottom-right (make-image-set 5 5))
		(transient-corner-bottom-right-mask [
			[sdw sdw dht dsw sdw]
			[sdw sdw dht dsw sdw]
			[dht dht dht dsw sdw]
			[dsw dsw dsw dsw sdw]
			[sdw sdw sdw sdw sdw]
		])
		
		(transient-grip (let
			((grp (make-image-set 3 3)))
			(image-put (last grp) 'tiled t)
			grp
		))
		(transient-grip-mask [
			[gsw dft dft]
			[dft dht dft]
			[dft dft dft]
		])
		
		;;
		;;
		;;
				
		left-button-list right-button-list
		
		(build-theme (lambda ()
			(letrec
				(
					(image-generator (lambda (mask)
						(lambda (x y)
							(color-rgb-8 (if (consp mask)
								(or
									(symbol-value (aref (aref (cdr mask) y) x))
									(symbol-value (aref (aref (car mask) y) x))
								)
								(symbol-value (aref (aref mask y) x))
							))
						)
					))
					
					(generate-image (lambda (index)
						(lambda (image-mask)
							(image-fill
								(image-generator (cdr image-mask))
								(nth index (car image-mask))
							)
						)
					))
					
					(generate-color (lambda (index base)
						(let*
							(
								(syn-color (mapcar
									(lambda (color)
										(/ (* color index) 255)
									)
									(color-rgb base)
								))
							)
							(get-color-rgb
								(nth 0 syn-color)
								(nth 1 syn-color)
								(nth 2 syn-color)
							)
						)
					))
					
					(create-button-list (lambda (button-list)
						(mapcar
							(lambda (button-type)
								(case button-type
									((Close) 'close-button)
									((Minimize) 'iconify-button)
									((Maximize) 'maximize-button)
									((Shade) 'shade-button)
							))
							(delete 'None button-list)
						)
					))
                    
					(get-custom-button-list (lambda (side)
						(case side
							((left)
								(create-button-list `(
									,Titanium:LeftButton1
									,Titanium:LeftButton2
									,Titanium:LeftButton3
									,Titanium:LeftButton4
								))
							)
							((right)
								(create-button-list `(
									,Titanium:RightButton1
									,Titanium:RightButton2
									,Titanium:RightButton3
									,Titanium:RightButton4
								))
					  		)
						)
					))
					
					(mapset (lambda (symbol-list value-list)
						(when (and symbol-list value-list)
							(set (car symbol-list) (car value-list))
							(mapset (cdr symbol-list) (cdr value-list))
						)
					))
				)
				
				;; set button layout
				
				(setq left-button-list
					(case Titanium:ButtonLayout
						((Platinum Platinum+ Amiga FVWM2 TWM) '(close-button))
						((Aqua) '(close-button iconify-button maximize-button))
						((KDE) '(shade-button))
						((Titanium) '())
						((WindowMaker) '(iconify-button))
						((Custom) (get-custom-button-list 'left))
					)
				)
				
				(setq right-button-list
					(case Titanium:ButtonLayout
						((Platinum) '(shade-button maximize-button))
						((Platinum+) '(iconify-button maximize-button))
						((Amiga) '(maximize-button iconify-button))
						((FVWM2) '(maximize-button iconify-button shade-button))
						((TWM) '())
						((Aqua) '(shade-button))
						((KDE Titanium) '(close-button maximize-button iconify-button))
						((WindowMaker) '(close-button))
						((Custom) (get-custom-button-list 'right))
					)
				)
				
				;; set button style
				
				(mapset
					'(
						close-button-mask
						maximize-button-mask
						iconify-button-mask
						shade-button-mask
						transient-close-button-mask
						transient-maximize-button-mask
						transient-iconify-button-mask
						transient-shade-button-mask
					)
					(case Titanium:ButtonStyle
						((Titanium) `(
							,titanium-close-button-mask
							,titanium-maximize-button-mask
							,titanium-iconify-button-mask
							,titanium-shade-button-mask
							,titanium-transient-close-button-mask
							,titanium-transient-maximize-button-mask
							,titanium-transient-iconify-button-mask
							,titanium-transient-shade-button-mask
						))
						((Platinum) `(
							,platinum-close-button-mask
							,platinum-maximize-button-mask
							,platinum-iconify-button-mask
							,platinum-shade-button-mask
							,platinum-transient-close-button-mask
							,platinum-transient-maximize-button-mask
							,platinum-transient-iconify-button-mask
							,platinum-transient-shade-button-mask
						))
					)
				)
				
				;; load default icon
				
				(if (eql 0 (length Titanium:DefaultIcon))
					(setq user-icon ())
					(setq user-icon (make-image Titanium:DefaultIcon))
				)
				
				;; set inactive colors
				
				(setq dht (generate-color #xdd Titanium:InactiveBaseColor))
				(setq dft (generate-color #xdd Titanium:InactiveBaseColor))
				(setq dsw (generate-color #xdd Titanium:InactiveBaseColor))
				(setq gsw (generate-color #xdd Titanium:InactiveBaseColor))
				(setq sdw (generate-color #x55 Titanium:InactiveBaseColor))
				
				(setq bt2 (generate-color #xdd Titanium:InactiveBaseColor))
				(setq bt4 (generate-color #xdd Titanium:InactiveBaseColor))
				(setq bt5 (generate-color #xdd Titanium:InactiveBaseColor))
				(setq bt6 (generate-color #xdd Titanium:InactiveBaseColor))
				(setq bt7 (generate-color #xdd Titanium:InactiveBaseColor))
				(setq bt8 (generate-color #xdd Titanium:InactiveBaseColor))
				(setq bt9 (generate-color #xdd Titanium:InactiveBaseColor))
				(setq btA (generate-color #xdd Titanium:InactiveBaseColor))
				(setq btB (generate-color #xdd Titanium:InactiveBaseColor))
				(setq btC (generate-color #xdd Titanium:InactiveBaseColor))
				(setq btD (generate-color #xdd Titanium:InactiveBaseColor))
				(setq btE (generate-color #xdd Titanium:InactiveBaseColor))
				(setq btF (generate-color #xdd Titanium:InactiveBaseColor))
				
				;; generate inactive decorations
				
				(mapc
					(generate-image 0)
					`(
						;; Common sets
						(,title-image . ,title-image-mask)
						(,shadow . ,shadow-mask)
						
						;; Default sets
						(,corner-top-left . ,corner-top-left-mask)
						(,corner-top-right . ,corner-top-right-mask)
						(,corner-bottom-left . ,corner-bottom-left-mask)
						(,corner-bottom-right . ,corner-bottom-right-mask)
						(,side-top . ,side-top-mask)
						(,side-bottom . ,side-bottom-mask)
						(,sides . ,sides-mask)
						(,side-subtitle . ,side-subtitle-mask)
						(,junction-left . ,junction-left-mask)
						(,junction-right . ,junction-right-mask)
						(,corner-top-side-left . ,corner-top-side-left-mask)
						(,corner-top-side-right . ,corner-top-side-right-mask)
						(,grip . ,grip-mask)
						(,handle . ,handle-mask)
						
						;; Transient sets
						(,transient-corner-top-left . ,transient-corner-top-left-mask)
						(,transient-corner-top-right . ,transient-corner-top-right-mask)
						(,transient-corner-bottom-left . ,transient-corner-bottom-left-mask)
						(,transient-corner-bottom-right . ,transient-corner-bottom-right-mask)
						(,transient-side-top . ,transient-side-top-mask)
						(,transient-side-bottom . ,transient-side-bottom-mask)
						(,transient-sides . ,transient-sides-mask)
						(,transient-side-subtitle . ,transient-side-subtitle-mask)
						(,transient-junction-left . ,transient-junction-left-mask)
						(,transient-junction-right . ,transient-junction-right-mask)
						(,transient-corner-top-side-left . ,transient-corner-top-side-left-mask)
						(,transient-corner-top-side-right . ,transient-corner-top-side-right-mask)
						(,transient-grip . ,transient-grip-mask)
						
						;; Buttons
						(
							,close-image
							.
							(,button-default-mask . ,close-button-mask)
						)
						(
							,maximize-image
							.
							(,button-default-mask . ,maximize-button-mask)
						)
						(
							,iconify-image
							.
							(,button-default-mask . ,iconify-button-mask)
						)
						(
							,shade-image
							.
							(,button-default-mask . ,shade-button-mask)
						)
						(
							,transient-close-image
							. 
							(,transient-button-default-mask . ,transient-close-button-mask)
						)
						(
							,transient-maximize-image
							.
							(,transient-button-default-mask . ,transient-maximize-button-mask)
						)
						(
							,transient-iconify-image
							.
							(,transient-button-default-mask . ,transient-iconify-button-mask)
						)
						(
							,transient-shade-image
							.
							(,transient-button-default-mask . ,transient-shade-button-mask)
						)
					)
				)
				
				;; set active colors
				
				(setq dht (generate-color #xff Titanium:ActiveBaseColor))
				(setq dft (generate-color #xcc Titanium:ActiveBaseColor))
				(setq dsw (generate-color #x99 Titanium:ActiveBaseColor))
				(setq gsw (generate-color #x77 Titanium:ActiveBaseColor))
				(setq sdw (generate-color #x00 Titanium:ActiveBaseColor))
				
				(setq bt2 (generate-color #x22 Titanium:ActiveBaseColor))
				(setq bt4 (generate-color #x44 Titanium:ActiveBaseColor))
				(setq bt5 (generate-color #x55 Titanium:ActiveBaseColor))
				(setq bt6 (generate-color #x66 Titanium:ActiveBaseColor))
				(setq bt7 (generate-color #x77 Titanium:ActiveBaseColor))
				(setq bt8 (generate-color #x88 Titanium:ActiveBaseColor))
				(setq bt9 (generate-color #x99 Titanium:ActiveBaseColor))
				(setq btA (generate-color #xaa Titanium:ActiveBaseColor))
				(setq btB (generate-color #xbb Titanium:ActiveBaseColor))
				(setq btC (generate-color #xcc Titanium:ActiveBaseColor))
				(setq btD (generate-color #xdd Titanium:ActiveBaseColor))
				(setq btE (generate-color #xee Titanium:ActiveBaseColor))
				(setq btF (generate-color #xff Titanium:ActiveBaseColor))
				
				;; generate active decorations
				
				(mapc
					(generate-image 1)
					`(
						;; Common sets
						(,title-image . ,title-image-mask)
						(,shadow . ,shadow-mask)
						
						;; Default sets
						(,corner-top-left . ,corner-top-left-mask)
						(,corner-top-right . ,corner-top-right-mask)
						(,corner-bottom-left . ,corner-bottom-left-mask)
						(,corner-bottom-right . ,corner-bottom-right-mask)
						(,side-top . ,side-top-mask)
						(,side-bottom . ,side-bottom-mask)
						(,sides . ,sides-mask)
						(,side-subtitle . ,side-subtitle-mask)
						(,junction-left . ,junction-left-mask)
						(,junction-right . ,junction-right-mask)
						(,corner-top-side-left . ,corner-top-side-left-mask)
						(,corner-top-side-right . ,corner-top-side-right-mask)
						(,grip . ,grip-mask)
						(,handle . ,handle-mask)
						
						;; Transient sets
						(,transient-corner-top-left . ,transient-corner-top-left-mask)
						(,transient-corner-top-right . ,transient-corner-top-right-mask)
						(,transient-corner-bottom-left . ,transient-corner-bottom-left-mask)
						(,transient-corner-bottom-right . ,transient-corner-bottom-right-mask)
						(,transient-side-top . ,transient-side-top-mask)
						(,transient-side-bottom . ,transient-side-bottom-mask)
						(,transient-sides . ,transient-sides-mask)
						(,transient-side-subtitle . ,transient-side-subtitle-mask)
						(,transient-junction-left . ,transient-junction-left-mask)
						(,transient-junction-right . ,transient-junction-right-mask)
						(,transient-corner-top-side-left . ,transient-corner-top-side-left-mask)
						(,transient-corner-top-side-right . ,transient-corner-top-side-right-mask)
						(,transient-grip . ,transient-grip-mask)
						
						;; Buttons
						(
							,close-image
							.
							(,button-default-mask . ,close-button-mask)
						)
						(
							,maximize-image
							.
							(,button-default-mask . ,maximize-button-mask)
						)
						(
							,iconify-image
							.
							(,button-default-mask . ,iconify-button-mask)
						)
						(
							,shade-image
							.
							(,button-default-mask . ,shade-button-mask)
						)
						(
							,transient-close-image
							. 
							(,transient-button-default-mask . ,transient-close-button-mask)
						)
						(
							,transient-maximize-image
							.
							(,transient-button-default-mask . ,transient-maximize-button-mask)
						)
						(
							,transient-iconify-image
							.
							(,transient-button-default-mask . ,transient-iconify-button-mask)
						)
						(
							,transient-shade-image
							.
							(,transient-button-default-mask . ,transient-shade-button-mask)
						)
					)
				)
				
				;; generate clicked buttons
				
				(mapc
					(generate-image 3)
					`(
						;; Buttons
						(
							,close-image
							.
							(,button-clicked-mask . ,close-button-mask)
						)
						(
							,maximize-image
							.
							(,button-clicked-mask . ,maximize-button-mask)
						)
						(
							,iconify-image
							.
							(,button-clicked-mask . ,iconify-button-mask)
						)
						(
							,shade-image
							.
							(,button-clicked-mask . ,shade-button-mask)
						)
						(
							,transient-close-image
							. 
							(,transient-button-clicked-mask . ,transient-close-button-mask)
						)
						(
							,transient-maximize-image
							.
							(,transient-button-clicked-mask . ,transient-maximize-button-mask)
						)
						(
							,transient-iconify-image
							.
							(,transient-button-clicked-mask . ,transient-iconify-button-mask)
						)
						(
							,transient-shade-image
							.
							(,transient-button-clicked-mask . ,transient-shade-button-mask)
						)
					)
				)
			)
		))
		
		(title-area-width (lambda (win type)
			(let
				((lst (copy-sequence (append right-button-list left-button-list))))
				(mapc
					(lambda (class)
						(delete class lst)
					)
					(window-get win 'removed-classes)
				)
				(max 0 (-
					(+ (car (window-dimensions win)) 4)
					(*
						(case type ((default) 16) ((transient) 11))
						(length lst)
					)
				))
			)
		))
		
		(title-offset (lambda (win type)
			(let
				((lst (copy-sequence left-button-list)))
				(mapc
					(lambda (class)
						(delete class lst)
					)
					(window-get win 'removed-classes)
				)
				(-
					(*
						(case type ((default) 16) ((transient) 11))
						(length lst)
					)
					2
				)
			)
		))
		
		(title-font (lambda ()
			Titanium:TitleFont
		))
		
		(transient-title-font (lambda ()
			Titanium:TransientTitleFont
		))
		
		(title-width (lambda (type) (lambda (win)
			(min 
				(max 0 (-
					(title-area-width win type)
					(case type ((default) 24) ((transient) 15))
				))
				(text-width
					(window-name win)
					(case type
						((default) (title-font))
						((transient) (transient-title-font))
					)
				)
			)
		)))
		
		(icon-justify (lambda (type) (lambda (win)
			(+
				(/ 
					(-
						(title-area-width win type)
						(+
							((title-width type) win)
							(if Titanium:ShowIcon
								(case type ((default) 24) ((transient) 15))
								0
							)
						)
					)
					2
				)
				(title-offset win type)
			)
		)))
	  
		(title-justify (lambda (type) (lambda (win)
			(+
				((icon-justify type) win)
				(if Titanium:ShowIcon
					(case type ((default) 24) ((transient) 15))
					0
				)
			)
		)))
	  
		(hide-icon (lambda (win)
			(not Titanium:ShowIcon)
		))
		
		(hide-handle (lambda (win)
			(not Titanium:ShowHandle)
		))
		
		(title-text-color (lambda (win)
			`(,Titanium:InactiveTitleColor ,Titanium:ActiveTitleColor)
		))
		
		(title-parts `(
			(
				(class . title)
				(background . ,title-image)
				(left-edge . -2)
				(right-edge . -2)
				(top-edge . -18)
				(height . 14)
				(cursor . left_ptr)
			)
			(
				(class . title)
				(background . ,title-image)
				(foreground . ,title-text-color)
				(font . ,title-font)
				(text . ,window-name)
				(x-justify . center)
				(y-justify . center)
				(left-edge . ,(title-justify 'default))
				(width . ,(title-width 'default))
				(top-edge . -18)
				(height . 14)
				(cursor . left_ptr)
			)
			(
				(class . title)
				(background . ,icon-image)
				(top-edge . -21)
				(left-edge . ,(icon-justify 'default))
				(width . 18)
				(height . 18)
				(hidden . ,hide-icon)
				(cursor . left_ptr)
			)
		))
				
		(transient-title-parts `(
			(
				(class . title)
				(background . ,title-image)
				(left-edge . -2)
				(right-edge . -2)
				(top-edge . -14)
				(height . 12)
				(cursor . left_ptr)
			)
			(
				(class . title)
				(background . ,title-image)
				(foreground . ,title-text-color)
				(font . ,transient-title-font)
				(text . ,window-name)
				(x-justify . center)
				(y-justify . center)
				(left-edge . ,(title-justify 'transient))
				(width . ,(title-width 'transient))
				(top-edge . -14)
				(height . 12)
				(cursor . left_ptr)
			)
			(
				(class . title)
				(background . ,icon-image)
				(top-edge . -14)
				(left-edge . ,(icon-justify 'transient))
				(width . 12)
				(height . 12)
				(hidden . ,hide-icon)
				(cursor . left_ptr)
			)
		))
				
		(border-parts `(
			(
				(class . left-border)
				(left-edge . -6)
				(top-edge . -2)
				(background . ,junction-left)
			)
			(
				(class . left-border)
				(left-edge . -6)
				(top-edge . -12)
				(height . 10)
				(background . ,corner-top-side-left)
			)
			(
				(class . top-left-corner)
				(background . ,corner-top-left)
				(left-edge . -6)
				(top-edge . -22)
			)
			(
				(class . top-border)
				(background . ,side-top)
				(left-edge . 4)
				(right-edge . 4)
				(top-edge . -22)
			)
			(
				(class . top-right-corner)
				(background . ,corner-top-right)
				(right-edge . -6)
				(top-edge . -22)
			)
			(
				(class . right-border)
				(right-edge . -6)
				(top-edge . -12)
				(height . 10)
				(background . ,corner-top-side-right)
			)
			(
				(class . right-border)
				(right-edge . -6)
				(top-edge . -2)
				(background . ,junction-right)
			)
			(
				(background . ,side-subtitle)
				(left-edge  . 0)
				(right-edge . 0)
				(top-edge   . -4)
			)
			(
				(class . right-border)
				(top-edge . 0)
				(bottom-edge . 4)
				(background . ,sides)
				(right-edge . -6)
				(below-client . t)
			)
			(
				(class . bottom-right-corner)
				(background . ,corner-bottom-right)
				(right-edge . -6)
				(bottom-edge . -6)
				(below-client . t)
			)
			(
				(class . bottom-right-corner)
				(background . ,handle)
				(right-edge . -2)
				(bottom-edge . -2)
				(hidden . ,hide-handle)
			)
			(
				(class . bottom-border)
				(background . ,side-bottom)
				(left-edge . 4)
				(right-edge . 4)
				(bottom-edge . -6)
				(below-client . t)
			)
			(
				(class . bottom-left-corner)
				(background . ,corner-bottom-left)
				(left-edge . -6)
				(bottom-edge . -6)
				(below-client . t)
			)
			(
				(class . left-border)
				(background . ,sides)
				(left-edge . -6)
				(top-edge . 0)
				(bottom-edge . 4)
				(below-client . t)
			)
			;; Shadows
			(
				(background . ,shadow)
				(left-edge . -4)
				(right-edge . -7)
				(bottom-edge . -7)
				(height . 1)
			)
			(
				(background . ,shadow)
				(right-edge . -7)
				(width . 1)
				(top-edge . -20)
				(bottom-edge . -7)
			)
		))
		
		(transient-border-parts `(
			(
				(class . left-border)
				(left-edge . -4)
				(top-edge . -2)
				(background . ,transient-junction-left)
			)
			(
				(class . left-border)
				(left-edge . -4)
				(top-edge . -11)
				(height . 9)
				(background . ,transient-corner-top-side-left)
			)
			(
				(class . top-left-corner)
				(background . ,transient-corner-top-left)
				(left-edge . -4)
				(top-edge . -16)
			)
			(
				(class . top-border)
				(background . ,transient-side-top)
				(left-edge . 1)
				(right-edge . 1)
				(top-edge . -16)
			)
			(
				(class . top-right-corner)
				(background . ,transient-corner-top-right)
				(right-edge . -4)
				(top-edge . -16)
			)
			(
				(class . right-border)
				(right-edge . -4)
				(top-edge . -11)
				(height . 9)
				(background . ,transient-corner-top-side-right)
			)
			(
				(class . right-border)
				(right-edge . -4)
				(top-edge . -2)
				(background . ,transient-junction-right)
			)
			(
				(background . ,transient-side-subtitle)
				(left-edge  . 0)
				(right-edge . 0)
				(top-edge   . -2)
			)
			(
				(class . right-border)
				(top-edge . 0)
				(bottom-edge . 1)
				(background . ,transient-sides)
				(right-edge . -4)
				(below-client . t)
			)
			(
				(class . bottom-right-corner)
				(background . ,transient-corner-bottom-right)
				(right-edge . -4)
				(bottom-edge . -4)
				(below-client . t)
			)
			(
				(class . bottom-border)
				(background . ,transient-side-bottom)
				(left-edge . 1)
				(right-edge . 1)
				(bottom-edge . -4)
				(below-client . t)
			)
			(
				(class . bottom-left-corner)
				(background . ,transient-corner-bottom-left)
				(left-edge . -4)
				(bottom-edge . -4)
				(below-client . t)
			)
			(
				(class . left-border)
				(background . ,transient-sides)
				(left-edge . -4)
				(top-edge . 0)
				(bottom-edge . 1)
				(below-client . t)
			)
			;; Shadows
			(
				(background . ,shadow)
				(left-edge . -2)
				(right-edge . -5)
				(bottom-edge . -5)
				(height . 1)
			)
			(
				(background . ,shadow)
				(right-edge . -5)
				(width . 1)
				(top-edge . -14)
				(bottom-edge . -5)
			)
		))
		
		(shaped-parts `(
			(
				(class . title)
				(background . ,corner-top-left)
				(left-edge . -6)
				(top-edge . -22)
			)
			(
				(class . title)
				(background . ,side-top)
				(left-edge . 4)
				(right-edge . 4)
				(top-edge . -22)
			)
			(
				(class . title)
				(background . ,corner-top-right)
				(right-edge . -6)
				(top-edge . -22)
			)
			(
				(class . title)
				(top-edge . -12)
				(height . 2)
				(background . ,corner-top-side-right)
				(right-edge . -6)
			)
			(
				(class . title)
				(background . ,corner-bottom-right)
				(right-edge . -6)
				(top-edge . -10)
			)
			(
				(class . title)
				(background . ,side-subtitle)
				(left-edge . 4)
				(right-edge . 4)
				(top-edge . -4)
			)
			(
				(class . title)
				(background . ,corner-bottom-left)
				(left-edge . -6)
				(top-edge . -10)
			)
			(
				(class . title)
				(top-edge . -12)
				(height . 2)
				(background . ,corner-top-side-left)
				(left-edge . -6)
			)
			;; Shadows
			(
				(background . ,shadow)
				(left-edge . -4)
				(right-edge . -7)
				(top-edge . 0)
				(height . 1)
			)
			(
				(background . ,shadow)
				(right-edge . -7)
				(width . 1)
				(top-edge . -20)
				(height . 20)
			)
		))

		(transient-shaped-parts `(
			(
				(class . title)
				(background . ,transient-corner-top-left)
				(left-edge . -4)
				(top-edge . -16)
			)
			(
				(class . title)
				(background . ,transient-side-top)
				(left-edge . 1)
				(right-edge . 1)
				(top-edge . -16)
			)
			(
				(class . title)
				(background . ,transient-corner-top-right)
				(right-edge . -4)
				(top-edge . -16)
			)
			(
				(class . title)
				(top-edge . -11)
				(height . 6)
				(background . ,transient-corner-top-side-right)
				(right-edge . -4)
			)
			(
				(class . title)
				(background . ,transient-corner-bottom-right)
				(right-edge . -4)
				(top-edge . -5)
			)
			(
				(class . title)
				(background . ,transient-side-subtitle)
				(left-edge . 1)
				(right-edge . 1)
				(top-edge . -2)
			)
			(
				(class . title)
				(background . ,transient-corner-bottom-left)
				(left-edge . -4)
				(top-edge . -5)
			)
			(
				(class . title)
				(top-edge . -11)
				(height . 6)
				(background . ,transient-corner-top-side-left)
				(left-edge . -4)
			)
			;; Shadows
			(
				(background . ,shadow)
				(left-edge . -2)
				(right-edge . -5)
				(top-edge . 0)
				(height . 1)
			)
			(
				(background . ,shadow)
				(right-edge . -5)
				(width . 1)
				(top-edge . -14)
				(height . 14)
			)
		))

		(grip-width (lambda (pos edge type) (lambda (win)
			(case edge
				((left-edge)
					(- ((icon-justify type) win) pos 12)
				)
				((right-edge)
					(-
						(car (window-dimensions win))
						((icon-justify type) win)
						(if Titanium:ShowIcon
							(case type ((default) 38) ((transient) 29))
							14
						)
						((title-width type) win)
						pos
					)
				)
			)
		)))
		
		(place-grip (lambda (pos edge type)
			(case type
				((default)
					`(
						(class . title)
						(background . ,grip)
						(,edge . ,(+ pos 5))
						(width . ,(grip-width pos edge type))
						(top-edge . -16)
						(height . 12)
						(cursor . left_ptr)
					)
				)
				((transient)
					`(
						(class . title)
						(background . ,transient-grip)
						(,edge . ,(+ pos 5))
						(width . ,(grip-width pos edge type))
						(top-edge . -12)
						(height . 9)
						(cursor . left_ptr)
					)
				)
			)
		))
		
		(place-close-button (lambda (pos edge type)
			(case type
				((default)
					`(
						(class . close-button)
						(background . ,close-image)
						(,edge . ,pos)
						(top-edge . -18)
					)
				)
				((transient)
					`(
						(class . close-button)
						(background . ,transient-close-image)
						(,edge . ,pos)
						(top-edge . -13)
					)
				)
			)
		))
		
		(place-shade-button (lambda (pos edge type)
			(case type
				((default)
					`(
						(class . shade-button)
						(background . ,shade-image)
						(,edge . ,pos)
						(top-edge . -18)
					)
				)
				((transient)
					`(
						(class . shade-button)
						(background . ,transient-shade-image)
						(,edge . ,pos)
						(top-edge . -13)
					)
				)
			)
		))
		
		(place-maximize-button (lambda (pos edge type)
			(case type
				((default)
					`(
						(class . maximize-button)
						(background . ,maximize-image)
						(,edge . ,pos)
						(top-edge . -18)
					)
				)
				((transient)
					`(
						(class . maximize-button)
						(background . ,transient-maximize-image)
						(,edge . ,pos)
						(top-edge . -13)
					)
				)
			)
		))
		
		(place-iconify-button (lambda (pos edge type)
			(case type
				((default)
					`(
						(class . iconify-button)
						(background . ,iconify-image)
						(,edge . ,pos)
						(top-edge . -18)
					)
				)
				((transient)
					`(
						(class . iconify-button)
						(background . ,transient-iconify-image)
						(,edge . ,pos)
						(top-edge . -13)
					)
				)
			)
		))
		
		(place-button (lambda (button-type pos edge type)
			(case button-type
				((close-button) (place-close-button pos edge type))
				((maximize-button) (place-maximize-button pos edge type))
				((iconify-button) (place-iconify-button pos edge type))
				((shade-button) (place-shade-button pos edge type))
				((grip) (place-grip pos edge type))
			)
		))
				
		(place-buttons (lambda (button-list pos edge frame-type)
			(when button-list `(
				,(place-button (car button-list) pos edge frame-type)
				,@(place-buttons 
					(cdr button-list)
					(+
						pos 
						(case frame-type
							((default) 16)
							((transient) 11)
						)
					)
					edge
					frame-type
				)
			))
		))
              
		(button-parts (lambda (win frame-type)
			(let
				(
					(lbl (copy-sequence left-button-list))
					(rbl (copy-sequence right-button-list))
				)
				(mapc
					(lambda (class)
						(delete class lbl)
						(delete class rbl)
					)
					(window-get win 'removed-classes)
				)
				`(
					,@(place-buttons (append lbl '(grip)) -2 'left-edge frame-type)
					,@(place-buttons (append rbl '(grip)) -2 'right-edge frame-type)
				)
			)
		))

		(default-frame (lambda (win)
			`(,@border-parts ,@title-parts ,@(button-parts win 'default))
		))
		
		(transient-frame (lambda (win)
			`(,@transient-border-parts ,@transient-title-parts ,@(button-parts win 'transient))
		))
		
		(shaped-frame (lambda (win)
			`(,@shaped-parts ,@title-parts ,@(button-parts win 'default))
		))
		
		(shaped-transient-frame (lambda (win)
			`(,@transient-shaped-parts ,@transient-title-parts ,@(button-parts win 'transient))
		))
		
		(rebuild-theme (lambda ()
			(build-theme)
			(reframe-windows-with-style 'Titanium)
		))
		      
	)

	(build-theme)
	
	(call-after-property-changed
		'(WM_NAME WM_HINTS)
		(lambda (win) (rebuild-frame win))
	)
	
	(def-frame-class
		shade-button
		nil
		(bind-keys shade-button-keymap "Button1-Off" 'toggle-window-shaded)
	)

	(add-frame-style 'Titanium
		(lambda (win type)
			(case type
				((default) (default-frame win))
				((transient) (transient-frame win))
				((shaped) (shaped-frame win))
				((shaped-transient) (shaped-transient-frame win))
			)
		)
        
	)
	
	(custom-set-property 'Titanium:ShowIcon ':after-set rebuild-theme)
	(custom-set-property 'Titanium:ShowHandle ':after-set rebuild-theme)
	(custom-set-property 'Titanium:ButtonLayout ':after-set rebuild-theme)
	(custom-set-property 'Titanium:ButtonStyle ':after-set rebuild-theme)
	(custom-set-property 'Titanium:TitleFont ':after-set rebuild-theme)
	(custom-set-property 'Titanium:TransientTitleFont ':after-set rebuild-theme)
	(custom-set-property 'Titanium:ActiveBaseColor ':after-set rebuild-theme)
	(custom-set-property 'Titanium:InactiveBaseColor ':after-set rebuild-theme)
	(custom-set-property 'Titanium:ActiveTitleColor ':after-set rebuild-theme)
	(custom-set-property 'Titanium:InactiveTitleColor ':after-set rebuild-theme)
	(custom-set-property 'Titanium:DefaultIcon ':after-set rebuild-theme)
	(custom-set-property 'Titanium:LeftButton1 ':after-set rebuild-theme)
	(custom-set-property 'Titanium:LeftButton2 ':after-set rebuild-theme)
	(custom-set-property 'Titanium:LeftButton3 ':after-set rebuild-theme)
	(custom-set-property 'Titanium:LeftButton4 ':after-set rebuild-theme)
	(custom-set-property 'Titanium:RightButton1 ':after-set rebuild-theme)
	(custom-set-property 'Titanium:RightButton2 ':after-set rebuild-theme)
	(custom-set-property 'Titanium:RightButton3 ':after-set rebuild-theme)
	(custom-set-property 'Titanium:RightButton4 ':after-set rebuild-theme)
)

;; BWM (Bat-Window Manager) by Matt Chisholm http://www.theory.org/~matt/sawfish/
;; July 11 2001
;; 

(let*

  (
    (font (get-font "-sharefont-comicscartoon-normal-r-normal-*-*-180-*-*-p-*-iso8859-1"))

    ;; Update window title pixel length
    (title-width
      (lambda (w)
        (let
          ((w-width (car (window-dimensions w))))
          (max 0 (min (- w-width 100) (text-width (window-name w) font
;;           (get-font
;;             "-sharefont-comicscartoon-normal-r-normal-*-*-180-*-*-p-*-iso8859-1")
          ))))))
        ;; Batman images
        (topleft (list 
         (make-image  "b-topleft-i.png")
         (make-image "b-topleft-a.png")))
        (top (list 
         (make-image  "b-top-i.png")
         (make-image "b-top-a.png")))
        (topright (list 
         (make-image  "b-topright-i.png")
         (make-image "b-topright-a.png")))
        (right (list 
         (make-image  "b-right-i.png")
         (make-image "b-right-a.png")))
        (bottomright (list 
         (make-image  "b-bottomright-i.png")
         (make-image "b-bottomright-a.png")))
        (bottom (list 
         (make-image  "b-bottom-i.png")
         (make-image "b-bottom-a.png")))
        (bottomleft (list 
         (make-image  "b-bottomleft-i.png")
         (make-image "b-bottomleft-a.png")))
        (left (list 
         (make-image  "b-left-i.png")
         (make-image "b-left-a.png")))
        (button (list 
         (make-image "b-button-i.png")
         (make-image "b-button-a.png")
         (make-image "b-button-h.png")))
        (bubble (list 
         (make-image  "b-bubble-i.png")
         (make-image "b-bubble-a.png")))
        (hand (list 
         (make-image  "b-hand-i.png")
         (make-image "b-hand-a.png")))
        (topright-s (list 
         (make-image  "b-topright-i-s.png")
         (make-image "b-topright-a-s.png")))
        (top-s (list 
         (make-image  "b-top-i-s.png")
         (make-image "b-top-a-s.png")))
        (topleft-s (list 
         (make-image  "b-topleft-i-s.png")
         (make-image "b-topleft-a-s.png")))
        (emblem (list 
         (make-image  "b-emblem-i.png")
         (make-image "b-emblem-a.png")
         (make-image "b-emblem-h.png")))

	;; Robin images
        (r-topleft (list 
         (make-image  "r-topleft-i.png")
         (make-image "r-topleft-a.png")))
        (r-top (list 
         (make-image  "r-top-i.png")
         (make-image "r-top-a.png")))
        (r-topright (list 
         (make-image  "r-topright-i.png")
         (make-image "r-topright-a.png")))
        (r-right (list 
         (make-image  "r-right-i.png")
         (make-image "r-right-a.png")))
        (r-bottomright (list 
         (make-image  "r-bottom-i.png")
         (make-image "r-bottom-a.png")))
        (r-button (list 
         (make-image "r-button-i.png")
         (make-image "r-button-a.png")
         (make-image "r-button-h.png")))
	(r-bubble (let ((tilei (make-image "r-bubble-i.png"))
			(tilea (make-image "r-bubble-a.png")))
			(image-put tilei `tiled t)
			(image-put tilea `tiled t)
		    	(list tilei tilea)))
        (r-bubble-r (list 
         (make-image  "r-bubble-i-r.png")
         (make-image "r-bubble-a-r.png")))
        (r-bubble-l (list 
         (make-image  "r-bubble-i-l.png")
         (make-image "r-bubble-a-l.png")))
        (r-hand (list 
         (make-image  "r-hand-i.png")
         (make-image "r-hand-a.png")))
        (r-topright-s (list 
         (make-image  "r-topright-i-s.png")
         (make-image "r-topright-a-s.png")))
        (r-top-s (list 
         (make-image  "r-top-i-s.png")
         (make-image "r-top-a-s.png")))
        (r-topleft-s (list 
         (make-image  "r-topleft-i-s.png")
         (make-image "r-topleft-a-s.png")))
        (r-emblem (list 
         (make-image  "r-emblem-i.png")
         (make-image "r-emblem-a.png")
         (make-image "r-emblem-h.png")))
	(blackdot (list
	 (make-image "blackdot.png")
	 (make-image "blackdot.png")))

       ;;Batman frames
       (frame `(
         ((top-edge . -58)
          (left-edge . -23)
          (background . ,topleft)
          (class . top-left-corner))
         ((bottom-edge . -44)
          (left-edge . -23)
          (background . ,bottomleft)
          (class . bottom-left-corner))
         ((right-edge . -40)
          (background . ,bottomright)
          (bottom-edge . -35)
          (class . bottom-right-corner))
         ((left-edge . 25)
          (right-edge . 46)
          (top-edge . -18)
          (background . ,top)
          (class . top-border))
         ((top-edge . 16)
          (bottom-edge . 31)
          (left-edge . -23)
          (background . ,left)
          (class . left-border))
         ((left-edge . 16)
          (right-edge . 36)
          (bottom-edge . -34)
          (background . ,bottom)
          (class . bottom-border))
         ((top-edge . 40)
          (right-edge . -38)
          (bottom-edge . 37)
          (background . ,right)
          (class . right-border))
         ((left-edge . 18)
	  (font . ,font)
          (top-edge . -54)
          (width . ,(lambda (w) (floor (+ (title-width w) (/ (title-width w) 4) ))))
          (y-justify . center)
          (x-justify . center)
          (text . ,window-name)
          (background . ,bubble)
          (class . title))
         ((left-edge . 60)
          (top-edge . -5)
          (background . ,hand)
          (class . title))
         ((right-edge . 20)
          (top-edge . -40)
          (background . ,button)
          (class . close-button))
         ((top-edge . -19)
          (background . ,topright)
          (right-edge . -53)
          (class . top-right-corner))
         ((background . ,button)
          (top-edge . -40)
          (right-edge . 20)
          (class . close-button))
         ((top-edge . -6)
          (left-edge . 0)
          (background . ,emblem)
          (class . menu-button))))

        (shaped-frame `(
         ((left-edge . -23)
          (top-edge . -58)
          (background . ,topleft-s)
          (class . top-left-corner))
         ((class . title)
          (left-edge . 25)
          (top-edge . -18)
          (right-edge . 46)
          (background . ,top-s))
         ((width . ,(lambda (w) (floor (+ (title-width w) (/ (title-width w) 4) ))))
          (left-edge . 18)
          (top-edge . -54)
	  (font . ,font)
          (y-justify . center)
          (x-justify . center)
          (text . ,window-name)
          (background . ,bubble)
          (class . title))
         ((right-edge . 20)
          (top-edge . -40)
          (background . ,button)
          (class . close-button))
         ((right-edge . -53)
          (top-edge . -19)
          (background . ,topright-s)
          (class . top-right-corner))
         ((background . ,button)
          (top-edge . -40)
          (right-edge . 20)
          (class . close-button))
         ((top-edge . -6)
          (left-edge . 0)
          (background . ,emblem)
          (class . menu-button))))

       ;; Robin frames
       (transient-frame `(
         ((class . top-border)
          (left-edge . 46)
          (top-edge . -18)
          (right-edge . 32)
          (background . ,r-top))
         ((top-edge . -19)
          (left-edge . -41)
          (background . ,r-topleft)
          (class . top-left-corner))
         ((right-edge . -23)
          (background . ,r-bottomright)
          (bottom-edge . -44)
          (class . bottom-right-corner))
         ((top-edge . 17)
          (right-edge . -23)
          (bottom-edge . 47)
          (background . ,r-right)
          (class . right-border))
	 ((class . title)
	  (top-edge . -54)
          (right-edge . 18)
	  (background . ,r-bubble-r))
	 ((class . title)
	  (top-edge . -54)
          (right-edge . ,(lambda (w) (+ (title-width w) 50 )))
	  (background . ,r-bubble-l))
         ((right-edge . 50)
	  (font . ,font)
          (top-edge . -54)
          (width . ,(lambda (w) (title-width w) ))
          (y-justify . center)
          (x-justify . center)
          (text . ,window-name)
          (background . ,r-bubble)
          (class . title))
         ((right-edge . 60)
          (top-edge . -5)
          (background . ,r-hand)
          (class . title))
         ((top-edge . -56)
          (background . ,r-topright)
          (right-edge . -23)
          (class . top-right-corner))
         ((background . ,r-button)
          (top-edge . -40)
          (left-edge . 20)
          (class . close-button))
         ((top-edge . -4)
          (right-edge . -2)
          (background . ,r-emblem)
          (class . menu-button))
	 ((class . bottom-left-corner)
	  (bottom-edge . -2)
          (left-edge . -2)
          (background . ,blackdot))
	 ((class . bottom-border)
	  (bottom-edge . -2)
          (left-edge . -2)
	  (right-edge . 40)
          (background . ,blackdot))
	 ((class . left-border)
	  (bottom-edge . -2)
          (left-edge . -2)
	  (top-edge . 40)
          (background . ,blackdot))))

       (shaped-transient-frame `(
         ((class . title)
          (left-edge . 46)
          (top-edge . -18)
          (right-edge . 32)
          (background . ,r-top-s))
         ((top-edge . -19)
          (left-edge . -41)
          (background . ,r-topleft-s)
          (class . top-left-corner))
	 ((class . title)
	  (top-edge . -54)
          (right-edge . 18)
	  (background . ,r-bubble-r))
	 ((class . title)
	  (top-edge . -54)
          (right-edge . ,(lambda (w) (+ (title-width w) 50 )))
	  (background . ,r-bubble-l))
         ((right-edge . 50)
	  (font . ,font)
          (top-edge . -54)
          (width . ,(lambda (w) (title-width w) ))
          (y-justify . center)
          (x-justify . center)
          (text . ,window-name)
          (background . ,r-bubble)
          (class . title))
         ((top-edge . -56)
          (background . ,r-topright-s)
          (right-edge . -23)
          (class . top-right-corner))
         ((background . ,r-button)
          (top-edge . -40)
          (left-edge . 20)
          (class . close-button))
         ((top-edge . -4)
          (right-edge . -2)
          (background . ,r-emblem)
          (class . menu-button))))
    )

  (add-frame-style 'BWM
                   (lambda (w type)
                     (case type
                       ((default) frame)
                       ((transient) transient-frame)
                       ((shaped) shaped-frame)
                       ((shaped-transient) shaped-transient-frame))))

  (call-after-property-changed
   'WM_NAME (lambda ()
              (rebuild-frames-with-style 'BWM))))

#| theme.jl for Greene2.0 sawfish theme


   This was hacked together from Eazel Inc's Crux theme  (which is very cool, 
   I suggest you try it.)  Basicly I use images from Greene (1.0) with the 
   geometry management of Crux.

   Copyright 2001 Doug Johnson (doug@centibyte.org) under the GPL.

|#


(require 'rep.data.tables)		;need hash tables for icon cache
(require 'sawfish.wm.util.recolor-image)

(defgroup Greene2.0 "Greene Theme 2.0"
  :group appearance)

(defcustom Greene2.0:normal-color nil
  "Accent color for focused windows (if unset uses the GTK+ selection color)."
  :type (optional color)
  :group (appearance Greene2.0)
  :user-level novice
  :after-set (lambda () (color-changed)))

(defcustom Greene2.0:unfocused-color nil
  "Color for unfocused windows (if unset uses gray)."
  :type (optional color)
  :group (appearance Greene2.0)
  :user-level novice
  :after-set (lambda () (color-changed)))

(defcustom Greene2.0:show-window-icons nil
  "Display the window's icon in its menu button."
  :type boolean
  :group (appearance Greene2.0)
  :after-set (lambda () (rebuild-all)))

(defcustom Greene2.0:button-theme 'none
  "Display title buttons to mimic: \\w"
  :type (choice (platinum "MacOS Platinum")
		(macos-x "MacOS X")
		(windows "MS Windows")
		(next "NeXTSTEP")
		(none "None"))
  :group (appearance Greene2.0)
  :after-set (lambda () (reframe-all)))

;; maps WINDOW -> BUTTON-LIST
(define button-table (make-weak-table eq-hash eq))


;; images

(define ne-self-contained 
  (list (make-image "active:ne-self-contained.png")
		  (make-image "active:ne-self-contained.png")))

(define nw-self-contained 
  (list (make-image "active:nw-self-contained.png")
		  (make-image "active:nw-self-contained.png")))


(define top-center-left
  (list (make-image "active:n.png")
	(make-image "active:n.png")))

(define top-center-mid
  (list (make-image "active:ne.png")
	(make-image "active:ne.png")))

(define corner-nw
  (list (make-image "active:nw.png")
		  (make-image "active:nw.png")))

(define corner-sw
  (list (make-image "active:sw.png")
		  (make-image "active:sw.png")))



;; 48*x19
;;(define top-center-right
;;  (list (make-image "active:ne.png")
;;	(make-image "active:ne.png")))

(define menu-button
  `((inactive . ,(make-image "inactive:menu-button.png"))
    (focused . ,(make-image "active:menu-button.png"))
    (inactive-highlighted . ,(make-image "inactive:menu-button-hilight.png"))
    (highlighted . ,(make-image "active:menu-button-hilight.png"))
    (inactive-clicked . ,(make-image "inactive:menu-button-pressed.png"))
    (clicked . ,(make-image "active:menu-button-pressed.png"))))
(define button-background
  `((inactive . ,(make-image "inactive:button.png"))
    (focused . ,(make-image "active:button.png"))
    (inactive-highlighted . ,(make-image "inactive:button-hilight.png"))
    (highlighted . ,(make-image "active:button-hilight.png"))
    (inactive-clicked . ,(make-image "inactive:button-pressed.png"))
    (clicked . ,(make-image "active:button-pressed.png"))))

;; 12x12
(define minimize-fg
  `((inactive . ,(make-image "inactive:minimize-button.png"))
    (focused . ,(make-image "active:minimize-button.png"))))
(define maximize-fg
  `((inactive . ,(make-image "inactive:maximize-button.png"))
    (focused . ,(make-image "active:maximize-button.png"))))
(define close-fg
  `((inactive . ,(make-image "inactive:close-button.png"))
    (focused . ,(make-image "active:close-button.png"))))
(define shade-fg
  `((inactive . ,(make-image "inactive:shade-button.png"))
    (focused . ,(make-image "active:shade-button.png"))))


;; geometry computations

(define (title-left-width w)
  (let ((buttons (table-ref button-table w)))
    (max 0 (min (- (car (window-dimensions w))
		   (* (length (cdr buttons)) 18))
		(+ (text-width (window-name w)) 52
		   (* (length (car buttons)) 18))))))

(define (top-border-left-width w)
  (let ((buttons (table-ref button-table w)))
    (max 0 (min (- (car (window-dimensions w)) (* (length (cdr buttons)) 18))
		(+ (title-left-width w) -43)))))

;;(define (bottom-border-left-width w)
;;  (max 0 (min (car (window-dimensions w))
;;	      (+ (title-left-width w)
;;		 (quotient (cdr (window-dimensions w)) 2)))))

(define (vertical-justification)
  ;; `center' justification adjusted for the 3-pixel top-border
  (max 0 (- (/ (- 22 (font-height default-font)) 2) 3)))

(define (horizontal-justification w)
  (+ (* (length (car (table-ref button-table w))) 18) 2))


;; recolouring images

(define (foreground-color)
  (if (colorp Greene2.0:normal-color)
      Greene2.0:normal-color
    (initialize-gtkrc)
    (if (colorp (nth 3 gtkrc-background))
	(nth 3 gtkrc-background)
      (get-color "steelblue"))))

;; now we have a unfocused color too.
;; later, maybe make it a lighter/darker version of foreground?
(define (unfocused-color)
  (if (colorp Greene2.0:unfocused-color)
      Greene2.0:unfocused-color
	 (get-color "gray")))

;; Recolor all images that need recolouring. Precalculates the lookup
;; tables first.
(define (recolor-all)
  ;; Use the SELECTED state of the background colors as the
  ;; midpoint of the gradient for recolouring images. (This is
  ;; usually a bright, contrasting colour, and thus is the
  ;; best choice. It works particularly well with the Eazel-Foo
  ;; themes)
  (let ((recolorer (make-image-recolorer (foreground-color)
					 #:zero-channel red-channel
					 #:index-channel green-channel)))
    (mapc (lambda (x) (mapc recolorer (cdr x)))
	  (list 
;;top-left-border
;;		top-center-left-border
		top-center-left
		top-center-mid
		corner-sw
		corner-nw
		nw-self-contained
		ne-self-contained
		))
    (mapc (lambda (x)
				(recolorer (cdr x))) menu-button))
  
  ;; and now the inactive border...
  (let ((recolorer (make-image-recolorer (unfocused-color)
													  #:zero-channel red-channel
													  #:index-channel green-channel)))
	 (recolorer (car top-center-left))
	 (recolorer (car top-center-mid))
	 (recolorer (car corner-sw))
	 (recolorer (car corner-nw))
	 (recolorer (car nw-self-contained))
	 (recolorer (car ne-self-contained))
;;	 (mapc (lambda (x) (mapc recolorer (car x)))
;;			 (list 
;;			  ;;top-left-border
;;			  ;;		top-center-left-border
;;			  top-center-left
;;			  top-center-mid
;;			  corner-sw
;;			  corner-nw
;;			  ))
;;  (mapc (lambda (x)
;;				(recolorer (cdr x))) menu-button))
	 ))


;; window icons

(define icon-table (make-weak-table eq-hash eq))

(define (window-icon w)
  (when Greene2.0:show-window-icons
    (or (table-ref icon-table w)
	(let ((icon (window-icon-image w)))
	  (when icon	    (let ((scaled (scale-image icon 12 12)))
	      (table-set icon-table w scaled)
	      scaled))))))


;; frames

(define common-frame-parts
  `(
	 ;;((background . ,top-left-border)
    ;; (left-edge . -5)
     ;;(top-edge . -22)
     ;;(class . top-left-corner))

;;    ((background . ,top-center-left-border)
;;     (left-edge . 11)
;;     (top-edge . -22)
;;     (width . ,top-border-left-width)
;;     (class . top-border))
;;    ((background . ,top-center-right-border)
;;     (left-edge . ,(lambda (w) (+ (top-border-left-width w) 11)))
;;     (right-edge . 10)
;;     (top-edge . -22)
;;     (class . top-border))

    ((background . ,top-center-left)
     (left-edge . 0)
     (width . ,(lambda (w) (+ (title-left-width w) 2 -48)))
     (top-edge . -16)
     (text . ,window-name)
     (foreground . ("grey95" "white"))
     (x-justify . ,horizontal-justification)
     (y-justify . ,vertical-justification)
     (class . title))
;;    ((background . ,top-center-right)
;;     (left-edge . ,title-left-width)
;;     (right-edge . -1)
;;     (top-edge . -19)
;;     (class . title))

;;    ((background . ,top-right-border)
;;     (right-edge . -6)
;;     (top-edge . -22)
;;     (class . top-right-corner))
))

(define normal-frame
  `(,@common-frame-parts


    ((background . ,top-center-mid)
     (left-edge . ,(lambda (w) (max 0 (- (title-left-width w) 46)))) ;; was 48
     (top-edge . -16)
     (class . title))

	 ;; top black line
	 ((background . "black")
     (left-edge . ,(lambda (w) (+ (top-border-left-width w) 12)))
     (right-edge . -1)
     (top-edge . -1)
	  (height . 1)
	  (class . title))

	 ((top-edge . -16)
	  (left-edge . -16)
	  (background . ,corner-nw)
	  (class . title))

	 ((class . title)
          (top-edge . -1)
          (left-edge . -16)
          (background . ,corner-sw))
	 
;;    ((background . "#002900770016")
;;       (left-edge . ,top-center-right)
;;       (right-edge . -1)
;;       (top-edge . -3)
;;       (height . 10)
;;       (class . title))
	 
	 
	 
	 
	 ((width . 1)
	       (right-edge . -1)
			 (top-edge . 0)
			 (bottom-edge . 0)
			 (background . "#002900770016")
			 (class . right-border))

	 ((bottom-edge . -1)
	       (left-edge . -1)
          (height . 1)
          (right-edge . -1)
          (background . "#00360077001f")
          (class . bottom-border))
	 
	 ((top-edge . 15)
          (left-edge . -1)
			 (width . 1)
          (bottom-edge . 0)
          (background . "#002900770016")
          (class . left-border))
))

(define shaped-frame
  `(,@common-frame-parts

	 ((background . ,ne-self-contained)
			 (left-edge . ,(lambda (w) (max 0 (- (title-left-width w) 46))))
			 (top-edge . -16)
			 (class . title))

	 ((background . ,nw-self-contained)
			 (left-edge . -8)
			 (top-edge . -16)
			 (class . title))

	 

;;    ((background . ,left-top-border-shaped)
;;     (left-edge . -5)
;;     (top-edge . -19)
;;     (class . top-left-corner))
;;    ((background . ,right-top-border-shaped)
;;     (right-edge . -6)
;;     (top-edge . -19)
;;     (class . top-right-corner))
))


;; packing buttons

(define button-map
  `((iconify-button . ,minimize-fg)
    (maximize-button . ,maximize-fg)
    (close-button . ,close-fg)
    (menu-button . ,window-icon)
    (shade-button . ,shade-fg)))

(define (button-theme type)
  (case Greene2.0:button-theme
    ((platinum)
     '((close-button) . (maximize-button shade-button)))
    ((macos-x)
     '((close-button maximize-button iconify-button) . ()))
    ((windows)
     (if (eq type 'transient)
	 '((menu-button) . (close-button))
       '((menu-button) . (iconify-button maximize-button close-button))))
    ((next)
     '((iconify-button) . (close-button)))
	 ((none) '())
	 ))

(define (make-buttons spec background edge)

  (define (make-button class fg point)
    `((background . ,background)
      (foreground . ,fg)
      (x-justify . 2)
      (y-justify . 2)
      (,edge . ,point)
      (top-edge . -19)
      (class . ,class)))

  (do ((rest spec (cdr rest))
       (point -1 (+ point 18))
       (out '() (cons (make-button (car rest)
				   (cdr (assq (car rest) button-map))
				   point) out)))
      ((null rest) out)))


;; misc stuff

(define (rebuild-all)
  (rebuild-frames-with-style 'Greene2.0))

(define (reframe-all)
  (reframe-windows-with-style 'Greene2.0))

(define (color-changed)
  (recolor-all)
  (reframe-all))

(define (make-frame w frame buttons)
  (table-set button-table w buttons)
  (append frame
	  (make-buttons (car buttons) menu-button 'left-edge)
	  (make-buttons (reverse (cdr buttons)) button-background 'right-edge)))

(define (get-frame w type)
  (case type
    ((default)
	  (make-frame w normal-frame (button-theme 'normal)))
    ((transient)
     (make-frame w normal-frame (button-theme 'transient)))
    ((shaped)
     (make-frame w shaped-frame (button-theme 'normal)))
    ((shaped-transient)
     (make-frame w shaped-frame (button-theme 'transient)))))


;; initialization

(define initialize-gtkrc
  (let ((done nil))
    (lambda ()
      (unless done
	(require 'gtkrc)
	;; recolour everything when the GTK theme changes
	(gtkrc-call-after-changed color-changed)
	(setq done t)))))

;; setup the initial colours
(recolor-all)

;; register the theme
;; (add-frame-style 'Greene2.0-get-frame)
(add-frame-style 'Greene2.0 get-frame)

;; recalibrate frames when the window-name changes
(call-after-property-changed 'WM_NAME rebuild-all)

; CoolClean/theme.jl

;; Version 0.6
;; Modified by Scott Sams <sbsams@digitallabyrinth.com>
;; This theme was modified from the CleanBig theme from Sawmill. It has support
;; for custom gradient colors. A few of the frame images were modified to look
;; more consistent.

;; Copyright (C) 1999 Red Hat, Inc., <jrb@redhat.com>

;; This theme was based on the CleanBig enlightenment theme created by
;; Michael Fulbright <drmike@redhat.com> and Carsten Haitzler
;; <raster@valinux.com>.  It is inspired by a certain, very popular
;; operating system.

(require 'gradient)

(defgroup CoolClean-frame "CoolClean Settings")

(defcustom CoolClean:gradient-type 'horizontal
  "Direction of gradient."
  :type (set horizontal vertical diagonal)
  :group CoolClean-frame
  :after-set after-setting-frame-option)

(defcustom CoolClean:solid-colors nil
  "Use solid colors instead of gradients (Uses `From' colors)."
  :group CoolClean-frame
  :type boolean
  :after-set after-setting-frame-option)

(defcustom CoolClean:normal-from-color(get-color "#8d8d8d")
  "`From' color of inactive frames."
  :type color
  :group CoolClean-frame
  :after-set after-setting-frame-option)

(defcustom CoolClean:normal-to-color (get-color "#bcbcbc")
  "`To' color of inactive frames."
  :type color
  :group CoolClean-frame
  :after-set after-setting-frame-option)

(defcustom CoolClean:active-from-color (get-color "#0100c7")
  "`From' color of active frames."
  :type color
  :group CoolClean-frame
  :after-set after-setting-frame-option)

(defcustom CoolClean:active-to-color (get-color "#00c6ef")
  "`To' color of active frames."
  :type color
  :group CoolClean-frame
  :after-set after-setting-frame-option)

(defcustom CoolClean:normal-text-color (get-color "#333333")
  "Title text color of inactive frames."
  :type color
  :group CoolClean-frame
  :after-set after-setting-frame-option)

(defcustom CoolClean:active-text-color (get-color "#FFFFFF")
  "Title text color of active frames."
  :type color
  :group CoolClean-frame
  :after-set after-setting-frame-option)

;; The font
(defcustom CoolClean:font 
  (get-font "-adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-1")
  "Font for window titles."
  :type font
  :group CoolClean-frame
  :after-set after-setting-frame-option)



(let*
;; images
;; The standard images
;; 2x6
((bottom-images (make-image "bottom.png"))

;; 16x3
(top-images (list (make-image "top_inactive.png")
				  (make-image "top_active.png")))

;; 26x19
(title-bar-images (list (make-image "title_bar_inactive.png")
					(make-image "title_bar_active.png")))

;; 3x22
(top-right-images (make-image "top_right.png"))

;; 53x22
(top-right-button-box-images (list (make-image "top_right_button_box_inactive.png")
						   (make-image "top_right_button_box_active.png")))

;; 25x25
(bottom-left-images (make-image "bottom_left.png"))

;; 25x25
(bottom-right-images (make-image "bottom_right.png"))

;; 16x16
(close-images (list (make-image "close_normal.png")
				    nil nil
				    (make-image "close_clicked.png")))

;; 16x16
(maximize-images (list (make-image "maximize_active.png")
				       nil nil
				       (make-image "maximize_clicked.png")))

;; 16x16
(iconify-images (list (make-image "minimize_active.png")
				      nil nil
				      (make-image "minimize_clicked.png")))

;; 22x22
(menu-images (list (make-image "menu_inactive.png")
				   (make-image "menu_active.png")))

;; 6x19
(left-images (make-image "left.png"))

;; 6x19
(right-images (make-image "right.png"))

;; For the transients
;; 19x22
(t-top-right-button-box-images (list (make-image "t_top_right_button_box_inactive.png")
						     (make-image "t_top_right_button_box_active.png")))



;; For the shaded window
;; 22x22
(s-menu-images (list (make-image "s_menu_inactive.png")
				     (make-image "s_menu_active.png")))


;; 56x22
(s-top-right-images (list (make-image "s_top_right_inactive.png")
					  (make-image "s_top_right_active.png")))


;; For the Shaped, transient windows
;; 22x22
(st-top-right-images (list (make-image "st_top_right_inactive.png")
					   (make-image "st_top_right_active.png")))


(render-bg (lambda (img state)
  (apply (cond ((eq CoolClean:gradient-type 'diagonal)
        draw-diagonal-gradient)
           ((eq CoolClean:gradient-type 'horizontal)
        draw-horizontal-gradient)
           ((eq CoolClean:gradient-type 'vertical)
        draw-vertical-gradient))
         img (if state
                 (list CoolClean:active-from-color (if CoolClean:solid-colors CoolClean:active-from-color CoolClean:active-to-color))
               (list CoolClean:normal-from-color (if CoolClean:solid-colors CoolClean:normal-from-color CoolClean:normal-to-color))))
  (when (> (cdr (image-dimensions img)) 4)
    (bevel-image img 1 1))
  (set-image-border img 1 1 1 1)))


;; frame layout
(frame
  `(
    ;; title bar image
    ((background . "black")
     (top-edge . -22)
     (left-edge . 15)
     (right-edge . 49)
	 (height . 22)
     (class . top-border))

 ;; title bar
    ((renderer . ,render-bg)
     (foreground . ,(lambda () (list CoolClean:normal-text-color CoolClean:active-text-color)))
	 (font . ,(lambda () (list CoolClean:font)))
     (text . ,window-name)
     (x-justify . 4)
     (y-justify . center)
     (top-edge . -21)
	 (height . 20)
     (left-edge . 15)
     (right-edge . 49)
     (class . title))

    ;; menu button
    ((background . ,menu-images)
     (top-edge . -22)
     (left-edge . -6)
     (class . menu-button))

    ;; left border
    ((background . ,left-images)
     (left-edge . -6)
     (top-edge . 0)
     (bottom-edge . 19)
     (class . left-border))

    ;; top-right corner
    ((background . ,top-right-images)
     (right-edge . -6)
     (top-edge . -22)
     (class . top-right-corner))

    ;; top-right-button-box corner
    ((background . ,top-right-button-box-images)
     (right-edge . -3)
     (top-edge . -22)
     (class . title))

    ;; right border
    ((background . ,right-images)
     (right-edge . -6)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . right-border))

    ;; bottom border
    ((background . ,bottom-images)
     (left-edge . 17)
     (right-edge . 19)
     (bottom-edge . -6)
     (class . bottom-border))

    ;; bottom-left corner
    ((background . ,bottom-left-images)
     (left-edge . -6)
     (bottom-edge . -6)
     (class . bottom-left-corner))

    ;; bottom-right corner
    ((background . ,bottom-right-images)
     (right-edge . -6)
     (bottom-edge . -6)
     (class . bottom-right-corner))

    ;; iconify button
    ((background . ,iconify-images)
     (right-edge . 31)
     (top-edge . -19)
     (class . iconify-button))

    ;; maximize button
    ((background . ,maximize-images)
     (right-edge . 14)
     (top-edge . -19)
     (class . maximize-button))

    ;; delete button
    ((background . ,close-images)
     (right-edge . -3)
     (top-edge . -19)
     (class . close-button))))


; Shaped
(shaped-frame
  `(
    ;; title bar image
    ((background . "black")
     (top-edge . -22)
     (left-edge . 15)
     (right-edge . 49)
	 (height . 22)
     (class . top-border))

	;; title bar
    ((renderer . ,render-bg)
     (foreground . ,(lambda () (list CoolClean:normal-text-color CoolClean:active-text-color)))
	 (font . ,(lambda () (list CoolClean:font)))
     (text . ,window-name)
     (x-justify . 4)
	 (y-justify . center)
     (top-edge . -21)
	 (height . 20)
     (left-edge . 15)
     (right-edge . 49)
     (class . title))

    ;; menu button
    ((background . ,s-menu-images)
     (top-edge . -22)
     (left-edge . -6)
     (class . menu-button))

    ;; top-right corner
    ((background . ,s-top-right-images)
     (right-edge . -6)
     (top-edge . -22)
     (class . title))

    ;; iconify button
    ((background . ,iconify-images)
     (right-edge . 31)
     (top-edge . -19)
     (class . iconify-button))

    ;; maximize button
    ((background . ,maximize-images)
     (right-edge . 14)
     (top-edge . -19)
     (class . maximize-button))

    ;; delete button
    ((background . ,close-images)
     (right-edge . -3)
     (top-edge . -19)
     (class . close-button))))


; Transient
(transient-frame
  `(
    ;; title bar image
    ((background . "black")
     (top-edge . -22)
     (left-edge . 15)
     (right-edge . 15)
	 (height . 22)
     (class . top-border))

	;; title bar
    ((renderer . ,render-bg)
     (foreground . ,(lambda () (list CoolClean:normal-text-color CoolClean:active-text-color)))
	 (font . ,(lambda () (list CoolClean:font)))
     (text . ,window-name)
     (x-justify . 4)
	 (y-justify . center)
     (top-edge . -21)
	 (height . 20)
     (left-edge . 15)
     (right-edge . 15)
     (class . title))

    ;; menu button
    ((background . ,menu-images)
     (top-edge . -22)
     (left-edge . -6)
     (class . menu-button))

    ;; left border
    ((background . ,left-images)
     (left-edge . -6)
     (top-edge . 0)
     (bottom-edge . 19)
     (class . left-border))

    ;; top-right corner
    ((background . ,top-right-images)
     (right-edge . -6)
     (top-edge . -22)
     (class . top-right-corner))

    ;; top-right-button-box corner
    ((background . ,t-top-right-button-box-images)
     (right-edge . -3)
     (top-edge . -22)
     (class . title))

    ;; right border
    ((background . ,right-images)
     (right-edge . -6)
     (top-edge . 0)
     (bottom-edge . 0)
     (class . right-border))

    ;; bottom border
    ((background . ,bottom-images)
     (left-edge . 17)
     (right-edge . 19)
     (bottom-edge . -6)
     (class . bottom-border))

    ;; bottom-left corner
    ((background . ,bottom-left-images)
     (left-edge . -6)
     (bottom-edge . -6)
     (class . bottom-left-corner))

    ;; bottom-right corner
    ((background . ,bottom-right-images)
     (right-edge . -6)
     (bottom-edge . -6)
     (class . bottom-right-corner))

    ;; delete button
    ((background . ,close-images)
     (right-edge . -3)
     (top-edge . -19)
     (class . close-button))))


; Shaped-transient
(shaped-transient-frame
  `(
	;; title bar image
    ((background . "black")
     (top-edge . -22)
     (left-edge . 15)
     (right-edge . 15)
	 (height . 22)
     (class . top-border))

	;; title bar
    ((renderer . ,render-bg)
     (foreground . ,(lambda () (list CoolClean:normal-text-color CoolClean:active-text-color)))
	 (font . ,(lambda () (list CoolClean:font)))
     (text . ,window-name)
     (x-justify . 4)
	 (y-justify . center)
     (top-edge . -21)
	 (height . 20)
     (left-edge . 15)
     (right-edge . 15)
     (class . title))

    ;; menu button
    ((background . ,s-menu-images)
     (top-edge . -22)
     (left-edge . -6)
     (class . menu-button))

    ;; top-right corner
    ((background . ,st-top-right-images)
     (right-edge . -6)
     (top-edge . -22)
     (class . title))

    ;; delete button
    ((background . ,close-images)
     (right-edge . -3)
     (top-edge . -19)
     (class . close-button)))))


;; Frame definition
(add-frame-style 'CoolClean
   (lambda (w type)
	 (cond ((eq type 'shaped)
		shaped-frame)
	   ((eq type 'transient)
		transient-frame)
	   ((eq type 'shaped-transient)
		shaped-transient-frame)
	   ((eq type 'unframed)
		nil-frame)
	   (t
		frame)))))

;; theme file, written Tue Mar 26 11:02:46 2002
;; created by sawfish-themer -- DO NOT EDIT!

(require 'make-theme)

(let
    ((patterns-alist
      '(("t-esq-sup-der"
         (inactive
          "u_esq-sup-der.png")
         (focused
          "f_esq-sup-der.png"))
        ("t-esq-sup-izq"
         (inactive
          "u_esq-sup-izq.png")
         (focused
          "f_esq-sup-izq.png"))
        ("t-bor-sup"
         (inactive
          "u_bor-sup-cen.png"
          (tiled . t))
         (focused
          "f_bor-sup-cen.png"
          (tiled . t))
         (highlighted
          "f_bor-sup-cen.png"
          (tiled . t))
         (inactive-highlighted
          "u_bor-sup-cen.png"
          (tiled . t))
         (clicked
          "f_bor-sup-cen.png"
          (tiled . t))
         (inactive-clicked
          "u_bor-sup-cen.png"
          (tiled . t)))
        ("bor-inf"
         (inactive
          "uu_bor-inf-cen.png"
          (tiled . t))
         (focused
          "bor-inf-cen.png"
          (tiled . t)))
        ("bor-der"
         (inactive
          "uu_bor-cen-der.png"
          (tiled . t))
         (focused
          "bor-cen-der.png"
          (tiled . t)))
        ("bor-izq"
         (inactive
          "uu_bor-cen-izq.png"
          (tiled . t))
         (focused
          "bor-cen-izq.png"
          (tiled . t)))
        ("esq-inf-der"
         (inactive
          "esq-inf-der.png")
         (focused
          "esq-inf-der.png"))
        ("esq-inf-izq"
         (inactive
          "esq-inf-izq.png")
         (focused
          "esq-inf-izq.png"))
        ("but-min"
         (inactive
          "but-minimize.png")
         (focused
          "but-minimize.png")
         (highlighted
          "but-minimize.png")
         (inactive-highlighted
          "but-minimize.png")
         (clicked
          "but-minimize.png")
         (inactive-clicked
          "but-minimize.png"))
        ("esq-sup-izq"
         (inactive
          "esq-sup-izq.png")
         (focused
          "esq-sup-izq.png"))
        ("esq-sup-der"
         (inactive
          "esq-sup-der.png")
         (focused
          "esq-sup-der.png"))
        ("bor-sup"
         (inactive
          "uu_bor-sup-cen.png"
          (tiled . t))
         (focused
          "bor-sup-cen.png"
          (tiled . t)))))

     (frames-alist
      '(("estandar"
         ((top-edge . -25)
          (left-edge . 6)
          (font . "-dec-terminal-bold-r-normal-*-*-140-*-*-c-*-iso8859-1")
          (right-edge . 6)
          (background . "t-bor-sup")
          (y-justify . center)
          (x-justify . center)
          (text . window-name)
          (class . title))
         ((left-edge . -5)
          (top-edge . 0)
          (bottom-edge . 6)
          (background . "bor-izq")
          (class . left-border))
         ((right-edge . -5)
          (top-edge . 0)
          (bottom-edge . 6)
          (background . "bor-der")
          (class . right-border))
         ((left-edge . 6)
          (right-edge . 6)
          (bottom-edge . -5)
          (background . "bor-inf")
          (class . bottom-border))
         ((left-edge . -5)
          (bottom-edge . -5)
          (background . "esq-inf-izq")
          (class . bottom-left-corner))
         ((right-edge . -5)
          (bottom-edge . -5)
          (background . "esq-inf-der")
          (class . bottom-right-corner))
         ((top-edge . -25)
          (left-edge . -5)
          (background . "t-esq-sup-izq")
          (class . top-left-corner))
         ((top-edge . -25)
          (right-edge . -5)
          (background . "t-esq-sup-der")
          (class . top-right-corner))
         ((top-edge . -20)
          (left-edge . 9)
          (background . "but-min")
          (class . iconify-button)))
        ("sintitulo"
         ((left-edge . -5)
          (top-edge . -5)
          (background . "esq-sup-izq")
          (class . top-left-corner))
         ((right-edge . -5)
          (top-edge . -5)
          (background . "esq-sup-der")
          (class . top-right-corner))
         ((left-edge . -5)
          (bottom-edge . -5)
          (background . "esq-inf-izq")
          (class . bottom-left-corner))
         ((right-edge . -5)
          (bottom-edge . -5)
          (background . "esq-inf-der")
          (class . bottom-right-corner))
         ((left-edge . 6)
          (right-edge . 6)
          (top-edge . -5)
          (background . "bor-sup")
          (class . top-border))
         ((left-edge . 6)
          (right-edge . 6)
          (bottom-edge . -5)
          (background . "bor-inf")
          (class . bottom-border))
         ((bottom-edge . 6)
          (top-edge . 6)
          (left-edge . -5)
          (background . "bor-izq")
          (class . left-border))
         ((bottom-edge . 6)
          (top-edge . 6)
          (right-edge . -5)
          (background . "bor-der")
          (class . right-border)))
        ("ensombra"
         ((left-edge . 6)
          (font . "-dec-terminal-bold-r-normal-*-*-140-*-*-c-*-iso8859-1")
          (right-edge . 6)
          (top-edge . -25)
          (y-justify . center)
          (x-justify . center)
          (foreground . "#7fff7fff7fff")
          (text . window-name)
          (background . "t-bor-sup")
          (class . title))
         ((left-edge . -5)
          (top-edge . -25)
          (background . "t-esq-sup-izq")
          (class . top-left-corner))
         ((right-edge . -5)
          (top-edge . -25)
          (background . "t-esq-sup-der")
          (class . top-right-corner))
         ((top-edge . -4)
          (left-edge . 6)
          (right-edge . 6)
          (background . "bor-inf")
          (class . bottom-border))
         ((left-edge . -5)
          (top-edge . -10)
          (background . "esq-inf-izq")
          (class . bottom-left-corner))
         ((right-edge . -5)
          (top-edge . -10)
          (background . "esq-inf-der")
          (class . bottom-right-corner))
         ((top-edge . -20)
          (left-edge . 9)
          (background . "but-min")
          (class . iconify-button)))))

     (mapping-alist
      '((default . "estandar")
        (transient . "sintitulo")
        (shaded . "ensombra")))

     (theme-name 'SawLook))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))

; mxflat/mxflat.jl
;;; START

#| theme.jl for mxflat (v0.7.3) sawfish theme

   Copyright (C) 2002 mx & ta

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   authors: mx (email) & ta (dev.null@gmx.net)
|#

(require 'gradient)
; need hash tables for icon cache
(require 'rep.data.tables)
(require 'rep.io.timers)
(require 'sawfish.wm.util.recolor-image)

; required when gaoling is turned off (for debugging)
;(require 'rep.mmsystem)
;(require 'sawfish.wm.custom)
;(require 'sawfish.wm.colors)
;(require 'sawfish.wm.images)
;(require 'sawfish.wm.fonts)

;   ---------
;;; REDRAWING
;   ---------

;
;; redrawing:internal vars
;

; we need to define theme here
; so we can reach them from our defcustom clauses

; cache for window icons
(defvar icon-cache (make-weak-table eq-hash eq))

; holds the shadow side for the current selected option
(defvar shadow-side ())

; for now empty, see below
(define (recolor-all))

;
;; redrawing:functions
;

(define (get-symbol #!rest strings)
	(intern (mapconcat identity strings ""))
)
(define (check-symbol #!rest strings)
	(let
		(
			(name (intern (mapconcat identity strings "")))
		)
		(if (boundp name)
			(symbol-value name)
			nil
		)
	)
)

(define (refresh-one-frame w)
	(if (eq (window-get w 'current-frame-style) 'mxflat)
		(refresh-window w)
	)
)

(define (refresh-all-frames)
	(map-windows refresh-window)
)

(define (rebuild-all-frames)
		(rebuild-frames-with-style 'mxflat)
)

; same as rebuild but this also deletes the icon cache
(define (recreate-all-frames)
	(reframe-windows-with-style 'mxflat)
)

; after the light source direction is updated we have to destroy the cache
; with the correct shadow sides, it will be recreated on next access
(define (after-set-shadow-light-source)
	(setq shadow-side ())
	(recreate-all-frames)
)

(define update-interval nil)
(define update-timer 
	(make-timer (lambda ()
		(refresh-all-frames)
		(if update-interval
			(set-timer update-timer update-interval)
		)
	))
)

(define (after-set-title-periodic-update)
	(if (check-symbol "mxflat:title-periodic-update")
		(set-timer update-timer update-interval)
		(delete-timer update-timer)
	)
)

(define (after-set-title-update-interval)
	(setq update-interval (check-symbol "mxflat:title-update-interval"))
	(after-set-title-periodic-update)
)

(define (recreate-all-frames-clear-cache)
	; reset icon cache
	(setq icon-cache (make-weak-table eq-hash eq))
	(recreate-all-frames)
)

(define (recreate-all-frames-recolor-all)
	(recolor-all)
	(recreate-all-frames)
)

;   -------------
;;; CONFIGURATION
;   -------------

;
;; configuration:keymaps
;

; we need to define our default keymaps here,
; so we can reach them from our defcustom clauses

(defvar sticky-button-keymap
	(bind-keys (make-keymap)
		"Button1-Off" 'toggle-window-sticky
	)
)
(defvar previous-button-keymap
	(bind-keys (make-keymap)
		"Button6-Click" 'pack-window-left
		"Button3-Off" '(command-sequence `((send-to-workspace ,(1+ (car (workspace-limits))))
											(activate-workspace ,(1+ (car (workspace-limits))))))
		"Button2-Click" 'popup-workspace-list
		"Button1-Off" 'send-to-previous-workspace
	)
)
(defvar next-button-keymap
	(bind-keys (make-keymap)
		"Button6-Click" 'pack-window-right
		"Button3-Off" '(command-sequence `((send-to-workspace ,(1+ (cdr (workspace-limits))))
											(activate-workspace ,(1+ (cdr (workspace-limits))))))
		"Button2-Click" 'popup-workspace-list
		"Button1-Off" 'send-to-next-workspace
	)
)

(defvar configure-button-keymap
	(bind-keys (make-keymap)
		"Button1-Off" 'customize
		"Button3-Off" '(call-command
			(lambda ()
				(if mxflat:custom-title
					(setq mxflat:custom-title nil)
					(setq mxflat:custom-title t)
				)
				;(reframe-windows-with-style 'mxflat)
				(map-windows refresh-window)
			))
	)
)
(defvar always-on-top-button-keymap
	(bind-keys (make-keymap)
		"Button1-Off" '(call-command
			(lambda ()
				(if (> (window-get (current-event-window) 'depth) 0)
					(window-put (current-event-window) 'depth 0)
					(window-put (current-event-window) 'depth mxflat:always-on-top-depth)
				)
				(reframe-window (current-event-window))
			))
	)
)
(defvar lock-button-keymap
	(bind-keys (make-keymap)
		"Button1-Off" '(call-command
			(lambda ()
				(if (window-get (current-event-window) 'fixed-position)
					(window-put (current-event-window) 'fixed-position nil)
					(window-put (current-event-window) 'fixed-position t)
				)
				(reframe-window (current-event-window))
			))
	)
)


;
;; configuration:groups
;

; there are just too many options
; so we put them into several groups/tabs
(defgroup mxflat:group
	"mxflat"
	:group appearance
)
(defgroup mxflat:title-group
	"title"
	:group (appearance mxflat:group)
)
(defgroup mxflat:title-basic-group
	"basic"
	:group (appearance mxflat:group mxflat:title-group)
)
(defgroup mxflat:title-gradient-group
	"gradient"
	:group (appearance mxflat:group mxflat:title-group)
)
(defgroup mxflat:title-colors-group
	"colors"
	:group (appearance mxflat:group mxflat:title-group)
)
(defgroup mxflat:buttons-group
	"buttons"
	:group (appearance mxflat:group)
)
(defgroup mxflat:buttons-basic-group
	"basic"
	:group (appearance mxflat:group mxflat:buttons-group)
)
(defgroup mxflat:buttons-positions1-group
	"positions 1"
	:group (appearance mxflat:group mxflat:buttons-group)
)
(defgroup mxflat:buttons-positions2-group
	"positions 2"
	:group (appearance mxflat:group mxflat:buttons-group)
)
(defgroup mxflat:buttons-keymaps1-group
	"keymaps 1"
	:group (appearance mxflat:group mxflat:buttons-group)
)
(defgroup mxflat:buttons-keymaps2-group
	"keymaps 2"
	:group (appearance mxflat:group mxflat:buttons-group)
)
(defgroup mxflat:button-colors-group
	"colors"
	:group (appearance mxflat:group mxflat:buttons-group)
)
(defgroup mxflat:border-group
	"borders"
	:group (appearance mxflat:group)
)
(defgroup mxflat:border1-group
	"basic"
	:group (appearance mxflat:group mxflat:border-group)
)
(defgroup mxflat:border-extended-group
	"extended"
	:group (appearance mxflat:group mxflat:border-group)
)
(defgroup mxflat:border-colors-group
	"colors"
	:group (appearance mxflat:group mxflat:border-group)
)

;
;; configuration:title-basic
;

(defcustom mxflat:decoration-mode
	'normal
	"decoration mode"
	:tooltip "set the mode 'when to draw a titlebar and window buttons'. the decoration mode 'all' means that all windows, even transients/dialogs, will get a titlebar and buttons. none means no window will get any :-). usually transients only have a contents-border. this option is for reimplementing a sawfish feature that is gone in the latest version."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type symbol
	:options (normal all none)
	:after-set recreate-all-frames
)

(defcustom mxflat:title-height
	16
	"titlebar height (9 - 1000 pixel)"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type (number 9 1000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:custom-title
	nil
	"customize title string"
	:tooltip "see the tooltip for the 'title string' option below for more information. (NOTE: i hope the redrawing problems with this option are solved. if not, write an email please!)"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type boolean
	:after-set refresh-all-frames
)

(defcustom mxflat:title-string
	"$fullname |$widthx$height-($x-pos,$y-pos)@$current-ws/$last-ws-$(DISPLAY)"
	"title string"
	:tooltip "the string you insert here will be your new title string. variables always start with a dollar-sign $ and are replaced with their actual values. to get the value of an environment variable use $(variable), eg $(DISPLAY). to get the value of an rep/sawfish function use $[fuction], eg $[current-time-string]. the following vars are built-in: $name, $fullname, $width, $width-content, $height, $height-content, $depth, $x-pos, $y-pos, $current-ws and $last-ws. (NOTE: i hope the redrawing problems with this option are solved. if not, write an email please!"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type string
	:depends mxflat:custom-title
	:after-set refresh-all-frames
)

(defcustom mxflat:title-periodic-update
	nil
	"update title string periodically"
	:tooltip "this is useful if your title string changes without user interaction (eg because it displays the current time or something like that)."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type boolean
	:depends mxflat:custom-title
	:after-set after-set-title-periodic-update
)

(defcustom mxflat:title-update-interval
	1000
	"title string update interval (1 - 1000000 s)"
	:tooltip "this is useful if your title string changes without user interaction (eg because it displays the current time or something like that)."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type (number 1 1000000)
	:depends mxflat:custom-title
	:after-set after-set-title-update-interval
)

(defcustom mxflat:title-font
	default-font
	"title string font"
	:tooltip "you should really choose a better font. verdana bold 8 pt looks nice."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type font
	:after-set rebuild-all-frames
)

(defcustom mxflat:customize-title-position
	nil
	"customize title position"
	:tooltip "by default the title string is centered horizontally and vertically."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type boolean
	:after-set rebuild-all-frames
)

(defcustom mxflat:title-x-justify
	'center
	"title string horizontal alignment"
	:tooltip "'real-center' means to take the whole titlebar into account while centering the string. when selecting 'center' only the distance between the buttons is taken into account."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type symbol
	:depends mxflat:customize-title-position
	:options (left center real-center right)
	:after-set rebuild-all-frames
)

(defcustom mxflat:title-x-adjustment
	0
	"title string horizontal align adjustment (-10000 - 10000 pixel)"
	:tooltip "the horizontal position of the title string can only be adjusted if the horizontal alignment is not 'center'. the range also depends on the setting of the option above. it the title string is already aligned left, you cannot adjust it to be even further left because there are button in the way."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type (number -10000 10000)
	:depends mxflat:customize-title-position
	:after-set rebuild-all-frames
)

(defcustom mxflat:title-y-justify
	'center
	"title string vertical alignment"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type symbol
	:depends mxflat:customize-title-position
	:options (top center bottom)
	:after-set rebuild-all-frames
)

(defcustom mxflat:title-y-adjustment
	0
	"title string vertical align adjustment (-10000 - 10000 pixel)"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-basic-group)
	:type (number -10000 10000)
	:depends mxflat:customize-title-position
	:after-set rebuild-all-frames
)

;
;; configuration:title-gradient
;

(defcustom mxflat:title-gradient
	nil
	"gradient titlebar background (experimental)"
	:tooltip "when activating the gradient background the normal titlebar background colors will be ignored. besides the button background colors will be ignored. (NOTE: this can be very cpu intensive if you set the quality to a low value, ie high quality.)"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-gradient-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:gradient-direction
	'horizontal
	"gradient mode"
	:tooltip "with gradient mode vertical or diagonal only the first or last (reversed) 2 colors in the list are used."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-gradient-group)
	:options (none horizontal vertical diagonal)
	:depends mxflat:title-gradient
	:type symbol
	:after-set recreate-all-frames
)

(defcustom mxflat:gradient-scale
	3
	"gradient quality (1 best - 20 worst)"
	:tooltip "the value here is the factor the calculated gradient image will be scaled down. this increases speed but decreases quality."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-gradient-group)
	:depends mxflat:title-gradient
	:type (number 1 20)
	:after-set recreate-all-frames
)

(defcustom mxflat:titlebar-gradient-color-mode
	'rainbow
	"gradient color mode"
	:tooltip "the custom mode will respect the colors set in the list below."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-gradient-group)
	:options (rainbow jamaica rgb custom)
	:depends mxflat:title-gradient
	:type symbol
	:after-set recreate-all-frames
)

(defcustom mxflat:titlebar-gradient-bgcolors
	nil
	nil
	:tooltip "with gradient mode vertical or diagonal only the first or last (reversed) 2 colors in the list are used. besides the gradient color mode must be set to custom to activate this list."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-gradient-group)
	:widget-flags (expand-horizontally)
	:depends mxflat:title-gradient
	:type* `(list color "titlebar background colors")
	:after-set recreate-all-frames
)

(defcustom mxflat:titlebar-gradient-bgcolors-reverse
	nil
	"reverse colors"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-gradient-group)
	:depends mxflat:title-gradient
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:color-hue
	0
	"unfocused/highlighted titlebar colors hue (0 - 360)"
	:tooltip "this value changes the hue of a color, by moving (0 - 360) degress around the color cycle...180 for example inverts the color"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-gradient-group)
	:depends mxflat:title-gradient
	:type (number 0 360)
	:after-set recreate-all-frames
)

(defcustom mxflat:color-saturation
	50
	"unfocused/highlighted titlebar colors saturation (0 - 100% of the focused color)"
	:tooltip "the saturation of a color is a measurement of the color intensity"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-gradient-group)
	:depends mxflat:title-gradient
	:type (number 0 100)
	:after-set recreate-all-frames
)

(defcustom mxflat:color-brightness
	90
	"unfocused/highlighted titlebar colors brightness (0 - 100% of the focused color)"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-gradient-group)
	:depends mxflat:title-gradient
	:type (number 0 100)
	:after-set recreate-all-frames
)

;
;; configuration:title-colors
;

(defcustom mxflat:titlebar-bgcolor-focused
	(get-color "#fffbde")
	"  focused titlebar color"
	:tooltip "this is one of the 4 base colors. you can set these 4 colors and keep the extended colors deactivated. all other color options of the theme will then depend on these 4 colors."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-colors-group)
	:type color
	:after-set recreate-all-frames
)

(defcustom mxflat:titlebar-bgcolor-unfocused
	(get-color "#cedfef")
	"unfocused titlebar color"
	:tooltip "this is one of the 4 base colors. you can set these 4 colors and keep the extended colors deactivated. all other color options of the theme will then depend on these 4 colors."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-colors-group)
	:type color
	:after-set recreate-all-frames
)

(defcustom mxflat:text-color-focused
	(get-color "#000000")
	"  focused title string color"
	:tooltip "this is one of the 4 base colors. you can set these 4 colors and keep the extended colors deactivated. all other color options of the theme will then depend on these 4 colors."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-colors-group)
	:type color
	:after-set recreate-all-frames-recolor-all
)

(defcustom mxflat:text-color-unfocused
	(get-color "#838383")
	"unfocused title string color"
	:tooltip "this is one of the 4 base colors. you can set these 4 colors and keep the extended colors deactivated. all other color options of the theme will then depend on these 4 colors."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-colors-group)
	:type color
	:after-set recreate-all-frames-recolor-all
)

(defcustom mxflat:customize-extended-text-colors
	nil
	"customize extended title string colors"
	:tooltip "you can customize additional colors of the title string. if you deactivate this, these colors will be set to the focused title string color."
	:group (appearance mxflat:group mxflat:title-group mxflat:title-colors-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:text-color-highlighted
	(get-color "#000000")
	"  focused highlighted title string color"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-colors-group)
	:type color
	:depends mxflat:customize-extended-text-colors
	:after-set recreate-all-frames
)

(defcustom mxflat:text-color-inactive-highlighted
	(get-color "#000000")
	"unfocused highlighted title string color"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-colors-group)
	:type color
	:depends mxflat:customize-extended-text-colors
	:after-set recreate-all-frames
)

(defcustom mxflat:text-color-clicked
	(get-color "#000000")
	"  focused clicked title string color"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-colors-group)
	:type color
	:depends mxflat:customize-extended-text-colors
	:after-set recreate-all-frames
)

(defcustom mxflat:text-color-inactive-clicked
	(get-color "#000000")
	"unfocused clicked title string color"
	:group (appearance mxflat:group mxflat:title-group mxflat:title-colors-group)
	:type color
	:depends mxflat:customize-extended-text-colors
	:after-set recreate-all-frames
)


;; configuration:buttons-basic
;

(defcustom mxflat:button-icon-set
	'default-9
	"button icon set (experimental)"
	:tooltip "the number at the end is the width/height of the button icons in the icon set. (NOTE: YOU NEED TO RESTART SAWFISH AFTER CHANGING THE BUTTON ICON SET!)"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-basic-group)
	:options (default-9 default-12 square-6 square-9 square-12 square-15 square-18 ball-9 ball-12)
	:type symbol
	:after-set recreate-all-frames-clear-cache
)

(defcustom mxflat:customize-button-size
	nil
	"customize button size"
	:tooltip "by default the button size follows the size of the titlebar, but by activating this you can set it to something different."
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-basic-group)
	:type boolean
	:after-set rebuild-all-frames
)

(defcustom mxflat:button-size
	14
	"buttons size (1 - 1000 pixel)"
	:tooltip "a buttons size that is bigger than your current titlebar height is ignored."
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-basic-group)
	:depends mxflat:customize-button-size
	:type (number 1 1000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:button-y-alignment
	'center
	"button vertical alignment"
	:tooltip "if a button is smaller than the titlebar you might want to set its vertical alignment."
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-basic-group)
	:depends mxflat:customize-button-size
	:options (top center bottom)
	:type symbol
	:after-set rebuild-all-frames
)

(defcustom mxflat:scale-buttons
	nil
	"scale button icons (experimental)"
	:tooltip "in case you don't like the default size of 9 pixel you might activate button-scaling. YOU NEED TO RESTART SAWFISH AFTER CHANGING THE BUTTON SCALE!"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-basic-group)
	:type boolean
	:after-set recreate-all-frames-clear-cache
)

(defcustom mxflat:button-scale
	9
	"button icon scale; changes here need a restart of sawfish (0 - 1000 pixel)"
	:tooltip "in case you don't like the default size of 9 pixel you might activate button-scaling. (NOTE: YOU NEED TO RESTART SAWFISH AFTER CHANGING THE BUTTON SCALE!)"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-basic-group)
	:depends mxflat:scale-buttons
	:type (number 0 1000)
	:after-set recreate-all-frames-clear-cache
)

(defcustom mxflat:menu-button-icon
	nil
	"display window icon on menu button"
	:tooltip "many people like having the window-icon displayed on the menu-button. this icon is defined by the application itself and is also shown in your pager and task-list."
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-basic-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:menu-button-scale
	12
	"menu icon scale (0 - 1000 pixel)"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-basic-group)
	:depends mxflat:menu-button-icon
	:type (number 0 1000)
	:after-set recreate-all-frames-clear-cache
)

;
;; configuration:buttons-position1
;

(defcustom mxflat:button-distance
	3
	"button distance (0 - 1000 pixel)"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions1-group)
	:type (number 0  1000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:button-left-offset
	1
	"buttons left offset (0 - 1000 pixel)"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions1-group)
	:type (number 0  1000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:button-right-offset
	1
	"buttons right offset (0 - 1000 pixel)"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions1-group)
	:type (number 0  1000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:customize-buttons
	nil
	"customize button position (-1 -2 -3 .. title string .. +3 +2 +1)"
	:tooltip "enabling this will allow you to set the positon of each button in the titlebar manually. a negative/positiv value means the button will be drawn on left/right side of the titlebar."
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions1-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:button-position-model
	'title-height
	"button position model"
	:tooltip "'titel-height' means calculate position as multiple of title height. when selecting 'pixel' you can adjust the button position pixelwise, but keep in mind that several buttons might slide on top of each other. 'none' means no buttons at all."
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions1-group)
	:options (title-height pixel none)
	:depends mxflat:customize-buttons
	:type symbol
	:after-set rebuild-all-frames
)

;
;; configuration:buttons-position2
;

(defcustom mxflat:menu-button-position
	-1
	"menu button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:shade-button-position
	-2
	"shade button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:iconify-button-position
	+3
	"iconify button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:maximize-button-position
	+2
	"maximize button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:close-button-position
	+1
	"close button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:sticky-button-position
	-3
	"sticky button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:previous-button-position
	-5
	"previous workspace button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:next-button-position
	-6
	"next workspace button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:configure-button-position
	0
	"configure button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:info-button-position
	0
	"info button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:always-on-top-button-position
	0
	"always-on-top button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:lock-button-position
	0
	"lock button position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-positions2-group)
	:depends mxflat:customize-buttons
	:type (number -10000 10000)
	:after-set rebuild-all-frames
)

;
;; configuration:buttons-keymaps1
;

(defcustom mxflat:customize-sticky-keymap
	nil
	"customize sticky button keymap"
	:tooltip "by default a button will work as it's name suggests. button1: toggle sticky state of window"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps1-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:sticky-button-keymap
	nil
	nil
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps1-group)
	:widget-flags (expand-horizontally)
	:depends mxflat:customize-sticky-keymap
    :type keymap
)

(defcustom mxflat:customize-previous-keymap
	nil
	"customize previous button keymap"
	:tooltip "by default a button will work as it's name suggests. button1: send window to previous workspace - button2 workspace-list - button3 send window to first workspace - button6 pack window left"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps1-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:previous-button-keymap
	nil
	nil
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps1-group)
	:widget-flags (expand-horizontally)
	:depends mxflat:customize-previous-keymap
    :type keymap
)

(defcustom mxflat:customize-next-keymap
	nil
	"customize next button keymap"
	:tooltip "by default a button will work as it's name suggests. button1: send window to next workspace - button2 workspace-list - button3 send window to last workspace - button6 pack window right"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps1-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:next-button-keymap
	nil
	nil
	:tooltip "button1: send window to next workspace - button2 workspace-list - button3 send window to last workspace - button6 pack window right"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps1-group)
	:widget-flags (expand-horizontally)
	:depends mxflat:customize-next-keymap
    :type keymap
)

;
;; configuration:buttons-keymaps2
;

(defcustom mxflat:customize-configure-keymap
	nil
	"customize configure button keymap"
	:tooltip "by default a button will work as it's name suggests. button1: start sawfish-ui - button3: toggle custom title string"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps2-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:configure-button-keymap
	nil
	nil
	:tooltip "button1: start sawfish-ui - button3: toggle custom title string"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps2-group)
	:widget-flags (expand-horizontally)
	:depends mxflat:customize-configure-keymap
    :type keymap
)

(defcustom mxflat:customize-info-keymap
	nil
	"customize info button keymap"
	:tooltip "by default a button will work as it's name suggests. button1: window list - button3 window snooper (not included by default)"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps2-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:info-button-keymap
	nil
	nil
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps2-group)
	:widget-flags (expand-horizontally)
	:depends mxflat:customize-info-keymap
    :type keymap
)

(defcustom mxflat:always-on-top-depth
	1
	"always on top depth (-1000 - 1000)"
	:tooltip "a window will have this depth after you have pressed the always-on-top button. 0 is the normal window level. every positive value means above other windows, a negative value means below. keept it at a positive value in order to have the always-on-top button do it's job."
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps2-group)
	:type (number -1000 1000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:customize-always-on-top-keymap
	nil
	"customize always-on-top button keymap"
	:tooltip "by default a button will work as it's name suggests. button1: sets window depth to the adjusted value"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps2-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:always-on-top-button-keymap
	nil
	nil
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps2-group)
	:depends mxflat:customize-always-on-top-keymap
	:widget-flags (expand-horizontally)
    :type keymap
)

(defcustom mxflat:customize-lock-keymap
	nil
	"customize look button keymap"
	:tooltip "by default a button will work as it's name suggests. button1: lock window position"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps2-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:lock-button-keymap
	nil
	nil
	:group (appearance mxflat:group mxflat:buttons-group mxflat:buttons-keymaps2-group)
	:depends mxflat:customize-lock-keymap
	:widget-flags (expand-horizontally)
    :type keymap
)

;
;; configuration:button-colors
;

(defcustom mxflat:custom-button-colors
	nil
	"customize button-colors"
	:tooltip "when you active this you will be able to set custom button colors. by default the button colors depend on the titlebar colors."
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:type boolean
	:after-set recreate-all-frames-recolor-all
)

(defcustom mxflat:button-bgcolor-focused
	(get-color "#fffbde")
	"  focused button background color"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:depends mxflat:custom-button-colors
	:type color
	:after-set recreate-all-frames
)

(defcustom mxflat:button-bgcolor-unfocused
	(get-color "#cedfef")
	"unfocused button background color"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:depends mxflat:custom-button-colors
	:type color
	:after-set recreate-all-frames
)

(defcustom mxflat:button-bgcolor-highlighted
	(get-color "#def3ff")
	"  focused highlighted button background color"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:depends mxflat:custom-button-colors
	:type color
	:after-set recreate-all-frames
)

(defcustom mxflat:button-bgcolor-inactive-highlighted
	(get-color "#fffbde")
	"unfocused highlighted button background color"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:depends mxflat:custom-button-colors
	:type color
	:after-set recreate-all-frames
)

(defcustom mxflat:button-bgcolor-clicked
	(get-color "#cecece")
	"  focused clicked button background color"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:depends mxflat:custom-button-colors
	:type color
	:after-set recreate-all-frames
)

(defcustom mxflat:button-bgcolor-inactive-clicked
	(get-color "#cecece")
	"unfocused clicked button background color"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:depends mxflat:custom-button-colors
	:type color
	:after-set recreate-all-frames
)

(defcustom mxflat:button-fgcolor-focused
	(get-color "#000000")
	"  focused button foreground color"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:depends mxflat:custom-button-colors
	:type color
	:after-set recreate-all-frames-recolor-all
)

(defcustom mxflat:button-fgcolor-inactive
	(get-color "#838383")
	"unfocused button foreground color"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:depends mxflat:custom-button-colors
	:type color
	:after-set recreate-all-frames-recolor-all
)

(defcustom mxflat:button-fgcolor-highlighted
	(get-color "#000000")
	"  focused highlighted button foreground color"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:depends mxflat:custom-button-colors
	:type color
	:after-set recreate-all-frames-recolor-all
)

(defcustom mxflat:button-fgcolor-clicked
	(get-color "#000000")
	"  focused clicked button foreground color"
	:group (appearance mxflat:group mxflat:buttons-group mxflat:button-colors-group)
	:depends mxflat:custom-button-colors
	:type color
	:after-set recreate-all-frames-recolor-all
)

;
;; configuration:border-basic
;

(defcustom mxflat:border-width-unmaximized
	1
	"border width (0 - 1000 pixel)"
	:tooltip "set the width border around the window."
	:group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
	:type (number 0 1000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:border-width-maximized
	1
	"border width for maximized windows (0 - 1000 pixel)"
	:tooltip "when you like having a big border around your windows you might have noticed that sawfish still draws that big border when the window is maximized. if you don't want that, set the border width for maximized windows smaller than the border width for unmaximized windows. (NOTE: this feature is still buggy as sawfish does not resize the windows correctly yet, so the best might be to set it to the normal border width.)"
	:group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
	:type (number 0 1000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:custom-border-focused
	nil
	"customize border for focused windows (experimental)"
	:tooltip "(NOTE: this works but it is VERY cpu intensive and might slow down your computer noticably. so turn it on at your own risk.)"
	:group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
	:type boolean
	:after-set rebuild-all-frames
)

(defcustom mxflat:border-width-focused
	1
	"border width for focused windows (0 - 1000 pixel)"
	:tooltip "(NOTE: this works but it is VERY cpu intensive and might slow down your computer noticably. so turn it on at your own risk.)"
	:group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
	:type (number 0 1000)
	:depends mxflat:custom-border-focused
	:after-set rebuild-all-frames
)

(defcustom mxflat:border-width-titlebar-contents
	1
	"title-contents border width (0 - 1000 pixel)"
	:tooltip "sets the widths of the line between titlebar and contents window"
	:group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
	:type (number 0 1000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:border-offset
	-1
	"border offset (-1000 - 1000 pixel)"
	:tooltip "adjust the point where the border actually starts. many gtk2 apps draw a small black border around their contents window and this is just ugly when sawfish draws another border around the window. with a border offset of -1 the sawfish window border will overlay the gtk2 border exactly."
	:group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
	:type (number -1000 1000)
	:after-set rebuild-all-frames
)

(defcustom mxflat:keep-borders-when-shaded
	nil
	"keep window borders and corners at their place when shading a window"
	:tooltip "when shading a window borders and corners will stay where they were and not merge with the titlebar."
	:group (appearance mxflat:group mxflat:border-group mxflat:border1-group)
	:type boolean
	:after-set recreate-all-frames
)

;
;; configuration:border-extended
;

(defcustom mxflat:show-corners
	t
	"show window corners"
	:tooltip " the corners are used to resize a window in two directions at the same time. usually the width and length of window corners are determined by the border width but you can adjust them below."
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:corner-length-adjustment
	20
	"corners length adjustement (-1 - 100 pixel)"
	:tooltip "increasing the corner length will grow the window corners along the window border (i.e. make them longer). with a border width of 1 pixel it is hard to grab the 1 pixel corner to be able to resize the window in two directions; thus, make it bigger."
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type (number -1 100)
	:depends mxflat:show-corners
	:after-set rebuild-all-frames
)

(defcustom mxflat:corner-direction
	'outside
	"corner direction"
	:"inside or outside the window border"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type symbol
	:options (outside inside)
	:depends mxflat:show-corners
	:after-set recreate-all-frames
)

(defcustom mxflat:corner-width-adjustment
	1
	"corners width adjustement (0 - 100 pixel)"
	:tooltip "this option makes the window corners broader. with a border width of 1 pixel it is hard to grab this 1 pixel corner to be able to resize the window in two directions; thus, make it bigger."
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type (number 0 100)
	:depends mxflat:show-corners
	:after-set rebuild-all-frames
)

(defcustom mxflat:corner-width-adjustment-maximized
	0
	"corners width adjustement for maximized windows (0 - 100 pixel)"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type (number 0 100)
	:depends mxflat:show-corners
	:after-set rebuild-all-frames
)

(defcustom mxflat:fake-shadow
	nil
	"fake shadow (experimental)"
	:tooltip "draw a small additional border around your windows emulating a solid shadow effect. use the options below to adjust its width and direction. (NOTE: this is VERY cpu intensive and might slow down your computer noticably. so turn it on at your own risk.)"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type boolean
	:after-set recreate-all-frames
)

(defcustom mxflat:fake-shadow-focused-only
	nil
	"fake shadow only on focused windows"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type boolean
	:depends mxflat:fake-shadow
	:after-set recreate-all-frames
)

(defcustom mxflat:shadow-light-source
	'north-west
	"fake shadow light source"
	:tooltip "set the direction of the fake shadow. usually only 2 or 3 borders of your window have a fake shadow. this depends on where the light comes from."
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type symbol
	:options (north east south west north-east north-west south-east south-west)
	:depends mxflat:fake-shadow
	:after-set after-set-shadow-light-source
)

(defcustom mxflat:shadow-light-distance
	3
	"fake shadow light distance (0 - 100)"
	:tooltip "this option has only an effect on the north, east, south and west light sources. the further away the light source is, the smaller will the two 'side' shadows be."
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type (number 1 100)
	:depends mxflat:fake-shadow
	:after-set rebuild-all-frames
)

(defcustom mxflat:shadow-width
	4
	"fake shadow width (0 - 100 pixel)"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type (number 0 100)
	:depends mxflat:fake-shadow
	:after-set rebuild-all-frames
)

(defcustom mxflat:shadow-color
	(get-color "#838383")
	"shadow color"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-extended-group)
	:type color
	:depends mxflat:fake-shadow
	:after-set rebuild-all-frames
)

;
;; configuration:border-colors
;

(defcustom mxflat:customize-border-colors
	nil
	"customize border colors"
	:tooltip "you can customize your border colors here. if you deactivate this, these colors will be set to the focused title string color."
	:group (appearance mxflat:group mxflat:border-group mxflat:border-colors-group)
	:type boolean
	:after-set rebuild-all-frames
)

(defcustom mxflat:border-color-focused
	(get-color "#000000")
	"  focused border color"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-colors-group)
	:type color
	:depends mxflat:customize-border-colors
	:after-set rebuild-all-frames
)

(defcustom mxflat:border-color-unfocused
	(get-color "#000000")
	"unfocused border color"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-colors-group)
	:type color
	:depends mxflat:customize-border-colors
	:after-set rebuild-all-frames
)

(defcustom mxflat:border-color-highlighted
	(get-color "#000000")
	"  focused highlighted border color"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-colors-group)
	:type color
	:depends mxflat:customize-border-colors
	:after-set rebuild-all-frames
)

(defcustom mxflat:border-color-inactive-highlighted
	(get-color "#000000")
	"unfocused highlighted border color"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-colors-group)
	:type color
	:depends mxflat:customize-border-colors
	:after-set rebuild-all-frames
)

(defcustom mxflat:border-color-clicked
	(get-color "#000000")
	"  focused clicked border color"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-colors-group)
	:type color
	:depends mxflat:customize-border-colors
	:after-set rebuild-all-frames
)

(defcustom mxflat:border-color-inactive-clicked
	(get-color "#000000")
	"unfocused clicked border color"
	:group (appearance mxflat:group mxflat:border-group mxflat:border-colors-group)
	:type color
	:depends mxflat:customize-border-colors
	:after-set rebuild-all-frames
)

;   ----
;;; MISC
;   ----

(define (get-last-workspace)
	(aref
		(nth 2 (get-x-property 'root '_NET_NUMBER_OF_DESKTOPS))
		0
	)
)

(define (get-first-workspace) 1)

(defmacro window-in-workspace-p (w space)
	`(memq ,space (window-get ,w 'workspaces))
)

(define (window-maximized-p w)
	(window-get w 'unmaximized-geometry)
)

(define (window-maximized-horizontally-p w)
	(window-get w 'maximized-horizontally)
)

(define (window-maximized-vertically-p w)
	(window-get w 'maximized-vertically)
)

; constant accuracy factor since
; we ???are not allowed to  use floats in themes???
; / seems to be gaoled
(defvar afactor 10000000000000)
(defvar afactor360 (* 360 afactor))

;
;; misc:color manipulation
;

; returns a list containing hue saturation and value of color
(define (rgb2hsv color)
	(let*
		(
			; get rgb ints for the color
			(rgbchannels (color-rgb color))

			; get red, green and blue ints from rgbchannels
			(red   (nth 0 rgbchannels))
			(green (nth 1 rgbchannels))
			(blue  (nth 2 rgbchannels))

			; channnel with the biggest int value
			(value (apply max (list red green blue)))
			; delta
			(max-min (- value (apply min (list red green blue))))

			; saturation: 1 - min / max  =  (max - min) / max  =  delta / max
			; saturation * afactor - acutally the saturation
			; is a float between 0 and 1 but as it seems
			; we cannot use them in themes
			(saturation
				(if (= max-min 0)
					0
					(/
						(* max-min afactor)
						value
					)
				)
			)
			; value between 0 and 360 degree * afactor
			; 0 = red, 120 = green, 240 = blue
			(hue
				(if (= max-min 0)
					0
					(/
						(*
							60
							afactor
							(cond
								(
									(= value red)
									(- green blue)
								)
								(
									(= value green)
									(+ (* 2 max-min) (- blue red))
								)
								(
									; (= value blue)
									t
									(+ (* 4 max-min) (- red green))
								)
							)
						)
						max-min
					)
				)
			)
		)
		(list (if (< hue 0) (+ hue afactor360) hue) saturation value)
	)
)

; translates a rgb-color from the ints of the list, which contains hue, saturation and value
(define (hsv2rgb hsv)
	(let*
		(
			(hue (nth 0 hsv))
			(saturation (nth 1 hsv))
			(value (nth 2 hsv))
			
		)

		; value zero -> color black
		(cond
			((= value 0)
				(get-color-rgb 0 0 0)
			)
			((= saturation 0)
		
				; in this case the color is grey and
				; thus its rgb value is:
				(get-color-rgb value value value)
			)
			(t
				; else we need to do some calculations -
				; the hue and saturation are aleady
				; multiplied with afactor
				(let*
					(
						; we need it often, so we define
						; it once here
						(afactor2 (* afactor afactor))
						; kind of an 'compensation delta'
						(f
							(if
								(or
									(= hue 0)
									(= hue afactor360)
								)
								0
								(/ (mod hue (* 60 afactor)) 60)
							)
						)

							; p is the lowest color int
							(p
							(/
								(*  value
									(- afactor saturation)
								)
								afactor
							)
						)
						; tt is a medium color int
						(q
							(/
								(*
									value
									(-
										afactor2
										(* saturation f)
									)
								)
								afactor2
							)
						)
						; tt is a medium color int
						(tt
							(/
								(*
									value
									(-
										afactor2
										(*
											saturation
											(- afactor f)
										)
									)
								)
								afactor2
							)
						)

						; area on the color circle (0 .. 5)
						(circle-part
							(if (>= hue afactor360)
								0
								(/
									(/ hue afactor)
									60
								)
							)
						)
					)
					; arrange the right vars for the current
					; color circle part
					(case circle-part
						((0) (get-color-rgb value  	tt 		p))
						((1) (get-color-rgb q 		value 	p))
						((2) (get-color-rgb p 		value 	tt))
						((3) (get-color-rgb p 		q 		value))
						((4) (get-color-rgb tt 		p 		value))
						((5) (get-color-rgb value 	p 		p))
					)
				)
			)
		)
	)
)

; adjusts the hue, brightness and saturation of color
(define (adjust-color color)
	(let*
		(
			; hue saturation value list
			(hsv (rgb2hsv color))
			; add used configured adjustment to
			; the hue of the color
			(a-hue
				(+
					(nth 0 hsv)
					(* mxflat:color-hue afactor)
				)
			)
			; adjust saturation with
			; user configured factor
			(a-saturation
				(/
					(*
						(nth 1 hsv)
						mxflat:color-saturation
					)
					100
				)
			)
			; adjust value/brightness with
			; user configured factor
			(a-value
				(/
					(*
						(nth 2 hsv)
						mxflat:color-brightness
					)
					100
				)
			)
		)
		(hsv2rgb
			(list
				; adjust the hue if necessary
				; (ie it is >360 degree)
				(if (> a-hue afactor360)
					(- a-hue afactor360)
					a-hue
				)
				a-saturation
				a-value
			)
		)
	)
)

;
;; misc:hook-ins
;

; when the window title or some other wm_hints attribute changes, redraw the window
(call-after-property-changed (list 'WM_NAME)
	(lambda (w)
		(if (eq mxflat:title-x-justify 'real-center)
			(rebuild-frame w)
			(refresh-one-frame w)
		)
	)
)

; when we set a window sticky we have to redraw it,
; the sticky button has changed
(call-after-state-changed '(sticky)	reframe-window)

; when the window is sent to another workspace
; redraw it to update the buttons and titlebar if necessary
(add-hook 'remove-from-workspace-hook
	(lambda (w)
		(reframe-window w)
	)
)

; not necessary anymore?
;(add-hook 'after-resize-hook refresh-one-frame)

(add-hook 'focus-in-hook
	(lambda (w)
		; if 'custom borders for focused windows' -> redraw
		(if (or
				mxflat:custom-border-focused
				(and
					mxflat:fake-shadow
					mxflat:fake-shadow-focused-only
				)
			)
			(reframe-window w)
		)
	)
)

(add-hook 'focus-out-hook
	(lambda (w)
		; if 'custom borders for focused windows' -> redraw
		(if (or
				mxflat:custom-border-focused
				(and
					mxflat:fake-shadow
					mxflat:fake-shadow-focused-only
				)
			)
			(reframe-window w)
		)
	)
)

;
;; misc:functions
;

(define (get-border-offset)
	; we use the negative value to make the defcustom option
	; work more like one would expect, ie a positive value
	; means the border will have a bigger distance to the
	; contents window
	(- mxflat:border-offset)
)

(define (get-button-size)
	(if
		(and
			mxflat:customize-button-size
			(< mxflat:button-size mxflat:title-height)
		)
		mxflat:button-size
		mxflat:title-height
	)
)

;   -----------
;;; FAKE SHADOW
;   -----------

; this list defines which window sides have shadows
; for which direction
(defvar shadow-sides
	`(
		(north . (bottom left right))
		(east . (top bottom left))
		(west . (top bottom right))
		(south . (top left right))
		(north-east . (bottom left))
		(north-west . (bottom right))
		(south-west . (top right))
		(south-east . (top left))
	)
)

; selects the right shadow-side from the shadow-sides list
(define (get-shadow-side)
	(mapc
		(lambda (ss)
			(if (eq (car ss) mxflat:shadow-light-source)
				(setq shadow-side (cdr ss))
			)
		)
		shadow-sides
	)
)

(define (get-shadow-color) mxflat:shadow-color)

(define (get-shadow-width w side)
	(if (member side shadow-side)
		(get-neg-border-width w side)
		mxflat:shadow-width
	)
)

(define (get-shadow-offset w side)
	; the shadow is only not visible on all window edges
	(if (not (window-maximized-p w))
		(if
			(or
				(and
					(eq mxflat:shadow-light-source 'north)
					(not (eq side 'bottom))
				)
				(and
					(eq mxflat:shadow-light-source 'south)
					(not (eq side 'top))
				)
				(and
					(eq mxflat:shadow-light-source 'east)
					(not (eq side 'left))
				)
				(and
					(eq mxflat:shadow-light-source 'west)
					(not (eq side 'right))
				)
			)
			(/ mxflat:shadow-width mxflat:shadow-light-distance)
			(if (member side shadow-side)
				mxflat:shadow-width
				0
			)
		)
		0
	)
)

;   --------
;;; TITLEBAR
;   --------

;
;; titlebar:colors
;

(define (get-text-colors)
	(if mxflat:customize-extended-text-colors
		`(
   			(inactive				. ,mxflat:text-color-unfocused)
			(focused				. ,mxflat:text-color-focused)
			(highlighted			. ,mxflat:text-color-highlighted)
			(inactive-highlighted	. ,mxflat:text-color-inactive-highlighted)
			(clicked				. ,mxflat:text-color-clicked)
			(inactive-clicked		. ,mxflat:text-color-inactive-clicked)
		)
		`(
   			(inactive				. ,mxflat:text-color-unfocused)
			(focused				. ,mxflat:text-color-focused)
			(highlighted			. ,mxflat:text-color-focused)
			(inactive-highlighted	. ,mxflat:text-color-focused)
			(clicked				. ,mxflat:text-color-focused)
			(inactive-clicked		. ,mxflat:text-color-focused)
		)
	)
)

(define (titlebar-gradient-colors-helper)
	(case mxflat:titlebar-gradient-color-mode
		((custom)
			(if (> (length mxflat:titlebar-gradient-bgcolors) 0)
				mxflat:titlebar-gradient-bgcolors
				(list (get-color "#ffffffffffff"))
			)
		)
		((rainbow)
			(list
				(get-color "#ffff0000153b")
				(get-color "#ffff9b700000")
				(get-color "#fffff92d0000")
				(get-color "#3661ffff0000")
				(get-color "#00004c0dffff")
				(get-color "#b7ad0000ffff")
			)
		)
		((jamaica)
			(list
				(get-color "#7899f1340000")
				(get-color "#ffffffff0000")
				(get-color "#ffff37030000")
			)
		)
		((rgb)
			(list
				(get-color "#ffff00000000")
				(get-color "#0000ffff0000")
				(get-color "#00000000ffff")
			)
		)
	)
)
	
(define (titlebar-gradient-colors)
	(if mxflat:titlebar-gradient-bgcolors-reverse
		(reverse (titlebar-gradient-colors-helper))
		(titlebar-gradient-colors-helper)
	)
)

; changes the brightness and saturation for the
; titlebar gradient color with index i
(define (adjust-titlebar-bgcolor i)
	; get rgb ints for the color with index i
	(adjust-color (nth i (titlebar-gradient-colors)))
)

(define (get-titlebar-bgcolors #!optional side)
	(cond
		((and mxflat:title-gradient side)
			(let*
				(
					(index
						(if (eq side 'right)
							(1- (length (titlebar-gradient-colors)))
							0
						)
					)
				)
				`(
					(inactive	. ,(adjust-titlebar-bgcolor index))
					(focused	. ,(nth index (titlebar-gradient-colors)))
				)
			)
		)
		(t
			`(
				(inactive	. ,mxflat:titlebar-bgcolor-unfocused)
				(focused	. ,mxflat:titlebar-bgcolor-focused)
			)
		)
	)
)

;
;; titlebar:bg rendering
;

(define (num-titlebar-parts)
	(if
		(or
			(= (length (titlebar-gradient-colors)) 1)
			(eq mxflat:gradient-direction 'none)
		)
		(length (titlebar-gradient-colors))
		(1- (length (titlebar-gradient-colors)))
   	)
)

; render frame-part background
; this function takes the background img and uses
; many single 2-color gradients to fill it
(define (render-bg img state)
	(let*
		(
			; width and height of the titlebar part we have to fill
			(width (car (image-dimensions img)))
			(height (cdr (image-dimensions img)))

			; 2-color gradient width
			(part-width (/ width (num-titlebar-parts)))
			(rest-width (modulo width (num-titlebar-parts)))

			; the offset in the img that we've already reached
			; with our 2-color gradients
			(offset 0)

			; get the width of the 2-color gradient with index i
			(titlebar-parts-width-helper (lambda (i)
				(if (= i (1- (num-titlebar-parts)))
					(+ part-width rest-width)
					part-width
				)
			))

			; check the 2-color gradient width if it is > 0
			(titlebar-parts-width (lambda (i)
				(let
					(
						(val (titlebar-parts-width-helper i))
					)
					(if (< val 1)
						1
						val
					)
				)
			))

			; 2-color gradient image
			(img2 ())
		)

		(case mxflat:gradient-direction
			((horizontal none)
				(do
					((i 0 (1+ i)))
					((= i (num-titlebar-parts)))

					; create the 2-color gradient image and fill
					; it with a background color
					(setq img2
						(make-sized-image
							(titlebar-parts-width i)
							height
							(if state
								(nth i (titlebar-gradient-colors))
								(adjust-titlebar-bgcolor i)
							)
						)
					)

					; fill the img2 with the 2-color gradient
					; in necessary
					(if (not (eq mxflat:gradient-direction 'none))
						(apply
							draw-horizontal-gradient
							img2
							(if state
								(list
									(nth i (titlebar-gradient-colors))
									(if (or
											(= (length  (titlebar-gradient-colors)) 1)
											(eq mxflat:gradient-direction 'none)
										)
										(nth i (titlebar-gradient-colors))
										(nth (1+ i) (titlebar-gradient-colors))
									)
								)
								(list
									(adjust-titlebar-bgcolor i)
									(if (or
										(= (length (titlebar-gradient-colors)) 1)
											(eq mxflat:gradient-direction 'none)
										)
										(adjust-titlebar-bgcolor i)
										(adjust-titlebar-bgcolor (1+ i))
									)
								)
							)
						)
					)

					; paste the current 2-color gradient into
					; the titlebar background image
					(composite-images img img2 offset 0)
					(setq offset (+ offset (titlebar-parts-width i)))
				)
			)
			((vertical diagonal)
				(apply
					(if (eq mxflat:gradient-direction 'vertical)
						draw-vertical-gradient
						draw-diagonal-gradient
					)
					img
					(if state
						(list
							(nth 0 (titlebar-gradient-colors))
							(if (= (length  (titlebar-gradient-colors)) 1)
								(nth 0 (titlebar-gradient-colors))
								(nth 1 (titlebar-gradient-colors))
							)
						)
						(list
							(adjust-titlebar-bgcolor 0)
							(if (= (length (titlebar-gradient-colors)) 1)
								(adjust-titlebar-bgcolor 0)
								(adjust-titlebar-bgcolor 1)
							)
						)
					)
				)
			)
		)
		img
	)
)

;
;; titlebar:string
;

(define (get-title-font) mxflat:title-font)

; replace vars in the title string with their actual values
; and return the  new title string
(define (get-title-string w)
	(if mxflat:custom-title
		(let*
			(
				(title mxflat:title-string)
				(update-title (lambda (match-str replace-str)
						(while (string-match match-str title)
							(setq title
								(concat
									(expand-last-match "\\1")
									(if (numberp replace-str)
										(number->string replace-str)
										replace-str
									)
									(expand-last-match "\\3")
								)
							)
						)
					))
				)
				; some built-in vars
				(update-title "(.*)(\\$name)(.*)" (window-name w))
				(update-title "(.*)(\\$fullname)(.*)" (window-full-name w))
				(update-title "(.*)(\\$width)(.*)" (car (window-frame-dimensions w)))
				(update-title "(.*)(\\$height)(.*)" (cdr (window-frame-dimensions w)))
				(update-title "(.*)(\\$width-content)(.*)" (car (window-dimensions w)))
				(update-title "(.*)(\\$height-content)(.*)" (cdr (window-dimensions w)))
				(update-title "(.*)(\\$x-pos)(.*)" (car (window-position w)))
				(update-title "(.*)(\\$y-pos)(.*)" (cdr (window-position w)))
				(update-title "(.*)(\\$id)(.*)" (window-id w))
				(update-title "(.*)(\\$depth)(.*)" (window-get w 'depth))
				(update-title "(.*)(\\$gid)(.*)" (window-group-id w))
				(update-title "(.*)(\\$last-ws)(.*)" (get-last-workspace))
				(update-title "(.*)(\\$current-ws)(.*)"
						(let
							(
								(workspaces (window-get w 'workspaces))
							)
							(if workspaces
								(1+ (nth 0 workspaces))
								"*"
							)
						)
				)
				; replace environment vars
				(while (string-match "(.*)\\$\\((.+?)\\)(.*)" title)
					(let
						(
							(part1 (expand-last-match "\\1"))
							(part2 (expand-last-match "\\3"))
							(envvar (getenv (expand-last-match "\\2")))
						)
						(if (not envvar)
							(setq envvar (concat "$?(" (expand-last-match "\\2") ")"))
						)
						(setq title (concat part1 envvar part2))
					)
				)
				; replace rep functions
				; XXX: no arguments to the functions possible yet,
				; does someone need this?
				(while (string-match "(.*)\\$\\[(.+?)\\](.*)" title)
					(let
						(
							(part1 (expand-last-match "\\1"))
							(part2 (expand-last-match "\\3"))
							(symb (intern (expand-last-match "\\2")))
							(func ())
							(value (concat "$?[" (expand-last-match "\\2") "]"))
						)
						(if (boundp symb)
							(setq func (symbol-value symb))
						)
						(if (functionp func)
							(setq value (funcall func))
						)
						(setq title (concat part1 value part2))
					)
				)
				title
			)
			(window-name w)
		)
)

;
;; titlebar:position
;

; calculate the leftmost x position of an object on the titlebar
; this function is also used for button positions on the titlebar
(define (calculate-position pos)
	(if
		(and
			mxflat:customize-buttons
			(eq mxflat:button-position-model 'pixel)
		)
		; if the button-position-model is pixel we dont
		; need to calculate anything but just return the
		; argument value
		pos
		; actually calculate the positon
		(*
			(1- pos)
			(+
				(get-button-size)
				mxflat:button-distance
			)
		)
	)
)

(define (get-title-height)
	(+
		mxflat:title-height
		mxflat:border-width-titlebar-contents
	)
)

; not really the neg value since we add the border offset
; but thats the easiest place for doing so
(define (get-neg-title-height)
	(-
		(get-border-offset)
		(get-title-height)
	)
)

(define (get-titlebar-height w)
	(+
		(get-title-height)
		(get-border-width w 'top)
	)
)

; not really the neg value since we add the border offset
; but thats the easiest place for doing so
(define (get-neg-titlebar-height w)
	(-
		(get-border-offset)
		(get-titlebar-height w)
	)
)

	; get the 1+ position of the leftmost or rightmost button
(define (get-last-button-position left-right)
	(let
		((pos
			(if mxflat:customize-buttons
				(abs (apply
					(if (eq left-right 'left)
						min
						max
					)
					(list mxflat:menu-button-position mxflat:shade-button-position
						mxflat:sticky-button-position mxflat:previous-button-position
						mxflat:next-button-position mxflat:configure-button-position
						mxflat:info-button-position mxflat:iconify-button-position
						mxflat:maximize-button-position mxflat:close-button-position
						mxflat:always-on-top-button-position mxflat:lock-button-position
					)
				))
				(if (eq left-right 'left)
					3
					2
				)
			)
		))
		(if
			(or
				(eq mxflat:button-position-model 'title-height)
				(not mxflat:customize-buttons)
			)
			(calculate-position (1+ pos))
			(if (eq mxflat:button-position-model 'pixel)
				(+
					pos
					mxflat:title-height
				)
				1
			)
		)
	)
)

; by default the title is vertically centered and pixelwise
; adjusted through mxflat:title-y-adjustment
(define (get-title-y-alignment)
	(if mxflat:customize-title-position
		(case mxflat:title-y-justify
			((top)
				; sanity check on the value
				; else the title string would not be visible
				(if (> mxflat:title-y-adjustment 0)
					mxflat:title-y-adjustment
					0
				)
			)
			
			; we have to calculate it manually to be able to take
			; the y align adjustment into account
			((center)
				(+
					mxflat:title-y-adjustment
					(/
						(-
							mxflat:title-height
							(font-height mxflat:title-font)
						)
						2
					)
				)
			)
			; bottom
			(t
				; sanity check on the value
				; else the title string would not be visible
				(if (< mxflat:title-y-adjustment 0)
					mxflat:title-y-adjustment
					-1
				)
			)
		)
		'center
	)
)

(define (get-title-x-alignment w)
	(if mxflat:customize-title-position
		(case mxflat:title-x-justify
			((left)
				; sanity check on the value
				; else the title string would not be visible
				(if (< mxflat:title-x-adjustment 0)
					0
					mxflat:title-x-adjustment
				)
			)
			((center)
				'center
			)
			((right)
				; sanity check on the value
				; else the title string would not be visible
				(if (> mxflat:title-x-adjustment -1)
					-1
					mxflat:title-x-adjustment
				)
			)
			; 'real-center' means to take the whole titlebar into account
			; while centering the title string
			((real-center)
				(let
					(
						(real-title-offset
							(/
								(-
									(car (window-dimensions w))
									(text-width (get-title-string w) (get-title-font))
								)
								2
							)
						)
						(title-offset
							(-
								(get-last-button-position 'left)
								mxflat:title-x-adjustment
							)
						)
					)
					(if (> title-offset real-title-offset)
						0
						(- real-title-offset title-offset)
					)
				)
			)
		)
		'center
	)
)

(define (left-buttons-end-offset)
	(get-last-button-position 'left)
)
(define (right-buttons-end-offset)
	(get-last-button-position 'right)
)

;
;; titlebar:creation
;

(define (titlebar-center backgroun backgroundd)
	`(
		(
			(class			. title)
			(,backgroun		. ,backgroundd)
			(render-scale	. ,mxflat:gradient-scale)
			(foreground		. ,get-text-colors)
			(font			. ,get-title-font)
			(text			. ,get-title-string)
			(x-justify		. ,get-title-x-alignment)
			(y-justify		. ,get-title-y-alignment)
			(left-edge		.
				,(lambda ()
					(+
						(left-buttons-end-offset)
						(get-border-offset)
					)
				)
			)
			(right-edge		.
				,(lambda ()
					(+
						(right-buttons-end-offset)
						(get-border-offset)
					)
				)
			)
			(top-edge		. ,get-neg-title-height)
			(height			. ,(lambda () mxflat:title-height))
		)
	)
)

(define (titlebar-left-right backgroun backgroundd edg1 edgee1 edg2 edgee2)
	`(
		; left part of the titlebar
		(
			(class			. title)
			(,backgroun		. ,backgroundd)
			(render-scale	. ,mxflat:gradient-scale)
			(,edg1			. ,edgee1)
			(,edg2			. ,edgee2)
			(top-edge		. ,get-neg-title-height)
			(height			. ,(lambda () mxflat:title-height))
		)
	)
)

(define (titlebar)
	(append
		(if
			(and
				(or
					(eq mxflat:gradient-direction 'vertical)
					(eq mxflat:gradient-direction 'diagonal)
				)
				mxflat:title-gradient
			)
			(append
				(titlebar-left-right
					'renderer render-bg
					'left-edge get-border-offset
					'width left-buttons-end-offset
				)
				(titlebar-left-right
					'renderer render-bg
					'width right-buttons-end-offset
					'right-edge get-border-offset
				)
			)
			(append
				(titlebar-left-right
					'background	(lambda () (get-titlebar-bgcolors 'left))
					'left-edge get-border-offset
					'width left-buttons-end-offset
				)
				(titlebar-left-right
					'background	(lambda () (get-titlebar-bgcolors 'right))
					'width right-buttons-end-offset
					'right-edge get-border-offset
				)
			)
		)
		(if mxflat:title-gradient
			(titlebar-center 'renderer render-bg)
			(titlebar-center 'background get-titlebar-bgcolors)
		)
	)
)

;   -------
;;; BORDERS
;   -------

;
;; borders:colors
;

(define (get-border-color)
	(if mxflat:customize-border-colors
		`(
			(inactive				. ,mxflat:border-color-unfocused)
			(focused				. ,mxflat:border-color-focused)
			(highlighted			. ,mxflat:border-color-highlighted)
			(inactive-highlighted	. ,mxflat:border-color-inactive-highlighted)
			(clicked				. ,mxflat:border-color-clicked)
			(inactive-clicked		. ,mxflat:border-color-inactive-clicked)
		)
		`(
			(inactive				. ,mxflat:text-color-unfocused)
			(focused				. ,mxflat:text-color-focused)
		)
	)
)

(define (get-border-color-titlebar-contents)
	(if mxflat:customize-border-colors
		`(
			(inactive . ,mxflat:border-color-unfocused)
			(focused . ,mxflat:border-color-focused)
		)
		`(
			(inactive . ,mxflat:text-color-unfocused)
			(focused . ,mxflat:text-color-focused)
		)
	)
)

;
;; borders:width
;

(define (get-border-width w #!optional side)
	(cond
		(
			(or
				(and
					(window-maximized-vertically-p w)
					(or
						(eq side 'top)
						(eq side 'bottom)
					)
				)
				(and
					(window-maximized-horizontally-p w)
					(or
						(eq side 'left)
						(eq side 'right)
					)
				)
			)
			mxflat:border-width-maximized
		)
		(
			(and
				mxflat:custom-border-focused
				(eq w (input-focus))
			)
			mxflat:border-width-focused
		)
		(
			t
			mxflat:border-width-unmaximized
		)
	)
)

(define (get-neg-border-width w #!optional side)
	(-
		(get-border-offset)
		(get-border-width w side)
	)
)

;
;; borders:creation
;

(define (create-border-frame-parts color offset widthh #!optional mode border-list)
	(let*
		(
			(get-pos (lambda (w side)
				(-
					(offset w side)
					(widthh w side)
				)
			))
			; bottom edge of the frame
			(bottom-edgee1 'bottom-edge)
			(bottom-edgee2 'bottom-edge)
			(bottom-edg1 (lambda (w) (offset w 'bottom)))
			(bottom-edg2 (lambda (w) (get-pos w 'bottom)))
			(top-edg1 (lambda (w)
				(-
					(offset w 'top)
					(get-title-height)
				)
			))
			(top-edg2 (lambda (w)
				(-
					(offset w 'top)
					(+
						(get-title-height)
						(widthh w 'top)
					)
				)
			))
			(left-edg (lambda (w) (get-pos w 'left)))
			(right-edg (lambda (w) (get-pos w 'right)))
			(right-borderr (if border-list 'shadow 'right-border))
			(left-borderr (if border-list 'shadow 'left-border))
			(top-borderr (if border-list 'shadow 'top-border))
			(bottom-borderr (if border-list 'shadow 'bottom-border))
		)
		(case mode
			('transient
				(setq top-edg1 (lambda (w) (offset w 'top)))
				(setq top-edg2 (lambda (w) (get-pos w 'top)))
			)
			('shaded
				(setq bottom-edgee2 'top-edge)
				(setq bottom-edg2 (lambda (w) (- (offset w 'bottom) mxflat:border-width-titlebar-contents)))
				; when the window is shaded we rather define the borders by
				; top-edge and height instead of using top- and bottom-edge
				(setq bottom-edgee1 'height)
				(setq bottom-edg1 (lambda (w) (get-titlebar-height w)))
			)
		)
		(append
			; draw the right border
			(if
				(or
					(not border-list)
					(member 'right border-list)
				)
				`((
					(class		. ,right-borderr)
					(background	. ,color)
					(width		. ,(lambda (w) (widthh w 'right)))
					(right-edge	. ,right-edg)
					(top-edge	. ,top-edg1)
					(,bottom-edgee1		. ,bottom-edg1)
				))
			)

			; draw the left border
			(if
				(or
					(not border-list)
					(member 'left border-list)
				)
				`((
					(class		. ,left-borderr)
					(background	. ,color)
					(width		. ,(lambda (w) (widthh w 'left)))
					(left-edge	. ,left-edg)
					(top-edge	. ,top-edg1)
					(,bottom-edgee1		. ,bottom-edg1)
				))
			)

			; draw the top border of the title frame
			(if
				(or
					(not border-list)
					(member 'top border-list)
				)
				`((
					(class		. ,top-borderr)
					(background	. ,color)
					(height		. ,(lambda (w) (widthh w 'top)))
					(left-edge	. ,left-edg)
					(right-edge	. ,right-edg)
					(top-edge	. ,top-edg2)
				))
			)

			; draw the bottom border
			(if
				(or
					(not border-list)
					(member 'bottom border-list)
				)
				`((
					(class		. ,bottom-borderr)
					(background	. ,color)
					(height		. ,(lambda (w) (widthh w 'bottom)))
					(left-edge	. ,left-edg)
					(right-edge	. ,right-edg)
					(,bottom-edgee2		. ,bottom-edg2)
				))
			)
		)
	)
)

; this function appends the window border (frame) and its shadow
(define (create-borders w #!optional mode)
	(if (= (length shadow-side) 0)
		(get-shadow-side)
	)
	(append
		; create normal window border
		(create-border-frame-parts
			get-border-color
			get-border-offset
			get-border-width
			mode
		)
		; create fake shadow if necessary
		(if
			(and
				mxflat:fake-shadow
				(or
					(not mxflat:fake-shadow-focused-only)
					(eq w (input-focus))
				)
			)
			(create-border-frame-parts
				get-shadow-color
				get-shadow-width
				get-shadow-offset
				mode
				shadow-side
			)
		)
	)
)

; create the (small) line between titlebar and contents window
(define (create-titlebar-contents-border)
	`(
		(
			(class			. middle-border)
			(background		. ,get-border-color-titlebar-contents)
			(height			. ,(lambda () mxflat:border-width-titlebar-contents))
			(top-edge		. ,(lambda ()
				(-
					(get-border-offset)
					mxflat:border-width-titlebar-contents
				)
			))
			(left-edge		. ,get-border-offset)
			(right-edge		. ,get-border-offset)
		)
	)
)

; return a top border (for shaded-transient)
(define (create-top-border)
	`(
		(
			(class			. top-border)
			(background		. ,get-border-color)
			(height			. ,(lambda (w) (get-border-width w 'top)))
			(top-edge		. ,(lambda (w) (get-neg-border-width w 'top)))
			(left-edge		. 0)
			(right-edge		. 0)
		)
	)
)

;   -------
;;; BUTTONS
;   -------


; create, scale and cache an image
(define (get-image img)
	(or
		(table-ref icon-cache img)
		(let
			(
				(image
					(if mxflat:scale-buttons
						(scale-image
							(make-image img)
							mxflat:button-scale mxflat:button-scale
						)
						(make-image img)
					)
				)
			)
			(table-set icon-cache img image)
			image
		)
	)
)

;
;; buttons:colors
;

(define (get-button-bgcolor #!optional edge)
	(cond
		(mxflat:title-gradient
			(let*
				(
					(index
						(if (eq edge 'right-edge)
							(1- (length (titlebar-gradient-colors)))
							0
						)
					)
				)
				`(
					(inactive				. ,(adjust-titlebar-bgcolor index))
					(focused				. ,(nth index (titlebar-gradient-colors)))
					(highlighted			. ,(adjust-titlebar-bgcolor index))
					(inactive-highlighted	. ,(nth index (titlebar-gradient-colors)))
					(clicked				. ,(adjust-titlebar-bgcolor index))
					(inactive-clicked		. ,(nth index (titlebar-gradient-colors)))
				)
			)
		)
		(mxflat:custom-button-colors
			`(
				(inactive				. ,mxflat:button-bgcolor-unfocused)
				(focused				. ,mxflat:button-bgcolor-focused)
				(highlighted			. ,mxflat:button-bgcolor-highlighted)
				(inactive-highlighted	. ,mxflat:button-bgcolor-inactive-highlighted)
				(clicked				. ,mxflat:button-bgcolor-clicked)
				(inactive-clicked		. ,mxflat:button-bgcolor-inactive-clicked)
			)
		)
		(t
			`(
				(inactive				. ,mxflat:titlebar-bgcolor-unfocused)
				(focused				. ,mxflat:titlebar-bgcolor-focused)
				(highlighted			. ,mxflat:titlebar-bgcolor-unfocused)
				(inactive-highlighted	. ,mxflat:titlebar-bgcolor-focused)
				(clicked				. ,mxflat:text-color-unfocused)
				(inactive-clicked		. ,mxflat:text-color-unfocused)
			)
		)
	)
)


;
;; buttons:icons
;

; return a list of 4 different image objects
; as needed for the button fg images/icons
(define (get-images img)
	(let
		(
			(image (get-image (concat "button-icons/" (symbol-name mxflat:button-icon-set) "/" img)))
		)
		(list
			image
			(copy-image image)
			(copy-image image)
			(copy-image image)
		)
	)
)

(defvar get-menu-button1 (get-images "button-menu.png"))
(define (get-menu-button w)
	(if mxflat:menu-button-icon
		(or
			(table-ref icon-cache w)
			(or
				(let
					(
						(icon (window-icon-image w))
					)
					(when icon
						(let
							(
								(scaled
									(scale-image icon mxflat:menu-button-scale
										mxflat:menu-button-scale)
								)
							)
							(table-set icon-cache w scaled)
							scaled
						)
					)
				)
				get-menu-button1
			)
		)
		get-menu-button1
	)
)

(defvar get-shade-button1 (get-images "button-shade1.png"))
(defvar get-shade-button2 (get-images "button-shade2.png"))
(define (get-shade-button w)
	(if (window-get w 'shaded)
		get-shade-button2
		get-shade-button1
	)
)

(defvar get-sticky-button1 (get-images "button-sticky1.png"))
(defvar get-sticky-button2 (get-images "button-sticky2.png"))
(define (get-sticky-button w)
	(if (window-get w 'sticky)
		get-sticky-button2
		get-sticky-button1
	)
)

(defvar get-iconify-button (get-images "button-minimize.png"))

(defvar get-maximize-button1 (get-images "button-maximize1.png"))
(defvar get-maximize-button2 (get-images "button-maximize2.png"))
(define (get-maximize-button w)
	(if (window-maximized-p w)
		get-maximize-button2
		get-maximize-button1
	)
)

(defvar get-close-button (get-images "button-close.png"))

(defvar get-previous-button1 (get-images "button-previous1.png"))
(defvar get-previous-button2 (get-images "button-previous2.png"))
(define (get-previous-button w)
	(if
		(or
			(window-in-workspace-p w (- (get-first-workspace) 1))
			(window-get w 'sticky)
		)
		get-previous-button2
		get-previous-button1
	)
)

(defvar get-next-button1 (get-images "button-next1.png"))
(defvar get-next-button2 (get-images "button-next2.png"))
(define (get-next-button w)
	(if
		(or
			(window-in-workspace-p w (- (get-last-workspace) 1))
			(window-get w 'sticky)
		)
		get-next-button2
		get-next-button1
	)
)

(defvar get-configure-button (get-images "button-configure.png"))

(defvar get-info-button (get-images "button-info.png"))

(defvar get-always-on-top-button1 (get-images "button-a1.png"))
(defvar get-always-on-top-button2 (get-images "button-a2.png"))
(define (get-always-on-top-button w)
	(if (> (window-get w 'depth) 0)
		get-always-on-top-button2
		get-always-on-top-button1
	)
)

(defvar get-lock-button1 (get-images "button-lock1.png"))
(defvar get-lock-button2 (get-images "button-lock2.png"))
(define (get-lock-button w)
	(if (window-get w 'fixed-position)
		get-lock-button2
		get-lock-button1
	)
)

;
;; buttons:fg recolor
;

; this function is stolen from the crux sawfish theme
; (the theme is included in the original sawfish package)
(setq recolor-all (lambda ()
	(let*
		(
			(recolorer (lambda (color1 color2)
				(make-image-recolorer
					(if mxflat:custom-button-colors
						color1
						color2
					)
					#:zero-channel blue-channel
					#:index-channel red-channel
				)
			))
			
			; unfocused
			(recolorer1
				(recolorer
					mxflat:button-fgcolor-inactive
					mxflat:text-color-unfocused
				)
			)
			; focused
			(recolorer2
				(recolorer
					mxflat:button-fgcolor-focused
					mxflat:text-color-focused
				)
			)
			; highlighted
			(recolorer3
				(recolorer
					mxflat:button-fgcolor-highlighted
					mxflat:text-color-unfocused
				)
			)
			; clicked
			(recolorer4
				(recolorer
					mxflat:button-fgcolor-clicked
					mxflat:text-color-focused
				)
			)
		)
    	(mapc
			(lambda (x)
				(apply recolorer1 x)
				(apply recolorer2 (cdr x))
				(if (> (length x) 2)
					(apply recolorer3 (nthcdr 2 x))
				)
				(if (> (length x) 3)
					(apply recolorer4 (nthcdr 3 x))
				)
			)
			; list of all button fg icon lists that we have to recolor
			(list get-menu-button1 get-shade-button1 get-shade-button2
				get-sticky-button1 get-sticky-button2 get-iconify-button
				get-maximize-button1 get-maximize-button2 get-close-button
				get-previous-button1 get-previous-button2 get-next-button1
				get-next-button2 get-configure-button get-info-button
				get-always-on-top-button1 get-always-on-top-button2
				get-lock-button1 get-lock-button2
			)
		)
	)
))

;
;; buttons:define classes
;

; missing button frame part classes
; all other classes are defined by sawfish by default -
; it are always 2 classes, one with the default key binding
; and one with the custom (user defined) one
(define-frame-class 'configure-button-custom	'((keymap . mxflat:configure-button-keymap)))
(define-frame-class 'configure-button			'((keymap . configure-button-keymap)))
(define-frame-class 'info-button-custom			'((keymap . mxflat:info-button-keymap)))
(define-frame-class 'info-button				'((keymap . info-button-keymap)))
(define-frame-class 'next-button-custom			'((keymap . mxflat:next-button-keymap)))
(define-frame-class 'next-button				'((keymap . next-button-keymap)))
(define-frame-class 'previous-button-custom		'((keymap . mxflat:previous-button-keymap)))
(define-frame-class 'previous-button			'((keymap . previous-button-keymap)))
(define-frame-class 'sticky-button-custom		'((keymap . mxflat:sticky-button-keymap)))
(define-frame-class 'sticky-button				'((keymap . sticky-button-keymap)))
(define-frame-class 'always-on-top-button-custom '((keymap . mxflat:always-on-top-button-keymap)))
(define-frame-class 'always-on-top-button		'((keymap . always-on-top-button-keymap)))
(define-frame-class 'lock-button-custom			'((keymap . mxflat:lock-button-keymap)))
(define-frame-class 'lock-button				'((keymap . lock-button-keymap)))

;
;; buttons:creation
;

; this function actually creates a button frame part and returns it
(define (create-button-frame-part classs fg edge x-pos y-pos backgroun backgroundd)
	; button frame part definition
	`(
		(class		. ,classs)
		(,backgroun	. ,backgroundd)
		(render-scale . ,mxflat:gradient-scale)
		(foreground	. ,fg)
		(x-justify	. center)
		(y-justify	. center)
		(,edge		. ,x-pos)
		(top-edge	. ,y-pos)
		(height		. ,get-button-size)
		(width		. ,get-button-size)
	)
)

; gather all necessary arguments and then call create-button-frame-part
; to actually create the button
(define (create-button button-type #!optional x-pos-default)
	(let
		(
			; raw position, creatue-button-frame-part does some more
			; calculations on it
			(x-pos-raw
				(if mxflat:customize-buttons
					(check-symbol "mxflat:" button-type "-button-position")
					(if x-pos-default x-pos-default 0)
				)
			)
		)
		
		; position = 0 means the button is not displayed
		; so we can save some time be not doing all these evaluations
		(if (not (= x-pos-raw 0))
			(let*
				(
					; if the position parameter (x-pos-raw) for the current button is
					; positive it starts on the right side
					(edge (if (> x-pos-raw 0) 'right-edge 'left-edge))

					; default button background mode (ie static color)
					(backgroun 'background)
					(backgroundd (get-button-bgcolor edge))
					
					; button x offset from the left/right titlebar edge
					(x-pos (lambda ()
						(+
							(-
								(calculate-position (abs x-pos-raw))
								mxflat:border-offset
							)
							(if (> x-pos-raw 0)
								mxflat:button-right-offset
								mxflat:button-left-offset
							)
						)
					))

					; different top positions for different mxflat:button-y-alignment
					; but only in case mxflat:customize-button-size is true
					; because in the other case the buttons height and width is equal
					; to the titlebar height
					(y-pos (lambda ()
						(if mxflat:customize-button-size
							(case mxflat:button-y-alignment
								((top)
									(get-neg-title-height)
								)
								((bottom)
									(+
										(get-neg-title-height)
										(-
											mxflat:title-height
											(get-button-size)
										)
									)
								)
								; this is the center case
								(t
									(+
										(get-neg-title-height)
										(/
											(-
												mxflat:title-height
												(get-button-size)
											)
											2
										)
									)
								)
							)
							; in case the size is the default we start on top
							; of the titlebar
							(get-neg-title-height)
						)
					))
				)
				
				; in case of a gradient titlebar bg
				; change the button bg to rendering
				(cond
					(
						(and
							mxflat:title-gradient
							(or
								(eq mxflat:gradient-direction 'vertical)
								(eq mxflat:gradient-direction 'diagonal)
							)
						)
						(setq backgroun 'renderer)
						(setq backgroundd render-bg)
					)
				)

				(create-button-frame-part
					; decide which frame part (and indirectly which keymap) to use
					(if (check-symbol "mxflat:customize-" button-type "-keymap")
						(get-symbol button-type "-button-custom")
						(get-symbol button-type "-button")
					)
					; button fg images/icons
					(check-symbol "get-" button-type "-button")
					edge
					x-pos
					y-pos
					backgroun
					backgroundd
				)
			)
		)
	)
)

; create a list of button frame parts and return it
(define (create-buttons)
	; create a list of all custom buttons if the button
	; position model is not none (none means no buttons)
	(if (not (eq mxflat:button-position-model 'none))
		(list
			(create-button "menu" -1)
			(create-button "shade" -2)
			(create-button "iconify" +3)
			(create-button "maximize" +2)
			(create-button "close" +1)
			(create-button "sticky")
			(create-button "next")
			(create-button "previous")
			(create-button "configure")
			(create-button "info")
			(create-button "always-on-top")
			(create-button "lock")
		)
	)
)

;   -------
;;; CORNERS
;   -------

;
;; corners:size
;

(define (get-corner-width-adjustment w #!optional side)
	(if
		(or
			(and
				(window-maximized-vertically-p w)
				(or
					(eq side 'top)
					(eq side 'bottom)
				)
			)
			(and
				(window-maximized-horizontally-p w)
				(or
					(eq side 'left)
					(eq side 'right)
				)
			)
		)
		mxflat:corner-width-adjustment-maximized
		mxflat:corner-width-adjustment
	)
)

(define (get-corner-width w #!optional frame-type side)
	(if
		(and
			(eq frame-type 'shaded)
			(> (get-corner-width-adjustment w side) (/ (get-title-height) 2))
			(eq mxflat:corner-direction 'inside)
		)
		(/ (1+ (get-title-height)) 2)
		(+
			(get-corner-width-adjustment w side)
			(get-border-width w side)
		)
	)
)

(define (get-corner-length w #!optional frame-type)
	(if (= mxflat:corner-length-adjustment -1)
		0
		(+
			(+
				(if (and
						(eq frame-type 'shaded)
						(> mxflat:corner-length-adjustment (/ (get-title-height) 2))
					)
					(/ (1+ (get-title-height)) 2)
					mxflat:corner-length-adjustment
				)
				(get-border-width w 'top)
			)
			(if (eq mxflat:corner-direction 'inside)
				0
				(get-corner-width-adjustment w)
			)
		)
	)
)

;
;; corners:position
;

; get top or bottom position
(define (get-corner-1-pos w side part #!optional frame-type)
	(-
		(if (eq side 'bottom)
			(if (eq frame-type 'shaded)
				(+
					(if (eq part 'b)
						(+
							(- (get-corner-length w frame-type))
							(get-corner-width w frame-type side)
						)
						0
					)
					(-
						(get-border-offset)
						mxflat:border-width-titlebar-contents
					)
				)
				(get-neg-border-width w side)
			)
			(if (eq frame-type 'transient)
				(get-neg-border-width w 'top)
				(get-neg-titlebar-height w)
			)
		)
		(if
			(and
				(eq frame-type 'shaded)
				(eq side 'bottom)
			)
			(if (eq mxflat:corner-direction 'inside)
				(get-corner-width-adjustment w side)
				0
			)
			(if (eq mxflat:corner-direction 'inside)
				0
				(get-corner-width-adjustment w side)
			)
		)
	)
)

; get left or right position
(define (get-corner-2-pos w side)
		(-
			(get-neg-border-width w side)
			(if (eq mxflat:corner-direction 'inside)
				0
				(get-corner-width-adjustment w side)
			)
		)
)

;
;; corners:creation
;

; create the two corner lists a real corner consists of
(define (create-corner classs edgee1 side1 edgee2 side2 frame-type)
	`(
		(
			(class			. ,classs)
			(background		. ,get-border-color)
			(width			. ,get-corner-length)
			(height			. ,(lambda (w) (get-corner-width w frame-type side1)))
			(,edgee1			. ,(lambda (w) (get-corner-1-pos w side1 'a frame-type)))
			(,edgee2			. ,(lambda (w) (get-corner-2-pos w side2)))
		)
		(
			(class			. ,classs)
			(background		. ,get-border-color)
			(width			. ,(lambda (w) (get-corner-width w frame-type side2)))
			(height			. ,(lambda (w) (get-corner-length w frame-type)))
			(,edgee1			. ,(lambda (w) (get-corner-1-pos w side1 'b frame-type)))
			(,edgee2			. ,(lambda (w) (get-corner-2-pos w side2)))
		)
	)
)
; this function actually creates the 4 window corners and returns them
(define (create-corners #!optional frame-type)
	(if mxflat:show-corners
		(let
			(
				(edgee1 'top-edge)
				(edgee2 'bottom-edge)
			)
			(if (eq frame-type 'shaded)
				(setq edgee2 'top-edge)
			)
			(append
				(create-corner 'top-left-corner edgee1 'top 'left-edge 'left frame-type)
				(create-corner 'top-right-corner edgee1 'top 'right-edge 'right frame-type)
				(create-corner 'bottom-left-corner edgee2 'bottom 'left-edge 'left frame-type)
				(create-corner 'bottom-right-corner edgee2 'bottom 'right-edge 'right frame-type)
			)
		)
	)
)

;   --------------
;;; REGISTER THEME
;   --------------

#|

that is from the manual (http://sawmill.sourceforge.net/prog-manual.html)

Frame Types

default
	The normal frame type. Includes all decorations, both borders and the title bar.
	transient
	The frame for a transient window. This usually does not include a title bar,
	but does have all four borders.
shaped
	Shaped windows are normally decorated with only a title-bar, since their boundary
	is not rectangular it makes no sense to surround them with a rectangular border.
shaped-transient
	A combination of the shaped and transient types, normally just a very small title
	border with no text.
shaded
	A shaded window (normally just the title bar).
shaded-transient
	A shaded transient window.
unframed
	No frame at all, just the client window itself. The predefined nil-frame variable
	contains a null frame that may be used for this frame type.

"Normal" 'default
"Title-only" 'shaped
"Border-only" 'transient
"Top-border" 'shaped-transient
"None" 'unframed

|#

; return the window frame and decorations
(define (get-frame w frame-type)
	(let*
		(
			; window with all decorations
			(defaul (lambda ()
				(append (titlebar) (create-titlebar-contents-border)
					(create-borders w) (create-buttons) (create-corners))
			))

			; window with contents frame only
			(transien (lambda ()
				(append (create-borders w 'transient) (create-corners 'transient))
			))

			(titleba (lambda (#!optional mode)
				(if mode
					(titlebar)
					(append (titlebar) (create-buttons))
				)
			))

			; window that is shaded
			(shade (lambda (#!optional titlebar-mode)
				(if mxflat:keep-borders-when-shaded
					(append (titleba titlebar-mode) (create-titlebar-contents-border)
						(create-borders w) (create-corners))
					(append (titleba titlebar-mode)
						(create-borders w 'shaded) (create-corners 'shaded))
				)
			))

			(check (lambda (mode)
				(cond
					((eq mxflat:decoration-mode 'none)
						(transien)
					)
					((eq mxflat:decoration-mode 'all)
						(defaul)
					)
					(t
						(mode)
					)
				)
			))
		)

		(case frame-type
			((default)
				(check defaul)
			)
			((transient)
				(check transien)
			)
			((shaped shaded)
				(if (eq mxflat:decoration-mode 'none)
					(shade 'no-buttons)
					(shade)
				)
			)
			((shaded-transient)
				(if (eq mxflat:decoration-mode 'all)
					(shade)
					(shade 'no-buttons)
				)
			)
			((shaped-transient)
				(create-top-border)
			)
		)
	)
)

; setup initial colors
(recolor-all)
(after-set-title-update-interval)
; register theme with sawfish
(add-frame-style 'mxflat get-frame)

;;; END

;; theme file, written Mon Aug 19 14:03:46 2002
;; created by sawfish-themer -- DO NOT EDIT!

(require 'make-theme)

(let
    ((patterns-alist
      '(("close-button"
         (inactive
          "close-up.png"
          (border
           0
           0
           0
           0))
         (clicked
          "close-down.png"))
        ("maximize-button"
         (inactive
          "restore-up.png")
         (clicked
          "maximize-down.png"))
        ("minimize-button"
         (inactive
          "minimize-up.png")
         (clicked
          "minimize-down.png"))
        ("controlbox"
         (inactive
          "menu-up.png")
         (clicked
          "menu-down.png"))
        ("title-bar"
         (inactive
          "unfocus-titlebar-up.png")
         (focused
          "titlebar.png")
         (clicked
          "titlebar-down.png"))
        ("text-color"
         (inactive . "#c5d0c5d0c5d0")
         (focused . "#ffffffffffff"))
        ("h-frame"
         (inactive
          "hborder.png"))
        ("v-frame"
         (inactive
          "vborder.png"))
        ("botright-corner"
         (inactive
          "botright.png"))
        ("botleft-corner"
         (inactive
          "boleft.png"))))

     (frames-alist
      '(("default"
         ((right-edge . -8)
          (top-edge . -40)
          (background . "close-button")
          (class . close-button))
         ((top-edge . -40)
          (right-edge . 32)
          (background . "maximize-button")
          (class . maximize-button))
         ((top-edge . -40)
          (right-edge . 72)
          (background . "minimize-button")
          (class . iconify-button))
         ((font . "-b&h-lucida console-medium-r-normal-*-*-160-*-*-m-*-koi8-u")
          (left-edge . 32)
          (right-edge . 112)
          (top-edge . -40)
          (text . window-name)
          (background . "title-bar")
          (foreground . "text-color")
          (y-justify . center)
          (x-justify . 10)
          (class . title))
         ((top-edge . -40)
          (left-edge . -8)
          (background . "controlbox")
          (class . menu-button))
         ((right-edge . 0)
          (height . 8)
          (bottom-edge . -8)
          (left-edge . 0)
          (background . "h-frame")
          (class . bottom-border))
         ((left-edge . -8)
          (bottom-edge . 0)
          (top-edge . 0)
          (background . "v-frame")
          (class . left-border))
         ((right-edge . -8)
          (top-edge . 0)
          (bottom-edge . 0)
          (background . "v-frame")
          (class . right-border))
         ((bottom-edge . -8)
          (right-edge . -8)
          (background . "botright-corner")
          (class . bottom-right-corner))
         ((bottom-edge . -8)
          (background . "botleft-corner")
          (left-edge . -8)
          (class . bottom-left-corner)))))

     (mapping-alist
      '((default . "default")
        (transient . "default")
        (shaped . "default")
        (shaped-transient . "default")
        (unframed . "default")))

     (theme-name 'Big))

  (add-frame-style
   theme-name (make-theme patterns-alist frames-alist mapping-alist))
  (when (boundp 'mark-frame-style-editable)
    (mark-frame-style-editable theme-name)))
